c#define MATHEMATICA

      subroutine CALC_HHHeff(slhafile,CPCon)
      implicit none  
      integer nout,i,i1,i2,idh(5)    
      character*30 slhafile     
      double precision resout
      logical CPcon 
      parameter (nout=44)
#include "bh_EWNMSSM.in"
      call HHHTL_calc()
      call reeffHHH(reHHH_T,0,CPcon)       
      call reeffHHH(reHHH_1L,1,CPcon)
c      call reeffHHH(reHHH_2QCD,2,CPcon)    
c      call reeffHHH(reHHH_2ATAT,3,CPcon)      
      open(unit=nout,file=slhafile,status="old",position="append",action='write')          
      if(CPcon)then       
       idH(3)=25;idH(4)=35; idH(5)=45 
       idH(1)=36; idH(2)=46
      write(nout,51) 'HiggsEffectiveTrilinearCouplings-HHH', 
     .               'Couplings between 3 CP-even Higgs bosons' 
      write(nout,116) '  Tree-level','1L','O(al_t al_s)','O(al_t^2)','IP1','IP2','IP3'
      Do i=3,5
      Do i1=i,5
      Do i2=i1,5
      write(nout,115)  reHHH_T(i,i1,i2),reHHH_1L(i,i1,i2),reHHH_2QCD(i,i1,i2),
     .                 reHHH_2ATAT(i,i1,i2), idH(i),idH(i1),idH(i2), 'H',i-2,'H',i1-2,'H',i2-2    
      enddo
      enddo
      enddo  
      write(nout,51) 'HiggsEffectiveTrilinearCouplings-HAA', 
     .               'Couplings between 1 CP-even and 2 CP-odd Higgs bosons' 
      write(nout,116) '  Tree-level','1L','O(al_t al_s)','O(al_t^2)','IP1','IP2','IP3'
      Do i=3,5
      Do i1=1,2
      Do i2=i1,2
      write(nout,115)  reHHH_T(i,i1,i2),reHHH_1L(i,i1,i2),reHHH_2QCD(i,i1,i2),
     .                 reHHH_2ATAT(i,i1,i2), idH(i),idH(i1),idH(i2), 'H',i-2,'A',i1,'A',i2      
      enddo
      enddo
      enddo       
      else        
       idH(1)=25;idH(2)=35; idH(3)=36 
       idH(4)=45; idH(5)=46
      write(nout,51) 'HiggsEffectiveTrilinearCouplings-HHH', 
     .               'Couplings between 3 Higgs bosons' 
      write(nout,116) '  Tree-level','1L','O(al_t al_s)','O(al_t^2)','IP1','IP2','IP3'
 


      Do i=1,5
      Do i1=i,5
      Do i2=i1,5
c      call reeffHHH_full(i,i1,i2,resout,1,CPcon)
c      write(nout,115)  reHHH_T(i,i1,i2),reHHH_1L(i,i1,i2),resout,
c     .                 (resout-reHHH_1L(i,i1,i2))/reHHH_T(i,i1,i2), idH(i),idH(i1),idH(i2), 'H',i,'H',i1,'H',i2    
           
      write(nout,115)  reHHH_T(i,i1,i2),reHHH_1L(i,i1,i2),reHHH_2QCD(i,i1,i2),
     .                 reHHH_2ATAT(i,i1,i2), idH(i),idH(i1),idH(i2), 'H',i,'H',i1,'H',i2    
      enddo
      enddo
      enddo                

      endif
      write(nout,105)      
      close(nout)
 51   format('BLOCK',1x,A,2x,'#',1x,A)  
 105  format('#')     
 115  format(1x,E16.8,1x,E16.8,1x,E16.8,1x,E16.8,3x,I2,2x,I2,2x,I2,2X,'#',1x,A,I1,A,I1,A,I1," coupling" ) 
 116  format('#',A,9x,A,12x,A,9x,A,3x,A,2x,A,2x,A)               
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
      subroutine HHHTL_calc()
      implicit none   
      double precision dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &      dL3HM(6,6,6),OLHHH(6,6,6),reHHHQCD(6,6,6),reHHHATAT(6,6,6)
      double complex resAG(6,6,6)
      common /HHHTL/dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &                 dL3HM,OLHHH,reHHHQCD,reHHHATAT,resAG
      
      call Counterterms(dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas)
      
      call dLHHH(dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas
     $        ,dL3HM,resAG)

      call ReHHH_at(OLHHH)    

      call ReHHH_QCD(reHHHQCD)  
      call ReHHH_atat(reHHHATAT)    
      end
      
      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine dLHHH(dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,
     &  dtad,dtas,dL3HM,resAG)
      implicit none
      integer i,j,k,i1,j1,k1
      double precision dMW2,dMZ2,dZe,dthd,dthu,dths,dtad,dtas,dMHpm2,
     &                 dL3H(6,6,6),dL3HM(6,6,6),dMAG(6),dMAGM(6),dSW
     &                 ,dCW,dLGACT(6,6,6), dM(6,6)
      double precision dReAlambda,dImAlambda,dv,dReAkappa,dImAkappa,
     &                 dMchaH2
      double precision sqrt2,MW2,MZ2,v2,vs2,la2,ka2,SB,CB,ImAlambda,
     &                 ReAlambda,ImAkappa,ReAkappa,CB2,SB2,phi,phiIl,
     &                 phiIk,SW,CW,SW2,CW2,masshh(6)

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
     
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      logical MHpmInput,CPcon,mQrun,onelswitch     
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      double complex  ChHpWmA(6,2),ChHmWpA(2,6),ChHpWmZ(6,2),
     &                ChHmWpZ(2,6),ChhWmWp(6,6),ChhAZ(6,6),ChhZZ(6,6),
     &                ChHpWm(6,2),ChHmWp(2,6),ChhZ(6,6),ChWmWp(6),
     &                ChZZ(6),ChSdmSdp(6,6,6),ChSemSep(6,6,6),
     &                ChSupSum(6,6,6),ChSvSvconj(6),ChHmHp(2,2,6),
     &                ChhSemSep(6,6,6,6),ChhSvSvconj(6,6),
     &                ChhHmHp(2,6,2,6),ChhSupSum(6,6,6,6),
     &                ChhSdmSdp(6,6,6,6),CLhChapCham(2,2,6),
     &                CRhChapCham(2,2,6),CLhFepFem(3,3,6),
     &                CRhFepFem(3,3,6),CLhFdpFdm(3,3,6),
     &                CRhFdpFdm(3,3,6),CLhFumFup(3,3,6),
     &                CRhFumFup(3,3,6),ChU3U3(6),ChU2U2(6),ChU4U4(6),
     &                Chhh(6,6,6),Chhhh(6,6,6,6),CLhChiChi(5,5,6),
     &                CRhChiChi(5,5,6),CHmHpSvSv(3,2,3,2),
     &                CHmHpSdmSdp(6,2,6,2),CHmHpSupSum(6,2,6,2),
     &                CHmHpSemSep(6,2,6,2),CHmSepSv(3,6,2),
     &                CHpSemSv(6,3,2),CHmSupSdp(6,6,2),
     &                CHpSumSdm(6,6,2),CLHpChiCha(5,2,2),
     &                CRHpChiCha(5,2,2),CLHmChiCha(2,5,2),
     &                CRHmChiCha(2,5,2)
      double complex  resAG(6,6,6),HSelf
 
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /coupl/ ChHpWmA,ChHmWpA,ChHpWmZ,ChHmWpZ,ChhWmWp,
     &               ChhAZ,ChhZZ,ChHpWm,ChHmWp,ChhZ,ChWmWp,ChZZ,
     &               ChSdmSdp,ChSemSep,ChSupSum,ChSvSvconj,ChHmHp,
     &               ChhSemSep,ChhSvSvconj,ChhHmHp,ChhSupSum,ChhSdmSdp,
     &               CLhChapCham,CRhChapCham,CLhFepFem,CRhFepFem,
     &               CLhFdpFdm,CRhFdpFdm,CLhFumFup,CRhFumFup,ChU3U3,
     &               ChU2U2,ChU4U4,Chhh,Chhhh,CLhChiChi,CRhChiChi,
     &               CHmHpSvSv,CHmHpSdmSdp,CHmHpSupSum,CHmHpSemSep,
     &               CHmSepSv,CHpSemSv,CHmSupSdp,CHpSumSdm,CRHpChiCha,
     &               CLHpChiCha,CRHmChiCha,CLHmChiCha
      sqrt2=Sqrt(2D0)
      SB=Sin(beta); SB2=SB**2
      CB=Cos(beta); CB2=CB**2
      la2= abslambda**2;  ka2= abskappa**2;   v2=v**2
      vS2=vs**2;      MW2=MW**2;      MZ2=MZ**2
      ReAlambda=absAlambda*Cos(phiAl)
      ImAlambda=absAlambda*Sin(phiAl)
      ReAkappa=absAkappa*Cos(phiAk)
      ImAkappa=absAkappa*Sin(phiAk)
      phi=phik - phil + 2*phis - phiu
      phiIl=phil + phis + phiu
      phiIk=phik + 3*phis
      CW=MW/MZ; CW2=CW**2;  SW2=1-CW2;  SW=Sqrt(SW2)
      dv = (2*(dMZ2*MW**4 + MZ2*(2*dZe*MW2*(MW2 - MZ2) 
     &       + dMW2*(-2*MW2 + MZ2))))/(e**2*MZ**4*v)
      dSW= CW2/SW/2D0*(dMZ2/MZ2 - dMW2/MW2)
      dCW=-((dSW*SW)/CW)
      if(MHpmInput) then

       dReAlambda=(sqrt2*(SB*(-(dthd*SB**3)+CB**5*dv*la2*SB*v2+CB*
     &  SB*v*(dMHpm2-CB2**2*dMW2-2*CB2*dMW2*SB2-dMW2*SB2**2+dv*la2*SB**
     &  4*v)-CB**3*(dthu-2*dv*la2*SB**3*v2))*Cos(phil+phis+phiu)+dtad
     &  *Sin(phil+phis+phiu)))/(abslambda*SB*v*vS)

       dImAlambda=(dtad*sqrt2/Cos(phil+phis+phiu))/(abslambda*SB*v*v
     &  S)-dReAlambda*Tan(phil+phis+phiu)

       dImAkappa=(1/cos(phik+3*phis)*(-(dtas*sqrt2)+abslambda*CB*SB*v
     &  *(2*dv*ImAlambda+dImAlambda*v)*Cos(phil+phis+phiu)+2*abskappa*a
     &  bslambda*CB*dv*SB*sqrt2*v*vS*Sin(phik-phil+2*phis-phiu)+2*absla
     &  mbda*CB*dv*ReAlambda*SB*v*Sin(phil+phis+phiu)+abslambda*CB*dReA
     &  lambda*SB*v2*Sin(phil+phis+phiu)))/(abskappa*vs2)

       dReAkappa=0D0
       dMchaH2=dMHpm2
      else
       dReAlambda=0D0
       dReAkappa=0D0
       dMchaH2=CB2**2*dMW2+2*CB2*dMW2*SB2+dMW2*SB2**2+(CB2*dthu)/
     &  (SB*v)+(dthd*SB2)/(CB*v)-CB**4*dv*la2*v-2*CB**2*dv*la2*SB**2*v-
     &  dv*la2*SB**4*v-(dtad*Tan(phil+phis+phiu))/(CB*SB**2*v)

      dImAlambda=(sqrt2*(dtad*Cos(phil+phis+phiu)+SB*(dthd*SB**3-CB
     &  **5*dv*la2*SB*v2+CB*SB*v*(-dMchaH2+CB2**2*dMW2+2*CB2*dMW2*SB2
     &  +dMW2*SB2**2-dv*la2*SB**4*v)+CB**3*(dthu-2*dv*la2*SB**3*v2))*
     &  Sin(phil+phis+phiu)))/(abslambda*SB*v*vS)

       dImAkappa=(sqrt2/Cos(phik+3*phis)*(-(dtas*vS**3)+CB*dtad*v*v
     &  s2+3*abskappa*abslambda*CB*dv*SB*v*vs2**2*Sin(phik-phil+2*phis-
     &  phiu)))/(abskappa*vS**3*vs2)
      endif

c(the basis here is (G, a, as, hd, hu, hs))
       dL3H(1,1,1)=0
       dL3H(1,1,2)=0
       dL3H(1,1,3)=abslambda*CB*dImAlambda*SB*sqrt2*Cos(phiIl)+abslam
     &  bda*CB*dReAlambda*SB*sqrt2*Sin(phiIl)
       dL3H(1,1,4)=(dMZ2*(CB**3-CB*SB2))/v+(dv*(-(CB**3*MZ2)+CB*SB2*(
     &  MZ2+la2*v2)))/v2
       dL3H(1,1,5)=(dMZ2*(-(CB2*SB)+SB**3))/v+(dv*SB*(-(MZ2*SB2)+CB2*
     &  (MZ2+la2*v2)))/v2
       dL3H(1,1,6)=-(abslambda*CB*dReAlambda*SB*sqrt2*Cos(phiIl))+abs
     &  lambda*CB*dImAlambda*SB*sqrt2*Sin(phiIl)
       dL3H(1,2,2)=0
       dL3H(1,2,3)=(abslambda*dImAlambda*(CB2-SB2)*Cos(phiIl))/sqrt2+
     &  (abslambda*dReAlambda*(CB2-SB2)*Sin(phiIl))/sqrt2
       dL3H(1,2,4)=(-2*CB2*dMZ2*SB)/v+CB2*dv*SB*(la2+(2*MZ2)/v2)
       dL3H(1,2,5)=(2*CB*dMZ2*SB2)/v-(CB*dv*SB2*(2*MZ2+la2*v2))/v2
       dL3H(1,2,6)=-((abslambda*dReAlambda*(CB2-SB2)*Cos(phiIl))/sqrt
     &  2)+(abslambda*dImAlambda*(CB2-SB2)*Sin(phiIl))/sqrt2
       dL3H(1,3,3)=0
       dL3H(1,3,4)=(abslambda*dReAlambda*SB*Cos(phiIl))/sqrt2-(abslam
     &  bda*dImAlambda*SB*Sin(phiIl))/sqrt2
       dL3H(1,3,5)=-((abslambda*CB*dReAlambda*Cos(phiIl))/sqrt2)+(abs
     &  lambda*CB*dImAlambda*Sin(phiIl))/sqrt2
       dL3H(1,3,6)=0
       dL3H(1,4,4)=0
       dL3H(1,4,5)=0
       dL3H(1,4,6)=(abslambda*dImAlambda*SB*Cos(phiIl))/sqrt2+(abslam
     &  bda*dReAlambda*SB*Sin(phiIl))/sqrt2
       dL3H(1,5,5)=0
       dL3H(1,5,6)=-((abslambda*CB*dImAlambda*Cos(phiIl))/sqrt2)-(abs
     &  lambda*CB*dReAlambda*Sin(phiIl))/sqrt2
       dL3H(1,6,6)=0
       dL3H(2,2,2)=0
       dL3H(2,2,3)=-(abslambda*CB*dImAlambda*SB*sqrt2*Cos(phiIl))-abs
     &  lambda*CB*dReAlambda*SB*sqrt2*Sin(phiIl)
       dL3H(2,2,4)=(dMZ2*(-CB**3+CB*SB2))/v+(dv*(-(CB*MZ2*SB2)+CB**3*
     &  (MZ2+la2*v2)))/v2
       dL3H(2,2,5)=(dMZ2*SB*(CB2-SB2))/v+(dv*(-(CB2*MZ2*SB)+SB**3*(MZ
     &  2+la2*v2)))/v2
       dL3H(2,2,6)=abslambda*CB*dReAlambda*SB*sqrt2*Cos(phiIl)-abslam
     &  bda*CB*dImAlambda*SB*sqrt2*Sin(phiIl)
       dL3H(2,3,3)=abskappa*abslambda*dv*(CB2+SB2)*Sin(phi)
       dL3H(2,3,4)=(abslambda*CB*dReAlambda*Cos(phiIl))/sqrt2-(abslam
     &  bda*CB*dImAlambda*Sin(phiIl))/sqrt2
       dL3H(2,3,5)=(abslambda*dReAlambda*SB*Cos(phiIl))/sqrt2-(abslam
     &  bda*dImAlambda*SB*Sin(phiIl))/sqrt2
       dL3H(2,3,6)=-(abskappa*abslambda*dv*(CB2+SB2)*Cos(phi))
       dL3H(2,4,4)=0
       dL3H(2,4,5)=0
       dL3H(2,4,6)=(abslambda*CB*dImAlambda*Cos(phiIl))/sqrt2+(abslam
     &  bda*CB*dReAlambda*Sin(phiIl))/sqrt2
       dL3H(2,5,5)=0
       dL3H(2,5,6)=(abslambda*dImAlambda*SB*Cos(phiIl))/sqrt2+(abslam
     &  bda*dReAlambda*SB*Sin(phiIl))/sqrt2
       dL3H(2,6,6)=-(abskappa*abslambda*dv*(CB2+SB2)*Sin(phi))
       dL3H(3,3,3)=abskappa*dImAkappa*sqrt2*Cos(phiIk)+abskappa*dReAk
     &  appa*sqrt2*Sin(phiIk)
       dL3H(3,3,4)=abslambda*dv*(abslambda*CB+abskappa*SB*Cos(phi))
       dL3H(3,3,5)=abslambda*dv*(abslambda*SB+abskappa*CB*Cos(phi))
       dL3H(3,3,6)=-(abskappa*dReAkappa*sqrt2*Cos(phiIk))+abskappa*dI
     &  mAkappa*sqrt2*Sin(phiIk)
       dL3H(3,4,4)=0
       dL3H(3,4,5)=(abslambda*dImAlambda*Cos(phiIl))/sqrt2+(abslambda
     &  *dReAlambda*Sin(phiIl))/sqrt2
       dL3H(3,4,6)=abskappa*abslambda*dv*SB*Sin(phi)
       dL3H(3,5,5)=0
       dL3H(3,5,6)=abskappa*abslambda*CB*dv*Sin(phi)
       dL3H(3,6,6)=-(abskappa*dImAkappa*sqrt2*Cos(phiIk))-abskappa*dR
     &  eAkappa*sqrt2*Sin(phiIk)
       dL3H(4,4,4)=(3*CB*dMZ2)/v-(3*CB*dv*MZ2)/v2
       dL3H(4,4,5)=-((dMZ2*SB)/v)+dv*SB*(la2+MZ2/v2)
       dL3H(4,4,6)=0
       dL3H(4,5,5)=-((CB*dMZ2)/v)+CB*dv*(la2+MZ2/v2)
       dL3H(4,5,6)=-((abslambda*dReAlambda*Cos(phiIl))/sqrt2)+(abslam
     &  bda*dImAlambda*Sin(phiIl))/sqrt2
       dL3H(4,6,6)=abslambda*dv*(abslambda*CB-abskappa*SB*Cos(phi))
       dL3H(5,5,5)=(3*dMZ2*SB)/v-(3*dv*MZ2*SB)/v2
       dL3H(5,5,6)=0
       dL3H(5,6,6)=abslambda*dv*(abslambda*SB-abskappa*CB*Cos(phi))
       dL3H(6,6,6)=abskappa*dReAkappa*sqrt2*Cos(phiIk)-abskappa*dImAk
     &  appa*sqrt2*Sin(phiIk)
       do i=1,6
        do j=i,6
         do k=j,6
         dL3H(k,j,i)=   dL3H(i,j,k)
         dL3H(k,i,j)=   dL3H(i,j,k)
         dL3H(j,k,i)=   dL3H(i,j,k)
         dL3H(j,i,k)=   dL3H(i,j,k)
         dL3H(i,k,j)=   dL3H(i,j,k)
         enddo
        enddo
       enddo
       dMAG(1)=(CB*dthd + dthu*SB )/v
       dMAG(2)=(CB*dthu - dthd*SB)/v
       dMAG(3)=0
       dMAG(4)=(-2*abslambda*CB*SB*vS*(dImAlambda*Cos(phiIl)+dReA
     &  lambda*Sin(phiIl)))/sqrt2
       dMAG(5)=-((abslambda*(CB2-SB2)*vS*(dImAlambda*Cos(phiIl)+d
     &  ReAlambda*Sin(phiIl)))/sqrt2)
       dMAG(6)=0

c counterterm in tree-level mass eigenstates
      do i=1,6
       dMAGM(i)=0D0
       do i1=1,6
       dMAGM(i)=dMAGM(i) + ZH(i,i1)*dMAG(i1)
       enddo
      enddo
      Masshh(1)=Mz;  Masshh(2:6)=Mh(1:5)
       do i=1,6
        do j=1,6
         do k=1,6
         dL3HM(k,j,i)=0D0
       do i1=1,6
        do j1=1,6
         do k1=1,6
       dL3HM(k,j,i)=dL3HM(k,j,i)+ZH(i,i1)*ZH(j,j1)*ZH(k,k1)*dL3H(k1,j1,i1)
         enddo
        enddo
       enddo
c[ nhung change 1/3/2015
                resAG(i,j,k)=-(0,1)*Chhh(j,k,1)*(HSelf(i,1,Masshh(i)**2)
     $               -dMAGM(i))/(-MZ2 + Masshh(i)**2)*(1- MZ2/Masshh(i)
     $               **2)-(0,1)*(Chhh(i,k,1)*(HSelf(j,1,Masshh(j)**2)
     $               -dMAGM(j)))/(-MZ2 + Masshh(j)**2)*(1- MZ2/Masshh(j)
     $               **2)-(0,1)*(Chhh(i,j,1)*(HSelf(k,1,Masshh(k)**2)
     $               -dMAGM(k)))/(-MZ2 + Masshh(k)**2)*(1- MZ2/Masshh(k)
     $               **2)
c end change]
         enddo
        enddo
       enddo

      end      

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine reeffHHH(reHHH,iloop,CPcon)
      implicit none    
      integer i,j,k,iloop,i1,j1,k1
      double precision reHHH(6,6,6),treHHH(6,6,6),SuHHH(6,6,6),
     &                 SuHHH_o(6,6,6)       
      logical CPcon
      double precision ZH5(5,5),ZH(6,6) 
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU 
      double precision Mh1l(5),ZH1l(5,5) 
      double precision MHpm1l
      common /H1loop/ MHpm1l,MH1l,ZH1l
      double precision dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &      dL3HM(6,6,6),OLHHH(6,6,6),reHHHQCD(6,6,6),reHHHATAT(6,6,6)
      double complex resAG(6,6,6)
      common /HHHTL/dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas,
     &                 dL3HM,OLHHH,reHHHQCD,reHHHATAT,resAG            
      call Tree_HHH(treHHH)
c      call CalcTrilCoupl  ! to test with Hanna's code. Both codes are in agreement
      if(iloop.eq.0) then
      call INTHHH(treHHH,suHHH_o,ZH1l)  
      reHHH=suHHH_o
      else                
      if (iloop.eq.1) then
      call INTHHH(treHHH+OLHHH,suHHH_o,ZH1l)        
      reHHH=suHHH_o
      else      
      if(iloop.eq.2) then    
      call INTHHH(treHHH+OLHHH+reHHHQCD,suHHH_o,ZH1l)            
      reHHH=suHHH_o
      else       
      call INTHHH(treHHH+OLHHH+reHHHQCD+reHHHATAT,suHHH_o,ZH1l)         
      reHHH=suHHH_o  
      endif  
      endif       
      endif            
      end
      
      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine INTHHH(CLIN,CLOUT,ZHN)
      implicit none
      integer i,j,k,i1,j1,k1,l  
      double precision ZHN(5,5)

      double precision CLIN(6,6,6),CLOUT(6,6,6)                 
c move from basis (a,as,hd,hu,hs) to tree-level mass basis (h1,h1,h3,h4,h5) using NMSSMCALC convention   
      do i=1,5
      do j=1,5
      do k=1,5
      CLOUT(i,j,k) =0D0
       do i1=1,5
       do j1=1,5
       do k1=1,5
      CLOUT(i,j,k) = CLOUT(i,j,k)+ZHN(i,i1)*ZHN(j,j1)*ZHN(k,k1)*CLIN(i1,j1,k1)
       enddo
       enddo
       enddo
      enddo
      enddo
      enddo 
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
      subroutine ReHHH_at(reHHH)
      implicit none
      integer i,j,k,i1,j1,k1,l,ischeme,izerodv1
      double precision renfin(6,6,6),regfac,ReHHHIN(6,6,6),ReHHH(6,6,6),MHp2
      double precision MW2,MZ2, A0k,pi,ass,ZG(6,6)
      double precision absM3, phiM3      
      double precision Qs
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
     
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision ZH5(5,5),ZH(6,6)
     
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      
      double complex nZU(6,6)
      
      double precision nMSu(6)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      logical CPcon,MHpmInput,onelswitch,mQrun

      double complex IC,ZUN(2,2),AT,la,Ala,ka,Aka,MUE,expETA,expVS,expM3
      common /gluino/ absM3,phiM3      
      common /scale/ Qs
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /nSu/ nMSu,nZU
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch
      IC=dcmplx(0,1D0)
      ZUN(1:2,1:2) = nZU(5:6,5:6)
      MW2=Mw**2; MZ2=Mz**2;MHp2=MHpm**2
      Ala= absAlambda*(cos(phiAl) + IC*Sin(phiAl))
      AT= absAu(3)*(cos(phiAu(3)) + IC*Sin(phiAu(3)))
      la= abslambda*(Cos(phil) + IC*Sin(phil))
      ka= abskappa*(Cos(phik) + IC*Sin(phik))
      Aka=absAkappa*(Cos(phiAk) + IC*Sin(phiAk))
      expvs=(Cos(phis) + IC*Sin(phis))
      expETA=(Cos(phiu) + IC*Sin(phiu))
      MUE=vs*la*expvS/dsqrt(2d0)
      expM3=sqrt((Cos(phiM3) + IC*Sin(phiM3)) )
      pi= 4D0*atan(1D0)
      ass=g3**2/4./pi
      if(mQrun)then
        ischeme=1
      else
        ischeme=3
      endif
#ifdef MATHEMATICAPRINT
      OPEN(16,FILE='slha_test.dat', STATUS= 'UNKNOWN')
#endif      
     
      call trilinearHHH_at(Qs**2,mt,MHp2,v,vS,Tanb,MW2,MZ2,
     -   nMSu(5),nMSu(6),ZUN,AT,MUE,Ala,ka,Aka,expETA,expvS,
     -   ReHHHIN,MQrun,MHpmInput)
c      print*, "ReHHHIN(2,2,2)",ReHHHIN(2,2,2)
c move from basis (hd,hu,hs,ad,au,as) to basis (a,as,hd,hu,hs,G) by rotation matrix ZG
      ZG=0D0
      ZG(1,4)=Sin(beta); ZG(1,5)=Cos(beta); ZG(2,6)=1D0; ZG(3,1)=1D0;
      ZG(4,2)=1D0; ZG(5,3)=1D0; ZG(6,4)=Cos(beta); ZG(6,5)=-Sin(beta)
      do i=1,6
      do j=1,6
      do k=1,6
      reHHH(i,j,k) =0D0
       do i1=1,6
       do j1=1,6
       do k1=1,6
      reHHH(i,j,k) = reHHH(i,j,k)+ZG(i,i1)*ZG(j,j1)*ZG(k,k1)*ReHHHIN(i1,j1,k1)
       enddo
       enddo
       enddo
      enddo
      enddo
      enddo
      end subroutine ReHHH_at
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
      subroutine trilinearHHH_at(Q2N,MTN,MHpm2N,vvN,vSN,TBN,
     -   MW2N,MZ2N,MST1,MST2,ZUN,ATN,MUEN,AlaN,kaN,AKaN,expETAN,expvSN,
     -   reHHHIN,MQrun,MHpmInput)
      implicit none
      integer i,j,l,k,gen2,Gen3,Gen4,Gen5,Gen6,h1,ierror,pole
      double precision reHHHIN(6,6,6),self(6,6),dMH2MT4(6,6),
     .     aTad(6),selfCT(6,6),TadCT(6),CHselfCT,
     .     selfIN(6,6),selfCTIN(6,6),selfINS(6,6),CHSELF,SCH_atat(2,2)

      double precision Q2N,MTN,MSt1,MSt2,MHpm2N,vvN,vSN,TBN,MW2N,MZ2N,
     .     S2B,C2B,dmsq4fin,dmsur4fin

      double complex ATN,ZUN(2,2),MUEN,expETAN,expvSN,dAt4fin
      double complex laN,AlaN,kaN,AKaN
      logical MHpmInput,mQrun
#include "TLMT4.h"
#include "TLMT4lambda.h"

      call couplings_atlambda(Q2N,MTN,MHpm2N,vvN,vSN,TBN, MW2N,MZ2N,MST1,
     -  MST2,ZUN,ATN,MUEN,AlaN,kaN,AKaN,expETAN,expvSN,MHpmInput,ierror,3)
      if(ierror.eq.1)then
      call couplingsEW(Q2N,MTN,MHpm2N,vvN,vSN,TBN,
     -   MW2N,MZ2N,MST1,MST2,ZUN,ATN,MUEN,expETAN,expvSN) 
      endif    
      MassHpm(1)=0D0
      MassHpm(2)=Sqrt(MHpm2N)
      S2B = 2*TB*CB2;          C2B= (CB - SB)*(CB + SB)
      pole=0
 
      call HHH_OL_at(ReHHHIN,pole)
      end
     
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine HHH_OL_CTat(tri1LCTIN,pole)
      implicit none    
      integer i,j,k,i1,j1,k1,pole 
      double precision tadHHSP(6),tadHH(6),tadiH(6),logM1,logM2,logM4,
     -                 logMSQ,M13,M14,pi2,CHself,CHselfSP,CF,xF0,dMW2n,dMZ2n 
      double precision dZe1,dZZH2,dvv1,dSW1,dTanB1, dlambda21,dkappa21, 
     .    dAkappa21,dMHpsq1, dphiy,tri1LCTIN(6,6,6),A0T     
#include "TLMT4.h"
#include "TLMT4lambda.h"
       logM1=Log(M12/Q2); LogM2=Log(M22/Q2);logM4=log(M42/Q2);logMSQ=log(MSQ2/Q2) 
       pi2=pi**2;M13=M1**3;M14=M12**2; A0T1=A0T(M12,Q2)        
       do i=1,6
        tadHHSP(i)=3/16./Pi2*(M22*CSSS(i,1,1) + M42*CSSS(i,2,2) 
     -   - 2*M13*(hy(i) + hyc(i)))
        tadHH(i)=3/16./Pi2*(M22*CSSS(i,1,1) - LogM2*M22*CSSS(i,1,1)
     -  + M42*CSSS(i,2,2) -  LogM4*M42*CSSS(i,2,2)
     -  - 2*M1*(M12 - LogM1*M12)*(hy(i) + hyc(i)))
       enddo

       do i=1,6
        tadiH(i)=0
         do i1=1,6
         if (pole.eq.0)then
         tadiH(i) =tadiH(i)+ZH(i1,i)*tadHH(i1)
         elseif(pole.eq.1)then
         tadiH(i) =tadiH(i)+ZH(i1,i)*tadHHSP(i1)  
         endif       
         enddo
       enddo
       CHselfSP=3/16D0/Pi2*(CS3SSS14*MSQ2 - (4*M14*CB2)/(SB2*vv2) 
     -  +CS3S13S14(1)*CS3S14S13(1) + CS3S13S14(2)*CS3S14S13(2) + 
     -  M22*CS3SSS13(1,1) + M42*CS3SSS13(2,2))       
       CHself=3/16./Pi2*(CS3SSS14*MSQ2 - CS3SSS14*LogMSQ*MSQ2 + 
     - (4*(-1 + LogM1)*M14)/(TB2*vv2) + ((M22 - LogM2*M22 + (-1 + 
     - LogMSQ)*MSQ2)*CS3S13S14(1)*CS3S14S13(1))/(M22 - MSQ2) + 
     - ((M42 - LogM4*M42 + (-1 + LogMSQ)*MSQ2)*
     - CS3S13S14(2)*CS3S14S13(2))/(M42 - MSQ2) + M22*CS3SSS13(1,1)* 
     - (1- LogM2) + M42*CS3SSS13(2,2)*(1 - LogM4))


       dphiy =0;dkappa21=0; dAkappa21=0;
       SW2= SW**2;	CW2=CW**2  
       if (pole.eq.1) then    
         dZZH2 =(-3*M12)/(8.*Pi2*SB2*vv2)
         dMHpsq1= CHselfSP-CB2*MHp2*dZZH2
         dTanB1= (-3*M12)/(16.*CB*Pi2*SB*vv2)
         dMW2n = -3/8.*M12/pi2/vv2
         dMZ2n = -3/8.*M12/pi2/vv2 
         dZe1  = MSQ2*SW2**2/6./pi2/vv2
         dvv1  =-CW2/SW2/2.*(dMW2n - dMZ2n)+1/2.*dMW2n-dZe1*0
         dSW1  = CW2/SW/2.*(dMZ2n - dMW2n)
         dlambda21= -abslambda*(dvv1 + 1/2D0*CB2*dZZH2)
         dvs1     = vs*dvv1 - (vS*SB2)/2D0*dZZH2
       elseif (pole.eq.0) then
         dZZH2 = 0;  dTanB1= 0
         CF    = 3/16D0/pi2/vv2
         dMW2n = -CF*(-M12 + 2*A0T1+ZU(1,1)*ZUC(1,1)*xF0(M22,MSQ2)+
     -      ZU(2,1)*ZUC(2,1)*xF0(M42,MSQ2))
         dMZ2n = -(- 2*CF*M12*Log(M12/Q2) +CF*ZU(1,1)*ZUC(1,1)
     -      *ZU(1,2)*ZUC(1,2)* xF0(M22,M42))
         dMHpsq1= CHself
         dZe1  = 0D0
         dvv1  =-CW2/SW2/2.*(dMW2n - dMZ2n)+1/2.*dMW2n-dZe1*0
         dSW1  = CW2/SW/2.*(dMZ2n - dMW2n)
         dMHpsq1= CHself        
         dlambda21=0
         dvs1     =0
       endif
       tri1LCTIN(1,1,1) = 0D0
       tri1LCTIN(1,1,2) = la2*vv*SB*dZZH2/2D0 + la2*SB*dvv1*vv 
     -  + la2*vv* CB*CB2*dTanB1+ 2* dlambda21*abslambda*vv*SB

       tri1LCTIN(1,1,3) =2* dlambda21*abslambda*vs+ la2*dvs1
       tri1LCTIN(1,1,4) =0D0
       tri1LCTIN(1,1,5) =0D0
       tri1LCTIN(1,1,6) =0D0 

       tri1LCTIN(1,2,2) = la2*vv*CB*dZZH2 + la2*vv*dvv1*CB +
     -  2* dlambda21*abslambda*vv*CB + la2*vv*(-CB2*dTanB1*SB)


       tri1LCTIN(1,2,3) =-((CB*dMHpsq1*SB)/vS)-(CB*dvv1*la2*SB*vv2)/vS
     - - (CB2*dTanB1*(CB2 - SB2)*(2*MHp2 + la2*vv2))/(2.*vS) + 
     -  (dvs1*(2*CB*MHp2*SB - abskappa*abslambda*Cosphiy*vs2 + 
     -   CB*la2*SB*vv2))/(2.*vs2) +dlambda21*(-(abskappa*Cosphiy*vS)/2. 
     - - (abslambda*CB*SB*vv2)/vS) + (CB**3*tadih(2) + SB**3*tadih(1))
     -  /(vS*vv)  -(abslambda*dZZH2*(2*abskappa*Cosphiy*vS + 
     -       (2*CB*SB*(MHp2 - (abskappa*abslambda*Cosphiy*vs2)/(2*SB*CB) 
     -  + (la2*vv2)/2.))/(abslambda*vS)))/4.


       tri1LCTIN(1,2,4)=0D0
       tri1LCTIN(1,2,5)=0D0

       tri1LCTIN(1,2,6)=(-3*abskappa*abslambda*dvs1*Sinphiy)/2. - 
     -  (3*abskappa*dlambda21*Sinphiy*vS)/2. + (tadih(4))/(vS*vv)/SB
     -  +(-3*abskappa*abslambda*dZZH2*Sinphiy*vS)/4.

       tri1LCTIN(1,3,3) =-(abslambda*CB2*dTanB1*(abskappa*CB*Cosphiy 
     - + abslambda*SB)*vv)+abslambda*dvv1*(abslambda*CB-abskappa*Cosphiy 
     -  *SB)*vv + dlambda21*(2*abslambda*CB - abskappa*Cosphiy*SB)*vv 

       tri1LCTIN(1,3,4) =0D0
       tri1LCTIN(1,3,5)= (abskappa*abslambda*dvs1*Sinphiy)/2.+(
     -  abskappa*dlambda21*Sinphiy*vS)/2. + tadih(4)/(vS*vv*SB)+
     -  (abskappa*abslambda*dZZH2*Sinphiy*vS)/4.
       tri1LCTIN(1,3,6)=-(abskappa*abslambda*CB**3*dTanB1*Sinphiy*vv) 
     - - abskappa*dlambda21*SB*Sinphiy*vv - abskappa*abslambda*dvv1*SB
     -  *Sinphiy*vv

       tri1LCTIN(1,4,4) =0D0
       tri1LCTIN(1,4,5) =0D0  
       tri1LCTIN(1,4,6) =0D0  
       tri1LCTIN(1,5,5) = tri1LCTIN(1,2,2)
 
       tri1LCTIN(1,5,6) =-tri1LCTIN(1,2,3)


       tri1LCTIN(1,6,6) =abslambda*CB2*dTanB1*(abskappa*CB*Cosphiy
     - - abslambda*SB)*vv+ abslambda*dvv1*(abslambda*CB+abskappa*Cosphiy
     -  *SB)*vv + dlambda21*(2*abslambda*CB + abskappa*Cosphiy*SB)*vv


       tri1LCTIN(2,2,2) =0D0 
       tri1LCTIN(2,2,3) =  2* dlambda21*abslambda*vs+la2*dvs1+
     -      la2*vs*dZZH2
       tri1LCTIN(2,2,4) =0D0
       tri1LCTIN(2,2,5) =0D0
       tri1LCTIN(2,2,6) =0D0

       tri1LCTIN(2,3,3) =(abslambda*dZZH2*(-(abskappa*CB*Cosphiy) 
     - + abslambda*SB)*vv)/2.+abslambda*dvv1*(-(
     -  abskappa*CB*Cosphiy) + abslambda*SB)*vv + 
     -  abslambda*CB2*dTanB1*(abslambda*CB + abskappa*Cosphiy*SB)*vv+ 
     -  dlambda21*(-(abskappa*CB*Cosphiy*vv) + 2*abslambda*SB*vv)

       tri1LCTIN(2,3,4) =(abskappa*abslambda*dvs1*Sinphiy)/2. 
     -  + (abskappa*dlambda21*Sinphiy*vS)/2. + tadih(4)/(SB*vS*vv)+
     -  (abskappa*abslambda*dZZH2*Sinphiy*vS)/4.
       tri1LCTIN(2,3,5) =0D0
       tri1LCTIN(2,3,6) =-(abskappa*CB*dlambda21*Sinphiy*vv) - 
     -  abskappa*abslambda*CB*dvv1*Sinphiy*vv + abskappa*abslambda*CB2
     -  *dTanB1*SB*Sinphiy*vv-(abskappa*abslambda*CB*dZZH2*Sinphiy*vv)/2.

       tri1LCTIN(2,4,4) =CB**3*dTanB1*la2*vv+2*abslambda*dlambda21*SB*vv
     -   + dvv1*la2*SB*vv+(dZZH2*la2*SB*vv)/2.
       tri1LCTIN(2,4,5) = 0D0 
       tri1LCTIN(2,4,6) =(CB*dMHpsq1*SB)/vS + (CB*dvv1*la2*SB*vv2)/vS 
     -  + (CB2*dTanB1*(CB**4 - SB**4)*(2*MHp2 + la2*vv2))/(2.*vS) - 
     -  (dvs1*(2*CB*MHp2*SB + 3*abskappa*abslambda*Cosphiy*vs2 + 
     -  CB*la2*SB*vv2))/(2.*vs2) + dlambda21*((-3*abskappa*Cosphiy*vS)/2. 
     -+ (abslambda*CB*SB*vv2)/vS) - (SB**3*tadih(1) + CB**3*tadih(2))
     - /(vS*vv)+(dZZH2*(-(abskappa*abslambda*Cosphiy*vS) + (CB*SB*(MHp2 
     - - (abskappa*abslambda*Cosphiy*vs2)/(2*SB*CB) + (la2*vv2)/2.))/vS))/2.
       tri1LCTIN(2,5,5) =0D0 
       tri1LCTIN(2,5,6) =0D0 
       tri1LCTIN(2,6,6) =abslambda*dvv1*(abskappa*CB*Cosphiy + 
     -  abslambda*SB)*vv + dlambda21*(abskappa*CB*Cosphiy + 2*abslambda*SB)*vv + 
     -  abslambda*CB2*dTanB1*(abslambda*CB - abskappa*Cosphiy*SB)*vv 
     - + (abslambda*dZZH2*(abskappa*CB*Cosphiy + abslambda*SB)*vv)/2.


       tri1LCTIN(3,3,3) =(-9*abskappa*CB**3*dTanB1*la2*SB*(CB2 - SB2)*sign2*Sinphiy**2*vv**4)/
     -   (absAkappa*vs2*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2))) - 
     -  (9*abskappa*abslambda*CB2*dlambda21*SB2*sign2*Sinphiy**2*vv**4)/
     -   (absAkappa*vs2*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2))) - 
     -  (18*abskappa*CB2*dvv1*la2*SB2*sign2*Sinphiy**2*vv**4)/
     -   (absAkappa*vs2*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2))) + 
     -  3*abskappa*dvs1*(2*abskappa + (3*CB2*la2*SB2*sign2*Sinphiy**2*vv**4)/
     -      (absAkappa*vS**3*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2)))) + 
     -  (6*abslambda*CB2*SB*sign2*Sinphiy*vv**3*tadih(4))/
     -   (absAkappa*vS**4*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2)))

       tri1LCTIN(3,3,4) =abskappa*abslambda*CB**3*dTanB1*Sinphiy*vv
     -   + abskappa*dlambda21*SB*Sinphiy*vv + abskappa*abslambda*dvv1*SB*Sinphiy*vv

       tri1LCTIN(3,3,5) =abskappa*CB*dlambda21*Sinphiy*vv + abskappa
     -  *abslambda*CB*dvv1*Sinphiy*vv - abskappa*abslambda*CB2*dTanB1*SB*Sinphiy*vv
     -  +(abskappa*abslambda*CB*dZZH2*Sinphiy*vv)/2.

       tri1LCTIN(3,3,6) =(3*abskappa*CB*dlambda21*SB*Sinphiy*vv2)/vS 
     -  + (6*abskappa*abslambda*CB*dvv1*SB*Sinphiy*vv2)/vS + 
     -  (3*abskappa*abslambda*CB2*dTanB1*(CB2 - SB2)*Sinphiy*vv2)/vS 
     -  - (3*abskappa*abslambda*CB*dvs1*SB*Sinphiy*vv2)/vs2 + 
     -  (-2*CB*vv*tadih(4) + 2*vS*tadih(6))/vS**3

       tri1LCTIN(3,4,4) =tri1LCTIN(1,1,3)
       tri1LCTIN(3,4,5) =(CB*dMHpsq1*SB)/vS + (CB*dvv1*la2*SB*vv2)/vS 
     - + (CB2*dTanB1*(CB2 - SB2)*(2*MHp2 + la2*vv2))/(2.*vS) + 
     -  dlambda21*((abskappa*Cosphiy*vS)/2. + (abslambda*CB*SB*vv2)/vS) + 
     -  (dvs1*(abskappa*abslambda*Cosphiy*vs2 - CB*SB*(2*MHp2 + la2*vv2))) 
     -  /(2.*vs2) -(SB**3*tadih(1) + CB**3*tadih(2))/(vS*vv)+
     -  (dZZH2*(abskappa*abslambda*Cosphiy*vS + (CB*SB*(MHp2 
     - - (abskappa*abslambda*Cosphiy*vs2)/(2*SB*CB) + (la2*vv2)/2.))/vS))/2.

       tri1LCTIN(3,4,6) =-(abskappa*abslambda*CB**3*Cosphiy*dTanB1*vv)
     -  -abskappa*Cosphiy*dlambda21*SB*vv-abskappa*abslambda*Cosphiy*dvv1*SB*vv
       tri1LCTIN(3,5,5) =tri1LCTIN(2,2,3)
       tri1LCTIN(3,5,6) =-(abskappa*CB*Cosphiy*dlambda21*vv) 
     -  - abskappa*abslambda*CB*Cosphiy*dvv1*vv + abskappa*abslambda*CB2
     -  *Cosphiy*dTanB1*SB*vv-(abskappa*abslambda*CB*Cosphiy*dZZH2*vv)/2.

       tri1LCTIN(3,6,6) =(9*abskappa*CB**3*dTanB1*la2*SB*(CB2 - SB2)*sign2*Sinphiy**2*vv**4)/
     -   (absAkappa*vs2*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2))) + 
     -  (9*abskappa*abslambda*CB2*dlambda21*SB2*sign2*Sinphiy**2*vv**4)/
     -   (absAkappa*vs2*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2))) + 
     -  (18*abskappa*CB2*dvv1*la2*SB2*sign2*Sinphiy**2*vv**4)/
     -   (absAkappa*vs2*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2))) + 
     -  abskappa*dvs1*(2*abskappa - (9*CB2*la2*SB2*sign2*Sinphiy**2*vv**4)/
     -      (absAkappa*vS**3*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2)))) + 
     -  (6*abslambda*CB*SB*sign2*Sinphiy*vv2*(-(CB*vv*tadih(4)) + vS*tadih(6)))/
     -   (absAkappa*vS**4*Sqrt(2 - (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vs2)))

       do i=4,6
         do j=4,6
           do k=4,6
       tri1LCTIN(k,j,i) =0D0
           enddo
         enddo
       enddo

       tri1LCTIN(4,5,6)= (3*abskappa*abslambda*dvs1*Sinphiy)/2. + 
     -  (3*abskappa*dlambda21*Sinphiy*vS)/2. - tadih(4)/(SB*vS*vv)
     -  +(3*abskappa*abslambda*dZZH2*Sinphiy*vS)/4.
       tri1LCTIN(4,6,6)=-(abskappa*abslambda*CB**3*dTanB1*Sinphiy*vv)
     - - abskappa*dlambda21*SB*Sinphiy*vv - abskappa*abslambda*dvv1*SB*Sinphiy*vv

       tri1LCTIN(5,6,6)=-(abskappa*CB*dlambda21*Sinphiy*vv) - abskappa
     - *abslambda*CB*dvv1*Sinphiy*vv + abskappa*abslambda*CB2*dTanB1*SB*Sinphiy*vv
     -  -(abskappa*abslambda*CB*dZZH2*Sinphiy*vv)/2.

       tri1LCTIN(6,6,6)=(-3*abskappa*CB*dlambda21*SB*Sinphiy*vv2)/vS 
     -  - (6*abskappa*abslambda*CB*dvv1*SB*Sinphiy*vv2)/vS + 
     -  (3*abskappa*abslambda*CB2*dTanB1*(-CB2 + SB2)*Sinphiy*vv2)/vS 
     -  + (3*abskappa*abslambda*CB*dvs1*SB*Sinphiy*vv2)/vs2 + 
     -  (2*CB*vv*Tadih(4) - 2*vS*Tadih(6))/vS**3

       do i=1,6
        do j=i,6
         do k=j,6


       tri1LCTIN(k,j,i)= tri1LCTIN(i,j,k)
       tri1LCTIN(j,k,i)= tri1LCTIN(i,j,k)
       tri1LCTIN(i,k,j)= tri1LCTIN(i,j,k)
       tri1LCTIN(k,i,j)= tri1LCTIN(i,j,k)
       tri1LCTIN(j,i,k)= tri1LCTIN(i,j,k)
         enddo
        enddo
       enddo   
        

#ifdef PRINTTEST  
       print*, "*****one-loop tadpoles interaction states**************"
       print*, tadiH(1),tadiH(2),tadiH(3),tadiH(4),tadiH(5),tadiH(6) 
       print*, "dMW2n,dMZ2n,dvv1,dSW1,dMHpsq1" 
       print*, dMW2n,dMZ2n,dvv1,dSW1,dMHpsq1
       print*, "trilinear couplings 1 loop Counterterms in interaction states"
       print*, "111, 112, 113, 114, 115, 116: ", tri1LCTIN(1,1,1), tri1LCTIN(1,1,2)
     .     , tri1LCTIN(1,1,3), tri1LCTIN(1,1,4), tri1LCTIN(1,1,5), tri1LCTIN(1,1,6)
       print*, 'test 123',-((CB*dMHpsq1*SB)/vs) - (CB*dvv1*la2*SB*vv2)/vs - 
     -  (dZZH2*(2*CB*MHp2*SB + abskappa*abslambda*Cosphiy*vs**2 + CB*la2*SB*vv2))/(4.*vs) - 
     -  (CB2*dTanB1*(CB**4 - SB**4)*(2*MHp2 + la2*(CB2 + SB2)**2*vv2))/(2.*vs) + 
     -  dlambda21*(-(abskappa*Cosphiy*vs)/2. - (abslambda*CB*SB*vv2)/vs) + 
     -  (SB**3*Tadih(1) + CB**3*Tadih(2))/(vs*vv)
       print*, "122, 123, 124, 125, 126: ", tri1LCTIN(1,2,2), tri1LCTIN(1,2,3)
     .     , tri1LCTIN(1,2,4), tri1LCTIN(1,2,5), tri1LCTIN(1,2,6)
       print*, "133, 134, 135, 136: ", tri1LCTIN(1,3,3), tri1LCTIN(1,3,4)
     .     , tri1LCTIN(1,3,5), tri1LCTIN(1,3,6)
       print*, "144, 145, 146: ", tri1LCTIN(1,4,4), tri1LCTIN(1,4,5),tri1LCTIN(1,4,6)
       print*, "155, 156:  ", tri1LCTIN(1,5,5), tri1LCTIN(1,5,6)
       print*,"166:  ", tri1LCTIN(1,6,6)

       print*, "-----------"
       print*,"222, 223, 224, 225, 226:  ",tri1LCTIN(2,2,2),tri1LCTIN(2,2,3),
     .  tri1LCTIN(2,2,4),tri1LCTIN(2,2,5),tri1LCTIN(2,2,6)
       print*,"233,234 235 236: ",tri1LCTIN(2,3,3),tri1LCTIN(2,3,4),tri1LCTIN(2,3,5)
     .   ,tri1LCTIN(2,3,6)
       print*,"244,245,246: ",tri1LCTIN(2,4,4),tri1LCTIN(2,4,5),tri1LCTIN(2,4,6)
       print*,"255,256, 266:  ",tri1LCTIN(2,5,5),tri1LCTIN(2,5,6),tri1LCTIN(2,6,6)
       print*, "-----------"
       print*,"333, 334, 335,336: ",tri1LCTIN(3,3,3),tri1LCTIN(3,3,4),tri1LCTIN(3,3,5)
     .      ,tri1LCTIN(3,3,6)
       print*,"344,345,346:  ",tri1LCTIN(3,4,4),tri1LCTIN(3,4,5),tri1LCTIN(3,4,6)
       print*,"355,356,366:  ",tri1LCTIN(3,5,5),tri1LCTIN(3,5,6),tri1LCTIN(3,6,6)
       print*, "-----------"      
       print*,"444, 445, 446: ",tri1LCTIN(4,4,4),tri1LCTIN(4,4,5),tri1LCTIN(4,4,6)
       print*,"455,456,466:  ",tri1LCTIN(4,5,5),tri1LCTIN(4,5,6),tri1LCTIN(4,6,6)
       print*, "-----------" 
       print*,"555, 556: ",tri1LCTIN(5,5,5),tri1LCTIN(5,5,6)
       print*, "-----------" 
       print*,"666:  ",tri1LCTIN(6,6,6)       
#endif           
      end 
               
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
      subroutine HHH_OL_at(tri1LIN,pole)
      implicit none    
      integer i,j,k,i1,j1,k1,pole,IST6 
      double precision C0T,B0T,tri1LIN(6,6,6),MassHpm2(2),afac,
     &      LambdaOLSP(6,6,6),LambdaOL(6,6,6),tri1LCTIN(6,6,6)
#include "TLMT4.h"
#include "TLMT4lambda.h"

       MassHpm2(1:2)=MassHpm(1:2)**2
       aC0TT3= C0T(M12,M12,M12,Q2)      
       aB0TN1=B0T(M12,M12,Q2)
      do i=1,2
       do j=1,2
        aB0T1(j,i)= B0T(MassSu2(i),MassSu2(j),Q2)
       enddo
      enddo       
      do i=1,2
       do j=1,2
        Do k=1,2
       aC0T(i,j,k)=C0T(MassSu2(i),MassSu2(j),MassSu2(k),Q2)
        enddo
       enddo
      enddo       
       afac=1/16D0/pi**2
       LambdaOLSP(i,j,k)=      0D0  
       LambdaOL(i,j,k)  =      0D0        
      do i=ihiggs,ihiggse
      do j=ihiggs,ihiggse
      do k=ihiggs,ihiggse
      
       LambdaOLSP(i,j,k)=-12*M1*(hy(j)*(hy(k)*hyc(i)+(hy(i)+hyc(i))*
     &  hyc(k))+hyc(j)*(hy(k)*hyc(i)+hy(i)*(hy(k)+hyc(k))))
       LambdaOL(i,j,k)=12*M1*(-(aC0TT3*M12*(hy(i)+hyc(i))*(hy(j)+hyc(j)
     &  )*(hy(k)+hyc(k)))-aB0TN1*(hy(j)*(hy(k)*hyc(i)+(hy(i)+hyc(i))*
     &  hyc(k))+hyc(j)*(hy(k)*hyc(i)+hy(i)*(hy(k)+hyc(k)))))
     
     
#ifdef MATHEMATICAPRINT    
       LambdaOLSP(i,j,k)=       LambdaOLSP(i,j,k)*afac   
       LambdaOL(i,j,k)  =       LambdaOL(i,j,k)*afac  
      Write(16,*) "(*____________________one-loop_________________________*)"       
      Write(16,110) "OneLooph1h1h1[1][Nhung] =(",DBLE(LambdaOLSP(ihiggs,ihiggs,ihiggs)),")/Epsilon +(",
     &   DBLE(LambdaOL(ihiggs,ihiggs,ihiggs)),")" 
       LambdaOLSP(i,j,k)=      0D0  
       LambdaOL(i,j,k)  =      0D0      
#endif
     
       do ISt4=1,2
       do ISt5=1,2
       do ISt6=1,2
       LambdaOL(i,j,k)=3*aC0T(ISt4,ISt5,ISt6)*(CSSS(i,ISt4,ISt5)*
     &  CSSS(j,ISt6,ISt4)*CSSS(k,ISt5,ISt6)+CSSS(i,ISt5,ISt4)*
     &  CSSS(j,ISt4,ISt6)*CSSS(k,ISt6,ISt5))+LambdaOL(i,j,k)
       enddo 
       enddo 
       enddo 
#ifdef MATHEMATICAPRINT 
       LambdaOLSP(i,j,k)=       LambdaOLSP(i,j,k)*afac   
       LambdaOL(i,j,k)  =       LambdaOL(i,j,k)*afac   
        Write(16,110) "OneLooph1h1h1[2][Nhung] =(",DBLE(LambdaOLSP(ihiggs,ihiggs,ihiggs)),")/Epsilon +(",
     &   DBLE(LambdaOL(ihiggs,ihiggs,ihiggs)),")"
       LambdaOLSP(i,j,k)=      0D0  
       LambdaOL(i,j,k)  =      0D0  
#endif

       do ISt4=1,2
       do ISt5=1,2
       LambdaOLSP(i,j,k)=3*(CSSS(k,ISt4,ISt5)*CSSSS(i,j,ISt5,ISt4)+
     &  CSSS(j,ISt4,ISt5)*CSSSS(i,k,ISt5,ISt4)+CSSS(i,ISt4,ISt5)*
     &  CSSSS(j,k,ISt5,ISt4))+LambdaOLSP(i,j,k)
       LambdaOL(i,j,k)=3*aB0T1(ISt4,ISt5)*(CSSS(k,ISt4,ISt5)*
     &  CSSSS(i,j,ISt5,ISt4)+CSSS(j,ISt4,ISt5)*CSSSS(i,k,ISt5,ISt4)+
     &  CSSS(i,ISt4,ISt5)*CSSSS(j,k,ISt5,ISt4))+LambdaOL(i,j,k)
       enddo 
       enddo 
#ifdef MATHEMATICAPRINT  
       LambdaOLSP(i,j,k)=       LambdaOLSP(i,j,k)*afac   
       LambdaOL(i,j,k)  =       LambdaOL(i,j,k)*afac   
        Write(16,110) "OneLooph1h1h1[3][Nhung] =(",DBLE(LambdaOLSP(ihiggs,ihiggs,ihiggs)),")/Epsilon +(",
     &   DBLE(LambdaOL(ihiggs,ihiggs,ihiggs)),")"  
       LambdaOLSP(i,j,k)=      0D0  
       LambdaOL(i,j,k)  =      0D0  
#endif      
       LambdaOLSP(i,j,k)=       LambdaOLSP(i,j,k)*afac   
       LambdaOL(i,j,k)  =       LambdaOL(i,j,k)*afac           
      enddo
      enddo
      enddo

    
c      print*, "tri1L(k,j,i)",tri1L(1,1,1),LambdaOL(1,1,1)
c      stop
c      Write(16,110) "OneLooph1h1h1[sum][Nhung] =",DBLE(LambdaOLSP(ihiggs,ihiggs,ihiggs)),")/Epsilon +(",
c     &   DBLE(LambdaOL(ihiggs,ihiggs,ihiggs)),")" 

       do i=1,6
        do j=1,6
         do k=1,6
         tri1LIN(i,j,k)=0D0
       do i1=1,6
        do j1=1,6
         do k1=1,6   
         if (pole.eq.0)then
         tri1LIN(i,j,k)=tri1LIN(i,j,k)+ZH(i1,i)*ZH(j1,j)*ZH(k1,k)*LambdaOL(i1,j1,k1)    
         elseif (pole.eq.1)then
         tri1LIN(i,j,k)=tri1LIN(i,j,k)+ZH(i1,i)*ZH(j1,j)*ZH(k1,k)*LambdaOLSP(i1,j1,k1)   
         endif                   
       enddo
       enddo
       enddo
      enddo
      enddo
      enddo  
 
#ifdef PRINTTEST      
       print*, "Trilinear[OL][hu,hu,hu]",  tri1LIN(2,2,2) 
       print*, "*****1-looptrilinear couplings in interation state********"
       print*, "111, 112, 113, 114, 115, 116: ", tri1LIN(1,1,1), tri1LIN(1,1,2)
     .     , tri1LIN(1,1,3), tri1LIN(1,1,4), tri1LIN(1,1,5), tri1LIN(1,1,6)
       print*, "122, 123, 124, 125, 126: ", tri1LIN(1,2,2), tri1LIN(1,2,3)
     .     , tri1LIN(1,2,4), tri1LIN(1,2,5), tri1LIN(1,2,6)
       print*, "133, 134, 135, 136: ", tri1LIN(1,3,3), tri1LIN(1,3,4)
     .     , tri1LIN(1,3,5), tri1LIN(1,3,6)
       print*, "144, 145, 146: ", tri1LIN(1,4,4), tri1LIN(1,4,5),tri1LIN(1,4,6)
       print*, "155, 156:  ", tri1LIN(1,5,5), tri1LIN(1,5,6)
       print*,"166:  ", tri1LIN(1,6,6)

       print*, "-------------"
       print*,"222, 223, 224, 225, 226:  ",tri1LIN(2,2,2),tri1LIN(2,2,3),
     .  tri1LIN(2,2,4),tri1LIN(2,2,5),tri1LIN(2,2,6)
       print*,"233,234 235 236: ",tri1LIN(2,3,3),tri1LIN(2,3,4),tri1LIN(2,3,5)
     .   ,tri1LIN(2,3,6)
       print*,"244,245,246: ",tri1LIN(2,4,4),tri1LIN(2,4,5),tri1LIN(2,4,6)
       print*,"255,256, 266:  ",tri1LIN(2,5,5),tri1LIN(2,5,6),tri1LIN(2,6,6)
       print*, "-----------"
       print*,"333, 334, 335,336: ",tri1LIN(3,3,3),tri1LIN(3,3,4),tri1LIN(3,3,5)
     .      ,tri1LIN(3,3,6)
       print*,"344,345,346:  ",tri1LIN(3,4,4),tri1LIN(3,4,5),tri1LIN(3,4,6)
       print*,"355,356,366:  ",tri1LIN(3,5,5),tri1LIN(3,5,6),tri1LIN(3,6,6)
       print*, "-----------"      
       print*,"444, 445, 446: ",tri1LIN(4,4,4),tri1LIN(4,4,5),tri1LIN(4,4,6)
       print*,"455,456,466:  ",tri1LIN(4,5,5),tri1LIN(4,5,6),tri1LIN(4,6,6)
       print*, "-----------" 
       print*,"555, 556: ",tri1LIN(5,5,5),tri1LIN(5,5,6)
       print*, "-----------" 
       print*,"666:  ",tri1LIN(6,6,6)   
#endif     
      call HHH_OL_CTat(tri1LCTIN,pole)
c      print*, ihiggs,ihiggse
c      print*, "One loop [hu,hu,hu]",tri1LIN(2,2,2) ,tri1LCTIN(2,2,2) 
c      Print*, "======================================================"    
      tri1LIN=tri1LIN- tri1LCTIN    !renormalized one-loop trilinear coupling at order alpha_t 
c      Do i=1,6
c         Do j=1,i
c            Do k=1,j
c            Print*, "Nhung 1L",i,j,k,tri1LIN(i,j,k)
c            enddo
c         enddo
c      enddo     
 
110   format(A,F24.14,A,F24.14,A )          
      end   
c**********************************************************************
        subroutine Tree_HHH(treHHH)
        implicit none

        integer i,j,k,i1,j1,k1,sign2
        double precision CoupHHHIN(6,6,6),CoupHHH(6,6,6),TLHHH(6,6,6),
     &                   treHHH(6,6,6),ZG(6,6)  
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta 
         
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta   
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3) 
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)      
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe                
      double precision MW2,MZ2,la2,vv,CB,SB,vs2,vv2,sqrt2,Sinphiy,
     &                   Cosphiy,MHp2
      double complex expeta,expvs,expkap,explam,expAka
      expeta=cos(phiu) + (0,1D0)*sin(phiu)
      expvs =cos(phis) + (0,1D0)*sin(phis)
      expkap=cos(phik) + (0,1D0)*sin(phik)
      explam=cos(phil) + (0,1D0)*sin(phil)
      expAka=cos(phiAk) + (0,1D0)*sin(phiAk)
      cosphiy = DBLE(expeta/expvs**(2)/expkap*explam)
      sinphiy = DIMAG(expeta/expvs**(2)/expkap*explam)   
      sign2 =DBLE(expvs**3*expAka*expkap)/abs(DBLE(expvs**3*expAka*expkap))
              
      MZ2=MZ**2; la2=abslambda**2; vv=v; CB=cos(beta);SB=sin(beta)
      MW2=MW**2;vs2=vs**2;vv2=vv**2;sqrt2=sqrt(2D0);MHp2=MHpm**2

       CoupHHHIN(1,1,1)=(3*CB*MZ2)/vv
       CoupHHHIN(1,1,2)=-((MZ2*SB)/vv)+la2*SB*vv
       CoupHHHIN(1,1,3)=la2*vS
       CoupHHHIN(1,1,4)=0
       CoupHHHIN(1,1,5)=0
       CoupHHHIN(1,1,6)=0
       CoupHHHIN(1,2,1)=-((MZ2*SB)/vv)+la2*SB*vv
       CoupHHHIN(1,2,2)=CB*(-(MZ2/vv)+la2*vv)
       CoupHHHIN(1,2,3)=-(abslambda*(2*abskappa*Cosphiy*vS+(2*CB*SB*(MHp2-
     &  (abskappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*S
     &  B)))/(abslambda*vS)))/2.

       CoupHHHIN(1,2,4)=0
       CoupHHHIN(1,2,5)=0
       CoupHHHIN(1,2,6)=(-3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(1,3,1)=la2*vS
       CoupHHHIN(1,3,2)=-(abslambda*(2*abskappa*Cosphiy*vS+(2*CB*SB*(MHp2-
     &  (abskappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*S
     &  B)))/(abslambda*vS)))/2.
       CoupHHHIN(1,3,3)=abslambda*(abslambda*CB-abskappa*Cosphiy*SB)*vv
       CoupHHHIN(1,3,4)=0
       CoupHHHIN(1,3,5)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(1,3,6)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(1,4,1)=0
       CoupHHHIN(1,4,2)=0
       CoupHHHIN(1,4,3)=0
       CoupHHHIN(1,4,4)=(CB*MZ2)/vv
       CoupHHHIN(1,4,5)=0
       CoupHHHIN(1,4,6)=0
       CoupHHHIN(1,5,1)=0
       CoupHHHIN(1,5,2)=0
       CoupHHHIN(1,5,3)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(1,5,4)=0
       CoupHHHIN(1,5,5)=CB*(-(MZ2/vv)+la2*vv)
       CoupHHHIN(1,5,6)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(1,6,1)=0
       CoupHHHIN(1,6,2)=(-3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(1,6,3)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(1,6,4)=0
       CoupHHHIN(1,6,5)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(1,6,6)=abslambda*(abslambda*CB+abskappa*Cosphiy*SB)*vv
       CoupHHHIN(2,1,1)=-((MZ2*SB)/vv)+la2*SB*vv
       CoupHHHIN(2,1,2)=CB*(-(MZ2/vv)+la2*vv)
       CoupHHHIN(2,1,3)=-(abslambda*(2*abskappa*Cosphiy*vS+(2*CB*SB*(MHp2-
     &  (abskappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*S
     &  B)))/(abslambda*vS)))/2.
       CoupHHHIN(2,1,4)=0
       CoupHHHIN(2,1,5)=0
       CoupHHHIN(2,1,6)=(-3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(2,2,1)=CB*(-(MZ2/vv)+la2*vv)
       CoupHHHIN(2,2,2)=(3*MZ2*SB)/vv
       CoupHHHIN(2,2,3)=la2*vS
       CoupHHHIN(2,2,4)=0
       CoupHHHIN(2,2,5)=0
       CoupHHHIN(2,2,6)=0
       CoupHHHIN(2,3,1)=-(abslambda*(2*abskappa*Cosphiy*vS+(2*CB*SB*(MHp2-
     &  (abskappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*S
     &  B)))/(abslambda*vS)))/2.
       CoupHHHIN(2,3,2)=la2*vS
       CoupHHHIN(2,3,3)=abslambda*(-(abskappa*CB*Cosphiy)+abslambda*SB)*vv
       CoupHHHIN(2,3,4)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(2,3,5)=0
       CoupHHHIN(2,3,6)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(2,4,1)=0
       CoupHHHIN(2,4,2)=0
       CoupHHHIN(2,4,3)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(2,4,4)=-((MZ2*SB)/vv)+la2*SB*vv
       CoupHHHIN(2,4,5)=0
       CoupHHHIN(2,4,6)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(2,5,1)=0
       CoupHHHIN(2,5,2)=0
       CoupHHHIN(2,5,3)=0
       CoupHHHIN(2,5,4)=0
       CoupHHHIN(2,5,5)=(MZ2*SB)/vv
       CoupHHHIN(2,5,6)=0
       CoupHHHIN(2,6,1)=(-3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(2,6,2)=0
       CoupHHHIN(2,6,3)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(2,6,4)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(2,6,5)=0
       CoupHHHIN(2,6,6)=abslambda*(abskappa*CB*Cosphiy+abslambda*SB)*vv
       CoupHHHIN(3,1,1)=la2*vS
       CoupHHHIN(3,1,2)=-(abslambda*(2*abskappa*Cosphiy*vS+(2*CB*SB*(MHp2-
     &  (abskappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*S
     &  B)))/(abslambda*vS)))/2.
       CoupHHHIN(3,1,3)=abslambda*(abslambda*CB-abskappa*Cosphiy*SB)*vv
       CoupHHHIN(3,1,4)=0
       CoupHHHIN(3,1,5)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(3,1,6)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(3,2,1)=-(abslambda*(2*abskappa*Cosphiy*vS+(2*CB*SB*(MHp2-
     &  (abskappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*S
     &  B)))/(abslambda*vS)))/2.
       CoupHHHIN(3,2,2)=la2*vS
       CoupHHHIN(3,2,3)=abslambda*(-(abskappa*CB*Cosphiy)+abslambda*SB)*vv
       CoupHHHIN(3,2,4)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(3,2,5)=0
       CoupHHHIN(3,2,6)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(3,3,1)=abslambda*(abslambda*CB-abskappa*Cosphiy*SB)*vv
       CoupHHHIN(3,3,2)=abslambda*(-(abskappa*CB*Cosphiy)+abslambda*SB)*vv
       CoupHHHIN(3,3,3)=abskappa*(6*abskappa*vS+absAkappa*sign2*sqrt2*Sqrt
     &  (1-(9*abslambda**2*CB**2*SB**2*Sinphiy**2*vs2**2*vv**4)/(2.*abs
     &  Akappa**2*vS**6)))
       CoupHHHIN(3,3,4)=abskappa*abslambda*SB*Sinphiy*vv
       CoupHHHIN(3,3,5)=abskappa*abslambda*CB*Sinphiy*vv
       CoupHHHIN(3,3,6)=(3*abskappa*abslambda*CB*SB*Sinphiy*vs2*vv**2)/vS*
     &  *3
       CoupHHHIN(3,4,1)=0
       CoupHHHIN(3,4,2)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(3,4,3)=abskappa*abslambda*SB*Sinphiy*vv
       CoupHHHIN(3,4,4)=la2*vS
       CoupHHHIN(3,4,5)=abskappa*abslambda*Cosphiy*vS+(CB*SB*(MHp2-(abskap
     &  pa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))/vS
     &  
       CoupHHHIN(3,4,6)=-(abskappa*abslambda*Cosphiy*SB*vv)
       CoupHHHIN(3,5,1)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(3,5,2)=0
       CoupHHHIN(3,5,3)=abskappa*abslambda*CB*Sinphiy*vv
       CoupHHHIN(3,5,4)=abskappa*abslambda*Cosphiy*vS+(CB*SB*(MHp2-(abskap
     &  pa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))/vS
     &  
       CoupHHHIN(3,5,5)=la2*vS
       CoupHHHIN(3,5,6)=-(abskappa*abslambda*CB*Cosphiy*vv)
       CoupHHHIN(3,6,1)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(3,6,2)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(3,6,3)=(3*abskappa*abslambda*CB*SB*Sinphiy*vs2*vv**2)/vS*
     &  *3
       CoupHHHIN(3,6,4)=-(abskappa*abslambda*Cosphiy*SB*vv)
       CoupHHHIN(3,6,5)=-(abskappa*abslambda*CB*Cosphiy*vv)
       CoupHHHIN(3,6,6)=abskappa*(2*abskappa*vS-absAkappa*sign2*sqrt2*Sqrt
     &  (1-(9*abslambda**2*CB**2*SB**2*Sinphiy**2*vs2**2*vv**4)/(2.*abs
     &  Akappa**2*vS**6)))
       CoupHHHIN(4,1,1)=0
       CoupHHHIN(4,1,2)=0
       CoupHHHIN(4,1,3)=0
       CoupHHHIN(4,1,4)=(CB*MZ2)/vv
       CoupHHHIN(4,1,5)=0
       CoupHHHIN(4,1,6)=0
       CoupHHHIN(4,2,1)=0
       CoupHHHIN(4,2,2)=0
       CoupHHHIN(4,2,3)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(4,2,4)=-((MZ2*SB)/vv)+la2*SB*vv
       CoupHHHIN(4,2,5)=0
       CoupHHHIN(4,2,6)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(4,3,1)=0
       CoupHHHIN(4,3,2)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(4,3,3)=abskappa*abslambda*SB*Sinphiy*vv
       CoupHHHIN(4,3,4)=la2*vS
       CoupHHHIN(4,3,5)=abskappa*abslambda*Cosphiy*vS+(CB*SB*(MHp2-(abskap
     &  pa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))/vS
     &  
       CoupHHHIN(4,3,6)=-(abskappa*abslambda*Cosphiy*SB*vv)
       CoupHHHIN(4,4,1)=(CB*MZ2)/vv
       CoupHHHIN(4,4,2)=-((MZ2*SB)/vv)+la2*SB*vv
       CoupHHHIN(4,4,3)=la2*vS
       CoupHHHIN(4,4,4)=0
       CoupHHHIN(4,4,5)=0
       CoupHHHIN(4,4,6)=0
       CoupHHHIN(4,5,1)=0
       CoupHHHIN(4,5,2)=0
       CoupHHHIN(4,5,3)=abskappa*abslambda*Cosphiy*vS+(CB*SB*(MHp2-(abskap
     &  pa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))/vS
     &  
       CoupHHHIN(4,5,4)=0
       CoupHHHIN(4,5,5)=0
       CoupHHHIN(4,5,6)=(3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(4,6,1)=0
       CoupHHHIN(4,6,2)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(4,6,3)=-(abskappa*abslambda*Cosphiy*SB*vv)
       CoupHHHIN(4,6,4)=0
       CoupHHHIN(4,6,5)=(3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(4,6,6)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(5,1,1)=0
       CoupHHHIN(5,1,2)=0
       CoupHHHIN(5,1,3)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(5,1,4)=0
       CoupHHHIN(5,1,5)=CB*(-(MZ2/vv)+la2*vv)
       CoupHHHIN(5,1,6)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(5,2,1)=0
       CoupHHHIN(5,2,2)=0
       CoupHHHIN(5,2,3)=0
       CoupHHHIN(5,2,4)=0
       CoupHHHIN(5,2,5)=(MZ2*SB)/vv
       CoupHHHIN(5,2,6)=0
       CoupHHHIN(5,3,1)=(abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(5,3,2)=0
       CoupHHHIN(5,3,3)=abskappa*abslambda*CB*Sinphiy*vv
       CoupHHHIN(5,3,4)=abskappa*abslambda*Cosphiy*vS+(CB*SB*(MHp2-(abskap
     &  pa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))/vS
     &  
       CoupHHHIN(5,3,5)=la2*vS
       CoupHHHIN(5,3,6)=-(abskappa*abslambda*CB*Cosphiy*vv)
       CoupHHHIN(5,4,1)=0
       CoupHHHIN(5,4,2)=0
       CoupHHHIN(5,4,3)=abskappa*abslambda*Cosphiy*vS+(CB*SB*(MHp2-(abskap
     &  pa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))/vS
     &  
       CoupHHHIN(5,4,4)=0
       CoupHHHIN(5,4,5)=0
       CoupHHHIN(5,4,6)=(3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(5,5,1)=CB*(-(MZ2/vv)+la2*vv)
       CoupHHHIN(5,5,2)=(MZ2*SB)/vv
       CoupHHHIN(5,5,3)=la2*vS
       CoupHHHIN(5,5,4)=0
       CoupHHHIN(5,5,5)=0
       CoupHHHIN(5,5,6)=0
       CoupHHHIN(5,6,1)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(5,6,2)=0
       CoupHHHIN(5,6,3)=-(abskappa*abslambda*CB*Cosphiy*vv)
       CoupHHHIN(5,6,4)=(3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(5,6,5)=0
       CoupHHHIN(5,6,6)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(6,1,1)=0
       CoupHHHIN(6,1,2)=(-3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(6,1,3)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(6,1,4)=0
       CoupHHHIN(6,1,5)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(6,1,6)=abslambda*(abslambda*CB+abskappa*Cosphiy*SB)*vv
       CoupHHHIN(6,2,1)=(-3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(6,2,2)=0
       CoupHHHIN(6,2,3)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(6,2,4)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(6,2,5)=0
       CoupHHHIN(6,2,6)=abslambda*(abskappa*CB*Cosphiy+abslambda*SB)*vv
       CoupHHHIN(6,3,1)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(6,3,2)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(6,3,3)=(3*abskappa*abslambda*CB*SB*Sinphiy*vs2*vv**2)/vS*
     &  *3
       CoupHHHIN(6,3,4)=-(abskappa*abslambda*Cosphiy*SB*vv)
       CoupHHHIN(6,3,5)=-(abskappa*abslambda*CB*Cosphiy*vv)
       CoupHHHIN(6,3,6)=abskappa*(2*abskappa*vS-absAkappa*sign2*sqrt2*Sqrt
     &  (1-(9*abslambda**2*CB**2*SB**2*Sinphiy**2*vs2**2*vv**4)/(2.*abs
     &  Akappa**2*vS**6)))
       CoupHHHIN(6,4,1)=0
       CoupHHHIN(6,4,2)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(6,4,3)=-(abskappa*abslambda*Cosphiy*SB*vv)
       CoupHHHIN(6,4,4)=0
       CoupHHHIN(6,4,5)=(3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(6,4,6)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(6,5,1)=-(abskappa*abslambda*Cosphiy*vS)+(CB*SB*(MHp2-(abs
     &  kappa*abslambda*Cosphiy*vs2+CB*SB*(2*MW2-la2*vv2))/(2.*CB*SB)))
     &  /vS
       CoupHHHIN(6,5,2)=0
       CoupHHHIN(6,5,3)=-(abskappa*abslambda*CB*Cosphiy*vv)
       CoupHHHIN(6,5,4)=(3*abskappa*abslambda*Sinphiy*vS)/2.
       CoupHHHIN(6,5,5)=0
       CoupHHHIN(6,5,6)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(6,6,1)=abslambda*(abslambda*CB+abskappa*Cosphiy*SB)*vv
       CoupHHHIN(6,6,2)=abslambda*(abskappa*CB*Cosphiy+abslambda*SB)*vv
       CoupHHHIN(6,6,3)=abskappa*(2*abskappa*vS-absAkappa*sign2*sqrt2*Sqrt
     &  (1-(9*abslambda**2*CB**2*SB**2*Sinphiy**2*vs2**2*vv**4)/(2.*abs
     &  Akappa**2*vS**6)))
       CoupHHHIN(6,6,4)=-(abskappa*abslambda*SB*Sinphiy*vv)
       CoupHHHIN(6,6,5)=-(abskappa*abslambda*CB*Sinphiy*vv)
       CoupHHHIN(6,6,6)=(-3*abskappa*abslambda*CB*SB*Sinphiy*vs2*vv**2)/vS
     &  **3
     
c move from basis (hd,hu,hs,ad,au,as) to basis (a,as,hd,hu,hs,G) by rotation matrix ZG
c       do i1=1,6
c       do j1=1,i1
c       do k1=1,j1
c       print*, i1,j1,k1,  CoupHHHIN(k1,j1,i1)
c      enddo
c      enddo
c      enddo       
      CoupHHHIN=-CoupHHHIN  ! Nhung's convention
!      print*, "tree [hu,hu,hu]", CoupHHHIN(2,2,2)
      ZG=0D0
      ZG(1,4)=SB; ZG(1,5)=CB; ZG(2,6)=1D0; ZG(3,1)=1D0;
      ZG(4,2)=1D0; ZG(5,3)=1D0; ZG(6,4)=CB; ZG(6,5)=-SB
      do i=1,6
      do j=1,6
      do k=1,6
      treHHH(i,j,k) =0D0
       do i1=1,6
       do j1=1,6
       do k1=1,6
      treHHH(i,j,k) = treHHH(i,j,k)+ZG(i,i1)*ZG(j,j1)*ZG(k,k1)*CoupHHHIN(i1,j1,k1)
       enddo
       enddo
       enddo
      enddo
      enddo
      enddo
      
    
#ifdef treelevelcoupling
       print*, "*****tree-level trilinear couplings in interation state********"
       print*, "111, 112, 113, 114, 115, 116: ", CoupHHHIN(1,1,1), CoupHHHIN(1,1,2)
     .     , CoupHHHIN(1,1,3), CoupHHHIN(1,1,4), CoupHHHIN(1,1,5), CoupHHHIN(1,1,6)
       print*, "122, 123, 124, 125, 126: ", CoupHHHIN(1,2,2), CoupHHHIN(1,2,3)
     .     , CoupHHHIN(1,2,4), CoupHHHIN(1,2,5), CoupHHHIN(1,2,6)
       print*, "133, 134, 135, 136: ", CoupHHHIN(1,3,3), CoupHHHIN(1,3,4)
     .     , CoupHHHIN(1,3,5), CoupHHHIN(1,3,6)
       print*, "144, 145, 146: ", CoupHHHIN(1,4,4), CoupHHHIN(1,4,5),CoupHHHIN(1,4,6)
       print*, "155, 156:  ", CoupHHHIN(1,5,5), CoupHHHIN(1,5,6)
       print*,"166:  ", CoupHHHIN(1,6,6)

       print*, "-------------"
       print*,"222, 223, 224, 225, 226:  ",CoupHHHIN(2,2,2),CoupHHHIN(2,2,3),
     .  CoupHHHIN(2,2,4),CoupHHHIN(2,2,5),CoupHHHIN(2,2,6)
       print*,"233,234 235 236: ",CoupHHHIN(2,3,3),CoupHHHIN(2,3,4),CoupHHHIN(2,3,5)
     .   ,CoupHHHIN(2,3,6)
       print*,"244,245,246: ",CoupHHHIN(2,4,4),CoupHHHIN(2,4,5),CoupHHHIN(2,4,6)
       print*,"255,256, 266:  ",CoupHHHIN(2,5,5),CoupHHHIN(2,5,6),CoupHHHIN(2,6,6)
       print*, "-----------"
       print*,"333, 334, 335,336: ",CoupHHHIN(3,3,3),CoupHHHIN(3,3,4),CoupHHHIN(3,3,5)
     .      ,CoupHHHIN(3,3,6)
       print*,"344,345,346:  ",CoupHHHIN(3,4,4),CoupHHHIN(3,4,5),CoupHHHIN(3,4,6)
       print*,"355,356,366:  ",CoupHHHIN(3,5,5),CoupHHHIN(3,5,6),CoupHHHIN(3,6,6)
       print*, "-----------"      
       print*,"444, 445, 446: ",CoupHHHIN(4,4,4),CoupHHHIN(4,4,5),CoupHHHIN(4,4,6)
       print*,"455,456,466:  ",CoupHHHIN(4,5,5),CoupHHHIN(4,5,6),CoupHHHIN(4,6,6)
       print*, "-----------" 
       print*,"555, 556, 566: ",CoupHHHIN(5,5,5),CoupHHHIN(5,5,6),CoupHHHIN(5,6,6)
       print*, "-----------" 
       print*,"666:  ",CoupHHHIN(6,6,6)  
       print *, "hanna",  -Sqrt(2D0)*absAkappa*abskappa*Sinphiz,
     .   -Sqrt(2D0)*absAkappa*abskappa* DIMAG(kappa/abskappa*Akappa/absAkappa* expvs**3), 
     .   kappa, lambda1, expvs,expeta,Sinphiz,DIMAG(kappa/abskappa*Akappa/absAkappa* expvs**3)
#endif
        end      
