c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine couplingsQCDN(Q2N,asN,mg,MTN,MHpm2N,vvN,vSN,TBN,
     -   MW2N,MZ2N,MST1,MST2,ZUN,ATN,laN,kaN,AkaN,AlaN,expM3N,
     -   expETAN,expvSN,MHpmInput)  
      implicit none
      integer i,j,k,l1,i1,j1
      double precision Q2N,MTN,MSt1,MSt2,MHpm2N,asN,mg,vvN,
     &     vSN,TBN,MW2N,MZ2N
      double precision MZ2,MW2,SW2,CW2,ZP(2,2)
      double complex ATN,ZUN(2,2),expM3N,expETAN,expvSN,dAt4fin
      double complex laN,AlaN,kaN,AKaN,XT
      double precision mah(6),mah2(6),cosphix,cosphiz,
     .         sinphix,sinphiz,MHp2N,RAlambda,
     .         IAlambda,cosk3s,sink3s
      double complex expAka,expAla,expkap,explam,MassH(6,6),
     .         AlaC,ZHN(6,6)  
      logical MHpmInput   
#include "TLQCDN.h"

      pi = 2d0*Asin(1d0)
      ZetaN2= pi**2/6D0
      IC=dcmplx(0,1D0)
      sqrt2= sqrt(2D0)
      ZU(1:2,1:2)=ZUN(1:2,1:2); ZUC=DCONJG(ZU)
      
      Q2=Q2N;vs=vSN;vS2=vS**2
      vv=vvN;vv2= vv**2
      TB=TBN;      TB2= TB**2;	       CB2 = 1/(1 + TB2)
      SB2 = CB2*TB2;	       CB = sqrt(CB2);	SB = CB*TB
      S2B = 2*TB*CB2;          C2B= (CB - SB)*(CB + SB)
      ZP(1,1)=-CB; ZP(1,2)=SB; ZP(2,1)=SB;  ZP(2,2)= CB
            
      expETA=expETAN;expvS=expvSN; expM3=expM3N
      MHp2=MHpm2N;MW2=MW2N;MZ2=MZ2N
      CW2= MW2N/MZ2N; SW2= 1.-CW2; SW=sqrt(SW2);CW=sqrt(CW2)
c      ZH=ZHN


      M1= MTN;    M2= Mst1;   M3= mg;     M4= Mst2;
      M12= M1**2; M22= M2**2; M32= M3**2; M42=M4**2
      ass=asN
      AT=ATN;     
      la=laN; laC= DCONJG(laN);kappa=kaN; Aka=AkaN;Ala=AlaN
      laC=DCONJG(la)
      ATC= DCONJG(AT)     
      MUE=laN*vsN*expvSN/sqrt2; MUEC=DCONJG(MUE)
      MSQ2=-M12 + M22*ZU(1,1)*ZUC(1,1) + M42*ZU(2,1)*ZUC(2,1)
      XT= AT*expETA - laC*VS/expvs/sqrt2/TB             
      MassSu(1)=M2;  MassSu(2)=M4; MassSu2(1)=M22; MassSu2(2)=M42      
      MSQ2=-M12 + M22*ZU(1,1)*DCONJG(ZU(1,1)) + M42*ZU(2,1)*DCONJG(ZU(2,1))  
               
      abslambda = abs(la); la2=abslambda**2;laC=DCONJG(la)
      abskappa=abs(kappa); ka2=abskappa**2
      if (abslambda.gt.1D-10)then
      explam=la/abslambda
      else
      explam=1D0
      endif

      if (abskappa.gt.1D-10)then
      expkap=kappa/abskappa
      else
      expkap=1D0
      endif

      absAkappa=abs(Aka)
      if (absAkappa.gt.1D-10)then
      expAka = Aka/absAkappa
      else
      expAka=1D0
      endif

      cosphiy = DBLE(expETA/expVS**(2)/expkap*explam)
      sinphiy = DIMAG(expETA/expVS**(2)/expkap*explam)
      cosk3s= DBLE(expkap*expVS**3)
      sink3s= DIMAG(expkap*expVS**3)
      sign2 =DBLE(expVS*expAka*expkap)/abs(DBLE(expVS*expAka*expkap))
      if (MHpmInput)then

        MHp2N=MHp2
       
        RAlambda=(-4*abskappa*abslambda*vs**2*cosk3s + 
     -      (4*(MHp2N) + (2*abslambda**2 )*vv2)
     -      * DBLE(expVS*expETA*explam)*S2B)/
     -      (4.*Sqrt2*abslambda*vs)

        IAlambda=(abskappa*vs/DBLE(expVS*expETA*explam)*
     -        DIMAG(expVS**(2)*expkap/explam/expETA))/Sqrt2 
     -       - RAlambda*DIMAG(expVS*expETA*explam)/DBLE(expVS*expETA*explam)  


        Ala=RAlambda +IC*IAlambda 
      sign1 =  DBLE(expETA*expVS*Ala/abs(Ala)*explam)
     -    /abs(DBLE(expETA*expVS*Ala/abs(Ala)*explam))
      else
      sign1 =  DBLE(expETA*expVS*Ala/abs(Ala)*explam)
     -    /abs(DBLE(expETA*expVS*Ala/abs(Ala)*explam))
      sinphix =-((abskappa*Sinphiy*vS)/(abs(Ala)*sqrt2))
      sinphix =-((abskappa*Sinphiy*vS)/(abs(Ala)*sqrt2))
      sinphiz =(abslambda*CB*SB*(abs(Ala)*Sinphix*sqrt2 
     -  - 2*abskappa*Sinphiy*vS)*vv2)/(absAkappa*abskappa*sqrt2*vs2)

      Cosphix = Sign1*Sqrt(1D0- Sinphix**2)
      Cosphiz = Sign2*Sqrt(1D0- Sinphiz**2)

      MHp2N= (Abs(Ala)*abslambda*Cosphix*vS)/(CB*SB*sqrt2)+ 
     -     (abskappa*abslambda*Cosphiy*vs2)/(2.*CB*SB) - (la2*vv2)/2D0

      endif
      MHp2=MHp2N
      AlaC=DCONJG(Ala)
      absAlambda= Abs(Ala)
      if (absAlambda.gt.1D-10)then
      expAla = Ala/absAlambda
      else
      expAla=1D0
      endif
      sqrt1x=  Sqrt(2D0-0*(9*abslambda**2*CB2*SB2*Sinphiy**2*
     -      vv**4)/(absAkappa**2*vS2))
      sqrt2x= Sqrt(2D0 - (ka2*Sinphiy**2*vS2)/absAlambda**2)

      MassH(1,1)=CB2*MZ2 + MHp2*SB2 - MW2*SB2 + (la2*SB2*vv2)/2.
      MassH(1,2)=(CB*SB*(-2*MHp2 + 2*MW2 - 2*MZ2 + la2*vv2))/2.
      MassH(1,3)=-((CB*MHp2*SB2*vv)/vS) + (CB*MW2*SB2*vv)/vS  
     -  + CB*la2*vS*vv -(abskappa*abslambda*Cosphiy*SB*vS*vv)/2.
     -  - (CB*la2*SB2*vv**3)/(2.*vS)


      MassH(1,4)=0D0;
      MassH(1,5)=(-3*abskappa*abslambda*SB*Sinphiy*vS*vv)/2.
      MassH(1,6)=0D0
      MassH(2,2)=CB2*MHp2 - CB2*MW2+MZ2*SB2+(CB2*la2*vv2)/2.
      MassH(2,3)= -((CB2*MHp2*SB*vv)/vS) + (CB2*MW2*SB*vv)/vS - 
     -  (abskappa*abslambda*CB*Cosphiy*vS*vv)/2. + 
     -  la2*SB*vS*vv - (CB2*la2*SB*vv**3)/(2.*vS)
      MassH(2,4)=0D0
      MassH(2,5)=(-3*abskappa*abslambda*CB*Sinphiy*vS*vv)/2.
      MassH(2,6)=0D0
      MassH(3,3)=2*ka2*vs2 + (CB2*la2*SB2*vv**4)/(2.*vS2) + 
     -  (absAkappa*abskappa*sign2*vS*Sqrt(1D0 - 
     -  (9*CB2*la2*SB2*Sinphiy**2*vv**4)/(2.*absAkappa**2*vS2)))/sqrt2- 
     -  (abskappa*abslambda*CB*Cosphiy*SB*vv2)/2. + 
     -  (CB2*MHp2*SB2*vv2)/vS2 - (CB2*MW2*SB2*vv2)/vS2
      MassH(3,4)=(abskappa*abslambda*Sinphiy*vS*vv)/2.
      MassH(3,5)=2*abskappa*abslambda*CB*SB*Sinphiy*vv2
      MassH(3,6)=0D0
c      CW2= MW2/MZ2; SW2= 1-CW2
      MassH(4,4)=(2*MHp2 - 2*MW2 + la2*vv2)/2.

      MassH(4,5)= (vv*(-3*abskappa*abslambda*Cosphiy*vS**2 + 
     -      CB**3*SB*(2*MHp2 - 2*MW2 + la2*vv**2) + CB*SB**3*
     -     (2*MHp2 - 2*MW2 + la2*vv**2)))/(2.*vS)
      MassH(4,6)=0D0
      MassH(5,5)=(-3*absAkappa*abskappa*sign2*vS*vS2*
     -     Sqrt(4 - (18*CB2*la2*SB2*Sinphiy**2*vv**4)/(absAkappa**2*vS2)) + 
     -    3*abskappa*abslambda*CB*Cosphiy*SB*sqrt2*vS2*vv2 + 
     -    CB2*SB2*sqrt2*(la2*vv**4 + 2*(MHp2 - MW2)*vv2))/(2.*sqrt2*vS2)
      MassH(5,6)=0D0
      MassH(6,6)=0D0        
      MassH(2,1)=MassH(1,2)
      MassH(3,1)=MassH(1,3)
      MassH(3,2)=MassH(2,3)
      MassH(4,1)=MassH(1,4)
      MassH(4,2)=MassH(2,4)
      MassH(4,3)=MassH(3,4)
      MassH(5,1)=MassH(1,5)
      MassH(5,2)=MassH(2,5)
      MassH(5,3)=MassH(3,5)
      MassH(5,4)=MassH(4,5)
      MassH(6,1)=MassH(1,6)
      MassH(6,2)=MassH(2,6)
      MassH(6,3)=MassH(3,6)
      MassH(6,4)=MassH(4,6)
      MassH(6,5)=MassH(5,6)
      call HEIgensystem(5, MassH(1:5,1:5),5, Mah2(1:5), ZHN(1:5,1:5),5, 1)
      do i=1,5
        if (mah2(i).lt.0D0 .or. mah2(i).ne.mah2(i) ) then
        print*, '* Warning!! Negative or NAN Higgs mass Eigenvalues!!'
        print*, "MH[",i,"]^2=",mah2(i)   
        stop
        else 
        Mah(i) = Sqrt(mah2(i))
        endif
      enddo

        Mah(6)=0  
      do i=1,5
        ZHN(i,6)=ZHN(i,5)
        ZHN(i,5)= CB*ZHN(i,4)
        ZHN(i,4)= SB*ZHN(i,4)
      enddo
        ZHN(6,6)=0; ZHN(6,5)=-SB; ZHN(6,4)= CB
        ZH(1:6,1:6)=DBLE(ZHN(1:6,1:6))

 
c         print*,"ZH", ZH
c         print*, "mah",mah

      do k=1,2
       do j=1,2
         do i=1,6
         CSSS(i,j,k)=ZH(i,5)*(AT*expETA*IC*ZU(k,2)*ZUC(j,1) - 
     -   (IC*ATC*ZU(k,1)*ZUC(j,2))/expETA) + 
     -   vv*ZH(i,3)*(-((CB*laC*ZU(k,2)*ZUC(j,1))/(expVS*sqrt2)) -
     -   (CB*expVS*la*ZU(k,1)*ZUC(j,2))/sqrt2) + 
     -   vv*ZH(i,6)*((CB*IC*laC*ZU(k,2)*ZUC(j,1))/(expVS*sqrt2) - 
     -   (IC*CB*expVS*la*ZU(k,1)*ZUC(j,2))/sqrt2) + 
     -   ZH(i,1)*(-((MUEC*ZU(k,2)*ZUC(j,1))) - 
     -   (MUE*ZU(k,1)*ZUC(j,2))) + 
     -   ZH(i,4)*((IC*MUEC*ZU(k,2)*ZUC(j,1)) - 
     -   (IC*MUE*ZU(k,1)*ZUC(j,2))) + 
     -   ZH(i,2)*(AT*expETA*ZU(k,2)*ZUC(j,1) +(ATC*ZU(k,1)*ZUC(j,2))
     -   /expETA + M1*(2*ZU(k,1)*ZUC(j,1) + 2*ZU(k,2)*ZUC(j,2)))
         CSSS(i,j,k)=CSSS(i,j,k)*M1/vv/SB
         enddo
        enddo
      enddo

      do i =1,6
        hy(i)=(M1*(ZH(i,2) + IC*ZH(i,5)))/(SB*vv)
        hyc(i)=(M1*(ZH(i,2) - IC*ZH(i,5)))/(SB*vv)
      enddo

      do k=1,2
        do l1=1,2
         do j=1,6
          do i=1,6
        CSSSS(i,j,l1,k)=ZH(i,3)*(-((laC*(ZH(j,1) - IC*ZH(j,4))*
     -  ZU(k,2)*ZUC(l1,1))/(expVS*sqrt2)) - (expVS*la*(ZH(j,1) + 
     -  IC*ZH(j,4))*ZU(k,1)*ZUC(l1,2))/sqrt2) + ZH(i,6)*
     -  (-((laC*((-IC)*ZH(j,1) - ZH(j,4))*ZU(k,2)*ZUC(l1,1))/
     -  (expVS*sqrt2)) - (IC*expVS*la*(ZH(j,1) + IC*ZH(j,4))*ZU(k,1)*
     -  ZUC(l1,2))/sqrt2) + ZH(i,1)*(-((laC*(ZH(j,3) 
     -  - IC*ZH(j,6))*ZU(k,2)*ZUC(l1,1))/(expVS*sqrt2)) - 
     -  (expVS*la*(ZH(j,3) + IC*ZH(j,6))*ZU(k,1)*ZUC(l1,2))/sqrt2) + 
     -  ZH(i,4)*((IC*laC*(ZH(j,3) - IC*ZH(j,6))*ZU(k,2)*ZUC(l1,1))/
     -  (expVS*sqrt2) - (IC*expVS*la*(ZH(j,3) + IC*ZH(j,6))*ZU(k,1)*
     -  ZUC(l1,2))/sqrt2) + M1*ZH(i,2)*((2*ZH(j,2)*ZU(k,1)*ZUC(l1,1))
     -  /(SB*vv) + (2*ZH(j,2)*ZU(k,2)*ZUC(l1,2))/(SB*vv)) + 
     -  M1*ZH(i,5)*((2*ZH(j,5)*ZU(k,1)*ZUC(l1,1))/(SB*vv) + 
     -  (2*ZH(j,5)*ZU(k,2)*ZUC(l1,2))/(SB*vv))
        CSSSS(i,j,l1,k)=CSSSS(i,j,l1,k)*M1/vv/SB
            enddo   
          enddo
        enddo
       enddo 
       
       do k=1,2
        do l1=1,2
         do j=1,2
          do i=1,2
           CS13S13S13S13p1(i,j,l1,k)=(ZU(k,2)*(2*ZU(l1,2)*ZUC(i,2)* 
     -    ZUC(j,2)+ZU(l1,1)*(ZUC(i,2)*ZUC(j,1) - 3*ZUC(i,1)*ZUC(j,2)))+ 
     -    ZU(k,1)*(2*ZU(l1,1)*ZUC(i,1)*ZUC(j,1) +ZU(l1,2)*(-3*ZUC(i,2)* 
     -    ZUC(j,1) + ZUC(i,1)*ZUC(j,2))))/6.

           CS13S13S13S13p2(i,j,l1,k)=(ZU(k,1)*(2*ZU(l1,1)*ZUC(i,1)* 
     -     ZUC(j,1) +ZU(l1,2)*(ZUC(i,2)*ZUC(j,1)- 3*ZUC(i,1)*ZUC(j,2)))+ 
     -     ZU(k,2)*(2*ZU(l1,2)*ZUC(i,2)*ZUC(j,2) + 
     -     ZU(l1,1)*(-3*ZUC(i,2)*ZUC(j,1) + ZUC(i,1)*ZUC(j,2))))/6.

            enddo   
          enddo
        enddo
       enddo  
       do j=1,2
        do i=1,2
         CS14S13S14S13p1(i,j)= (ZU(j,1)*ZUC(i,1)-ZU(j,2)*ZUC(i,2))/2.
         CS14S13S14S13p2(i,j)=(-(ZU(j,1)*ZUC(i,1))+ZU(j,2)*ZUC(i,2))/6.
        enddo
       enddo  
       CS14S14S14S14p1=1/3.;    CS14S14S14S14p2=1/3.     

       do j=1,2
        CS3S13S14(j)=-((M12*sqrt2*ZUC(j,1))/(TB*vv)) -(ATC*M1*sqrt2*
     .  ZUC(j,2))/(expETA*TB*vv) - (expVS*la*M1*vS*ZUC(j,2))/vv

        CS3S14S13(j)=-((M12*sqrt2*ZU(j,1))/(TB*vv)) -(AT*expETA*M1* 
     .  sqrt2*ZU(j,2))/(TB*vv) - (laC*M1*vS*ZU(j,2))/(expVS*vv)
     
       CS3S13S14N(1,j)=-((M1**2*sqrt2*ZUC(j,1))/vv)-(ATC*M1*sqrt2*
     &  ZUC(j,2))/(expETA*vv)+(CB*M1*MUE*sqrt2*ZUC(j,2))/(SB*vv)
       CS3S13S14N(2,j)=-((CB*M1**2*sqrt2*ZUC(j,1))/(SB*vv))-(M1*MUE*
     &  sqrt2*ZUC(j,2))/vv-(ATC*CB*M1*sqrt2*ZUC(j,2))/(expETA*SB*vv)

       CS3S14S13N(1,j)=-((M1**2*sqrt2*ZU(j,1))/vv)-(AT*expETA*M1*sqrt2*
     &  ZU(j,2))/vv+(CB*M1*MUEC*sqrt2*ZU(j,2))/(SB*vv)
     
       CS3S14S13N(2,j)=-((CB*M1**2*sqrt2*ZU(j,1))/(SB*vv))-(M1*MUEC*
     &  sqrt2*ZU(j,2))/vv-(AT*CB*expETA*M1*sqrt2*ZU(j,2))/(SB*vv)
     
     
        do i=1,2
         CS3SSS13(i,j)=(2*M12*ZU(j,2)*ZUC(i,2))/(TB2*vv**2)
         CS3S13SC(i,j)=DCONJG(CS3S13S(i,j))
        enddo
       enddo
       
       do j=1,2
       do k=1,2
       CS3S3S13S13(1,1,j,k)=(2*M12*ZU(k,2)*ZUC(j,2))/vv**2
       CS3S3S13S13(1,2,j,k)=(2*CB*M12*ZU(k,2)*ZUC(j,2))/(SB*vv**2)
       CS3S3S13S13(2,1,j,k)=(2*CB*M12*ZU(k,2)*ZUC(j,2))/(SB*vv**2)
       CS3S3S13S13(2,2,j,k)=(2*CB**2*M12*ZU(k,2)*ZUC(j,2))/(SB**2*vv**2)
       enddo
       enddo
       CS3S3S13S13C=DCONJG(CS3S3S13S13)

      CS3SSS14 = (2*M12)/(TB2*vv**2)
      CS3S3S14S14(2,2) = CS3SSS14
      CS3S3S14S14(2,1) = (2*CB*M12)/(SB*vv**2)
      CS3S3S14S14(1,2) =       CS3S3S14S14(2,1)
      CS3S3S14S14(1,1) = (2*M12)/vv**2

      CTBS3R   =-(sqrt2/(sqrt(expETA)*vv))* M1/TB
      CTBS3(2)= -(sqrt2/(sqrt(expETA)*vv))* M1/TB
      CTBS3C(2)= DCONJG(CTBS3(2))
      CTBS3(1)= -sqrt2*M1/vv/sqrt(expETA)
      CTBS3C(1)=DCONJG(CTBS3(1))
c !note sqrt(expeta) must be set to one in the gluino couplings 
c  to check with the old code 
         do i=1,2
          CF15F3S13L(i)= 1/expM3*ZU(i,1)/sqrt2/sqrt(expeta)
          CF15F3S13LC(i)= DCONJG(CF15F3S13L(i))         
          CF15F3S13R(i)= sqrt(expeta)*expM3*ZU(i,2)/sqrt2
          CF15F3S13RC(i)=DCONJG(CF15F3S13R(i))
         enddo   
          CLFGBSB= 1./sqrt2/expM3   
          CLFGBSBC= 1./sqrt2*expM3  
c gauge boson couplings
      do i=1,2
        CS14S13V3(i)=ZU(i,1)/SW/sqrt2
      enddo

		CF4F3V3=1D0/sqrt2/SW/Sqrt(expeta)

	    CS14S14V3V3=-1/(2.*SW2)

        do i=1,2
        do j=1,2
       CS13S13V3V3(i,j)=-(ZU(j,1)*ZUC(i,1))/(2.*SW**2)
        enddo
        enddo

        do i=1,2
        do j=1,2
       CS13S13V2(i,j)=((3*CW**2-SW**2)*ZU(j,1)*ZUC(i,1)-4*SW**2*ZU(j,2)
     &  *ZUC(i,2))/(6.*CW*SW)
        enddo
        enddo

       CS14S14V2=-CW/(2.*SW)-SW/(6.*CW)

        do i=1,2
        do j=1,2
       CS13S13V2V2(i,j)=(-((3-4*SW**2)**2*ZU(j,1)*ZUC(i,1))-16*SW**4*
     &  ZU(j,2)*ZUC(i,2))/(18.*CW**2*SW**2)
        enddo
        enddo
       CS14S14V2V2=-(3-2*SW**2)**2/(18.*CW**2*SW**2)


       CS14S14V5V2=-((3*CW**2 + SW**2))/(6.*CW*SW)
       do i=1,2
       CS13S14V5V3(i)= ZUC(i,1)/sqrt2/SW
       enddo
       do i=1,2
       do j=1,2
       CS13S13V5V2(i,j)=((3*CW**2-SW**2)*(ZUC(i,1))*ZU(j,1) - 4*SW**2*(ZUC(i,2))*ZU(j,2))/(6.*CW*SW)
       enddo
       enddo
c gauge boson couplings          
          
c#define printQCD                    
#ifdef printQCD

      write(*,*) "*************** QCD Spectrum *********************"
      Write(*,*)'Mh1=',mah(1)
      Write(*,*)'Mh2=',mah(2)
      Write(*,*)'Mh3=',mah(3)
      Write(*,*)'Mh4=',mah(4)
      Write(*,*)'Mh5=',mah(5)
      Write(*,*)'Goldstone boson Mh6=',mah(6)
      Write(*,*) "ZHHN(1,i), i=1,6",ZHN(1,1),ZHN(1,2),ZHN(1,3),ZHN(1,4),ZHN(1,5),ZHN(1,6)
      Write(*,*)"ZHN(2,i), i=1,6",ZHN(2,1),ZHN(2,2),ZHN(2,3),ZHN(2,4),ZHN(2,5),ZHN(2,6)
      Write(*,*)"ZHN(3,i), i=1,6",ZHN(3,1),ZHN(3,2),ZHN(3,3),ZHN(3,4),ZHN(3,5),ZHN(3,6)
      Write(*,*) "ZHN(4,i), i=1,6",ZHN(4,1),ZHN(4,2),ZHN(4,3),ZHN(4,4),ZHN(4,5),ZHN(4,6)
      Write(*,*)"ZHN(5,i), i=1,6",ZHN(5,1),ZHN(5,2),ZHN(5,3),ZHN(5,4),ZHN(5,5),ZHN(5,6)
      Write(*,*) "ZHN(6,i), i=1,6",ZHN(6,1),ZHN(6,2),ZHN(6,3),ZHN(6,4),ZHN(6,5),ZHN(6,6)       
      write(*,*) "M1,M2,M3,M4, MSQ2",M1,M2,M3,M4, MSQ2 
      write(*,*) "ZUN,sqrt2",ZU, sqrt2
      write(*,*) "MUE,MUEC,AT,ATC,la,lac" ,MUE,MUEC,AT,ATC,la,lac
      write(*,*) "expM3,expETA,expvs",expM3,expETA,expvs
      write(*,*) "TB, vv,CB,SB,IC",TB, vv,CB,SB,IC
      write(*,*) ""
      write(*,*) '1)  1 Higgs i two stop j,k couplings, CSSS(i,j,k)'
      write(*,*) 'CSSS(1,1,1),CSSS(1,1,2),CSSS(1,2,1),CSSS(1,2,2)',CSSS(1,1,1),CSSS(1,1,2),CSSS(1,2,1),CSSS(1,2,2)
      write(*,*) 'CSSS(4,1,1),CSSS(4,1,2),CSSS(4,2,1),CSSS(4,2,2)',CSSS(4,1,1),CSSS(4,1,2),CSSS(4,2,1),CSSS(4,2,2)
      write(*,*) 'CSSS(5,1,1),CSSS(5,1,2),CSSS(5,2,1),CSSS(5,2,2)',CSSS(5,1,1),CSSS(5,1,2),CSSS(5,2,1),CSSS(5,2,2)
      write(*,*) '---------------------------------------------------------'
      write(*,*) '2)  2 Higgs i,j  two stop l,k couplings, CSSSS(i,j,l,k)'
      write(*,*) "CSSSS(1,1,1,1),CSSSS(1,1,1,2)",CSSSS(1,1,1,1),CSSSS(1,1,1,2)
      write(*,*) "CSSSS(1,1,2,1),CSSSS(1,1,2,2)",CSSSS(1,1,2,1),CSSSS(1,1,2,2)
      write(*,*) "CSSSS(1,2,1,1),CSSSS(1,2,1,2)",CSSSS(1,2,1,1),CSSSS(1,2,1,2)
      write(*,*) "CSSSS(1,2,2,1),CSSSS(1,2,2,2)",CSSSS(1,2,2,1),CSSSS(1,2,2,2)

      write(*,*) "CSSSS(4,4,1,1),CSSSS(4,4,1,2)",CSSSS(4,4,1,1),CSSSS(4,4,1,2)
      write(*,*) "CSSSS(4,4,2,1),CSSSS(4,4,2,2)",CSSSS(4,4,2,1),CSSSS(4,4,2,2)
      write(*,*) "CSSSS(4,5,1,1),CSSSS(4,5,1,2)",CSSSS(4,5,1,1),CSSSS(4,5,1,2)
      write(*,*) "CSSSS(4,5,2,1),CSSSS(4,5,2,2)",CSSSS(4,5,2,1),CSSSS(4,5,2,2)


      write(*,*) '---------------------------------------------------------'

      write(*,*) '4)   4 stop, CS13S13S13S13MT4(i,j,k,l)' 
      write(*,*) 'CS13S13S13S13MT4(1,1,1,1)',CS13S13S13S13p1(1,1,1,1)
      write(*,*) 'CS13S13S13S13MT4(1,1,1,2)',CS13S13S13S13p1(1,1,1,2)
      write(*,*) 'CS13S13S13S13MT4(1,1,2,2)',CS13S13S13S13p1(1,1,2,2)
      write(*,*) 'CS13S13S13S13MT4(1,2,2,2)',CS13S13S13S13p1(1,2,2,2)
      write(*,*) 'CS13S13S13S13MT4(2,2,2,2)',CS13S13S13S13p1(2,2,2,2)
      write(*,*) 'CS13S13S13S13MT4(1,2,1,2)',CS13S13S13S13p1(1,2,1,2)
      write(*,*) '---------------------------------------------------------'
      write(*,*) '5)   2 stop, 2 sbottom, CS14S13S14S13MT4(i,j)' 
      write(*,*) 'CS14S13S14S13MT4(1,1)',CS14S13S14S13p1(1,1)
      write(*,*) 'CS14S13S14S13MT4(1,2)',CS14S13S14S13p1(1,2)
      write(*,*) 'CS14S13S14S13MT4(2,2)',CS14S13S14S13p1(2,2)
      write(*,*) '---------------------------------------------------------'
      write(*,*) '11) charged Higgs i, stop j, sbottom, CS3S13S(i,j)'
      write(*,*) 'CS3S13S(1,1),CS3S13S(1,2)',CS3S13S(1,1),CS3S13S(1,2)
      write(*,*) 'CS3S13S(2,1),CS3S13S(2,2)',CS3S13S(2,1),CS3S13S(2,2)

      write(*,*) '---------------------------------------------------------'
      write(*,*) '12) charged Higgs i, top bottom CTBS3(i)'
      write(*,*) 'CTBS3(1),CTBS3(2)',CTBS3(1),CTBS3(2)
      
#endif      
      
      end 
      

c**********************************************************************
      subroutine TLcouplings_QCD
      implicit none
      integer i,j,k,l1,i1,j1
#include "TLQCDN.h"


      ZUC= DCONJG(ZU)
      laC=DCONJG(la)
      ATC= DCONJG(AT)
      MUEC=DCONJG(MUE)

      do k=1,2
       do j=1,2
         do i=1,6
         CSSS(i,j,k)=ZH(i,5)*(AT*expETA*IC*ZU(k,2)*ZUC(j,1) - 
     -   (IC*ATC*ZU(k,1)*ZUC(j,2))/expETA) + 
     -   vv*ZH(i,3)*(-((CB*laC*ZU(k,2)*ZUC(j,1))/(expVS*sqrt2)) -
     -   (CB*expVS*la*ZU(k,1)*ZUC(j,2))/sqrt2) + 
     -   vv*ZH(i,6)*((CB*IC*laC*ZU(k,2)*ZUC(j,1))/(expVS*sqrt2) - 
     -   (IC*CB*expVS*la*ZU(k,1)*ZUC(j,2))/sqrt2) + 
     -   ZH(i,1)*(-((MUEC*ZU(k,2)*ZUC(j,1))) - 
     -   (MUE*ZU(k,1)*ZUC(j,2))) + 
     -   ZH(i,4)*((IC*MUEC*ZU(k,2)*ZUC(j,1)) - 
     -   (IC*MUE*ZU(k,1)*ZUC(j,2))) + 
     -   ZH(i,2)*(AT*expETA*ZU(k,2)*ZUC(j,1) +(ATC*ZU(k,1)*ZUC(j,2))
     -   /expETA + M1*(2*ZU(k,1)*ZUC(j,1) + 2*ZU(k,2)*ZUC(j,2)))
         CSSS(i,j,k)=CSSS(i,j,k)*M1/vv/SB
         enddo
        enddo
      enddo

      do i =1,6
        hy(i)=(M1*(ZH(i,2) + IC*ZH(i,5)))/(SB*vv)
        hyc(i)=(M1*(ZH(i,2) - IC*ZH(i,5)))/(SB*vv)
      enddo

      do k=1,2
        do l1=1,2
         do j=1,6
          do i=1,6
        CSSSS(i,j,l1,k)=ZH(i,3)*(-((laC*(ZH(j,1) - IC*ZH(j,4))*
     -  ZU(k,2)*ZUC(l1,1))/(expVS*sqrt2)) - (expVS*la*(ZH(j,1) + 
     -  IC*ZH(j,4))*ZU(k,1)*ZUC(l1,2))/sqrt2) + ZH(i,6)*
     -  (-((laC*((-IC)*ZH(j,1) - ZH(j,4))*ZU(k,2)*ZUC(l1,1))/
     -  (expVS*sqrt2)) - (IC*expVS*la*(ZH(j,1) + IC*ZH(j,4))*ZU(k,1)*
     -  ZUC(l1,2))/sqrt2) + ZH(i,1)*(-((laC*(ZH(j,3) 
     -  - IC*ZH(j,6))*ZU(k,2)*ZUC(l1,1))/(expVS*sqrt2)) - 
     -  (expVS*la*(ZH(j,3) + IC*ZH(j,6))*ZU(k,1)*ZUC(l1,2))/sqrt2) + 
     -  ZH(i,4)*((IC*laC*(ZH(j,3) - IC*ZH(j,6))*ZU(k,2)*ZUC(l1,1))/
     -  (expVS*sqrt2) - (IC*expVS*la*(ZH(j,3) + IC*ZH(j,6))*ZU(k,1)*
     -  ZUC(l1,2))/sqrt2) + M1*ZH(i,2)*((2*ZH(j,2)*ZU(k,1)*ZUC(l1,1))
     -  /(SB*vv) + (2*ZH(j,2)*ZU(k,2)*ZUC(l1,2))/(SB*vv)) + 
     -  M1*ZH(i,5)*((2*ZH(j,5)*ZU(k,1)*ZUC(l1,1))/(SB*vv) + 
     -  (2*ZH(j,5)*ZU(k,2)*ZUC(l1,2))/(SB*vv))
        CSSSS(i,j,l1,k)=CSSSS(i,j,l1,k)*M1/vv/SB
            enddo   
          enddo
        enddo
       enddo 
       
       do k=1,2
        do l1=1,2
         do j=1,2
          do i=1,2
           CS13S13S13S13p1(i,j,l1,k)=(ZU(k,2)*(2*ZU(l1,2)*ZUC(i,2)* 
     -    ZUC(j,2)+ZU(l1,1)*(ZUC(i,2)*ZUC(j,1) - 3*ZUC(i,1)*ZUC(j,2)))+ 
     -    ZU(k,1)*(2*ZU(l1,1)*ZUC(i,1)*ZUC(j,1) +ZU(l1,2)*(-3*ZUC(i,2)* 
     -    ZUC(j,1) + ZUC(i,1)*ZUC(j,2))))/6.

           CS13S13S13S13p2(i,j,l1,k)=(ZU(k,1)*(2*ZU(l1,1)*ZUC(i,1)* 
     -     ZUC(j,1) +ZU(l1,2)*(ZUC(i,2)*ZUC(j,1)- 3*ZUC(i,1)*ZUC(j,2)))+ 
     -     ZU(k,2)*(2*ZU(l1,2)*ZUC(i,2)*ZUC(j,2) + 
     -     ZU(l1,1)*(-3*ZUC(i,2)*ZUC(j,1) + ZUC(i,1)*ZUC(j,2))))/6.

            enddo   
          enddo
        enddo
       enddo  
       do j=1,2
        do i=1,2
         CS14S13S14S13p1(i,j)= (ZU(j,1)*ZUC(i,1)-ZU(j,2)*ZUC(i,2))/2.
         CS14S13S14S13p2(i,j)=(-(ZU(j,1)*ZUC(i,1))+ZU(j,2)*ZUC(i,2))/6.
        enddo
       enddo  
       CS14S14S14S14p1=1/3.;    CS14S14S14S14p2=1/3.     

       do j=1,2
        CS3S13S14(j)=-((M12*sqrt2*ZUC(j,1))/(TB*vv)) -(ATC*M1*sqrt2*
     .  ZUC(j,2))/(expETA*TB*vv) - (expVS*la*M1*vS*ZUC(j,2))/vv

        CS3S14S13(j)=-((M12*sqrt2*ZU(j,1))/(TB*vv)) -(AT*expETA*M1* 
     .  sqrt2*ZU(j,2))/(TB*vv) - (laC*M1*vS*ZU(j,2))/(expVS*vv)
     
       CS3S13S14N(1,j)=-((M1**2*sqrt2*ZUC(j,1))/vv)-(ATC*M1*sqrt2*
     &  ZUC(j,2))/(expETA*vv)+(CB*M1*MUE*sqrt2*ZUC(j,2))/(SB*vv)
       CS3S13S14N(2,j)=-((CB*M1**2*sqrt2*ZUC(j,1))/(SB*vv))-(M1*MUE*
     &  sqrt2*ZUC(j,2))/vv-(ATC*CB*M1*sqrt2*ZUC(j,2))/(expETA*SB*vv)

       CS3S14S13N(1,j)=-((M1**2*sqrt2*ZU(j,1))/vv)-(AT*expETA*M1*sqrt2*
     &  ZU(j,2))/vv+(CB*M1*MUEC*sqrt2*ZU(j,2))/(SB*vv)
     
       CS3S14S13N(2,j)=-((CB*M1**2*sqrt2*ZU(j,1))/(SB*vv))-(M1*MUEC*
     &  sqrt2*ZU(j,2))/vv-(AT*CB*expETA*M1*sqrt2*ZU(j,2))/(SB*vv)
     
     
        do i=1,2
         CS3SSS13(i,j)=(2*M12*ZU(j,2)*ZUC(i,2))/(TB2*vv**2)
         CS3S13SC(i,j)=DCONJG(CS3S13S(i,j))
        enddo
       enddo
       
       do j=1,2
       do k=1,2
       CS3S3S13S13(1,1,j,k)=(2*M12*ZU(k,2)*ZUC(j,2))/vv**2
       CS3S3S13S13(1,2,j,k)=(2*CB*M12*ZU(k,2)*ZUC(j,2))/(SB*vv**2)
       CS3S3S13S13(2,1,j,k)=(2*CB*M12*ZU(k,2)*ZUC(j,2))/(SB*vv**2)
       CS3S3S13S13(2,2,j,k)=(2*CB**2*M12*ZU(k,2)*ZUC(j,2))/(SB**2*vv**2)
       enddo
       enddo
       CS3S3S13S13C=DCONJG(CS3S3S13S13)

      CS3SSS14 = (2*M12)/(TB2*vv**2)
      CS3S3S14S14(2,2) = CS3SSS14
      CS3S3S14S14(2,1) = (2*CB*M12)/(SB*vv**2)
      CS3S3S14S14(1,2) =       CS3S3S14S14(2,1)
      CS3S3S14S14(1,1) = (2*M12)/vv**2

      CTBS3R   =-(sqrt2/(sqrt(expETA)*vv))* M1/TB
      CTBS3(2)= -(sqrt2/(sqrt(expETA)*vv))* M1/TB
      CTBS3C(2)= DCONJG(CTBS3(2))
      CTBS3(1)= -sqrt2*M1/vv/sqrt(expETA)
      CTBS3C(1)=DCONJG(CTBS3(1))

         do i=1,2
          CF15F3S13L(i)= 1/expM3*ZU(i,1)/sqrt2/sqrt(expETA)
          CF15F3S13LC(i)= DCONJG(CF15F3S13L(i))         
          CF15F3S13R(i)=sqrt(expETA)*expM3*ZU(i,2)/sqrt2
          CF15F3S13RC(i)=DCONJG(CF15F3S13R(i))
         enddo    
          CLFGBSB= 1./sqrt2/expM3   
          CLFGBSBC= 1./sqrt2*expM3  
          
c gauge boson couplings
      do i=1,2
        CS14S13V3(i)=ZU(i,1)/SW/sqrt2
      enddo

		CF4F3V3=1D0/sqrt2/SW/Sqrt(expeta)

	    CS14S14V3V3=-1/(2.*SW**2)

        do i=1,2
        do j=1,2
       CS13S13V3V3(i,j)=-(ZU(j,1)*ZUC(i,1))/(2.*SW**2)
        enddo
        enddo

        do i=1,2
        do j=1,2
       CS13S13V2(i,j)=((3*CW**2-SW**2)*ZU(j,1)*ZUC(i,1)-4*SW**2*ZU(j,2)
     &  *ZUC(i,2))/(6.*CW*SW)
        enddo
        enddo

       CS14S14V2=-CW/(2.*SW)-SW/(6.*CW)

        do i=1,2
        do j=1,2
       CS13S13V2V2(i,j)=(-((3-4*SW**2)**2*ZU(j,1)*ZUC(i,1))-16*SW**4*
     &  ZU(j,2)*ZUC(i,2))/(18.*CW**2*SW**2)
        enddo
        enddo
       CS14S14V2V2=-(3-2*SW**2)**2/(18.*CW**2*SW**2)


       CS14S14V5V2=-((3*CW**2 + SW**2))/(6.*CW*SW)
       do i=1,2
       CS13S14V5V3(i)= ZUC(i,1)/sqrt2/SW
       enddo
       do i=1,2
       do j=1,2
       CS13S13V5V2(i,j)=((3*CW**2-SW**2)*(ZUC(i,1))*ZU(j,1) - 4*SW**2*(ZUC(i,2))*ZU(j,2))/(6.*CW*SW)
       enddo
       enddo
c gauge boson couplings                    
c#define printQCD                    
#ifdef printQCD
      write(*,*) "*************** QCD Spectrum *********************"
      write(*,*) "M1,M2,M3,M4, MSQ2",M1,M2,M3,M4, MSQ2 
      write(*,*) "ZUN,sqrt2",ZU, sqrt2
      write(*,*) "MUE,MUEC,AT,ATC,la,lac" ,MUE,MUEC,AT,ATC,la,lac
      write(*,*) "expM3,expETA,expvs",expM3,expETA,expvs
      write(*,*) "TB, vv,CB,SB,IC",TB, vv,CB,SB,IC
      write(*,*) "ZH", ZH
      write(*,*) ""
      write(*,*) '1)  1 Higgs i two stop j,k couplings, CSSS(i,j,k)'
      write(*,*) 'CSSS(1,1,1),CSSS(1,1,2),CSSS(1,2,1),CSSS(1,2,2)',CSSS(1,1,1),CSSS(1,1,2),CSSS(1,2,1),CSSS(1,2,2)
      write(*,*) 'CSSS(4,1,1),CSSS(4,1,2),CSSS(4,2,1),CSSS(4,2,2)',CSSS(4,1,1),CSSS(4,1,2),CSSS(4,2,1),CSSS(4,2,2)
      write(*,*) 'CSSS(5,1,1),CSSS(5,1,2),CSSS(5,2,1),CSSS(5,2,2)',CSSS(5,1,1),CSSS(5,1,2),CSSS(5,2,1),CSSS(5,2,2)
      write(*,*) '---------------------------------------------------------'
      write(*,*) '2)  2 Higgs i,j  two stop l,k couplings, CSSSS(i,j,l,k)'
      write(*,*) "CSSSS(1,1,1,1),CSSSS(1,1,1,2)",CSSSS(1,1,1,1),CSSSS(1,1,1,2)
      write(*,*) "CSSSS(1,1,2,1),CSSSS(1,1,2,2)",CSSSS(1,1,2,1),CSSSS(1,1,2,2)
      write(*,*) "CSSSS(1,2,1,1),CSSSS(1,2,1,2)",CSSSS(1,2,1,1),CSSSS(1,2,1,2)
      write(*,*) "CSSSS(1,2,2,1),CSSSS(1,2,2,2)",CSSSS(1,2,2,1),CSSSS(1,2,2,2)

      write(*,*) "CSSSS(4,4,1,1),CSSSS(4,4,1,2)",CSSSS(4,4,1,1),CSSSS(4,4,1,2)
      write(*,*) "CSSSS(4,4,2,1),CSSSS(4,4,2,2)",CSSSS(4,4,2,1),CSSSS(4,4,2,2)
      write(*,*) "CSSSS(4,5,1,1),CSSSS(4,5,1,2)",CSSSS(4,5,1,1),CSSSS(4,5,1,2)
      write(*,*) "CSSSS(4,5,2,1),CSSSS(4,5,2,2)",CSSSS(4,5,2,1),CSSSS(4,5,2,2)


      write(*,*) '---------------------------------------------------------'

      write(*,*) '4)   4 stop, CS13S13S13S13MT4(i,j,k,l)' 
      write(*,*) 'CS13S13S13S13MT4(1,1,1,1)',CS13S13S13S13p1(1,1,1,1)
      write(*,*) 'CS13S13S13S13MT4(1,1,1,2)',CS13S13S13S13p1(1,1,1,2)
      write(*,*) 'CS13S13S13S13MT4(1,1,2,2)',CS13S13S13S13p1(1,1,2,2)
      write(*,*) 'CS13S13S13S13MT4(1,2,2,2)',CS13S13S13S13p1(1,2,2,2)
      write(*,*) 'CS13S13S13S13MT4(2,2,2,2)',CS13S13S13S13p1(2,2,2,2)
      write(*,*) 'CS13S13S13S13MT4(1,2,1,2)',CS13S13S13S13p1(1,2,1,2)
      write(*,*) '---------------------------------------------------------'
      write(*,*) '5)   2 stop, 2 sbottom, CS14S13S14S13MT4(i,j)' 
      write(*,*) 'CS14S13S14S13MT4(1,1)',CS14S13S14S13p1(1,1)
      write(*,*) 'CS14S13S14S13MT4(1,2)',CS14S13S14S13p1(1,2)
      write(*,*) 'CS14S13S14S13MT4(2,2)',CS14S13S14S13p1(2,2)
      write(*,*) '---------------------------------------------------------'
      write(*,*) '11) charged Higgs i, stop j, sbottom, CS3S13S(i,j)'
      write(*,*) 'CS3S13S(1,1),CS3S13S(1,2)',CS3S13S(1,1),CS3S13S(1,2)
      write(*,*) 'CS3S13S(2,1),CS3S13S(2,2)',CS3S13S(2,1),CS3S13S(2,2)

      write(*,*) '---------------------------------------------------------'
      write(*,*) '12) charged Higgs i, top bottom CTBS3(i)'
      write(*,*) 'CTBS3(1),CTBS3(2)',CTBS3(1),CTBS3(2)
      
#endif      

      end subroutine TLcouplings_QCD
      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine CT1loop_QCD(ischeme,dmsq4fin,dmsur4fin,dAt4fin,MHpminput)
      implicit none
      integer i,j,k,l,ischeme
      integer IST3,IST4
      double precision A0T,AEpT,B0T,BEpT,fac 
      double complex B0P,B1P,BEpP,B1EpP
      logical MQrun,MHpminput   
      double precision dmsq4fin,dmsur4fin  
      double complex dAt4fin
#include "TLQCDN.h"
      double precision indexdelta(2,2),p2
      double complex aBfunc(4),XTC
      fac = ass/3./pi
c diagram + 1 

       RCMT=0D0
       do ISt3=1,2
       RCMT(1)=(CF15F3S13R(ISt3)*(-2*M3*CF15F3S13LC(ISt3)+M1*
     &  CF15F3S13RC(ISt3))+CF15F3S13L(ISt3)*(M1*CF15F3S13LC(ISt3)-2*M3*
     &  CF15F3S13RC(ISt3)))+RCMT(1)
       enddo 
       RCMT(1)=-3*M1+RCMT(1)      
       RCMT(1)=fac*RCMT(1)  
        !eps

       do ISt3=1,2
       aBfunc(2)=B0P(M12,M32,MassSu2(ISt3),Q2)
       aBfunc(4)=BEpP(M12,M32,MassSu2(ISt3),Q2)   
   
       RCMT(2)=(-(a0t3*M1*(CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)+
     &  CF15F3S13R(ISt3)*CF15F3S13RC(ISt3)))+M1*aA0TN(ISt3)*
     &  (CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt3))+aBfunc(2)*(CF15F3S13L(ISt3)*(-2*M12*M3*
     &  CF15F3S13RC(ISt3)+M1*CF15F3S13LC(ISt3)*(M12+M32-MassSu2(ISt3)))
     &  +CF15F3S13R(ISt3)*(-2*M12*M3*CF15F3S13LC(ISt3)+M1*
     &  CF15F3S13RC(ISt3)*(M12+M32-MassSu2(ISt3)))))/M12+RCMT(2)
       RCMT(3)=(CF15F3S13L(ISt3)*(-2*M12*M3*aBfunc(4)*CF15F3S13RC(ISt3)
     &  +M1*CF15F3S13LC(ISt3)*(-aet3+aAETN(ISt3)+aBfunc(4)*(M12+M32-
     &  MassSu2(ISt3))))+CF15F3S13R(ISt3)*(-2*M12*M3*aBfunc(4)*
     &  CF15F3S13LC(ISt3)+M1*CF15F3S13RC(ISt3)*(-aet3+aAETN(ISt3)+
     &  aBfunc(4)*(M12+M32-MassSu2(ISt3)))))/M12+RCMT(3)
       enddo 
c diagram + 2

       aBfunc(1)=DBLE(B0P(M12,0D0,M12,Q2)   )     
       aBfunc(3)=DBLE(BEpP(M12,0D0,M12,Q2)  )      
        
       RCMT(2)=-((M1*(a0t1+2*M12*aBfunc(1)))/M12)+RCMT(2)
       RCMT(3)=-((M1*(aet1+2*M12*aBfunc(3)))/M12)+RCMT(3) 
       
       RCMT(2:3)=fac*RCMT(2:3)

c%%%%%%%%%%%%%%%%% stop           
       RCMSfsq=0D0   
       
       do i=1,2
        p2= MassSu2(i) 
       do ISt3=1,2
       RCMSfsq(i,i,1)=(9*(CS13S13S13S13p1(i,ISt3,i,ISt3)+3*
     &  CS13S13S13S13p2(i,ISt3,i,ISt3))*MassSu2(ISt3))/4.+
     &  RCMSfsq(i,i,1)
       enddo               
       RCMSfsq(i,i,1)=(9*MSQ2*(CS14S13S14S13p1(i,i)+3*
     &  CS14S13S14S13p2(i,i)))/4.+RCMSfsq(i,i,1) 
       RCMSfsq(i,i,1)=3*(-2*P2+8*M1*M3*CF15F3S13LC(i)*CF15F3S13R(i)+4*
     &  (-2*(M12+M32)+P2)*CF15F3S13R(i)*CF15F3S13RC(i)+CF15F3S13L(i)*
     &  (4*(-2*(M12+M32)+P2)*CF15F3S13LC(i)+8*M1*M3*CF15F3S13RC(i))-
     &  MassSu2(i))+RCMSfsq(i,i,1)
       RCMSfsq(i,i,1)=RCMSfsq(i,i,1)*fac  /3D0 
       enddo

       
       do ISt3=1,2
       RCMSfsq(1,2,1)=(9*(CS13S13S13S13p1(2,ISt3,1,ISt3)+3*
     &  CS13S13S13S13p2(2,ISt3,1,ISt3))*MassSu2(ISt3))/4.+
     &  RCMSfsq(1,2,1)
       enddo 
       RCMSfsq(1,2,1)=(9*MSQ2*(CS14S13S14S13p1(2,1)+3*
     &  CS14S13S14S13p2(2,1)))/4.+RCMSfsq(1,2,1)             
       RCMSfsq(1,2,1)=(6*CF15F3S13LC(2)*((-4*M12+M22-4*M32+M42)*
     &  CF15F3S13L(1)+4*M1*M3*CF15F3S13R(1))+6*(4*M1*M3*CF15F3S13L(1)+
     &  (-4*M12+M22-4*M32+M42)*CF15F3S13R(1))*CF15F3S13RC(2))+
     &  RCMSfsq(1,2,1)
       RCMSfsq(1,2,1)=RCMSfsq(1,2,1)*fac /3D0         
           
                                     
       do i=1,2
        p2= MassSu2(i)
       aBfunc(1)=DBLE(B0P(P2,0D0,MassSu2(i),Q2))
       aBfunc(2)=DBLE(B0P(P2,M12,M32,Q2))
       aBfunc(3)=DBLE(BEpP(P2,0D0,MassSu2(i),Q2))
       aBfunc(4)=DBLE(BEpP(P2,M12,M32,Q2) )
       
c diagram + 1     
       do ISt3=1,2
       RCMSfsq(i,i,2)=(9*aA0TN(ISt3)*(CS13S13S13S13p1(i,ISt3,i,ISt3)+3*
     &  CS13S13S13S13p2(i,ISt3,i,ISt3)))/4.+RCMSfsq(i,i,2)
       RCMSfsq(i,i,3)=(9*aAETN(ISt3)*(CS13S13S13S13p1(i,ISt3,i,ISt3)+3*
     &  CS13S13S13S13p2(i,ISt3,i,ISt3)))/4.+RCMSfsq(i,i,3)
       enddo 
c diagram + 2
        
       RCMSfsq(i,i,2)=(9*a0t5*(CS14S13S14S13p1(i,i)+3*
     &  CS14S13S14S13p2(i,i)))/4.+RCMSfsq(i,i,2)
       RCMSfsq(i,i,3)=(9*aet5*(CS14S13S14S13p1(i,i)+3*
     &  CS14S13S14S13p2(i,i)))/4.+RCMSfsq(i,i,3)
c diagram + 3        
        !eps
        
       RCMSfsq(i,i,2)=3*(aA0TN(i)-2*(2*CF15F3S13LC(i)*((a0t1+a0t3+(M12+
     &  M32-P2)*aBfunc(2))*CF15F3S13L(i)-2*M1*M3*aBfunc(2)*
     &  CF15F3S13R(i))+2*(-2*M1*M3*aBfunc(2)*CF15F3S13L(i)+(a0t1+a0t3+
     &  (M12+M32-P2)*aBfunc(2))*CF15F3S13R(i))*CF15F3S13RC(i)+aBfunc(1)
     &  *(P2+MassSu2(i))))+RCMSfsq(i,i,2)
       RCMSfsq(i,i,3)=3*(aAETN(i)-2*(2*CF15F3S13L(i)*((aet1+aet3+(M12+
     &  M32-P2)*aBfunc(4))*CF15F3S13LC(i)-2*M1*M3*aBfunc(4)*
     &  CF15F3S13RC(i))+2*CF15F3S13R(i)*(-2*M1*M3*aBfunc(4)*
     &  CF15F3S13LC(i)+(aet1+aet3+(M12+M32-P2)*aBfunc(4))*
     &  CF15F3S13RC(i))+aBfunc(3)*(P2+MassSu2(i))))+RCMSfsq(i,i,3)

       RCMSfsq(i,i,2:3)=RCMSfsq(i,i,2:3)*fac   /3D0       
       enddo      
        
c %%%%%%%%%%%%
c diagram + 1
       aBfunc(1)=DBLE(B0P(M22,M12,M32,Q2))
       aBfunc(2)=DBLE(B0P(M42,M12,M32,Q2))
       aBfunc(3)=DBLE(BEpP(M22,M12,M32,Q2))
       aBfunc(4)=DBLE(BEpP(M42,M12,M32,Q2))

       do ISt3=1,2
       RCMSfsq(1,2,2)=(9*aA0TN(ISt3)*(CS13S13S13S13p1(2,ISt3,1,ISt3)+3*
     &  CS13S13S13S13p2(2,ISt3,1,ISt3)))/4.+RCMSfsq(1,2,2)
       RCMSfsq(1,2,3)=(9*aAETN(ISt3)*(CS13S13S13S13p1(2,ISt3,1,ISt3)+3*
     &  CS13S13S13S13p2(2,ISt3,1,ISt3)))/4.+RCMSfsq(1,2,3)
       enddo 
c diagram + 2
        
       RCMSfsq(1,2,2)=(9*a0t5*(CS14S13S14S13p1(2,1)+3*
     &  CS14S13S14S13p2(2,1)))/4.+RCMSfsq(1,2,2)
       RCMSfsq(1,2,3)=(9*aet5*(CS14S13S14S13p1(2,1)+3*
     &  CS14S13S14S13p2(2,1)))/4.+RCMSfsq(1,2,3)
c diagram + 3
        
       RCMSfsq(1,2,2)=(6*CF15F3S13LC(2)*(-((2*a0t1+2*a0t3+(M12-M22+M32)
     &  *aBfunc(1)+(M12+M32-M42)*aBfunc(2))*CF15F3S13L(1))+2*M1*M3*
     &  (aBfunc(1)+aBfunc(2))*CF15F3S13R(1))+6*(2*M1*M3*(aBfunc(1)+
     &  aBfunc(2))*CF15F3S13L(1)-(2*a0t1+2*a0t3+(M12-M22+M32)*aBfunc(1)
     &  +(M12+M32-M42)*aBfunc(2))*CF15F3S13R(1))*CF15F3S13RC(2))+
     &  RCMSfsq(1,2,2)
       RCMSfsq(1,2,3)=(6*CF15F3S13LC(2)*(-((2*aet1+2*aet3+(M12-M22+M32)
     &  *aBfunc(3)+(M12+M32-M42)*aBfunc(4))*CF15F3S13L(1))+2*M1*M3*
     &  (aBfunc(3)+aBfunc(4))*CF15F3S13R(1))+6*(2*M1*M3*(aBfunc(3)+
     &  aBfunc(4))*CF15F3S13L(1)-(2*aet1+2*aet3+(M12-M22+M32)*aBfunc(3)
     &  +(M12+M32-M42)*aBfunc(4))*CF15F3S13R(1))*CF15F3S13RC(2))+
     &  RCMSfsq(1,2,3)   
       RCMSfsq(1,2,2:3)=       RCMSfsq(1,2,2:3)*fac/3D0 
c AT couterterm 
       RCMSfsq(2,1,1:3)=       DCONJG(RCMSfsq(1,2,1:3) )
       XTC= ATC/expETA - la*VS*expvs/sqrt2/TB  
      if(ischeme.eq.1) then
       RCMSfsq(:,:,2:3)=0D0
       RCMT(2:3)=0D0
      elseif (ischeme.eq.3) then  
       RCMSfsq(:,:,3)=0D0
       RCMT(3)=0D0         
      endif
      do i=1,3
         if (M1.ne.0D0) then
         dATC(i)=(-((XTC*RCMT(i))/M1) + (RCMSfsq(1,1,i)*ZU(1,2)*
     -  ZUC(1,1))/M1 + (RCMSfsq(1,2,i)*ZU(2,2)*ZUC(1,1))/M1 + 
     -  (RCMSfsq(2,1,i)*ZU(1,2)*ZUC(2,1))/M1 + 
     -  (RCMSfsq(2,2,i)*ZU(2,2)*ZUC(2,1))/M1)*expETA
         dAT(i) = DCONJG(dATC(i))                 
         else
         dATC(i)=0
         dAT(i) = DCONJG(dATC(i))
         endif
        dMSQsq1(i)=-2*M1*RCMT(i) + RCMSfsq(1,1,i)*ZU(1,1)*ZUC(1,1) + 
     -   RCMSfsq(1,2,i)*ZU(2,1)*ZUC(1,1) + RCMSfsq(2,1,i)*ZU(1,1)*ZUC(2,1)+ 
     -   RCMSfsq(2,2,i)*ZU(2,1)*ZUC(2,1)  
      enddo   

         dmsq4fin= dMSQsq1(2)
         dmsur4fin=-2*M1*RCMT(2) + RCMSfsq(1,1,2)*ZU(1,2)*ZUC(1,2) + 
     &  RCMSfsq(1,2,2)*ZU(2,2)*ZUC(1,2) + RCMSfsq(2,1,2)*ZU(1,2)*ZUC(2,2) +
     &  RCMSfsq(2,2,2)*ZU(2,2)*ZUC(2,2)
         dAt4fin=dAT(2) 
              
c#define printQCD 
#ifdef printQCD
      print*, "********* top-stop-renormalization****************"
      print*, "RCMT1,2,3=",RCMT
      print*, "RCMSfsq(1,1)1,2,3=",RCMSfsq(1,1,1:3)  
      print*, "RCMSfsq(2,2)1,2,3=",RCMSfsq(2,2,1:3)  
      print*, "RCMSfsq(1,2)1,2,3=",RCMSfsq(1,2,1:3)  
      print*, "dATC1,2,3=", dATC   
      print*, "dMSQsq1(i)",dMSQsq1(1:3)               
#endif      
      end subroutine CT1loop_QCD
      
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c**********************************************************************
      subroutine TLCTcouplings_QCD
      implicit none
      integer i,j,k,l1,i1,j1
#include "TLQCDN.h"   

       do j=1,3
         do i =1,6        
          dhy(i,j)=(RCMT(j)*(ZH(i,2) + IC*ZH(i,5)))/(SB*vv)
          dhyc(i,j)=(RCMT(j)*(ZH(i,2) - IC*ZH(i,5)))/(SB*vv)
         enddo
       enddo

       do l1=1,3
        do k=1,2
         do j=1,2
          do i=1,6
          dCSSS(i,j,k,l1)=(expVS*M1*sqrt2*
     -    (expETA**2*dAT(l1)*(ZH(i,2) + IC*ZH(i,5))*ZU(k,2)*ZUC(j,1)+ 
     -    dATC(l1)*(ZH(i,2) - IC*ZH(i,5))*ZU(k,1)*ZUC(j,2)) + 
     -    RCMT(l1)*(-(CB*expETA*laC*vv*ZH(i,3)*ZU(k,2)*ZUC(j,1)) + 
     -    expETA*IC*laC*vS*ZH(i,4)*ZU(k,2)*ZUC(j,1) + 
     -    AT*expETA**2*expVS*IC*sqrt2*ZH(i,5)*ZU(k,2)*
     -    ZUC(j,1) + CB*expETA*IC*laC*vv*ZH(i,6)*ZU(k,2)*
     -    ZUC(j,1) - CB*expETA*expVS**2*la*vv*ZH(i,3)*ZU(k,1)*
     -    ZUC(j,2) - IC*expETA*expVS**2*la*vS*ZH(i,4)*ZU(k,1)*ZUC(j,2)- 
     -    IC*ATC*expVS*sqrt2*ZH(i,5)*ZU(k,1)*ZUC(j,2) - IC*CB*expETA*
     -    expVS**2*la*vv*ZH(i,6)*ZU(k,1)*ZUC(j,2) - expETA*vS*ZH(i,1)*
     -    (laC*ZU(k,2)*ZUC(j,1) + expVS**2*la*ZU(k,1)*ZUC(j,2))
     -    + expVS*sqrt2*ZH(i,2)*(ZU(k,1)*(4*expETA*M1*ZUC(j,1) + 
     -    ATC*ZUC(j,2)) + expETA*ZU(k,2)*(AT*expETA*ZUC(j,1) + 
     -    4*M1*ZUC(j,2)))))/(expETA*expVS*SB*sqrt2*vv)
          enddo
         enddo
        enddo
       enddo
       
       do i1=1,3
       do k=1,2
        do l1=1,2
         do j=1,6
          do i=1,6
         dCSSSS(i,j,l1,k,i1)=RCMT(i1)*(-((laC*sqrt2*(ZH(i,6)*(-IC*
     -   ZH(j,1) - ZH(j,4)) + ZH(i,3)*(ZH(j,1) - IC*ZH(j,4)) + 
     -   (ZH(i,1) - IC*ZH(i,4))*(ZH(j,3) - IC*ZH(j,6)))*
     -   ZU(k,2)*ZUC(l1,1))/(SB*vv) +(expVS**2*la*sqrt2*
     -   (ZH(i,3)*(ZH(j,1) + IC*ZH(j,4)) +IC*ZH(i,6)*(ZH(j,1) +  
     -   IC*ZH(j,4)) +(ZH(i,1) + IC*ZH(i,4))*(ZH(j,3)+IC*ZH(j,6))) 
     -   *ZU(k,1)*ZUC(l1,2))/(SB*vv))/(2.*expVS) -(M1*((-4*expVS* 
     -   (ZH(i,2)*ZH(j,2) + ZH(i,5)*ZH(j,5))*ZU(k,1)*ZUC(l1,1))
     -   /(SB2*vv**2) - (4*expVS*(ZH(i,2)*ZH(j,2)+ZH(i,5)*ZH(j,5))*
     -   ZU(k,2)*ZUC(l1,2))/(SB2*vv**2)))/expVS)

          enddo
         enddo
        enddo
       enddo
       enddo 
       
       do i1=1,3       
       do j=1,2
        dCS3S13S14(j,i1)=-((2*M1*(RCMT(i1)) *sqrt2*ZUC(j,1))/(TB*vv))
     .    -((dATC(i1)*M1 + ATC*RCMT(i1) )*sqrt2*
     .  ZUC(j,2))/(expETA*TB*vv) - (expVS*la*RCMT(i1)*vS*ZUC(j,2))/vv

        dCS3S14S13(j,i1)=-((2*M1*RCMT(i1)*sqrt2*ZU(j,1))/(TB*vv)) 
     .  -((dAT(i1)*M1 + AT*RCMT(i1))*expETA* 
     .  sqrt2*ZU(j,2))/(TB*vv) - (laC*RCMT(i1)*vS*ZU(j,2))/(expVS*vv)
       enddo
       do j=1,2
       dCS3S13S14N(1,j,i1)=(-2*M1*sqrt2*RCMT(i1)*ZUC(j,1))/vv-(M1*
     &  sqrt2*DCONJG(dAT(i1))*ZUC(j,2))/(expETA*vv)-(ATC*sqrt2*RCMT(i1)
     &  *ZUC(j,2))/(expETA*vv)+(CB*MUE*sqrt2*RCMT(i1)*ZUC(j,2))/(SB*vv)
     &  
       dCS3S13S14N(2,j,i1)=(-2*CB*M1*sqrt2*RCMT(i1)*ZUC(j,1))/(SB*vv)-
     &  (CB*M1*sqrt2*DCONJG(dAT(i1))*ZUC(j,2))/(expETA*SB*vv)-(MUE*
     &  sqrt2*RCMT(i1)*ZUC(j,2))/vv-(ATC*CB*sqrt2*RCMT(i1)*ZUC(j,2))
     &  /(expETA*SB*vv)
     
       dCS3S14S13N(1,j,i1)=(-2*M1*sqrt2*RCMT(i1)*ZU(j,1))/vv-(expETA*
     &  M1*sqrt2*dAT(i1)*ZU(j,2))/vv-(AT*expETA*sqrt2*RCMT(i1)*ZU(j,2)
     &  )/vv+(CB*MUEC*sqrt2*RCMT(i1)*ZU(j,2))/(SB*vv)
       dCS3S14S13N(2,j,i1)=(-2*CB*M1*sqrt2*RCMT(i1)*ZU(j,1))/(SB*vv)-
     &  (CB*expETA*M1*sqrt2*dAT(i1)*ZU(j,2))/(SB*vv)-(MUEC*sqrt2*
     &  RCMT(i1)*ZU(j,2))/vv-(AT*CB*expETA*sqrt2*RCMT(i1)*ZU(j,2))
     &  /(SB*vv)
          
          
       enddo

      dCS3SSS14(i1) = (2*2*M1*RCMT(i1))/(TB2*vv**2)
      dCS3S3S14S14(2,2,i1) = dCS3SSS14(i1) 
      dCS3S3S14S14(2,1,i1) = (2*CB*2*M1*RCMT(i1))/(SB*vv**2)
      dCS3S3S14S14(1,2,i1) =       dCS3S3S14S14(2,1,i1)
      dCS3S3S14S14(1,1,i1) = (2*2*M1*RCMT(i1))/vv**2

      dCTBS3R(i1)    =-(sqrt2/(sqrt(expETA)*vv))* RCMT(i1)/TB
      dCTBS3(2,i1)= -(sqrt2/(sqrt(expETA)*vv))* RCMT(i1)/TB
      dCTBS3C(2,i1)= DCONJG(dCTBS3(2,i1))
      dCTBS3(1,i1)= -sqrt2*RCMT(i1)/vv/sqrt(expETA)
      dCTBS3C(1,i1)=DCONJG(dCTBS3(1,i1))
       enddo 

       do i=1,3
       do k=1,2
       do j=1,2
       dCS3S3S13S13(1,1,j,k,i)=(4*M1*RCMT(i)*ZU(k,2)*ZUC(j,2))/vv**2
       dCS3S3S13S13(2,1,j,k,i)=(4*CB*M1*RCMT(i)*ZU(k,2)*ZUC(j,2))/(SB*vv**2)
       dCS3S3S13S13(1,2,j,k,i)=(4*CB*M1*RCMT(i)*ZU(k,2)*ZUC(j,2))/(SB*vv**2)
       dCS3S3S13S13(2,2,j,k,i)=(4*CB**2*M1*RCMT(i)*ZU(k,2)*ZUC(j,2))
     &  /(SB**2*vv**2)
       enddo
       enddo
       enddo                   
       
       end subroutine TLCTcouplings_QCD   
