       
c**********************************************************************
      subroutine TLTad_QCD(tadiH)
      implicit none
      integer i,j,k,l1,i1,j1,ist2,ist3,ist4,gen3
      double precision atadCTDP(6),atadCTSP(6),atadCT(6),tadHH(6),
     &      fac,ctfac,atad(6),atadDP(6),atadSP(6)
      double complex tadiH(6)
#include "TLQCDN.h"   
       fac= ass*3./4./pi**3 
c counterterm part
       ctfac= 1/16./pi**2
       atadCTDP=0D0;atadCTSP=0D0;atadCT=0D0    
       atadDP=0D0;atadSP=0D0;atad=0D0          
       do i=1,6  
       atadCTDP(i)=atadCTDP(i)+-6*M12*(M1*(dhy(i,1)+dhyc(i,1))+3*(hy(i)
     &  +hyc(i))*RCMT(1))
       atadCTSP(i)=atadCTSP(i)+-6*(a0t1*(M1*(dhy(i,1)+dhyc(i,1))+(hy(i)
     &  +hyc(i))*RCMT(1))+M12*(M1*(dhy(i,2)+dhyc(i,2))+(hy(i)+hyc(i))*
     &  (2*aB0TN1*RCMT(1)+3*RCMT(2))))
       atadCT(i)=atadCT(i)+-6*(aet1*(M1*(dhy(i,1)+dhyc(i,1))+(hy(i)+
     &  hyc(i))*RCMT(1))+a0t1*(M1*(dhy(i,2)+dhyc(i,2))+(hy(i)+hyc(i))*
     &  RCMT(2))+M12*(M1*(dhy(i,3)+dhyc(i,3))+(hy(i)+hyc(i))*(2*
     &  aBEpTN1*RCMT(1)+2*aB0TN1*RCMT(2)+3*RCMT(3))))
       do ISt2=1,2
       atadCTDP(i)=atadCTDP(i)+3*dCSSS(i,ISt2,ISt2,1)*MassSu2(ISt2)
       atadCTSP(i)=atadCTSP(i)+3*(aA0TN(ISt2)*dCSSS(i,ISt2,ISt2,1)+
     &  dCSSS(i,ISt2,ISt2,2)*MassSu2(ISt2))
       atadCT(i)=atadCT(i)+3*(aAETN(ISt2)*dCSSS(i,ISt2,ISt2,1)+
     &  aA0TN(ISt2)*dCSSS(i,ISt2,ISt2,2)+dCSSS(i,ISt2,ISt2,3)*
     &  MassSu2(ISt2))
       enddo 
       do ISt2=1,2
       do ISt3=1,2
       atadCTDP(i)=atadCTDP(i)+3*CSSS(i,ISt3,ISt2)*RCMSfsq(ISt3,ISt2,1)
       atadCTSP(i)=atadCTSP(i)+3*CSSS(i,ISt3,ISt2)*(aB0T1(ISt2,ISt3)*
     &  RCMSfsq(ISt3,ISt2,1)+RCMSfsq(ISt3,ISt2,2))
       atadCT(i)=atadCT(i)+3*CSSS(i,ISt3,ISt2)*(aBEpT1(ISt2,ISt3)*
     &  RCMSfsq(ISt3,ISt2,1)+aB0T1(ISt2,ISt3)*RCMSfsq(ISt3,ISt2,2)+
     &  RCMSfsq(ISt3,ISt2,3))
       enddo 
       enddo   
       enddo
c#define PRINTYES
#ifdef PRINTYES
      print*,"-----------counterterm Tadpoles in Mass eigenstates------"
      print*, atadCT(1:6)*ctfac
      print*,"------------------------------------------------------"
#endif
       do i=1,6  
       do ISt2=1,2
       do ISt3=1,2
       do ISt4=1,2
       atadDP(i)=atadDP(i)+-((CS13S13S13S13p1(ISt3,ISt4,ISt2,ISt4)+3*
     &  CS13S13S13S13p2(ISt3,ISt4,ISt2,ISt4))*CSSS(i,ISt2,ISt3)*
     &  MassSu2(ISt4))/16.
       atadSP(i)=atadSP(i)+-((CS13S13S13S13p1(ISt3,ISt4,ISt2,ISt4)+3*
     &  CS13S13S13S13p2(ISt3,ISt4,ISt2,ISt4))*CSSS(i,ISt2,ISt3)*
     &  (aA0TN(ISt4)+aB0T1(ISt2,ISt3)*MassSu2(ISt4)))/16.
       atad(i)=atad(i)+-((CS13S13S13S13p1(ISt3,ISt4,ISt2,ISt4)+3*
     &  CS13S13S13S13p2(ISt3,ISt4,ISt2,ISt4))*CSSS(i,ISt2,ISt3)*
     &  (aAETN(ISt4)+aA0TN(ISt4)*aB0T1(ISt2,ISt3)+aBEpT1(ISt2,ISt3)*
     &  MassSu2(ISt4)))/16.
       enddo 
       enddo 
       enddo 
       do ISt2=1,2
       do ISt3=1,2
       atadDP(i)=atadDP(i)+-(MSQ2*(CS14S13S14S13p1(ISt3,ISt2)+3*
     &  CS14S13S14S13p2(ISt3,ISt2))*CSSS(i,ISt2,ISt3))/16.
       atadSP(i)=atadSP(i)+-((a0t5+MSQ2*aB0T1(ISt2,ISt3))*
     &  (CS14S13S14S13p1(ISt3,ISt2)+3*CS14S13S14S13p2(ISt3,ISt2))*
     &  CSSS(i,ISt2,ISt3))/16.
       atad(i)=atad(i)+-((aet5+a0t5*aB0T1(ISt2,ISt3)+MSQ2*
     &  aBEpT1(ISt2,ISt3))*(CS14S13S14S13p1(ISt3,ISt2)+3*
     &  CS14S13S14S13p2(ISt3,ISt2))*CSSS(i,ISt2,ISt3))/16.
       enddo 
       enddo 

c set4 part + 1
       do ISt2=1,2
       atadDP(i)=atadDP(i)+(3*CSSS(i,ISt2,ISt2)*MassSu2(ISt2)+4*M1*
     &  CF15F3S13R(ISt2)*CF15F3S13RC(ISt2)*(hy(i)+hyc(i))*(M12+
     &  MassSu2(ISt2))-4*M3*CF15F3S13LC(ISt2)*CF15F3S13R(ISt2)*(M12*
     &  hyc(i)+hy(i)*(2*M12+M32+MassSu2(ISt2)))+4*CF15F3S13L(ISt2)*(M1*
     &  CF15F3S13LC(ISt2)*(hy(i)+hyc(i))*(M12+MassSu2(ISt2))-M3*
     &  CF15F3S13RC(ISt2)*(M12*hy(i)+hyc(i)*(2*M12+M32+MassSu2(ISt2))))
     &  )/12.
       atadSP(i)=atadSP(i)+(aA0TN(ISt2)*(6*CSSS(i,ISt2,ISt2)+8*
     &  CF15F3S13L(ISt2)*(-(M3*CF15F3S13RC(ISt2)*hyc(i))+M1*
     &  CF15F3S13LC(ISt2)*(hy(i)+hyc(i)))+8*CF15F3S13R(ISt2)*(-(M3*
     &  CF15F3S13LC(ISt2)*hy(i))+M1*CF15F3S13RC(ISt2)*(hy(i)+hyc(i))))+
     &  CSSS(i,ISt2,ISt2)*MassSu2(ISt2)+4*(CF15F3S13R(ISt2)*(M1*(2*
     &  a0t1+M32)*CF15F3S13RC(ISt2)*(hy(i)+hyc(i))-M3*CF15F3S13LC(ISt2)
     &  *(-((-2*a0t1+M12)*hyc(i))+hy(i)*(4*a0t1+2*a0t3+M32+
     &  MassSu2(ISt2))))+CF15F3S13L(ISt2)*(M1*(2*a0t1+M32)*
     &  CF15F3S13LC(ISt2)*(hy(i)+hyc(i))-M3*CF15F3S13RC(ISt2)*(-((-2*
     &  a0t1+M12)*hy(i))+hyc(i)*(4*a0t1+2*a0t3+M32+MassSu2(ISt2))))))
     &  /12.
       atad(i)=atad(i)+(-2*CSSS(i,ISt2,ISt2)*FD211STSTG(2,ISt2,ISt2)-
     &  CSSS(i,ISt2,ISt2)*FD211STSTG(3,ISt2,ISt2)-CSSS(i,ISt2,ISt2)*
     &  FD211STSTG(4,ISt2,ISt2)+8*M12*M3*CF15F3S13L(ISt2)*
     &  CF15F3S13RC(ISt2)*FD211TFGST(1,ISt2)*hy(i)-8*M1*
     &  CF15F3S13L(ISt2)*CF15F3S13LC(ISt2)*FD211TFGST(2,ISt2)*hy(i)-8*
     &  M1*CF15F3S13R(ISt2)*CF15F3S13RC(ISt2)*FD211TFGST(2,ISt2)*hy(i)+
     &  8*M3*CF15F3S13LC(ISt2)*CF15F3S13R(ISt2)*FD211TFGST(4,ISt2)*
     &  hy(i)+8*M12*M3*CF15F3S13LC(ISt2)*CF15F3S13R(ISt2)*
     &  FD211TFGST(1,ISt2)*hyc(i)-8*M1*CF15F3S13L(ISt2)*
     &  CF15F3S13LC(ISt2)*FD211TFGST(2,ISt2)*hyc(i)-8*M1*
     &  CF15F3S13R(ISt2)*CF15F3S13RC(ISt2)*FD211TFGST(2,ISt2)*hyc(i)+8*
     &  M3*CF15F3S13L(ISt2)*CF15F3S13RC(ISt2)*FD211TFGST(4,ISt2)*hyc(i)
     &  )/12.
       enddo 
c set4 part + 2
       do ISt2=1,2
       do ISt3=1,2
              if( ISt3.ne.ISt2 ) then 
       atadDP(i)=atadDP(i)+(CSSS(i,ISt3,ISt2)*(CF15F3S13L(ISt3)*(-2*M1*
     &  M3*CF15F3S13RC(ISt2)+CF15F3S13LC(ISt2)*(2*(M12+M32)-
     &  MassSu2(ISt2)-MassSu2(ISt3)))+CF15F3S13R(ISt3)*(-2*M1*M3*
     &  CF15F3S13LC(ISt2)+CF15F3S13RC(ISt2)*(2*(M12+M32)-MassSu2(ISt2)-
     &  MassSu2(ISt3)))))/6.
       atadSP(i)=atadSP(i)+(CSSS(i,ISt3,ISt2)*(4*aA0TN(ISt2)*
     &  (CF15F3S13L(ISt3)*((M12+M32)*CF15F3S13LC(ISt2)-M1*M3*
     &  CF15F3S13RC(ISt2))+CF15F3S13R(ISt3)*(-(M1*M3*CF15F3S13LC(ISt2))
     &  +(M12+M32)*CF15F3S13RC(ISt2)))-2*aA0TN(ISt2)*(CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt2)+CF15F3S13R(ISt3)*CF15F3S13RC(ISt2))*
     &  MassSu2(ISt2)+2*aA0TN(ISt3)*(CF15F3S13L(ISt3)*(2*M1*M3*
     &  CF15F3S13RC(ISt2)+CF15F3S13LC(ISt2)*(-2*(M12+M32)+MassSu2(ISt3)
     &  ))+CF15F3S13R(ISt3)*(2*M1*M3*CF15F3S13LC(ISt2)+
     &  CF15F3S13RC(ISt2)*(-2*(M12+M32)+MassSu2(ISt3))))-(MassSu(ISt2)-
     &  MassSu(ISt3))*(MassSu(ISt2)+MassSu(ISt3))*(CF15F3S13LC(ISt2)*
     &  (2*M1*M3*CF15F3S13R(ISt3)+CF15F3S13L(ISt3)*(MassSu2(ISt2)+
     &  MassSu2(ISt3)))+CF15F3S13RC(ISt2)*(2*M1*M3*CF15F3S13L(ISt3)+
     &  CF15F3S13R(ISt3)*(MassSu2(ISt2)+MassSu2(ISt3))))))/(6.*
     &  (MassSu2(ISt2)-MassSu2(ISt3)))
       atad(i)=atad(i)+(2*CSSS(i,ISt3,ISt2)*(-(CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt2)*FD111STFGT(2,ISt2))-CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt2)*FD111STFGT(2,ISt2)+CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt2)*FD111STFGT(2,ISt3)+CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt2)*FD111STFGT(2,ISt3)+CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt2)*FD111STFGT(4,ISt2)+CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt2)*FD111STFGT(4,ISt2)-CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt2)*FD111STFGT(4,ISt3)-CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt2)*FD111STFGT(4,ISt3)+M1*M3*CF15F3S13LC(ISt2)*
     &  CF15F3S13R(ISt3)*FD111TSTFG(1,ISt2)+M1*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt2)*FD111TSTFG(1,ISt2)-M1*M3*CF15F3S13LC(ISt2)*
     &  CF15F3S13R(ISt3)*FD111TSTFG(1,ISt3)-M1*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt2)*FD111TSTFG(1,ISt3)-CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt2)*FD111TSTFG(4,ISt2)-CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt2)*FD111TSTFG(4,ISt2)+CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt2)*FD111TSTFG(4,ISt3)+CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt2)*FD111TSTFG(4,ISt3)))/(3.*(MassSu2(ISt2)-
     &  MassSu2(ISt3)))
              else
       atadDP(i)=atadDP(i)+(CSSS(i,ISt2,ISt2)*(CF15F3S13L(ISt2)*(-(M1*
     &  M3*CF15F3S13RC(ISt2))+CF15F3S13LC(ISt2)*(M12+M32-MassSu2(ISt2))
     &  )+CF15F3S13R(ISt2)*(-(M1*M3*CF15F3S13LC(ISt2))+
     &  CF15F3S13RC(ISt2)*(M12+M32-MassSu2(ISt2)))))/3.
       atadSP(i)=atadSP(i)+(CSSS(i,ISt2,ISt2)*(2*aA0TN(ISt2)*
     &  (CF15F3S13L(ISt2)*((M12+M32)*CF15F3S13LC(ISt2)-M1*M3*
     &  CF15F3S13RC(ISt2))+CF15F3S13R(ISt2)*(-(M1*M3*CF15F3S13LC(ISt2))
     &  +(M12+M32)*CF15F3S13RC(ISt2)))-(CF15F3S13L(ISt2)*(2*(M12+M32+
     &  aA0TN(ISt2))*CF15F3S13LC(ISt2)-M1*M3*CF15F3S13RC(ISt2))+
     &  CF15F3S13R(ISt2)*(-(M1*M3*CF15F3S13LC(ISt2))+2*(M12+M32+
     &  aA0TN(ISt2))*CF15F3S13RC(ISt2)))*MassSu2(ISt2)))/(3.*
     &  MassSu(ISt2)**2)
       atad(i)=atad(i)+(2*CSSS(i,ISt2,ISt2)*(M1*M3*CF15F3S13LC(ISt2)*
     &  CF15F3S13R(ISt2)*FD211STTFG(1,ISt2)+M1*M3*CF15F3S13L(ISt2)*
     &  CF15F3S13RC(ISt2)*FD211STTFG(1,ISt2)+CF15F3S13L(ISt2)*
     &  CF15F3S13LC(ISt2)*FD211STTFG(2,ISt2)+CF15F3S13R(ISt2)*
     &  CF15F3S13RC(ISt2)*FD211STTFG(2,ISt2)-CF15F3S13L(ISt2)*
     &  CF15F3S13LC(ISt2)*FD211STTFG(3,ISt2)-CF15F3S13R(ISt2)*
     &  CF15F3S13RC(ISt2)*FD211STTFG(3,ISt2)))/3.
              endif
       enddo 
       enddo 
c set4 part + 3
       atadDP(i)=atadDP(i)+-(M1**3*(hy(i)+hyc(i)))
       atadSP(i)=atadSP(i)+(M1*(-6*a0t1+M12)*(hy(i)+hyc(i)))/3.
       atad(i)=atad(i)+(2*M1*(M12*FD211TTG(1)-FD211TTG(2)+FD211TTG(4))*
     &  (hy(i)+hyc(i)))/3.
       enddo

#ifdef PRINTYES
      print*,"-----------Tadpoles in mass EI-------"
      print*, atad(1:6)*fac,fac
      print*,"------------------------------------------------------"
#endif 
      do i=1,6
        tadHH(i) =atad(i)*fac + atadCT(i)*ctfac
      enddo
#ifdef PRINTYES
      print*,"-----------Tadpoles+ 1-loop counterterm in mass EI-------"
      print*, tadHH(1:6)
      print*,"------------------------------------------------------"
#endif


      do i=1,6
        tadiH(i)=0
         do Gen3=1,6
         tadiH(i) =tadiH(i)+ZH(gen3,i)*tadHH(Gen3)
         enddo
      enddo
      
       end subroutine TLTad_QCD
       
       
c**********************************************************************
      subroutine TLSeHH_QCD(selfHH)
      implicit none
      integer i,j,k,l1,i1,j1,ist2,ist3,ist4,ist5,ist6,gen3
      double precision selfCTDP(6,6),selfCTSP(6,6),selfCT(6,6),
     &      fac,ctfac,self(6,6),selfDP(6,6),selfSP(6,6)
      double complex selfHH(6,6),selfCT1(6,6)
#include "TLQCDN.h"   
       fac= ass*3./4./pi**3 
c counterterm part
       ctfac= 1/16./pi**2
       selfCTDP=0D0;selfCTSP=0D0;selfCT=0D0    
       selfDP=0D0;selfSP=0D0;self=0D0        
       do i=1,6
       do j=1,6
       selfCTDP(i,j)=6*M1*(-(M1*(dhyc(j,1)*(2*hy(i)+hyc(i))+dhy(j,1)*
     &  (hy(i)+2*hyc(i))+dhyc(i,1)*(2*hy(j)+hyc(j))+dhy(i,1)*(hy(j)+2*
     &  hyc(j))))-2*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*(hy(j)+2*hyc(j)))*
     &  RCMT(1))+selfCTDP(i,j)
       selfCTSP(i,j)=6*(-(aB0TN1*M12*(dhy(j,1)+dhyc(j,1))*(hy(i)+hyc(i)
     &  ))-a0t1*(dhyc(j,1)*hy(i)+dhy(j,1)*hyc(i))-aB0TN1*M12*(dhy(i,1)+
     &  dhyc(i,1))*(hy(j)+hyc(j))-a0t1*(dhyc(i,1)*hy(j)+dhy(i,1)*hyc(j)
     &  )-4*aC0TT3*M1**3*(hy(i)+hyc(i))*(hy(j)+hyc(j))*RCMT(1)-2*
     &  aB0TN1*M1*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*(hy(j)+2*hyc(j)))*
     &  RCMT(1)+M1*(-(M1*(dhyc(j,2)*(2*hy(i)+hyc(i))+dhy(j,2)*(hy(i)+2*
     &  hyc(i))+dhyc(i,2)*(2*hy(j)+hyc(j))+dhy(i,2)*(hy(j)+2*hyc(j))))-
     &  2*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*(hy(j)+2*hyc(j)))*RCMT(2)))+
     &  selfCTSP(i,j)
       selfCT(i,j)=6*(-(aB0TN1*M12*(dhy(j,2)+dhyc(j,2))*(hy(i)+hyc(i)))
     &  -a0t1*(dhyc(j,2)*hy(i)+dhy(j,2)*hyc(i))-aB0TN1*M12*(dhy(i,2)+
     &  dhyc(i,2))*(hy(j)+hyc(j))-aet1*(dhyc(j,1)*hy(i)+dhyc(i,1)*hy(j)
     &  +dhy(j,1)*hyc(i)+dhy(i,1)*hyc(j))-a0t1*(dhyc(i,2)*hy(j)+
     &  dhy(i,2)*hyc(j))-4*aCEpTT3*M1**3*(hy(i)+hyc(i))*(hy(j)+hyc(j))*
     &  RCMT(1)-aBEpTN1*M1*(M1*((dhy(j,1)+dhyc(j,1))*(hy(i)+hyc(i))+
     &  (dhy(i,1)+dhyc(i,1))*(hy(j)+hyc(j)))+2*(hyc(i)*(2*hy(j)+hyc(j))
     &  +hy(i)*(hy(j)+2*hyc(j)))*RCMT(1))-4*aC0TT3*M1**3*(hy(i)+hyc(i))
     &  *(hy(j)+hyc(j))*RCMT(2)-2*aB0TN1*M1*(hyc(i)*(2*hy(j)+hyc(j))+
     &  hy(i)*(hy(j)+2*hyc(j)))*RCMT(2)+M1*(-(M1*(dhyc(j,3)*(2*hy(i)+
     &  hyc(i))+dhy(j,3)*(hy(i)+2*hyc(i))+dhyc(i,3)*(2*hy(j)+hyc(j))+
     &  dhy(i,3)*(hy(j)+2*hyc(j))))-2*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*
     &  (hy(j)+2*hyc(j)))*RCMT(3)))+selfCT(i,j)
c       print*, "selfCTxxx(i,j)",selfCT(i,j)*ctfac,ctfac
c       selfCT(i,j)=0D0
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
       selfCTSP(i,j)=3*aC0T(ISt3,ISt4,ISt5)*(CSSS(i,ISt3,ISt5)*
     &  CSSS(j,ISt5,ISt4)*RCMSfsq(ISt3,ISt4,1)+CSSS(i,ISt5,ISt3)*
     &  CSSS(j,ISt4,ISt5)*RCMSfsq(ISt4,ISt3,1))+selfCTSP(i,j)
       selfCT(i,j)=3*(aCEpT(ISt3,ISt4,ISt5)*(CSSS(i,ISt3,ISt5)*
     &  CSSS(j,ISt5,ISt4)*RCMSfsq(ISt3,ISt4,1)+CSSS(i,ISt5,ISt3)*
     &  CSSS(j,ISt4,ISt5)*RCMSfsq(ISt4,ISt3,1))+aC0T(ISt3,ISt4,ISt5)*
     &  (CSSS(i,ISt3,ISt5)*CSSS(j,ISt5,ISt4)*RCMSfsq(ISt3,ISt4,2)+
     &  CSSS(i,ISt5,ISt3)*CSSS(j,ISt4,ISt5)*RCMSfsq(ISt4,ISt3,2)))+
     &  selfCT(i,j)
       enddo 
       enddo 
       enddo 
c        print*, "selfCT3(i,j)",selfCT(i,j)*ctfac,ctfac
c       selfCT(i,j)=0D0      
       
       do ISt3=1,2
       selfCTDP(i,j)=3*dCSSSS(i,j,ISt3,ISt3,1)*MassSu2(ISt3)+selfCTDP(i,j)
       selfCTSP(i,j)=3*(aA0TN(ISt3)*dCSSSS(i,j,ISt3,ISt3,1)+
     &  dCSSSS(i,j,ISt3,ISt3,2)*MassSu2(ISt3))+selfCTSP(i,j)
       selfCT(i,j)=3*(aAETN(ISt3)*dCSSSS(i,j,ISt3,ISt3,1)+aA0TN(ISt3)*
     &  dCSSSS(i,j,ISt3,ISt3,2)+dCSSSS(i,j,ISt3,ISt3,3)*MassSu2(ISt3))+
     &  selfCT(i,j)
       enddo 
c        print*, "selfCT1(i,j)",selfCT(i,j)*ctfac,ctfac
c       selfCT(i,j)=0D0         
       do ISt3=1,2
       do ISt4=1,2
       selfCTDP(i,j)=3*(CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,1)+
     &  CSSS(i,ISt3,ISt4)*dCSSS(j,ISt4,ISt3,1)+CSSSS(i,j,ISt4,ISt3)*
     &  RCMSfsq(ISt4,ISt3,1))+selfCTDP(i,j)
       selfCTSP(i,j)=3*(CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,2)+
     &  CSSS(i,ISt3,ISt4)*dCSSS(j,ISt4,ISt3,2)+aB0T1(ISt3,ISt4)*
     &  (CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,1)+CSSS(i,ISt3,ISt4)*
     &  dCSSS(j,ISt4,ISt3,1)+CSSSS(i,j,ISt4,ISt3)*RCMSfsq(ISt4,ISt3,1))
     &  +CSSSS(i,j,ISt4,ISt3)*RCMSfsq(ISt4,ISt3,2))+selfCTSP(i,j)
       selfCT(i,j)=3*(CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,3)+
     &  CSSS(i,ISt3,ISt4)*dCSSS(j,ISt4,ISt3,3)+aBEpT1(ISt3,ISt4)*
     &  (CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,1)+CSSS(i,ISt3,ISt4)*
     &  dCSSS(j,ISt4,ISt3,1)+CSSSS(i,j,ISt4,ISt3)*RCMSfsq(ISt4,ISt3,1))
     &  +aB0T1(ISt3,ISt4)*(CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,2)+
     &  CSSS(i,ISt3,ISt4)*dCSSS(j,ISt4,ISt3,2)+CSSSS(i,j,ISt4,ISt3)*
     &  RCMSfsq(ISt4,ISt3,2))+CSSSS(i,j,ISt4,ISt3)*RCMSfsq(ISt4,ISt3,3)
     &  )+selfCT(i,j)
       enddo 
       enddo 
c        print*, "selfCT2(i,j)",selfCT(i,j)*ctfac,ctfac
c       selfCT(i,j)=0D0         
       enddo
       enddo
c#define PRINTYES 
#ifdef PRINTYES
      print*, "self CT"   
      selfCT1=selfCT*ctfac   
      print*, selfCT1(1,1),SelfCT1(1,2),SelfCT1(1,3),SelfCT1(1,4),SelfCT1(1,5),SelfCT1(1,6)
      print*, SelfCT1(2,1),SelfCT1(2,2),SelfCT1(2,3),SelfCT1(2,4),SelfCT1(2,5),SelfCT1(2,6)
      print*, SelfCT1(3,1),SelfCT1(3,2),SelfCT1(3,3),SelfCT1(3,4),SelfCT1(3,5),SelfCT1(3,6)
      print*, SelfCT1(4,1),SelfCT1(4,2),SelfCT1(4,3),SelfCT1(4,4),SelfCT1(4,5),SelfCT1(4,6)
      print*, SelfCT1(5,1),SelfCT1(5,2),SelfCT1(5,3),SelfCT1(5,4),SelfCT1(5,5),SelfCT1(5,6)
      print*, SelfCT1(6,1),SelfCT1(6,2),SelfCT1(6,3),SelfCT1(6,4),SelfCT1(6,5),SelfCT1(6,6)
      print*, "end self CT"         
#endif
              

       do i=1,6
       do j=1,6
c set 1 diagram + 1
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
       do ISt6=1,2
       selfSP(i,j)=-(aC0T(ISt3,ISt4,ISt5)*
     &  ((CS13S13S13S13p1(ISt5,ISt6,ISt4,ISt6)+3*
     &  CS13S13S13S13p2(ISt5,ISt6,ISt4,ISt6))*CSSS(i,ISt4,ISt3)*
     &  CSSS(j,ISt3,ISt5)+(CS13S13S13S13p1(ISt4,ISt6,ISt5,ISt6)+3*
     &  CS13S13S13S13p2(ISt4,ISt6,ISt5,ISt6))*CSSS(i,ISt3,ISt4)*
     &  CSSS(j,ISt5,ISt3))*MassSu2(ISt6))/16.+selfSP(i,j)
       self(i,j)=-(((CS13S13S13S13p1(ISt5,ISt6,ISt4,ISt6)+3*
     &  CS13S13S13S13p2(ISt5,ISt6,ISt4,ISt6))*CSSS(i,ISt4,ISt3)*
     &  CSSS(j,ISt3,ISt5)+(CS13S13S13S13p1(ISt4,ISt6,ISt5,ISt6)+3*
     &  CS13S13S13S13p2(ISt4,ISt6,ISt5,ISt6))*CSSS(i,ISt3,ISt4)*
     &  CSSS(j,ISt5,ISt3))*(aA0TN(ISt6)*aC0T(ISt3,ISt4,ISt5)+
     &  aCEpT(ISt3,ISt4,ISt5)*MassSu2(ISt6)))/16.+self(i,j)
       enddo 
       enddo 
       enddo 
       enddo 
c set 1 diagram + 2
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
       selfSP(i,j)=(MSQ2*aC0T(ISt3,ISt4,ISt5)*(-
     &  ((CS14S13S14S13p1(ISt5,ISt4)+3*CS14S13S14S13p2(ISt5,ISt4))*
     &  CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt5))-
     &  (CS14S13S14S13p1(ISt4,ISt5)+3*CS14S13S14S13p2(ISt4,ISt5))*
     &  CSSS(i,ISt3,ISt4)*CSSS(j,ISt5,ISt3)))/16.+selfSP(i,j)
       self(i,j)=-((a0t5*aC0T(ISt3,ISt4,ISt5)+MSQ2*
     &  aCEpT(ISt3,ISt4,ISt5))*((CS14S13S14S13p1(ISt5,ISt4)+3*
     &  CS14S13S14S13p2(ISt5,ISt4))*CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt5)
     &  +(CS14S13S14S13p1(ISt4,ISt5)+3*CS14S13S14S13p2(ISt4,ISt5))*
     &  CSSS(i,ISt3,ISt4)*CSSS(j,ISt5,ISt3)))/16.+self(i,j)
       enddo 
       enddo 
       enddo        
c set 6 diagram + 1
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
       selfDP(i,j)=-((CS13S13S13S13p1(ISt4,ISt5,ISt3,ISt5)+3*
     &  CS13S13S13S13p2(ISt4,ISt5,ISt3,ISt5))*CSSSS(i,j,ISt3,ISt4)*
     &  MassSu2(ISt5))/16.+selfDP(i,j)
       selfSP(i,j)=-((CS13S13S13S13p1(ISt4,ISt5,ISt3,ISt5)+3*
     &  CS13S13S13S13p2(ISt4,ISt5,ISt3,ISt5))*CSSSS(i,j,ISt3,ISt4)*
     &  (aA0TN(ISt5)+aB0T1(ISt3,ISt4)*MassSu2(ISt5)))/16.+selfSP(i,j)
       self(i,j)=-((CS13S13S13S13p1(ISt4,ISt5,ISt3,ISt5)+3*
     &  CS13S13S13S13p2(ISt4,ISt5,ISt3,ISt5))*CSSSS(i,j,ISt3,ISt4)*
     &  (aAETN(ISt5)+aA0TN(ISt5)*aB0T1(ISt3,ISt4)+aBEpT1(ISt3,ISt4)*
     &  MassSu2(ISt5)))/16.+self(i,j)
       enddo 
       enddo 
       enddo 
c set 6 diagram + 2
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=-(MSQ2*(CS14S13S14S13p1(ISt4,ISt3)+3*
     &  CS14S13S14S13p2(ISt4,ISt3))*CSSSS(i,j,ISt3,ISt4))/16.+
     &  selfDP(i,j)
       selfSP(i,j)=-((a0t5+MSQ2*aB0T1(ISt3,ISt4))*
     &  (CS14S13S14S13p1(ISt4,ISt3)+3*CS14S13S14S13p2(ISt4,ISt3))*
     &  CSSSS(i,j,ISt3,ISt4))/16.+selfSP(i,j)
       self(i,j)=-((aet5+a0t5*aB0T1(ISt3,ISt4)+MSQ2*aBEpT1(ISt3,ISt4))*
     &  (CS14S13S14S13p1(ISt4,ISt3)+3*CS14S13S14S13p2(ISt4,ISt3))*
     &  CSSSS(i,j,ISt3,ISt4))/16.+self(i,j)
       enddo 
       enddo 
c set 7 diagram + 1
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
       do ISt6=1,2
       selfDP(i,j)=-((CS13S13S13S13p1(ISt4,ISt6,ISt3,ISt5)+3*
     &  CS13S13S13S13p2(ISt4,ISt6,ISt3,ISt5))*CSSS(i,ISt3,ISt4)*
     &  CSSS(j,ISt5,ISt6))/16.+selfDP(i,j)
       selfSP(i,j)=-((aB0T1(ISt3,ISt4)+aB0T1(ISt5,ISt6))*
     &  (CS13S13S13S13p1(ISt4,ISt6,ISt3,ISt5)+3*
     &  CS13S13S13S13p2(ISt4,ISt6,ISt3,ISt5))*CSSS(i,ISt3,ISt4)*
     &  CSSS(j,ISt5,ISt6))/16.+selfSP(i,j)
       self(i,j)=-((aB0T1(ISt3,ISt4)*aB0T1(ISt5,ISt6)+aBEpT1(ISt3,ISt4)
     &  +aBEpT1(ISt5,ISt6))*(CS13S13S13S13p1(ISt4,ISt6,ISt3,ISt5)+3*
     &  CS13S13S13S13p2(ISt4,ISt6,ISt3,ISt5))*CSSS(i,ISt3,ISt4)*
     &  CSSS(j,ISt5,ISt6))/16.+self(i,j)
       enddo 
       enddo 
       enddo 
       enddo               
       enddo
       enddo    
#ifdef PRINTYES
      print*, "self 1loop diagram"   
      self=self*fac   
      print*, self(1,1),self(1,2),self(1,3),self(1,4),self(1,5),self(1,6)
      print*, self(2,1),self(2,2),self(2,3),self(2,4),self(2,5),self(2,6)
      print*, self(3,1),self(3,2),self(3,3),self(3,4),self(3,5),self(3,6)
      print*, self(4,1),self(4,2),self(4,3),self(4,4),self(4,5),self(4,6)
      print*, self(5,1),self(5,2),self(5,3),self(5,4),self(5,5),self(5,6)
      print*, self(6,1),self(6,2),self(6,3),self(6,4),self(6,5),self(6,6)
      print*, "end 1loop diagram" 
      self=0D0        
#endif       
       do i=1,6
       do j=1,6
c set4 part + 1
       do ISt3=1,2
       do ISt4=1,2
              if( ISt4.ne.ISt3 ) then 
       selfDP(i,j)=(4*CSSS(j,ISt3,ISt4)*(CF15F3S13L(ISt3)*(-(M3*
     &  CF15F3S13RC(ISt4)*hyc(i))+M1*CF15F3S13LC(ISt4)*(hy(i)+hyc(i)))+
     &  CF15F3S13R(ISt3)*(-(M3*CF15F3S13LC(ISt4)*hy(i))+M1*
     &  CF15F3S13RC(ISt4)*(hy(i)+hyc(i))))+CSSS(i,ISt4,ISt3)*
     &  (CSSS(j,ISt3,ISt4)+4*CF15F3S13L(ISt4)*(-(M3*CF15F3S13RC(ISt3)*
     &  hyc(j))+M1*CF15F3S13LC(ISt3)*(hy(j)+hyc(j)))+4*CF15F3S13R(ISt4)
     &  *(-(M3*CF15F3S13LC(ISt3)*hy(j))+M1*CF15F3S13RC(ISt3)*(hy(j)+
     &  hyc(j)))))/12.+selfDP(i,j)
       selfSP(i,j)=(aA0TN(ISt4)*(-4*CSSS(j,ISt3,ISt4)*(CF15F3S13L(ISt3)
     &  *(-(M3*CF15F3S13RC(ISt4)*hyc(i))+M1*CF15F3S13LC(ISt4)*(hy(i)+
     &  hyc(i)))+CF15F3S13R(ISt3)*(-(M3*CF15F3S13LC(ISt4)*hy(i))+M1*
     &  CF15F3S13RC(ISt4)*(hy(i)+hyc(i))))-CSSS(i,ISt4,ISt3)*
     &  (CSSS(j,ISt3,ISt4)+4*CF15F3S13L(ISt4)*(-(M3*CF15F3S13RC(ISt3)*
     &  hyc(j))+M1*CF15F3S13LC(ISt3)*(hy(j)+hyc(j)))+4*CF15F3S13R(ISt4)
     &  *(-(M3*CF15F3S13LC(ISt3)*hy(j))+M1*CF15F3S13RC(ISt3)*(hy(j)+
     &  hyc(j)))))+aA0TN(ISt3)*(4*CSSS(j,ISt3,ISt4)*(CF15F3S13L(ISt3)*
     &  (-(M3*CF15F3S13RC(ISt4)*hyc(i))+M1*CF15F3S13LC(ISt4)*(hy(i)+
     &  hyc(i)))+CF15F3S13R(ISt3)*(-(M3*CF15F3S13LC(ISt4)*hy(i))+M1*
     &  CF15F3S13RC(ISt4)*(hy(i)+hyc(i))))+CSSS(i,ISt4,ISt3)*
     &  (CSSS(j,ISt3,ISt4)+4*CF15F3S13L(ISt4)*(-(M3*CF15F3S13RC(ISt3)*
     &  hyc(j))+M1*CF15F3S13LC(ISt3)*(hy(j)+hyc(j)))+4*CF15F3S13R(ISt4)
     &  *(-(M3*CF15F3S13LC(ISt3)*hy(j))+M1*CF15F3S13RC(ISt3)*(hy(j)+
     &  hyc(j)))))+(-2*M3*CSSS(j,ISt3,ISt4)*(CF15F3S13LC(ISt4)*
     &  CF15F3S13R(ISt3)*hy(i)+CF15F3S13L(ISt3)*CF15F3S13RC(ISt4)*
     &  hyc(i))+CSSS(i,ISt4,ISt3)*(CSSS(j,ISt3,ISt4)-2*M3*
     &  (CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*hy(j)+CF15F3S13L(ISt4)*
     &  CF15F3S13RC(ISt3)*hyc(j))))*(MassSu2(ISt3)-MassSu2(ISt4)))/(6.*
     &  (MassSu2(ISt3)-MassSu2(ISt4)))+selfSP(i,j)
       self(i,j)=(CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STGST(2,ISt3,ISt3)-2*CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STGST(2,ISt4,ISt3)+CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STGST(2,ISt4,ISt4)-CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STGST(4,ISt3,ISt3)+2*CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STGST(4,ISt4,ISt3)-CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STGST(4,ISt4,ISt4)-CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STSTG(4,ISt3,ISt3)+CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STSTG(4,ISt3,ISt4)+CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STSTG(4,ISt4,ISt3)-CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD111STSTG(4,ISt4,ISt4)+4*M12*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(1,ISt3)*hy(i)*
     &  MassSu2(ISt3)-4*M12*M3*CF15F3S13L(ISt3)*CF15F3S13RC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(1,ISt4)*hy(i)*MassSu2(ISt3)+4*M1*
     &  CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(2,ISt3)*hy(i)*MassSu2(ISt3)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt3)*hy(i)*
     &  MassSu2(ISt3)-4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt4)*hy(i)*MassSu2(ISt3)-4*M1*
     &  CF15F3S13R(ISt3)*CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(2,ISt4)*hy(i)*MassSu2(ISt3)-4*M1*CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt3)*hy(i)*
     &  MassSu2(ISt3)+4*M3*CF15F3S13LC(ISt4)*CF15F3S13R(ISt3)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt3)*hy(i)*MassSu2(ISt3)-4*M1*
     &  CF15F3S13R(ISt3)*CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(4,ISt3)*hy(i)*MassSu2(ISt3)+4*M1*CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt4)*hy(i)*
     &  MassSu2(ISt3)-4*M3*CF15F3S13LC(ISt4)*CF15F3S13R(ISt3)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt4)*hy(i)*MassSu2(ISt3)+4*M1*
     &  CF15F3S13R(ISt3)*CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(4,ISt4)*hy(i)*MassSu2(ISt3)+4*M12*M3*
     &  CF15F3S13L(ISt4)*CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(1,ISt3)*hy(j)*MassSu2(ISt3)-4*M12*M3*
     &  CF15F3S13L(ISt4)*CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(1,ISt4)*hy(j)*MassSu2(ISt3)+4*M1*CF15F3S13L(ISt4)*
     &  CF15F3S13LC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt3)*hy(j)*
     &  MassSu2(ISt3)+4*M1*CF15F3S13R(ISt4)*CF15F3S13RC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt3)*hy(j)*MassSu2(ISt3)-4*M1*
     &  CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(2,ISt4)*hy(j)*MassSu2(ISt3)-4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt4)*hy(j)*
     &  MassSu2(ISt3)-4*M1*CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt3)*hy(j)*MassSu2(ISt3)+4*M3*
     &  CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(4,ISt3)*hy(j)*MassSu2(ISt3)-4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt3)*hy(j)*
     &  MassSu2(ISt3)+4*M1*CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt4)*hy(j)*MassSu2(ISt3)-4*M3*
     &  CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(4,ISt4)*hy(j)*MassSu2(ISt3)+4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt4)*hy(j)*
     &  MassSu2(ISt3)+4*M12*M3*CF15F3S13LC(ISt4)*CF15F3S13R(ISt3)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(1,ISt3)*hyc(i)*MassSu2(ISt3)-4*
     &  M12*M3*CF15F3S13LC(ISt4)*CF15F3S13R(ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(1,ISt4)*hyc(i)*MassSu2(ISt3)+4*M1*CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt3)*hyc(i)*
     &  MassSu2(ISt3)+4*M1*CF15F3S13R(ISt3)*CF15F3S13RC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt3)*hyc(i)*MassSu2(ISt3)-4*M1*
     &  CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(2,ISt4)*hyc(i)*MassSu2(ISt3)-4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt4)*hyc(i)*
     &  MassSu2(ISt3)-4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt3)*hyc(i)*MassSu2(ISt3)+4*M3*
     &  CF15F3S13L(ISt3)*CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(4,ISt3)*hyc(i)*MassSu2(ISt3)-4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt3)*hyc(i)*
     &  MassSu2(ISt3)+4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt4)*hyc(i)*MassSu2(ISt3)-4*M3*
     &  CF15F3S13L(ISt3)*CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(4,ISt4)*hyc(i)*MassSu2(ISt3)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt4)*hyc(i)*
     &  MassSu2(ISt3)+4*M12*M3*CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(1,ISt3)*hyc(j)*MassSu2(ISt3)-4*
     &  M12*M3*CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(1,ISt4)*hyc(j)*MassSu2(ISt3)+4*M1*CF15F3S13L(ISt4)*
     &  CF15F3S13LC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt3)*hyc(j)*
     &  MassSu2(ISt3)+4*M1*CF15F3S13R(ISt4)*CF15F3S13RC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt3)*hyc(j)*MassSu2(ISt3)-4*M1*
     &  CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(2,ISt4)*hyc(j)*MassSu2(ISt3)-4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt4)*hyc(j)*
     &  MassSu2(ISt3)-4*M1*CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt3)*hyc(j)*MassSu2(ISt3)+4*M3*
     &  CF15F3S13L(ISt4)*CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(4,ISt3)*hyc(j)*MassSu2(ISt3)-4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt3)*hyc(j)*
     &  MassSu2(ISt3)+4*M1*CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt4)*hyc(j)*MassSu2(ISt3)-4*M3*
     &  CF15F3S13L(ISt4)*CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(4,ISt4)*hyc(j)*MassSu2(ISt3)+4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt4)*hyc(j)*
     &  MassSu2(ISt3)-4*M12*M3*CF15F3S13L(ISt3)*CF15F3S13RC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(1,ISt3)*hy(i)*MassSu2(ISt4)+4*M12*
     &  M3*CF15F3S13L(ISt3)*CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(1,ISt4)*hy(i)*MassSu2(ISt4)-4*M1*CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt3)*hy(i)*
     &  MassSu2(ISt4)-4*M1*CF15F3S13R(ISt3)*CF15F3S13RC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt3)*hy(i)*MassSu2(ISt4)+4*M1*
     &  CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(2,ISt4)*hy(i)*MassSu2(ISt4)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt4)*hy(i)*
     &  MassSu2(ISt4)+4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt3)*hy(i)*MassSu2(ISt4)-4*M3*
     &  CF15F3S13LC(ISt4)*CF15F3S13R(ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(4,ISt3)*hy(i)*MassSu2(ISt4)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt3)*hy(i)*
     &  MassSu2(ISt4)-4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt4)*hy(i)*MassSu2(ISt4)+4*M3*
     &  CF15F3S13LC(ISt4)*CF15F3S13R(ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(4,ISt4)*hy(i)*MassSu2(ISt4)-4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt4)*hy(i)*
     &  MassSu2(ISt4)-4*M12*M3*CF15F3S13L(ISt4)*CF15F3S13RC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(1,ISt3)*hy(j)*MassSu2(ISt4)+4*M12*
     &  M3*CF15F3S13L(ISt4)*CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(1,ISt4)*hy(j)*MassSu2(ISt4)-4*M1*CF15F3S13L(ISt4)*
     &  CF15F3S13LC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt3)*hy(j)*
     &  MassSu2(ISt4)-4*M1*CF15F3S13R(ISt4)*CF15F3S13RC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt3)*hy(j)*MassSu2(ISt4)+4*M1*
     &  CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(2,ISt4)*hy(j)*MassSu2(ISt4)+4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt4)*hy(j)*
     &  MassSu2(ISt4)+4*M1*CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt3)*hy(j)*MassSu2(ISt4)-4*M3*
     &  CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(4,ISt3)*hy(j)*MassSu2(ISt4)+4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt3)*hy(j)*
     &  MassSu2(ISt4)-4*M1*CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt4)*hy(j)*MassSu2(ISt4)+4*M3*
     &  CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(4,ISt4)*hy(j)*MassSu2(ISt4)-4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt4)*hy(j)*
     &  MassSu2(ISt4)-4*M12*M3*CF15F3S13LC(ISt4)*CF15F3S13R(ISt3)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(1,ISt3)*hyc(i)*MassSu2(ISt4)+4*
     &  M12*M3*CF15F3S13LC(ISt4)*CF15F3S13R(ISt3)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(1,ISt4)*hyc(i)*MassSu2(ISt4)-4*M1*CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt3)*hyc(i)*
     &  MassSu2(ISt4)-4*M1*CF15F3S13R(ISt3)*CF15F3S13RC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt3)*hyc(i)*MassSu2(ISt4)+4*M1*
     &  CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(2,ISt4)*hyc(i)*MassSu2(ISt4)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(2,ISt4)*hyc(i)*
     &  MassSu2(ISt4)+4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt3)*hyc(i)*MassSu2(ISt4)-4*M3*
     &  CF15F3S13L(ISt3)*CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(4,ISt3)*hyc(i)*MassSu2(ISt4)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt3)*hyc(i)*
     &  MassSu2(ISt4)-4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)*
     &  CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt4)*hyc(i)*MassSu2(ISt4)+4*M3*
     &  CF15F3S13L(ISt3)*CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*
     &  FD211TSTFG(4,ISt4)*hyc(i)*MassSu2(ISt4)-4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*CSSS(j,ISt3,ISt4)*FD211TSTFG(4,ISt4)*hyc(i)*
     &  MassSu2(ISt4)-4*M12*M3*CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(1,ISt3)*hyc(j)*MassSu2(ISt4)+4*
     &  M12*M3*CF15F3S13LC(ISt3)*CF15F3S13R(ISt4)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(1,ISt4)*hyc(j)*MassSu2(ISt4)-4*M1*CF15F3S13L(ISt4)*
     &  CF15F3S13LC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt3)*hyc(j)*
     &  MassSu2(ISt4)-4*M1*CF15F3S13R(ISt4)*CF15F3S13RC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt3)*hyc(j)*MassSu2(ISt4)+4*M1*
     &  CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(2,ISt4)*hyc(j)*MassSu2(ISt4)+4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(2,ISt4)*hyc(j)*
     &  MassSu2(ISt4)+4*M1*CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt3)*hyc(j)*MassSu2(ISt4)-4*M3*
     &  CF15F3S13L(ISt4)*CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(4,ISt3)*hyc(j)*MassSu2(ISt4)+4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt3)*hyc(j)*
     &  MassSu2(ISt4)-4*M1*CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)*
     &  CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt4)*hyc(j)*MassSu2(ISt4)+4*M3*
     &  CF15F3S13L(ISt4)*CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*
     &  FD211TSTFG(4,ISt4)*hyc(j)*MassSu2(ISt4)-4*M1*CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt4,ISt3)*FD211TSTFG(4,ISt4)*hyc(j)*
     &  MassSu2(ISt4))/(6.*(MassSu2(ISt3)-MassSu2(ISt4))**2)+self(i,j)
              else
       selfDP(i,j)=(4*CSSS(j,ISt3,ISt3)*(CF15F3S13L(ISt3)*(-(M3*
     &  CF15F3S13RC(ISt3)*hyc(i))+M1*CF15F3S13LC(ISt3)*(hy(i)+hyc(i)))+
     &  CF15F3S13R(ISt3)*(-(M3*CF15F3S13LC(ISt3)*hy(i))+M1*
     &  CF15F3S13RC(ISt3)*(hy(i)+hyc(i))))+CSSS(i,ISt3,ISt3)*
     &  (CSSS(j,ISt3,ISt3)+4*CF15F3S13L(ISt3)*(-(M3*CF15F3S13RC(ISt3)*
     &  hyc(j))+M1*CF15F3S13LC(ISt3)*(hy(j)+hyc(j)))+4*CF15F3S13R(ISt3)
     &  *(-(M3*CF15F3S13LC(ISt3)*hy(j))+M1*CF15F3S13RC(ISt3)*(hy(j)+
     &  hyc(j)))))/12.+selfDP(i,j)
       selfSP(i,j)=(aA0TN(ISt3)*(4*CSSS(j,ISt3,ISt3)*(CF15F3S13L(ISt3)*
     &  (-(M3*CF15F3S13RC(ISt3)*hyc(i))+M1*CF15F3S13LC(ISt3)*(hy(i)+
     &  hyc(i)))+CF15F3S13R(ISt3)*(-(M3*CF15F3S13LC(ISt3)*hy(i))+M1*
     &  CF15F3S13RC(ISt3)*(hy(i)+hyc(i))))+CSSS(i,ISt3,ISt3)*
     &  (CSSS(j,ISt3,ISt3)+4*CF15F3S13L(ISt3)*(-(M3*CF15F3S13RC(ISt3)*
     &  hyc(j))+M1*CF15F3S13LC(ISt3)*(hy(j)+hyc(j)))+4*CF15F3S13R(ISt3)
     &  *(-(M3*CF15F3S13LC(ISt3)*hy(j))+M1*CF15F3S13RC(ISt3)*(hy(j)+
     &  hyc(j)))))-2*(CF15F3S13L(ISt3)*(-(M3*CF15F3S13RC(ISt3)*
     &  (CSSS(j,ISt3,ISt3)*hyc(i)+CSSS(i,ISt3,ISt3)*hyc(j)))+2*M1*
     &  CF15F3S13LC(ISt3)*(CSSS(j,ISt3,ISt3)*(hy(i)+hyc(i))+
     &  CSSS(i,ISt3,ISt3)*(hy(j)+hyc(j))))+CF15F3S13R(ISt3)*(-(M3*
     &  CF15F3S13LC(ISt3)*(CSSS(j,ISt3,ISt3)*hy(i)+CSSS(i,ISt3,ISt3)*
     &  hy(j)))+2*M1*CF15F3S13RC(ISt3)*(CSSS(j,ISt3,ISt3)*(hy(i)+hyc(i)
     &  )+CSSS(i,ISt3,ISt3)*(hy(j)+hyc(j)))))*MassSu2(ISt3))/(6.*
     &  MassSu(ISt3)**2)+selfSP(i,j)
       self(i,j)=(-(CSSS(i,ISt3,ISt3)*CSSS(j,ISt3,ISt3)*
     &  FD221STSTG(2,ISt3,ISt3))-CSSS(i,ISt3,ISt3)*CSSS(j,ISt3,ISt3)*
     &  FD221STSTG(3,ISt3,ISt3)+4*M12*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt3)*CSSS(j,ISt3,ISt3)*FD221TSTFG(1,ISt3)*hy(i)+4*
     &  M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)*CSSS(j,ISt3,ISt3)*
     &  FD221TSTFG(2,ISt3)*hy(i)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt3)*CSSS(j,ISt3,ISt3)*FD221TSTFG(2,ISt3)*hy(i)-4*
     &  M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)*CSSS(j,ISt3,ISt3)*
     &  FD221TSTFG(3,ISt3)*hy(i)+4*M3*CF15F3S13LC(ISt3)*
     &  CF15F3S13R(ISt3)*CSSS(j,ISt3,ISt3)*FD221TSTFG(3,ISt3)*hy(i)-4*
     &  M1*CF15F3S13R(ISt3)*CF15F3S13RC(ISt3)*CSSS(j,ISt3,ISt3)*
     &  FD221TSTFG(3,ISt3)*hy(i)+4*M12*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt3,ISt3)*FD221TSTFG(1,ISt3)*hy(j)+4*
     &  M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)*CSSS(i,ISt3,ISt3)*
     &  FD221TSTFG(2,ISt3)*hy(j)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt3,ISt3)*FD221TSTFG(2,ISt3)*hy(j)-4*
     &  M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)*CSSS(i,ISt3,ISt3)*
     &  FD221TSTFG(3,ISt3)*hy(j)+4*M3*CF15F3S13LC(ISt3)*
     &  CF15F3S13R(ISt3)*CSSS(i,ISt3,ISt3)*FD221TSTFG(3,ISt3)*hy(j)-4*
     &  M1*CF15F3S13R(ISt3)*CF15F3S13RC(ISt3)*CSSS(i,ISt3,ISt3)*
     &  FD221TSTFG(3,ISt3)*hy(j)+4*M12*M3*CF15F3S13LC(ISt3)*
     &  CF15F3S13R(ISt3)*CSSS(j,ISt3,ISt3)*FD221TSTFG(1,ISt3)*hyc(i)+4*
     &  M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)*CSSS(j,ISt3,ISt3)*
     &  FD221TSTFG(2,ISt3)*hyc(i)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt3)*CSSS(j,ISt3,ISt3)*FD221TSTFG(2,ISt3)*hyc(i)-
     &  4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)*CSSS(j,ISt3,ISt3)*
     &  FD221TSTFG(3,ISt3)*hyc(i)+4*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt3)*CSSS(j,ISt3,ISt3)*FD221TSTFG(3,ISt3)*hyc(i)-
     &  4*M1*CF15F3S13R(ISt3)*CF15F3S13RC(ISt3)*CSSS(j,ISt3,ISt3)*
     &  FD221TSTFG(3,ISt3)*hyc(i)+4*M12*M3*CF15F3S13LC(ISt3)*
     &  CF15F3S13R(ISt3)*CSSS(i,ISt3,ISt3)*FD221TSTFG(1,ISt3)*hyc(j)+4*
     &  M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)*CSSS(i,ISt3,ISt3)*
     &  FD221TSTFG(2,ISt3)*hyc(j)+4*M1*CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt3,ISt3)*FD221TSTFG(2,ISt3)*hyc(j)-
     &  4*M1*CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)*CSSS(i,ISt3,ISt3)*
     &  FD221TSTFG(3,ISt3)*hyc(j)+4*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt3)*CSSS(i,ISt3,ISt3)*FD221TSTFG(3,ISt3)*hyc(j)-
     &  4*M1*CF15F3S13R(ISt3)*CF15F3S13RC(ISt3)*CSSS(i,ISt3,ISt3)*
     &  FD221TSTFG(3,ISt3)*hyc(j))/6.+self(i,j)
              endif
       enddo 
       enddo 
c set4 part + 2
       selfDP(i,j)=(-2*M12*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*(hy(j)+2*
     &  hyc(j))))/3.+selfDP(i,j)
       selfSP(i,j)=(hy(i)*((-4*a0t1+3*M12)*hy(j)+(-8*a0t1+M12)*hyc(j))+
     &  hyc(i)*((-8*a0t1+M12)*hy(j)+(-4*a0t1+3*M12)*hyc(j)))/3.+
     &  selfSP(i,j)
       self(i,j)=(2*(-(M12*FD221TTG(2)*hy(i)*hy(j))+2*M12*FD221TTG(3)*
     &  hy(i)*hy(j)+M12**2*FD221TTG(1)*hy(j)*hyc(i)-M12*FD221TTG(2)*
     &  hy(j)*hyc(i)+FD221TTG(7)*hy(j)*hyc(i)+M12**2*FD221TTG(1)*hy(i)*
     &  hyc(j)-M12*FD221TTG(2)*hy(i)*hyc(j)+FD221TTG(7)*hy(i)*hyc(j)-
     &  M12*FD221TTG(2)*hyc(i)*hyc(j)+2*M12*FD221TTG(3)*hyc(i)*hyc(j)))
     &  /3.+self(i,j)       
              
       enddo
       enddo 
       do i=1,6
       do j=1,6
c set5 part + 1
       selfDP(i,j)=-(M12*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*(hy(j)+2*hyc(j)
     &  )))/3.+selfDP(i,j)
       selfSP(i,j)=(hyc(i)*(-4*a0t1*hy(j)+7*M12*hy(j)-2*a0t1*hyc(j)+4*
     &  M12*hyc(j))+hy(i)*((-2*a0t1+4*M12)*hy(j)+(-4*a0t1+7*M12)*hyc(j)
     &  ))/3.+selfSP(i,j)
       self(i,j)=(2*(hyc(i)*(-((M12*FD311TTG(2)-4*M12*FD311TTG(3)+
     &  FD311TTG(4))*hy(j))+2*M12*(M12*FD311TTG(1)-FD311TTG(2)+
     &  FD311TTG(3))*hyc(j))+hy(i)*(2*M12*(M12*FD311TTG(1)-FD311TTG(2)+
     &  FD311TTG(3))*hy(j)-(M12*FD311TTG(2)-4*M12*FD311TTG(3)+
     &  FD311TTG(4))*hyc(j))))/3.+self(i,j)
c set5 part + 2
       do ISt3=1,2
       selfDP(i,j)=(M1*CF15F3S13L(ISt3)*(-2*M3*CF15F3S13RC(ISt3)*(hy(j)
     &  *hyc(i)+(hy(i)+hyc(i))*hyc(j))+M1*CF15F3S13LC(ISt3)*(hyc(i)*(2*
     &  hy(j)+hyc(j))+hy(i)*(hy(j)+2*hyc(j))))+M1*CF15F3S13R(ISt3)*(-2*
     &  M3*CF15F3S13LC(ISt3)*(hy(j)*hyc(i)+hy(i)*(hy(j)+hyc(j)))+M1*
     &  CF15F3S13RC(ISt3)*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*(hy(j)+2*
     &  hyc(j))))+(CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt3))*(hy(j)*hyc(i)+hy(i)*hyc(j))*MassSu2(ISt3))
     &  /3.+selfDP(i,j)
       selfSP(i,j)=(CF15F3S13L(ISt3)*(2*M3*CF15F3S13RC(ISt3)*(2*(-a0t1+
     &  M12)*hyc(i)*(hy(j)+hyc(j))+hy(i)*(M12*hy(j)+2*(-a0t1+M12)*
     &  hyc(j)))+M1*CF15F3S13LC(ISt3)*(hyc(i)*((4*a0t1-2*M12+M32+2*
     &  aA0TN(ISt3))*hy(j)+2*(a0t1-M12)*hyc(j))+hy(i)*(-2*(-a0t1+M12)*
     &  hy(j)+(4*a0t1-2*M12+M32+2*aA0TN(ISt3))*hyc(j))))+
     &  CF15F3S13R(ISt3)*(2*M3*CF15F3S13LC(ISt3)*(2*(-a0t1+M12)*hy(i)*
     &  (hy(j)+hyc(j))+hyc(i)*(2*(-a0t1+M12)*hy(j)+M12*hyc(j)))+M1*
     &  CF15F3S13RC(ISt3)*(hyc(i)*((4*a0t1-2*M12+M32+2*aA0TN(ISt3))*
     &  hy(j)+2*(a0t1-M12)*hyc(j))+hy(i)*(-2*(-a0t1+M12)*hy(j)+(4*a0t1-
     &  2*M12+M32+2*aA0TN(ISt3))*hyc(j)))))/(3.*M1)+selfSP(i,j)
       self(i,j)=(CF15F3S13L(ISt3)*(4*M1*M3*DCONJG(CF15F3S13R(ISt3))*
     &  (M1**2*FD311TFGST(1,ISt3)*hy(i)*hy(j)+FD311TFGST(3,ISt3)*(hy(j)
     &  *hyc(i)+(hy(i)+hyc(i))*hyc(j)))-2*DCONJG(CF15F3S13L(ISt3))*
     &  (FD311TFGST(4,ISt3)*(hy(j)*hyc(i)+hy(i)*hyc(j))+M12*
     &  FD311TFGST(2,ISt3)*(hy(j)*(2*hy(i)+hyc(i))+(hy(i)+2*hyc(i))*
     &  hyc(j))))-2*CF15F3S13R(ISt3)*(-2*M1*M3*DCONJG(CF15F3S13L(ISt3))
     &  *(M1**2*FD311TFGST(1,ISt3)*hyc(i)*hyc(j)+FD311TFGST(3,ISt3)*
     &  (hy(j)*(hy(i)+hyc(i))+hy(i)*hyc(j)))+DCONJG(CF15F3S13R(ISt3))*
     &  (FD311TFGST(4,ISt3)*(hy(j)*hyc(i)+hy(i)*hyc(j))+M12*
     &  FD311TFGST(2,ISt3)*(hy(j)*(2*hy(i)+hyc(i))+(hy(i)+2*hyc(i))*
     &  hyc(j)))))/3.+self(i,j)
       enddo 
c set5 part + 3
       do ISt3=1,2
       do ISt4=1,2
              if( ISt3.ne.ISt4) then 
       selfDP(i,j)=(CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)+
     &  CSSS(i,ISt3,ISt4)*CSSS(j,ISt4,ISt3))/12.+selfDP(i,j)
       selfSP(i,j)=((CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)+
     &  CSSS(i,ISt3,ISt4)*CSSS(j,ISt4,ISt3))*(MassSu(ISt3)**4-2*
     &  MassSu(ISt4)**4+MassSu2(ISt3)*MassSu2(ISt4)+aA0TN(ISt3)*(2*
     &  MassSu2(ISt3)+MassSu2(ISt4))+aA0TN(ISt4)*(-5*MassSu2(ISt3)+2*
     &  MassSu2(ISt4))))/(12.*(MassSu2(ISt3)-MassSu2(ISt4))**2)+
     &  selfSP(i,j)
       self(i,j)=((CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)+
     &  CSSS(i,ISt3,ISt4)*CSSS(j,ISt4,ISt3))*(2*FD111STGST(2,ISt4,ISt3)
     &  -2*FD111STGST(2,ISt4,ISt4)-2*FD111STGST(4,ISt4,ISt3)+2*
     &  FD111STGST(4,ISt4,ISt4)-FD111STSTG(4,ISt3,ISt4)-
     &  FD111STSTG(4,ISt4,ISt3)+2*FD111STSTG(4,ISt4,ISt4)+(2*
     &  FD211STSTG(2,ISt4,ISt4)+FD211STSTG(3,ISt4,ISt4)+
     &  FD211STSTG(4,ISt4,ISt4))*(MassSu(ISt3)**2-MassSu(ISt4)**2)))
     &  /(12.*(MassSu(ISt3)**2-MassSu(ISt4)**2)**2)+self(i,j)
              else
       selfDP(i,j)=(CSSS(i,ISt3,ISt3)*CSSS(j,ISt3,ISt3))/6.+selfDP(i,j)
       selfSP(i,j)=(CSSS(i,ISt3,ISt3)*CSSS(j,ISt3,ISt3)*(4*aA0TN(ISt3)-
     &  5*MassSu2(ISt3)))/(12.*MassSu(ISt3)**2)+selfSP(i,j)
       self(i,j)=-(CSSS(i,ISt3,ISt3)*CSSS(j,ISt3,ISt3)*(2*
     &  FD311STSTG(2,ISt3,ISt3)+FD311STSTG(3,ISt3,ISt3)+
     &  FD311STSTG(5,ISt3,ISt3)))/6.+self(i,j)
              endif
       enddo 
       enddo
       
c set5 part + 4
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
              if( ISt3.eq.ISt4.and.ISt5.ne.ISt4) then 
       selfDP(i,j)=-(CSSS(i,ISt3,ISt3)*((CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt5)+CF15F3S13R(ISt3)*CF15F3S13RC(ISt5))*
     &  CSSS(j,ISt3,ISt5)+(CF15F3S13L(ISt5)*CF15F3S13LC(ISt3)+
     &  CF15F3S13R(ISt5)*CF15F3S13RC(ISt3))*CSSS(j,ISt5,ISt3)))/6.+
     &  selfDP(i,j)
       selfSP(i,j)=(CSSS(i,ISt3,ISt3)*(-2*(CF15F3S13R(ISt3)*(-2*M1*M3*
     &  CF15F3S13LC(ISt5)+(2*(M12+M32)+aA0TN(ISt3))*CF15F3S13RC(ISt5))*
     &  CSSS(j,ISt3,ISt5)+(CF15F3S13L(ISt5)*((2*(M12+M32)+aA0TN(ISt3))*
     &  CF15F3S13LC(ISt3)-2*M1*M3*CF15F3S13RC(ISt3))+CF15F3S13R(ISt5)*
     &  (-2*M1*M3*CF15F3S13LC(ISt3)+(2*(M12+M32)+aA0TN(ISt3))*
     &  CF15F3S13RC(ISt3)))*CSSS(j,ISt5,ISt3))*MassSu(ISt3)**4+
     &  (CF15F3S13R(ISt3)*CF15F3S13RC(ISt5)*CSSS(j,ISt3,ISt5)+
     &  (CF15F3S13L(ISt5)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt5)*
     &  CF15F3S13RC(ISt3))*CSSS(j,ISt5,ISt3))*MassSu(ISt3)**6-
     &  (CF15F3S13R(ISt3)*CF15F3S13RC(ISt5)*CSSS(j,ISt3,ISt5)+
     &  (CF15F3S13L(ISt5)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt5)*
     &  CF15F3S13RC(ISt3))*CSSS(j,ISt5,ISt3))*MassSu(ISt5)**4*
     &  MassSu2(ISt3)+4*(aA0TN(ISt3)*(-(CF15F3S13R(ISt3)*(-(M1*M3*
     &  CF15F3S13LC(ISt5))+(M12+M32)*CF15F3S13RC(ISt5))*
     &  CSSS(j,ISt3,ISt5))-(CF15F3S13L(ISt5)*((M12+M32)*
     &  CF15F3S13LC(ISt3)-M1*M3*CF15F3S13RC(ISt3))+CF15F3S13R(ISt5)*(-
     &  (M1*M3*CF15F3S13LC(ISt3))+(M12+M32)*CF15F3S13RC(ISt3)))*
     &  CSSS(j,ISt5,ISt3))+(CF15F3S13R(ISt3)*(-(M1*M3*CF15F3S13LC(ISt5)
     &  )+(M12+M32+aA0TN(ISt3))*CF15F3S13RC(ISt5))*CSSS(j,ISt3,ISt5)+
     &  (CF15F3S13L(ISt5)*((M12+M32+aA0TN(ISt3))*CF15F3S13LC(ISt3)-M1*
     &  M3*CF15F3S13RC(ISt3))+CF15F3S13R(ISt5)*(-(M1*M3*
     &  CF15F3S13LC(ISt3))+(M12+M32+aA0TN(ISt3))*CF15F3S13RC(ISt3)))*
     &  CSSS(j,ISt5,ISt3))*MassSu2(ISt3))*MassSu2(ISt5)+2*aA0TN(ISt5)*
     &  MassSu2(ISt3)*(2*(CF15F3S13L(ISt3)*((M12+M32)*CF15F3S13LC(ISt5)
     &  -M1*M3*CF15F3S13RC(ISt5))+CF15F3S13R(ISt3)*(-(M1*M3*
     &  CF15F3S13LC(ISt5))+(M12+M32)*CF15F3S13RC(ISt5)))*
     &  CSSS(j,ISt3,ISt5)+2*(CF15F3S13L(ISt5)*((M12+M32)*
     &  CF15F3S13LC(ISt3)-M1*M3*CF15F3S13RC(ISt3))+CF15F3S13R(ISt5)*(-
     &  (M1*M3*CF15F3S13LC(ISt3))+(M12+M32)*CF15F3S13RC(ISt3)))*
     &  CSSS(j,ISt5,ISt3)-((CF15F3S13L(ISt3)*CF15F3S13LC(ISt5)+
     &  CF15F3S13R(ISt3)*CF15F3S13RC(ISt5))*CSSS(j,ISt3,ISt5)+
     &  (CF15F3S13L(ISt5)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt5)*
     &  CF15F3S13RC(ISt3))*CSSS(j,ISt5,ISt3))*MassSu2(ISt5))+
     &  CF15F3S13L(ISt3)*CSSS(j,ISt3,ISt5)*(4*M1*M3*CF15F3S13RC(ISt5)*
     &  (MassSu(ISt3)**4+(aA0TN(ISt3)-MassSu2(ISt3))*MassSu2(ISt5))+
     &  CF15F3S13LC(ISt5)*(-2*(2*(M12+M32)+aA0TN(ISt3))*MassSu(ISt3)**
     &  4+MassSu(ISt3)**6-MassSu(ISt5)**4*MassSu2(ISt3)+4*(-((M12+M32)*
     &  aA0TN(ISt3))+(M12+M32+aA0TN(ISt3))*MassSu2(ISt3))*MassSu2(ISt5)
     &  ))))/(6.*(MassSu(ISt3)**3-MassSu(ISt3)*MassSu2(ISt5))**2)+
     &  selfSP(i,j)
       self(i,j)=(2*CSSS(i,ISt3,ISt3)*(CF15F3S13L(ISt3)*
     &  CSSS(j,ISt3,ISt5)*(M1*M3*CF15F3S13RC(ISt5)*(-FD111TSTFG(1,ISt3)
     &  +FD111TSTFG(1,ISt5)+FD211STTFG(1,ISt3)*(MassSu(ISt3)**2-
     &  MassSu(ISt5)**2))+CF15F3S13LC(ISt5)*(FD111STFGT(2,ISt3)-
     &  FD111STFGT(2,ISt5)-FD111STFGT(4,ISt3)+FD111STFGT(4,ISt5)+
     &  FD111TSTFG(4,ISt3)-FD111TSTFG(4,ISt5)+(FD211STTFG(2,ISt3)-
     &  FD211STTFG(3,ISt3))*(MassSu(ISt3)**2-MassSu(ISt5)**2)))+
     &  CF15F3S13R(ISt3)*CSSS(j,ISt3,ISt5)*(M1*M3*CF15F3S13LC(ISt5)*(-
     &  FD111TSTFG(1,ISt3)+FD111TSTFG(1,ISt5)+FD211STTFG(1,ISt3)*
     &  (MassSu(ISt3)**2-MassSu(ISt5)**2))+CF15F3S13RC(ISt5)*
     &  (FD111STFGT(2,ISt3)-FD111STFGT(2,ISt5)-FD111STFGT(4,ISt3)+
     &  FD111STFGT(4,ISt5)+FD111TSTFG(4,ISt3)-FD111TSTFG(4,ISt5)+
     &  (FD211STTFG(2,ISt3)-FD211STTFG(3,ISt3))*(MassSu(ISt3)**2-
     &  MassSu(ISt5)**2)))+CSSS(j,ISt5,ISt3)*(CF15F3S13L(ISt5)*(M1*M3*
     &  CF15F3S13RC(ISt3)*(-FD111TSTFG(1,ISt3)+FD111TSTFG(1,ISt5)+
     &  FD211STTFG(1,ISt3)*(MassSu(ISt3)**2-MassSu(ISt5)**2))+
     &  CF15F3S13LC(ISt3)*(FD111STFGT(2,ISt3)-FD111STFGT(2,ISt5)-
     &  FD111STFGT(4,ISt3)+FD111STFGT(4,ISt5)+FD111TSTFG(4,ISt3)-
     &  FD111TSTFG(4,ISt5)+(FD211STTFG(2,ISt3)-FD211STTFG(3,ISt3))*
     &  (MassSu(ISt3)**2-MassSu(ISt5)**2)))+CF15F3S13R(ISt5)*(M1*M3*
     &  CF15F3S13LC(ISt3)*(-FD111TSTFG(1,ISt3)+FD111TSTFG(1,ISt5)+
     &  FD211STTFG(1,ISt3)*(MassSu(ISt3)**2-MassSu(ISt5)**2))+
     &  CF15F3S13RC(ISt3)*(FD111STFGT(2,ISt3)-FD111STFGT(2,ISt5)-
     &  FD111STFGT(4,ISt3)+FD111STFGT(4,ISt5)+FD111TSTFG(4,ISt3)-
     &  FD111TSTFG(4,ISt5)+(FD211STTFG(2,ISt3)-FD211STTFG(3,ISt3))*
     &  (MassSu(ISt3)**2-MassSu(ISt5)**2))))))/(3.*(MassSu(ISt3)**2-
     &  MassSu(ISt5)**2)**2)+self(i,j)
              endif
              if( ISt3.eq.ISt5.and.ISt5.ne.ISt4) then 
       selfDP(i,j)=-(((CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)+
     &  CF15F3S13R(ISt3)*CF15F3S13RC(ISt4))*CSSS(i,ISt3,ISt4)+
     &  (CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3))*CSSS(i,ISt4,ISt3))*CSSS(j,ISt3,ISt3))/6.+
     &  selfDP(i,j)
       selfSP(i,j)=(CSSS(j,ISt3,ISt3)*(-2*(CF15F3S13R(ISt3)*(-2*M1*M3*
     &  CF15F3S13LC(ISt4)+(2*(M12+M32)+aA0TN(ISt3))*CF15F3S13RC(ISt4))*
     &  CSSS(i,ISt3,ISt4)+(CF15F3S13L(ISt4)*((2*(M12+M32)+aA0TN(ISt3))*
     &  CF15F3S13LC(ISt3)-2*M1*M3*CF15F3S13RC(ISt3))+CF15F3S13R(ISt4)*
     &  (-2*M1*M3*CF15F3S13LC(ISt3)+(2*(M12+M32)+aA0TN(ISt3))*
     &  CF15F3S13RC(ISt3)))*CSSS(i,ISt4,ISt3))*MassSu(ISt3)**4+
     &  (CF15F3S13R(ISt3)*CF15F3S13RC(ISt4)*CSSS(i,ISt3,ISt4)+
     &  (CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3))*CSSS(i,ISt4,ISt3))*MassSu(ISt3)**6-
     &  (CF15F3S13R(ISt3)*CF15F3S13RC(ISt4)*CSSS(i,ISt3,ISt4)+
     &  (CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3))*CSSS(i,ISt4,ISt3))*MassSu(ISt4)**4*
     &  MassSu2(ISt3)+4*(aA0TN(ISt3)*(-(CF15F3S13R(ISt3)*(-(M1*M3*
     &  CF15F3S13LC(ISt4))+(M12+M32)*CF15F3S13RC(ISt4))*
     &  CSSS(i,ISt3,ISt4))-(CF15F3S13L(ISt4)*((M12+M32)*
     &  CF15F3S13LC(ISt3)-M1*M3*CF15F3S13RC(ISt3))+CF15F3S13R(ISt4)*(-
     &  (M1*M3*CF15F3S13LC(ISt3))+(M12+M32)*CF15F3S13RC(ISt3)))*
     &  CSSS(i,ISt4,ISt3))+(CF15F3S13R(ISt3)*(-(M1*M3*CF15F3S13LC(ISt4)
     &  )+(M12+M32+aA0TN(ISt3))*CF15F3S13RC(ISt4))*CSSS(i,ISt3,ISt4)+
     &  (CF15F3S13L(ISt4)*((M12+M32+aA0TN(ISt3))*CF15F3S13LC(ISt3)-M1*
     &  M3*CF15F3S13RC(ISt3))+CF15F3S13R(ISt4)*(-(M1*M3*
     &  CF15F3S13LC(ISt3))+(M12+M32+aA0TN(ISt3))*CF15F3S13RC(ISt3)))*
     &  CSSS(i,ISt4,ISt3))*MassSu2(ISt3))*MassSu2(ISt4)+2*aA0TN(ISt4)*
     &  MassSu2(ISt3)*(2*(CF15F3S13L(ISt3)*((M12+M32)*CF15F3S13LC(ISt4)
     &  -M1*M3*CF15F3S13RC(ISt4))+CF15F3S13R(ISt3)*(-(M1*M3*
     &  CF15F3S13LC(ISt4))+(M12+M32)*CF15F3S13RC(ISt4)))*
     &  CSSS(i,ISt3,ISt4)+2*(CF15F3S13L(ISt4)*((M12+M32)*
     &  CF15F3S13LC(ISt3)-M1*M3*CF15F3S13RC(ISt3))+CF15F3S13R(ISt4)*(-
     &  (M1*M3*CF15F3S13LC(ISt3))+(M12+M32)*CF15F3S13RC(ISt3)))*
     &  CSSS(i,ISt4,ISt3)-((CF15F3S13L(ISt3)*CF15F3S13LC(ISt4)+
     &  CF15F3S13R(ISt3)*CF15F3S13RC(ISt4))*CSSS(i,ISt3,ISt4)+
     &  (CF15F3S13L(ISt4)*CF15F3S13LC(ISt3)+CF15F3S13R(ISt4)*
     &  CF15F3S13RC(ISt3))*CSSS(i,ISt4,ISt3))*MassSu2(ISt4))+
     &  CF15F3S13L(ISt3)*CSSS(i,ISt3,ISt4)*(4*M1*M3*CF15F3S13RC(ISt4)*
     &  (MassSu(ISt3)**4+(aA0TN(ISt3)-MassSu2(ISt3))*MassSu2(ISt4))+
     &  CF15F3S13LC(ISt4)*(-2*(2*(M12+M32)+aA0TN(ISt3))*MassSu(ISt3)**
     &  4+MassSu(ISt3)**6-MassSu(ISt4)**4*MassSu2(ISt3)+4*(-((M12+M32)*
     &  aA0TN(ISt3))+(M12+M32+aA0TN(ISt3))*MassSu2(ISt3))*MassSu2(ISt4)
     &  ))))/(6.*(MassSu(ISt3)**3-MassSu(ISt3)*MassSu2(ISt4))**2)+
     &  selfSP(i,j)
       self(i,j)=(2*CSSS(j,ISt3,ISt3)*(CF15F3S13L(ISt3)*
     &  CSSS(i,ISt3,ISt4)*(M1*M3*CF15F3S13RC(ISt4)*(-FD111TSTFG(1,ISt3)
     &  +FD111TSTFG(1,ISt4)+FD211STTFG(1,ISt3)*(MassSu(ISt3)**2-
     &  MassSu(ISt4)**2))+CF15F3S13LC(ISt4)*(FD111STFGT(2,ISt3)-
     &  FD111STFGT(2,ISt4)-FD111STFGT(4,ISt3)+FD111STFGT(4,ISt4)+
     &  FD111TSTFG(4,ISt3)-FD111TSTFG(4,ISt4)+(FD211STTFG(2,ISt3)-
     &  FD211STTFG(3,ISt3))*(MassSu(ISt3)**2-MassSu(ISt4)**2)))+
     &  CF15F3S13R(ISt3)*CSSS(i,ISt3,ISt4)*(M1*M3*CF15F3S13LC(ISt4)*(-
     &  FD111TSTFG(1,ISt3)+FD111TSTFG(1,ISt4)+FD211STTFG(1,ISt3)*
     &  (MassSu(ISt3)**2-MassSu(ISt4)**2))+CF15F3S13RC(ISt4)*
     &  (FD111STFGT(2,ISt3)-FD111STFGT(2,ISt4)-FD111STFGT(4,ISt3)+
     &  FD111STFGT(4,ISt4)+FD111TSTFG(4,ISt3)-FD111TSTFG(4,ISt4)+
     &  (FD211STTFG(2,ISt3)-FD211STTFG(3,ISt3))*(MassSu(ISt3)**2-
     &  MassSu(ISt4)**2)))+CSSS(i,ISt4,ISt3)*(CF15F3S13L(ISt4)*(M1*M3*
     &  CF15F3S13RC(ISt3)*(-FD111TSTFG(1,ISt3)+FD111TSTFG(1,ISt4)+
     &  FD211STTFG(1,ISt3)*(MassSu(ISt3)**2-MassSu(ISt4)**2))+
     &  CF15F3S13LC(ISt3)*(FD111STFGT(2,ISt3)-FD111STFGT(2,ISt4)-
     &  FD111STFGT(4,ISt3)+FD111STFGT(4,ISt4)+FD111TSTFG(4,ISt3)-
     &  FD111TSTFG(4,ISt4)+(FD211STTFG(2,ISt3)-FD211STTFG(3,ISt3))*
     &  (MassSu(ISt3)**2-MassSu(ISt4)**2)))+CF15F3S13R(ISt4)*(M1*M3*
     &  CF15F3S13LC(ISt3)*(-FD111TSTFG(1,ISt3)+FD111TSTFG(1,ISt4)+
     &  FD211STTFG(1,ISt3)*(MassSu(ISt3)**2-MassSu(ISt4)**2))+
     &  CF15F3S13RC(ISt3)*(FD111STFGT(2,ISt3)-FD111STFGT(2,ISt4)-
     &  FD111STFGT(4,ISt3)+FD111STFGT(4,ISt4)+FD111TSTFG(4,ISt3)-
     &  FD111TSTFG(4,ISt4)+(FD211STTFG(2,ISt3)-FD211STTFG(3,ISt3))*
     &  (MassSu(ISt3)**2-MassSu(ISt4)**2))))))/(3.*(MassSu(ISt3)**2-
     &  MassSu(ISt4)**2)**2)+self(i,j)
              endif
              if( ISt5.eq.ISt4.and.ISt5.ne.ISt3) then 
       selfDP(i,j)=-((CF15F3S13L(ISt4)*CF15F3S13LC(ISt4)+
     &  CF15F3S13R(ISt4)*CF15F3S13RC(ISt4))*(CSSS(i,ISt4,ISt3)*
     &  CSSS(j,ISt3,ISt4)+CSSS(i,ISt3,ISt4)*CSSS(j,ISt4,ISt3)))/6.+
     &  selfDP(i,j)
       selfSP(i,j)=-((CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)+
     &  CSSS(i,ISt3,ISt4)*CSSS(j,ISt4,ISt3))*(2*aA0TN(ISt4)*
     &  (CF15F3S13L(ISt4)*(-2*M1*M3*CF15F3S13RC(ISt4)*MassSu2(ISt3)+
     &  CF15F3S13LC(ISt4)*(MassSu(ISt4)**4+2*MassSu2(ISt3)*(M12+M32-
     &  MassSu2(ISt4))))+CF15F3S13R(ISt4)*(-2*M1*M3*CF15F3S13LC(ISt4)*
     &  MassSu2(ISt3)+CF15F3S13RC(ISt4)*(MassSu(ISt4)**4+2*
     &  MassSu2(ISt3)*(M12+M32-MassSu2(ISt4)))))+MassSu2(ISt4)*(2*
     &  aA0TN(ISt3)*(CF15F3S13L(ISt4)*(2*M1*M3*CF15F3S13RC(ISt4)+
     &  CF15F3S13LC(ISt4)*(-2*(M12+M32)+MassSu2(ISt3)))+
     &  CF15F3S13R(ISt4)*(2*M1*M3*CF15F3S13LC(ISt4)+CF15F3S13RC(ISt4)*
     &  (-2*(M12+M32)+MassSu2(ISt3))))+(MassSu2(ISt3)-MassSu2(ISt4))*
     &  (CF15F3S13L(ISt4)*(4*M1*M3*CF15F3S13RC(ISt4)+CF15F3S13LC(ISt4)*
     &  (-4*(M12+M32)+MassSu2(ISt3)+MassSu2(ISt4)))+CF15F3S13R(ISt4)*
     &  (4*M1*M3*CF15F3S13LC(ISt4)+CF15F3S13RC(ISt4)*(-4*(M12+M32)+
     &  MassSu2(ISt3)+MassSu2(ISt4)))))))/(6.*(MassSu(ISt4)**3-
     &  MassSu(ISt4)*MassSu2(ISt3))**2)+selfSP(i,j)
       self(i,j)=(-2*(CSSS(i,ISt4,ISt3)*CSSS(j,ISt3,ISt4)+
     &  CSSS(i,ISt3,ISt4)*CSSS(j,ISt4,ISt3))*(CF15F3S13L(ISt4)*(M1*M3*
     &  CF15F3S13RC(ISt4)*(-FD111TSTFG(1,ISt3)+FD111TSTFG(1,ISt4)+
     &  FD211STTFG(1,ISt4)*(MassSu(ISt3)**2-MassSu(ISt4)**2))+
     &  CF15F3S13LC(ISt4)*(FD111STFGT(2,ISt3)-FD111STFGT(2,ISt4)-
     &  FD111STFGT(4,ISt3)+FD111STFGT(4,ISt4)+FD111TSTFG(4,ISt3)-
     &  FD111TSTFG(4,ISt4)+(FD211STTFG(2,ISt4)-FD211STTFG(3,ISt4))*
     &  (MassSu(ISt3)**2-MassSu(ISt4)**2)))+CF15F3S13R(ISt4)*(M1*M3*
     &  CF15F3S13LC(ISt4)*(-FD111TSTFG(1,ISt3)+FD111TSTFG(1,ISt4)+
     &  FD211STTFG(1,ISt4)*(MassSu(ISt3)**2-MassSu(ISt4)**2))+
     &  CF15F3S13RC(ISt4)*(FD111STFGT(2,ISt3)-FD111STFGT(2,ISt4)-
     &  FD111STFGT(4,ISt3)+FD111STFGT(4,ISt4)+FD111TSTFG(4,ISt3)-
     &  FD111TSTFG(4,ISt4)+(FD211STTFG(2,ISt4)-FD211STTFG(3,ISt4))*
     &  (MassSu(ISt3)**2-MassSu(ISt4)**2)))))/(3.*(MassSu(ISt3)**2-
     &  MassSu(ISt4)**2)**2)+self(i,j)
              endif
              if( ISt4.eq.ISt5.and.ISt3.eq.ISt4) then 
       selfDP(i,j)=-((CF15F3S13L(ISt3)*CF15F3S13LC(ISt3)+
     &  CF15F3S13R(ISt3)*CF15F3S13RC(ISt3))*CSSS(i,ISt3,ISt3)*
     &  CSSS(j,ISt3,ISt3))/3.+selfDP(i,j)
       selfSP(i,j)=(-2*CSSS(i,ISt3,ISt3)*CSSS(j,ISt3,ISt3)*
     &  (CF15F3S13L(ISt3)*(-(M1*M3*CF15F3S13RC(ISt3))+CF15F3S13LC(ISt3)
     &  *(M12+M32+aA0TN(ISt3)-MassSu2(ISt3)))+CF15F3S13R(ISt3)*(-(M1*
     &  M3*CF15F3S13LC(ISt3))+CF15F3S13RC(ISt3)*(M12+M32+aA0TN(ISt3)-
     &  MassSu2(ISt3)))))/(3.*MassSu(ISt3)**2)+selfSP(i,j)
       self(i,j)=(4*CSSS(i,ISt3,ISt3)*CSSS(j,ISt3,ISt3)*
     &  (CF15F3S13LC(ISt3)*(M1*M3*CF15F3S13R(ISt3)*FD311STTFG(1,ISt3)+
     &  CF15F3S13L(ISt3)*(FD311STTFG(2,ISt3)-FD311STTFG(5,ISt3)))+
     &  CF15F3S13RC(ISt3)*(M1*M3*CF15F3S13L(ISt3)*FD311STTFG(1,ISt3)+
     &  CF15F3S13R(ISt3)*(FD311STTFG(2,ISt3)-FD311STTFG(5,ISt3)))))/3.+
     &  self(i,j)
              endif
       enddo 
       enddo 
       enddo        
       enddo 
       enddo 
#ifdef PRINTYES
      print*, "self 45 diagram"   
      self=self*fac   
      print*, self(1,1),self(1,2),self(1,3),self(1,4),self(1,5),self(1,6)
      print*, self(2,1),self(2,2),self(2,3),self(2,4),self(2,5),self(2,6)
      print*, self(3,1),self(3,2),self(3,3),self(3,4),self(3,5),self(3,6)
      print*, self(4,1),self(4,2),self(4,3),self(4,4),self(4,5),self(4,6)
      print*, self(5,1),self(5,2),self(5,3),self(5,4),self(5,5),self(5,6)
      print*, self(6,1),self(6,2),self(6,3),self(6,4),self(6,5),self(6,6)
      print*, "end 45 diagram" 
      self=0D0        
#endif  
c set8 part + 1
       do i=1,6
       do j=1,6
       do ISt3=1,2
       do ISt4=1,2
              if( ISt4.ne.ISt3 ) then 
       selfDP(i,j)=(CSSSS(i,j,ISt3,ISt4)*(CF15F3S13L(ISt3)*(-2*M1*M3*
     &  CF15F3S13RC(ISt4)+CF15F3S13LC(ISt4)*(2*(M12+M32)-MassSu2(ISt3)-
     &  MassSu2(ISt4)))+CF15F3S13R(ISt3)*(-2*M1*M3*CF15F3S13LC(ISt4)+
     &  CF15F3S13RC(ISt4)*(2*(M12+M32)-MassSu2(ISt3)-MassSu2(ISt4)))))
     &  /6.+selfDP(i,j)
       selfSP(i,j)=(CSSSS(i,j,ISt3,ISt4)*(4*aA0TN(ISt3)*
     &  (CF15F3S13L(ISt3)*((M12+M32)*CF15F3S13LC(ISt4)-M1*M3*
     &  CF15F3S13RC(ISt4))+CF15F3S13R(ISt3)*(-(M1*M3*CF15F3S13LC(ISt4))
     &  +(M12+M32)*CF15F3S13RC(ISt4)))-2*aA0TN(ISt3)*(CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)+CF15F3S13R(ISt3)*CF15F3S13RC(ISt4))*
     &  MassSu2(ISt3)+2*aA0TN(ISt4)*(CF15F3S13L(ISt3)*(2*M1*M3*
     &  CF15F3S13RC(ISt4)+CF15F3S13LC(ISt4)*(-2*(M12+M32)+MassSu2(ISt4)
     &  ))+CF15F3S13R(ISt3)*(2*M1*M3*CF15F3S13LC(ISt4)+
     &  CF15F3S13RC(ISt4)*(-2*(M12+M32)+MassSu2(ISt4))))-(MassSu(ISt3)-
     &  MassSu(ISt4))*(MassSu(ISt3)+MassSu(ISt4))*(CF15F3S13LC(ISt4)*
     &  (2*M1*M3*CF15F3S13R(ISt3)+CF15F3S13L(ISt3)*(MassSu2(ISt3)+
     &  MassSu2(ISt4)))+CF15F3S13RC(ISt4)*(2*M1*M3*CF15F3S13L(ISt3)+
     &  CF15F3S13R(ISt3)*(MassSu2(ISt3)+MassSu2(ISt4))))))/(6.*
     &  (MassSu2(ISt3)-MassSu2(ISt4)))+selfSP(i,j)
       self(i,j)=(2*CSSSS(i,j,ISt3,ISt4)*(CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*FD111FGSTT(2,ISt3)+CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*FD111FGSTT(2,ISt3)-CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*FD111FGSTT(2,ISt4)-CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*FD111FGSTT(2,ISt4)-CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*FD111FGSTT(4,ISt3)-CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*FD111FGSTT(4,ISt3)+CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt4)*FD111FGSTT(4,ISt4)+CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt4)*FD111FGSTT(4,ISt4)+M1*M3*CF15F3S13LC(ISt4)*
     &  CF15F3S13R(ISt3)*FD111TFGST(1,ISt3)+M1*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt4)*FD111TFGST(1,ISt3)-M1*M3*CF15F3S13LC(ISt4)*
     &  CF15F3S13R(ISt3)*FD111TFGST(1,ISt4)-M1*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt4)*FD111TFGST(1,ISt4)))/(3.*(MassSu2(ISt3)-
     &  MassSu2(ISt4)))+self(i,j)

              else
       selfDP(i,j)=(CSSSS(i,j,ISt3,ISt3)*(CF15F3S13L(ISt3)*(-(M1*M3*
     &  CF15F3S13RC(ISt3))+CF15F3S13LC(ISt3)*(M12+M32-MassSu2(ISt3)))+
     &  CF15F3S13R(ISt3)*(-(M1*M3*CF15F3S13LC(ISt3))+CF15F3S13RC(ISt3)*
     &  (M12+M32-MassSu2(ISt3)))))/3.+selfDP(i,j)
       selfSP(i,j)=(CSSSS(i,j,ISt3,ISt3)*(2*aA0TN(ISt3)*
     &  (CF15F3S13L(ISt3)*((M12+M32)*CF15F3S13LC(ISt3)-M1*M3*
     &  CF15F3S13RC(ISt3))+CF15F3S13R(ISt3)*(-(M1*M3*CF15F3S13LC(ISt3))
     &  +(M12+M32)*CF15F3S13RC(ISt3)))-(CF15F3S13L(ISt3)*(2*(M12+M32+
     &  aA0TN(ISt3))*CF15F3S13LC(ISt3)-M1*M3*CF15F3S13RC(ISt3))+
     &  CF15F3S13R(ISt3)*(-(M1*M3*CF15F3S13LC(ISt3))+2*(M12+M32+
     &  aA0TN(ISt3))*CF15F3S13RC(ISt3)))*MassSu2(ISt3)))/(3.*
     &  MassSu(ISt3)**2)+selfSP(i,j)
       self(i,j)=(2*CSSSS(i,j,ISt3,ISt3)*(M1*M3*CF15F3S13LC(ISt3)*
     &  CF15F3S13R(ISt3)*FD211STFGT(1,ISt3)+M1*M3*CF15F3S13L(ISt3)*
     &  CF15F3S13RC(ISt3)*FD211STFGT(1,ISt3)+CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt3)*FD211STFGT(2,ISt3)+CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt3)*FD211STFGT(2,ISt3)-CF15F3S13L(ISt3)*
     &  CF15F3S13LC(ISt3)*FD211STFGT(3,ISt3)-CF15F3S13R(ISt3)*
     &  CF15F3S13RC(ISt3)*FD211STFGT(3,ISt3)))/3.+self(i,j)
              endif
       enddo 
       enddo 
       enddo
       enddo 
       
            
c set8 part + 2
       do i=1,6
       do j=1,6
       do ISt3=1,2
       selfDP(i,j)=(CSSSS(i,j,ISt3,ISt3)*MassSu2(ISt3))/4.+selfDP(i,j)
       selfSP(i,j)=(CSSSS(i,j,ISt3,ISt3)*(6*aA0TN(ISt3)+MassSu2(ISt3)))
     &  /12.+selfSP(i,j)
       self(i,j)=(CSSSS(i,j,ISt3,ISt3)*(8*FD211STGST(2,ISt3,ISt3)-4*
     &  FD211STGST(3,ISt3,ISt3)-4*FD211STGST(4,ISt3,ISt3)-2*
     &  FD211STSTG(2,ISt3,ISt3)+3*FD211STSTG(3,ISt3,ISt3)-
     &  FD211STSTG(4,ISt3,ISt3)))/12.+self(i,j)
       enddo        
        
       enddo
       enddo  
       
#ifdef PRINTYES
      print*, "self set81 diagram"   
      self=self*fac   
      print*, self(1,1),self(1,2),self(1,3),self(1,4),self(1,5),self(1,6)
      print*, self(2,1),self(2,2),self(2,3),self(2,4),self(2,5),self(2,6)
      print*, self(3,1),self(3,2),self(3,3),self(3,4),self(3,5),self(3,6)
      print*, self(4,1),self(4,2),self(4,3),self(4,4),self(4,5),self(4,6)
      print*, self(5,1),self(5,2),self(5,3),self(5,4),self(5,5),self(5,6)
      print*, self(6,1),self(6,2),self(6,3),self(6,4),self(6,5),self(6,6)
      print*, "end 1loop diagram" 
      self=0D0        
#endif  
       selfHH= selfCT*ctfac + self*fac  
      print*, "full self HH energy"         
      print*, selfHH(1,1),selfHH(1,2),selfHH(1,3),selfHH(1,4),selfHH(1,5),selfHH(1,6)
      print*, selfHH(2,1),selfHH(2,2),selfHH(2,3),selfHH(2,4),selfHH(2,5),selfHH(2,6)
      print*, selfHH(3,1),selfHH(3,2),selfHH(3,3),selfHH(3,4),selfHH(3,5),selfHH(3,6)
      print*, selfHH(4,1),selfHH(4,2),selfHH(4,3),selfHH(4,4),selfHH(4,5),selfHH(4,6)
      print*, selfHH(5,1),selfHH(5,2),selfHH(5,3),selfHH(5,4),selfHH(5,5),selfHH(5,6)
      print*, selfHH(6,1),selfHH(6,2),selfHH(6,3),selfHH(6,4),selfHH(6,5),selfHH(6,6)
      print*, "full self HH energy"                           
       end subroutine TLseHH_QCD

