      subroutine couplings_atlambda_zero(Q2N,MTN,MHpm2N,vvN,vSN,TBN,MW2N,MZ2N,
     -   MST1,MST2,ZUN,ATN,MUEN,AlaN,kaN,AKaN,expETAN,expvSN,MHpmInput,ierror)
      implicit none
      integer i,j,l,k,l1,gen1,gen2,gen3,gen4,gen5,i1,i2,i3,ierror
      double precision Q2N,MTN,MSt1,MSt2,MHpm2N,vvN,vSN,TBN,MW2N,MZ2N,
     .     S2B,C2B,am,diff
      double complex MassH(6,6),ZHN(6,6)
      double complex ATN,ZUN(2,2),MUEN,AlaN,kaN,AKaN,expETAN,expvSN,
     .     cm,yy(3,3)
      character(60) mathematica_c
      logical MHpmInput

      integer modselval(10)
      character spinfo1*100,spinfo2*100
      COMMON/SLHA_leshouches0_NMSSM/spinfo1,spinfo2,modselval

#include "TLMT4.h"
#include "TLMT4lambda.h"
      pi = 2d0*Asin(1d0)
      IC=dcmplx(0,1D0)
      sqrt2= sqrt(2D0)
      ZU(1:2,1:2)=ZUN(1:2,1:2)
      Q2=Q2N;vs=vSN;vS2=vS**2
      vv=vvN;vv2= vv**2;MW2=MW2N;MZ2=MZ2N
      CW2=MW2/MZ2; SW2=1-CW2;SW=sqrt(SW2);CW=Sqrt(CW2)     
      TB=TBN;      TB2= TB**2;	       CB2 = 1/(1 + TB2)
      SB2 = CB2*TB2;	       CB = sqrt(CB2);	SB = CB*TB
      S2B = 2*TB*CB2;          C2B= (CB - SB)*(CB + SB)
      ZP(1,1)=-CB; ZP(1,2)=SB; ZP(2,1)=SB;  ZP(2,2)= CB
      ATT=ATN
      expETA=expETAN;expvS=expvSN
      MUE=MUEN; MUEC=DCONJG(MUE)
      la=0D0
      ihiggs=1;ineu=1
      ihiggse=6;ineue=3
      abslambda = abs(la); la2=abslambda**2;laC=DCONJG(la)
      kappa=0D0; abskappa=abs(kappa); ka2=abskappa**2
      kappaC=DCONJG(kappa)
      if (abslambda.gt.1D-10)then
      explam=la/abslambda
      else
      explam=1D0
      endif

      if (abskappa.gt.1D-10)then
      expkap=kappa/abskappa
      else
      expkap=1D0
      endif

      Aka=AkaN; ReAkappa= DBLE(Aka);absAkappa=abs(Aka)
      if (absAkappa.gt.1D-10)then
      expAka = Aka/absAkappa
      else
      expAka=1D0
      endif

      cosphiy = DBLE(expETA/expVS**(2)/expkap*explam)
      sinphiy = DIMAG(expETA/expVS**(2)/expkap*explam)
      cosk3s= DBLE(expkap*expVS**3)
      sink3s= DIMAG(expkap*expVS**3)
      sign2 =DBLE(expVS*expAka*expkap)/abs(DBLE(expVS*expAka*expkap))

      if (MHpmInput)then

        MHp2N=MHpm2N
        RAlambda=DBLE(AlaN)
        IAlambda=DIMAG(AlaN)
        sign1 =  1D0
      else
        sign1 =  1D0
        sinphix =0D0
        sinphix =0D0
        sinphiz =0D0
        Cosphix = Sign1*Sqrt(1D0- Sinphix**2)
        Cosphiz = Sign2*Sqrt(1D0- Sinphiz**2)
        MHp2N= MHpm2N
      endif
      MHp2=MHp2N
      Ala=AlaN

      MHp2=MHp2N
      AlaC=DCONJG(Ala)
      absAlambda= Abs(Ala)
      if (absAlambda.gt.1D-10)then
      expAla = Ala/absAlambda
      else
      expAla=1D0
      endif
      sqrt1x=  Sqrt(2D0)
      sqrt2x= Sqrt(2D0)
      mah(1:2)=1d0
      mah(3)=0.d0;mah(4)=sqrt(MHp2N);mah(5)=mah(4);mah(6)=0d0
      ZH(1:6,1:6)=0d0
      ZH(3,1)=CB; ZH(3,2)=SB
      ZH(4,1)=SB; ZH(4,2)=-CB
      ZH(5,4)=SB; ZH(5,5)=CB
      ZH(6,4)=CB; ZH(6,5)=-SB   

      ihiggs=3;ineu=2
      ihiggse=6;ineue=3
c
      ZNeu(1:3,1:3)=0d0
      MNeu(1)=0D0;MNeu(2)=abs(MUE);MNeu(3)=abs(MUE)
      ZNeu(2,1)=-Sqrt((MUE/abs(MUE)))/sqrt2
      ZNeu(2,2)=-ZNeu(2,1)
      ZNeu(3,1)=IC*ZNeu(2,1)
      ZNeu(3,2)=-IC*ZNeu(2,2)

      Do i=ineu,ineue 
        MNeu2(i)=MNeu(i)**2; 
        ZNeuC(i,1:3)=DCONJG(ZNeu(i,1:3))
      enddo
      ZUC(1:2,1:2)=DCONJG(ZU(1:2,1:2))
      M1=MTN;   M2=MSt1;  M4=MSt2
      M12=M1**2;M22=M2**2;M42=M4**2
      MassSu(1)=M2; MassSu(2)= M4
      MassSu2(1)=M22; MassSu2(2)= M42
      logm12=Log(M12/Q2); logM22=Log(M22/Q2);logM42=log(M42/Q2)

      MCha=Abs(MUE); MCha2=MCha**2;VCha=MUE/MCha;VChaC=DCONJG(VCha)
      ATC= DCONJG(ATT)

      MSQ2=-M12+M22*ZU(1,1)*ZUC(1,1)+M42*ZU(2,1)*ZUC(2,1)
      Mah2(1:6)= mah(1:6)**2
      masshpm(1) = 0D0; masshpm(2)=dsqrt(MHp2)

      do k=1,2
       do j=1,2
         do i=1,6
         CSSS(i,j,k)=ZH(i,5)*(ATT*expETA*IC*ZU(k,2)*ZUC(j,1) - 
     -   (IC*ATC*ZU(k,1)*ZUC(j,2))/expETA) + 
     -   vv*ZH(i,3)*(-((CB*laC*ZU(k,2)*ZUC(j,1))/(expVS*sqrt2)) -
     -   (CB*expVS*la*ZU(k,1)*ZUC(j,2))/sqrt2) + 
     -   vv*ZH(i,6)*((CB*IC*laC*ZU(k,2)*ZUC(j,1))/(expVS*sqrt2) - 
     -   (IC*CB*expVS*la*ZU(k,1)*ZUC(j,2))/sqrt2) + 
     -   ZH(i,1)*(-((MUEC*ZU(k,2)*ZUC(j,1))) - 
     -   (MUE*ZU(k,1)*ZUC(j,2))) + 
     -   ZH(i,4)*((IC*MUEC*ZU(k,2)*ZUC(j,1)) - 
     -   (IC*MUE*ZU(k,1)*ZUC(j,2))) + 
     -   ZH(i,2)*(ATT*expETA*ZU(k,2)*ZUC(j,1) +(ATC*ZU(k,1)*ZUC(j,2))
     -   /expETA + M1*(2*ZU(k,1)*ZUC(j,1) + 2*ZU(k,2)*ZUC(j,2)))
         CSSS(i,j,k)=CSSS(i,j,k)*M1/vv/SB
         enddo
        enddo
      enddo

      do i =1,6
        hy(i)=(M1*(ZH(i,2) + IC*ZH(i,5)))/(SB*vv)
        hyc(i)=(M1*(ZH(i,2) - IC*ZH(i,5)))/(SB*vv)
      enddo

      do k=1,2
        do l1=1,2
         do j=1,6
          do i=1,6
        CSSSS(i,j,l1,k)=ZH(i,3)*(-((laC*(ZH(j,1) - IC*ZH(j,4))*
     -  ZU(k,2)*ZUC(l1,1))/(expVS*sqrt2)) - (expVS*la*(ZH(j,1) + 
     -  IC*ZH(j,4))*ZU(k,1)*ZUC(l1,2))/sqrt2) + ZH(i,6)*
     -  (-((laC*((-IC)*ZH(j,1) - ZH(j,4))*ZU(k,2)*ZUC(l1,1))/
     -  (expVS*sqrt2)) - (IC*expVS*la*(ZH(j,1) + IC*ZH(j,4))*ZU(k,1)*
     -  ZUC(l1,2))/sqrt2) + ZH(i,1)*(-((laC*(ZH(j,3) 
     -  - IC*ZH(j,6))*ZU(k,2)*ZUC(l1,1))/(expVS*sqrt2)) - 
     -  (expVS*la*(ZH(j,3) + IC*ZH(j,6))*ZU(k,1)*ZUC(l1,2))/sqrt2) + 
     -  ZH(i,4)*((IC*laC*(ZH(j,3) - IC*ZH(j,6))*ZU(k,2)*ZUC(l1,1))/
     -  (expVS*sqrt2) - (IC*expVS*la*(ZH(j,3) + IC*ZH(j,6))*ZU(k,1)*
     -  ZUC(l1,2))/sqrt2) + M1*ZH(i,2)*((2*ZH(j,2)*ZU(k,1)*ZUC(l1,1))
     -  /(SB*vv) + (2*ZH(j,2)*ZU(k,2)*ZUC(l1,2))/(SB*vv)) + 
     -  M1*ZH(i,5)*((2*ZH(j,5)*ZU(k,1)*ZUC(l1,1))/(SB*vv) + 
     -  (2*ZH(j,5)*ZU(k,2)*ZUC(l1,2))/(SB*vv))
        CSSSS(i,j,l1,k)=CSSSS(i,j,l1,k)*M1/vv/SB
            enddo   
          enddo
        enddo
       enddo 


      do j=1,2
       do i=1,6
       CS1S3SS(i,2,j)=-((M1*(2*CB*M1*(ZH(i,2)+ IC*ZH(i,5))*ZUC(j,1)+ 
     -  expvS*la*SB2*sqrt2*vv*(ZH(i,3) +IC*ZH(i,6))*ZUC(j,2)))/
     -  (SB2*sqrt2*vv2))
       CS1S3SSC(i,2,j)=DCONJG(CS1S3SS(i,2,j))
       CS1S3SS(i,1,j)=-((M12*sqrt2*(ZH(i,2)+Ic*ZH(i,5))*ZUC(j,1))/(SB*
     - vv2))+(CB*expvS*la*M1*(ZH(i,3) + Ic*ZH(i,6))*ZUC(j,2))/(SB*vv)
       CS1S3SSC(i,1,j)=DCONJG(CS1S3SS(i,1,j))
       enddo   
       CS3S13S(2,j)=-((M12*sqrt2*ZUC(j,1))/(TB*vv)) -(ATC*M1*sqrt2*
     .  ZUC(j,2))/(expETA*TB*vv) - (MUE*sqrt2*M1*ZUC(j,2))/vv

       CS3SSS13(1,j)=(2*M12*ZU(j,2)*ZUC(1,2))/(TB2*vv**2)
       CS3SSS13(2,j)=(2*M12*ZU(j,2)*ZUC(2,2))/(TB2*vv**2)
       CS3S13SC(2,j)=DCONJG(CS3S13S(2,j))
c
       CS3S13S(1,j)=-((expETA*M12*SB*sqrt2*ZUC(j,1)+ATC*M1*SB*sqrt2* 
     - ZUC(j,2) -CB*expETA*MUE*sqrt2*M1*ZUC(j,2))/(expETA*SB*vv))
       CS3S13SC(1,j)=DCONJG(CS3S13S(1,j))

       CS3S13S14(j)=-((M12*sqrt2*ZUC(j,1))/(TB*vv)) -(ATC*M1*sqrt2*
     .  ZUC(j,2))/(expETA*TB*vv) - (MUE*sqrt2*M1*ZUC(j,2))/vv

        CS3S14S13(j)=-((M12*sqrt2*ZU(j,1))/(TB*vv)) -(ATT*expETA*M1* 
     .  sqrt2*ZU(j,2))/(TB*vv) - (MUEC*sqrt2*M1*ZU(j,2))/(vv)
     
c nhung implemented 14/10/2021
       CS3S13S14N(1,j)=-((M12*sqrt2*ZUC(j,1))/vv)-(ATC*M1*sqrt2*
     &  ZUC(j,2))/(expETA*vv)+(CB*M1*MUE*sqrt2*ZUC(j,2))/(SB*vv)
       CS3S13S14N(2,j)=-((CB*M12*sqrt2*ZUC(j,1))/(SB*vv))-(M1*MUE*
     &  sqrt2*ZUC(j,2))/vv-(ATC*CB*M1*sqrt2*ZUC(j,2))/(expETA*SB*vv)
     
       CS3S14S13N(1,j)=-((M12*sqrt2*ZU(j,1))/vv)-(ATT*expETA*M1*sqrt2*
     &  ZU(j,2))/vv+(CB*M1*MUEC*sqrt2*ZU(j,2))/(SB*vv)
       CS3S14S13N(2,j)=-((CB*M12*sqrt2*ZU(j,1))/(SB*vv))-(M1*MUEC*
     &  sqrt2*ZU(j,2))/vv-(ATT*CB*expETA*M1*sqrt2*ZU(j,2))/(SB*vv)     
c end nhung implemented 14/10/2021
      enddo
      CS3SSS14 = (2*M12)/(TB2*vv**2)

      CS3S3S14S14(2,2) = CS3SSS14
      CS3S3S14S14(2,1) = (2*CB*M12)/(SB*vv**2)
      CS3S3S14S14(1,2) =       CS3S3S14S14(2,1)
      CS3S3S14S14(1,1) = (2*M12)/vv**2

      CTBS3R   =-(sqrt2/(sqrt(expETA)*vv))* M1/TB
      CTBS3(2)= -(sqrt2/(sqrt(expETA)*vv))* M1/TB
      CTBS3C(2)= DCONJG(CTBS3(2))
      CTBS3(1)= -sqrt2*M1/vv/sqrt(expETA)
      CTBS3C(1)=DCONJG(CTBS3(1))

      do i=1,3
       do j=1,2
       CF11FSR(i,j)=(Sqrt(expETA)*M1*sqrt2*ZNeu(i,2)*
     .     ZU(j,1))/(SB*vv)
       CF11FSL(i,j)=(M1*sqrt2*ZNeuC(i,2)*ZU(j,2))
     .     /(Sqrt(expETA)*SB*vv)
       CF11FSRC(i,j)=DCONJG(CF11FSR(i,j))
       CF11FSLC(i,j)=DCONJG(CF11FSL(i,j))
       enddo
      enddo

      do l=1,2
       do k=1,2
         do j=1,2
           do i=1,2
            CS13S13S13S13MT4(i,j,k,l)=(2*M12*(ZU(k,2)*ZU(l,1)*ZUC(i,2)
     -      *ZUC(j,1)+ZU(k,1)*ZU(l,2)*ZUC(i,1)*ZUC(j,2)))/(SB2*vv2)

           enddo
         enddo
            CS14S13S14S13MT4(k,l)=(2*M12*ZU(l,2)*ZUC(k,2))/(SB2*vv2)
       enddo
      enddo

      CF12F3S= -((Sqrt(expETA)*M1*sqrt2)/(SB*vv))
      CF12F3SC= DCONJG(CF12F3S)
      do i=1,2
      CF12F4S(i) =-((M1*sqrt2*ZU(i,2))/(SB*vv))
      CF12F4SC(i)= DCONJG(CF12F4S(i))
      enddo

      do k=1,2
        do i=1,2
         do l=1,2
          do j=1,2
          CS3S3S13S13(k,i,l,j)=(2*M12*ZP(k,2)*ZP(i,2)
     &    *ZU(j,2)*ZUC(l,2))/(SB2*vv2)
          enddo
        enddo
       enddo
      enddo

      do gen5=1,6
       do gen4=1,3
         do gen3=1,3
       CFF11S1L(gen3,gen4,gen5)=-((expvS*ZH(gen5,3)*(la*ZNeuC(gen3,2)
     &  *ZNeuC(gen4,1)+la
     &  *ZNeuC(gen3,1)*ZNeuC(gen4,2)-kappa*sqrt2**2*ZNeuC(gen3,3)*ZNeuC
     &  (gen4,3))+expvS*Ic*ZH(gen5,6)*(la*ZNeuC(gen3,2)*ZNeuC(gen4,1)+
     &  la*ZNeuC(gen3,1)*ZNeuC(gen4,2)-kappa*sqrt2**2*ZNeuC(gen3,3)*ZNe
     &  uC(gen4,3))+la*(expETA*ZH(gen5,2)*(ZNeuC(gen3,3)*ZNeuC(gen4,1)
     &  +ZNeuC(gen3,1)*ZNeuC(gen4,3))+expETA*Ic*ZH(gen5,5)*(ZNeuC(gen3
     &  ,3)*ZNeuC(gen4,1)+ZNeuC(gen3,1)*ZNeuC(gen4,3))+(ZH(gen5,1)+Ic*
     &  ZH(gen5,4))*(ZNeuC(gen3,3)*ZNeuC(gen4,2)+ZNeuC(gen3,2)*ZNeuC(g
     &  en4,3))))/sqrt2)

       CFF11S1R(gen3,gen4,gen5)=(-(expETA*ZH(gen5,3)*(laC*ZNeu(gen3,2)
     &  *ZNeu(gen4,1)+laC*
     &  ZNeu(gen3,1)*ZNeu(gen4,2)-kappaC*sqrt2**2*ZNeu(gen3,3)*ZNeu(g
     &  en4,3)))+expETA*Ic*ZH(gen5,6)*(laC*ZNeu(gen3,2)*ZNeu(gen4,1)+l
     &  aC*ZNeu(gen3,1)*ZNeu(gen4,2)-kappaC*sqrt2**2*ZNeu(gen3,3)*ZNeu(
     &  gen4,3))+expvS*laC*(-(ZH(gen5,2)*(ZNeu(gen3,3)*ZNeu(gen4,1)+ZN
     &  eu(gen3,1)*ZNeu(gen4,3)))+Ic*ZH(gen5,5)*(ZNeu(gen3,3)*ZNeu(gen
     &  4,1)+ZNeu(gen3,1)*ZNeu(gen4,3))-expETA*(ZH(gen5,1)-Ic*ZH(gen5
     &  ,4))*(ZNeu(gen3,3)*ZNeu(gen4,2)+ZNeu(gen3,2)*ZNeu(gen4,3))))/(e
     &  xpETA*expvS*sqrt2)
         enddo
       enddo
       CFF12S1L(gen5)=(expvS*la*VChaC*(ZH(gen5,3)+Ic*ZH(gen5,6)))/sqrt2
       CFF12S1R(gen5)=(laC*VCha*(ZH(gen5,3)-Ic*ZH(gen5,6)))/(expvS*sqrt2)
      enddo

c trilinear Higgs self coupling
c for test 

       CS1S1S1IN(1:6,1:6,1:6)=0D0


       do i=1,6
         do j=i,6
          do k= j,6
            CS1S1S1IN(k,j,i) = CS1S1S1IN(i,j,k)
            CS1S1S1IN(k,i,j) = CS1S1S1IN(i,j,k)
            CS1S1S1IN(i,k,j) = CS1S1S1IN(i,j,k)
            CS1S1S1IN(j,k,i) = CS1S1S1IN(i,j,k)
            CS1S1S1IN(j,i,k) = CS1S1S1IN(i,j,k)
          enddo
         enddo
        enddo



       do i=1,6
         do j=1,6
          do k= 1,6
            CS1S1S1(i,j,k) =0D0
            do i1=1,6
            do i2=1,6
            do i3=1,6
            CS1S1S1(i,j,k)=CS1S1S1(i,j,k)+ZH(i,i1)*ZH(j,i2)*ZH(k,i3)*CS1S1S1IN(i1,i2,i3)
            enddo
            enddo
            enddo
          enddo
         enddo
        enddo


       CS1S1S1IN(1:6,1:6,1:6)=0D0


       do i=1,6
         do j=1,2
          do k= 1,2

            CS1S3S3(i,j,k) =0D0
            do i1=1,6
            do i2=1,2
            do i3=1,2
            CS1S3S3(i,j,k)=CS1S3S3(i,j,k)+ZH(i,i1)*ZP(j,i2)*ZP(k,i3)*CS1S1S1IN(i1,i2,i3)
            enddo
            enddo
            enddo
          enddo
         enddo
        enddo

       CS1S1S1S1IN(1:6,1:6,1:2,1:2)=0D0
       
       do i=1,6
         do j=i,6
       CS1S1S1S1IN(j,i,1:2,1:2)=CS1S1S1S1IN(i,j,1:2,1:2)
	 enddo
       enddo

       do i=1,6
        do i1=1,6
         do j=1,2
          do k= 1,2
            CS1S1S3S3(i,i1,j,k) =0D0
            do gen1=1,6
            do gen2=1,6
            do gen3=1,2
            do gen4=1,2
            CS1S1S3S3(i,i1,j,k)=CS1S1S3S3(i,i1,j,k)+ZH(i,gen1)*ZH(i1,gen2)*
     &          ZP(j,gen3)*ZP(k,gen4)*CS1S1S1S1IN(gen1,gen2,gen3,gen4)
            enddo
            enddo
            enddo
            enddo
           enddo
          enddo
         enddo
        enddo

       CS1S1S1S1IN(1:6,1:6,1:6,1:6)=0D0


       CS1S1S1S1(1:6,1:6,1:6,1:6)=0D0

       CS3S3S3S3(1:2,1:2,1:2,1:2)=0

      do gen3=1,3
       do gen4=1,2
       CF11FSR(gen3,gen4)=(Sqrt(expETA)*M1*sqrt2*ZNeu(gen3,2)*
     .     ZU(gen4,1))/(SB*vv)
       CF11FSL(gen3,gen4)=(M1*sqrt2*ZNeuC(gen3,2)*ZU(gen4,2))
     .     /(Sqrt(expETA)*SB*vv)
       CF11FSRC(gen3,gen4)=DCONJG(CF11FSR(gen3,gen4))
       CF11FSLC(gen3,gen4)=DCONJG(CF11FSL(gen3,gen4))
       enddo
      enddo
c gauge boson couplings
        do i=1,3
       CF11F12V3R(i)=-(sqrt2*ZNeuC(i,2))/(2.*SW)
       CF11F12V3L(i)=(sqrt2*VChaC*ZNeu(i,1))/(2.*SW)
         do j=1,3
       CF11F11V2R(i,j)=-((ZNeu(j,1)*ZNeuC(i,1)-ZNeu(j,2)*
     &  ZNeuC(i,2)))/(2.*CW*SW)
       CF11F11V2L(i,j)=((ZNeu(i,1)*ZNeuC(j,1)-ZNeu(i,2)*
     &  ZNeuC(j,2)))/(2.*CW*SW)
         enddo
         do k=1,2
       CF11F12S3L(i,k)=expETA*la*VChaC*ZNeuC(i,3)*ZP(k,2)
       CF11F12S3R(i,k)=laC*ZNeu(i,3)*ZP(k,1)
         enddo
        enddo

       do i=1,2
       do j=1,2
       CS3S3V3V3(i,j)=-(ZP(i,1)*ZP(j,1)+ZP(i,2)*ZP(j,2))/(2.*SW2)
       CS3S3V2V2(i,j)=-((CW2-SW2)**2*(ZP(i,1)*ZP(j,1)+ZP(i,2)*ZP(j,2)))
     &      /(2.*CW2*SW2)
       enddo
       enddo
       do i=1,6
       do j=1,2
       CS1S3V3(i,j)=(Ic*ZH(i,1)*ZP(j,1)+ZH(i,4)*ZP(j,1)+(-(Ic*
     &  ZH(i,2))+ZH(i,5))*ZP(j,2))/(2.*SW)
       CS1S3V3C(i,j)=DCONJG(       CS1S3V3(i,j))
       enddo
       do j=1,6
       CS1S1V3V3(i,j)=-(ZH(i,1)*ZH(j,1)+ZH(i,2)*ZH(j,2)+ZH(i,4)*
     &  ZH(j,4)+ZH(i,5)*ZH(j,5))/(2.*SW2)
       CS1S1V2V2(i,j)=-(ZH(i,1)*ZH(j,1)+ZH(i,2)*ZH(j,2)+ZH(i,4)*ZH(j,4)
     &     +ZH(i,5)*ZH(j,5))/(2.*CW2*SW2)
       CS1S1V2(i,j)=((ZH(i,4)*ZH(j,1)-ZH(i,5)*ZH(j,2)-
     &  ZH(i,1)*ZH(j,4)+ZH(i,2)*ZH(j,5)))/(2.*CW*SW)
       enddo
       enddo
       CF12F12V2R=(-CW2+SW2)/(2.*CW*SW)
       CF12F12V2L=((-CW2+SW2))/(2.*CW*SW)
       CS3S3V2(1,1)= (CW2-SW2)/(2*CW*SW)
       CS3S3V2(2,2)= (CW2-SW2)/(2*CW*SW)
       CS3S3V2(2,1)=0D0 
       CS3S3V2(1,2)=0D0



      do gen3=1,2
        CS14S13V3(gen3)=ZU(gen3,1)/SW/sqrt2
      enddo

		CF4F3V3=1D0/sqrt2/SW/Sqrt(expeta)

	    CS14S14V3V3=-1/(2.*SW2)

        do i=1,2
        do j=1,2
       CS13S13V3V3(i,j)=-(ZU(j,1)*ZUC(i,1))/(2.*SW**2)
        enddo
        enddo

        do i=1,6
        do j=1,6
       CS1S1V3V3(i,j)=-(ZH(i,1)*ZH(j,1)+ZH(i,2)*ZH(j,2)+ZH(i,4)*ZH(j,4)
     &  +ZH(i,5)*ZH(j,5))/(2.*SW**2)
        enddo
        enddo

        do i=1,2
        do j=1,2
       CS3S3V3V3(i,j)=-(ZP(i,1)*ZP(j,1)+ZP(i,2)*ZP(j,2))/(2.*SW**2)
        enddo
        enddo

        do i=1,2
        do j=1,2
       CS13S13V2(i,j)=((3*CW**2-SW**2)*ZU(j,1)*ZUC(i,1)-4*SW**2*ZU(j,2)
     &  *ZUC(i,2))/(6.*CW*SW)
        enddo
        enddo

       CS14S14V2=-CW/(2.*SW)-SW/(6.*CW)

        do i=1,2
        do j=1,2
       CS13S13V2V2(i,j)=(-((3-4*SW**2)**2*ZU(j,1)*ZUC(i,1))-16*SW**4*
     &  ZU(j,2)*ZUC(i,2))/(18.*CW**2*SW**2)
        enddo
        enddo
       CS14S14V2V2=-(3-2*SW**2)**2/(18.*CW**2*SW**2)
#ifdef printMT4
c     output for mathematica routines
        OPEN(16,FILE='slha_test.dat', STATUS= 'UNKNOWN')
      Write(16,*)'alambda', AlaN
      Write(16,*) 'akappa',Aka
	  Write(16,*)'kappa',kappa
      Write(16,*) 'sign1,sign2',sign1,sign2
      Write(16,*)'sinphix,cosphix',sinphix,cosphix  
      Write(16,*)'sinphiy,cosphiy',sinphiy,cosphiy   
      Write(16,*)'sinphiz,cosphiz',sinphiz,cosphiz

      Write(16,*)'Mh1=',mah(1)
      Write(16,*)'Mh2=',mah(2)
      Write(16,*)'Mh3=',mah(3)
      Write(16,*)'Mh4=',mah(4)
      Write(16,*)'Mh5=',mah(5)
      Write(16,*)'Goldstone boson Mh6=',mah(6)
      Write(16,*) "ZH(1,i), i=1,6",ZH(1,1),ZH(1,2),ZH(1,3),ZH(1,4),ZH(1,5),ZH(1,6)
      Write(16,*) "ZH(2,i), i=1,6",ZH(2,1),ZH(2,2),ZH(2,3),ZH(2,4),ZH(2,5),ZH(2,6)
      Write(16,*) "ZH(3,i), i=1,6",ZH(3,1),ZH(3,2),ZH(3,3),ZH(3,4),ZH(3,5),ZH(3,6)
      Write(16,*) "ZH(4,i), i=1,6",ZH(4,1),ZH(4,2),ZH(4,3),ZH(4,4),ZH(4,5),ZH(4,6)
      Write(16,*) "ZH(5,i), i=1,6",ZH(5,1),ZH(5,2),ZH(5,3),ZH(5,4),ZH(5,5),ZH(5,6)
      Write(16,*) "ZH(6,i), i=1,6",ZH(6,1),ZH(6,2),ZH(6,3),ZH(6,4),ZH(6,5),ZH(6,6)
      Write(16,*) "MNeu", Mneu(1:3), ZNeu(2,1:3),ZNeu(3,1:3)
      Write(16,*)"phase",Sqrt((MUE/abs(MUE)))/sqrt2
      Write(16,*)"ZUN(1,1),ZUN(1,2)", ZU(1,1),ZU(1,2)
      Write(16,*)"ZUN(2,1),ZUN(2,2)", ZU(2,1),ZU(2,2)
      Write(16,*)'mst1,mst2',mst1,mst2
      Write(16,*)'MSQ(3), MSU(3), ATT, MTN',sqrt(MSQ2), ATT, MTN
#endif

      end subroutine couplings_atlambda_zero
      
      
