#define xfacWSM 1.D0
!#define printdetails
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine WMass(slhafile,ilevel)
      implicit none
      integer ilevel,i,ihsm,ierr
      logical printiter,calcapprox
      character*30 slhafile
      double precision xMW,xMZ,xMT,xMH,xMZ2,xalfas,xalfa,xGF,
     .     res,xfac,aQ2,DelAlfa,xMW2,MW21L,MW22LQCD,MW22LEW,rk
      double precision MW2SM
      common /SMWmass/MW2SM
      double precision aMz,aGf,aalpha,aMw,ae,av,ag1,ag2,aalphaS,ag3
      common /SMinput/ aMz,aGf,aalpha,aMw,ae,av,ag1,ag2,aalphaS,ag3 

      double precision ame,ammu,amtau,amu,amd,ams,amc,amt,amb,aYe(3),
     .                 aYd(3),aYu(3)
      common /Yukawa/ ame,ammu,amtau,amu,amd,ams,amc,amt,amb,aYe,aYd,aYu
      double precision mtpole,mbMsmb,MSin,MCin
      common /topoles/ mtpole,mbMsmb,MSin,MCin   
      double precision aMh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      double precision Mh1l(5),ZH1l(5,5)
      double precision MHpm1l, MWapprox
      common /treemasses/ aMh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU 
      common /WMASS_NMSSM/MW21L,MW22LQCD,MW22LEW 
      common /H1loop/ MHpm1l,MH1l,ZH1l              
#include "SM.h"
      xGF=aGF
      ! These values are fixed for W-mass calculation only 
      xalfa=Alfa0
      ! These masses have been changed since the evaluation of g-2
      ! This is to reset the masses
      MT=mtpole; MT2=MT**2           
      MB=mbMsmb; MB2=MB**2 
      MS=MSin;MS2=MS**2  
      MC=MCin; MC2=MC**2
      amc=MC;  ams=MS
      amb=MB;  amt=MT
      DelAlfa=DelAlfa0
!      DelAlfa=0.02766 + 0.031497687
      printiter = .False. ! prints results during iteration
      calcapprox = .False. ! calculates and prints approx
      CKM(3,3)= 0.9991D0
      CKM(3,2)= 0.0404D0
      CKM(3,1)= 0.00867D0
      CKM(2,3)= 0.0412D0
      CKM(2,2)= 0.97344D0
      CKM(2,1)= 0.22520D0
      CKM(1,3)= 0.00351D0
      CKM(1,2)= 0.22534D0
      CKM(1,1)= 0.97427D0     
      CKMC(1:3,1:3) = DCONJG(CKM(1:3,1:3))       
      ! end These values are fixed for W-mass calculation only     
      ML=amtau;ML2= ML**2
      ME=ame;ME2=ME**2
      MM=ammu; MM2=MM**2
      MD=amd; MD2=MD**2
      MU=amu; MU2=MU**2
	  MassFe(1) = ME 
	  MassFe(2) = MM
	  MassFe(3) = ML
   	  MassFu(1) = MU
	  MassFu(2) = MC
	  MassFu(3) = MT
	  MassFd(1) = MD
	  MassFd(2) = MS 
	  MassFd(3) = MB 
	   
      MassFe2(1:3)=MassFe(1:3)**2   
      MassFu2(1:3)=MassFu(1:3)**2             
      MassFd2(1:3)=MassFd(1:3)**2        
      MFu2(1:3) = massFu2(1:3)
      MFd2(1:3) = massFd2(1:3) 
      MFe2(1:3) = massFe2(1:3)	
      !xMZ= aMZ  - .5D0*GammaZ**2/aMZ*0; xMZ2=xMZ**2
      xMZ= aMZ; xMZ2=xMZ**2
      
      xMT=MT
      xalfas= aalphas    

       rk= abs(ZH1l(1,4))
       ihsm=1
       do i=2,5
       if (abs(ZH1l(i,4)).gt.rk)then
         ihsm=i
         rk =  abs(ZH1l(i,4))
       endif
       enddo
       xMH=MH1l(ihsm)
       ! xMH= 125.09D0
       ! warn if Higgs mass if too far off
       if(abs(xMH-125d0).gt.10d0) then
          write(*,*) 'Warning: Higgs mass used in W-mass calculation:', xMH
      endif

c      xMH=xMH+1d0 
c      xMH=xMH-1d0 
       ierr=0
      if (printiter) write(*,*) '--------SM-----------',xMH
      call MWiter(xMZ2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,
     &                  MW2SM,0,ierr,printiter)
      if (printiter) write(*,*) 'SM:', sqrt(MW2SM)

      if (printiter) write(*,*) '--------1L-----------'
      call MWiter(xMZ2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,
     &                  MW21L,1,ierr,printiter)  
      if (ierr .gt.0) MW21L=MW2SM              
      if (printiter) write(*,*) '--------QCD-----------'
      call MWiter(xMZ2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,
     &                  MW22LQCD,2,ierr,printiter) 
      if (ierr .gt.0)then
       MW22LQCD=MW21L
      endif    
      if (printiter) write(*,*) '--------EW-----------'
      call MWiter(xMZ2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,
     &                  MW22LEW,3,ierr,printiter)

      if(calcapprox) then
        if (printiter) write(*,*) '--------approx-----------'
        call MWiterapprox(xMZ2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,
     &                    MWapprox,3,ierr,printiter)
        write(*,*) 'MWapprox=', sqrt(MWapprox)
      endif
      
      if (printiter) write(*,*) 'MWeW=',sqrt(MW22LEW)


      if (ierr .gt.0)then
       MW22LEW=MW22LQCD
      endif     
      open(unit=46,file=slhafile,status="old",position="append",action='write')
      write(46,51) 'BLOCK WMASS'
      write(46,51) '# W mass prediction in the on-shell scheme'
      write(46,53) 1,0,sqrt(MW2SM),'W mass in the SM using MH=MHSUSY'
      write(46,53) 1,1,sqrt(MW21L),'W mass in the NMSSM at 1-loop'
      write(46,53) 1,2,sqrt(MW22LQCD),'W mass in the NMSSM at 2-loop QCD'           
      write(46,53) 1,3,sqrt(MW22LEW),'W mass in the NMSSM at 2-loop EW'                
      close(46)
 51   format(A)
 53   format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A)     
      end
      
c*********************************************************************c
      subroutine MWiterapprox(Qin2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,
     &                  xMW2out,ilevel,ierr,printiter) 
      implicit none
      logical printiter
      integer ilevel,i,j,ierror,ierr,imwfix,imwcon
      double precision value,res,lastten(10)
      double precision Qin2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,xfac
      double precision xMZ2,xMW2in,xMW2out,prec,drSM1L,drSMHO,drSUSY 
      double precision mtpole,mbMsmb,MSin,MCin,MW2_SM,xMZfw,xMZ2fw,xMWrun
      common /topoles/ mtpole,mbMsmb,MSin,MCin    
      character*30 order 
      common/MWCONiss/imwcon  
#include "SM.h" 
      if (ilevel.eq.1)then
          order="one-loop"
      elseif (ilevel.eq.2)then
          order="two-loop QCD"
      else
          order="two-loop EW"
      endif
     
      prec= 1D-6 
      i=0
      ierror=0
      xMZ2=xMZ**2
      
      ! convert from the measured MZ, which a running-width measurement,
      ! to the fixed-width mass which corresponds to our OS definition.
      xMZfw = xMZ - 0.5D0*GammaZ**2/xMZ 
      xMZ2fw=xMZfw**2

      xfac = xalfa*pi/sqrt2/xGF/xMZ2           
      xMW2out=80.36D0**2          ! the result doesnot depend on this initial value         
      xMW2in=0D0 
      imwfix=0
      imwcon=0
111   continue       
      do while (abs(sqrt(xMW2out)-sqrt(xMW2in)).gt.prec .and. i.lt.100)
      
      xMW2in= xMW2out
      xMW=sqrt(xMW2in)
      CW= xMW/xMZ
      SW=dsqrt(1d0-CW**2)

      ! compute W mass in the SM
      call MWiter(xMZ2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,
     &                  MW2_SM,0,ierr,printiter)
      ! Deltar in the NMSSM at 2-loops
      call NMSSMDeltaR1L_OS(Qin2,xMW,xMZ,xGF,xMT,xalfas,xalfa,
     &             DelAlfa,drSUSY,ilevel,3,ierror,imwfix,printiter)
      if (ierror.gt.0) then
      ierr=2
      return
      endif

      xMW2out= MW2_SM*(1d0-SW**2/(CW**2-SW**2)*drSUSY)


      if(xMW2out.ne.xMW2out)then
      ierr=2
      print*, '* Warning! too large negative correction to W-mass '
      print*, '  at the order: ',order  
      print*, "value at this order is set equal to the value of
     &  the previous order"             
      return
      endif
        do j=1,9
        lastten(j)=lastten(j+1)
        end do
        lastten(10)=xMW2out             
      i=i+1
      enddo

      if(i.eq.100 .or. ierr.gt.0) then  
        print*, '* Warning! Convergence issues in the calculation of W mass'
        print*, '  at the order: ',order  
        print*, "value at this order is set equal to the value of
     &  the previous order"
        ierr=1
      endif
      end subroutine
c*********************************************************************c
      subroutine MWiter(Qin2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,
     &                  xMW2out,ilevel,ierr,printiter) 
      implicit none
      logical printiter
      integer ilevel,i,j,ierror,ierr,imwfix,imwcon
      double precision value,res,lastten(10),xMWout,MWsave,MZsave 
      double precision Qin2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,DelAlfa,xfac
      double precision xMZ2,xMW2in,xMW2out,prec,drSM1L,drSMHO,drSUSY 
      double precision mtpole,mbMsmb,MSin,MCin,xMWrun,xMZfw,xMZ2fw
      common /topoles/ mtpole,mbMsmb,MSin,MCin
      character*30 order 
      common/MWCONiss/imwcon  
#include "SM.h" 
      if (ilevel.eq.1)then
          order="one-loop"
      elseif (ilevel.eq.2)then
          order="two-loop QCD"
      else
          order="two-loop EW"
      endif
      prec= 1D-6 
      i=0
      ierror=0
      xMZ2=xMZ**2
      xMZfw = xMZ - 0.5D0*GammaZ**2/xMZ 
      xMZ2fw=xMZfw**2
      xGF = 1.1663787e-05
      xfac = xalfa*pi/sqrt2/xGF/xMZ2fw
      xMW2out=80.36D0**2          ! the result doesnot depend on this initial value         
      xMW2in=0D0 
      imwfix=0
      imwcon=0
111   continue       
      do while (abs(sqrt(xMW2out)-sqrt(xMW2in)).gt.prec .and. i.lt.100)
      xMW2in= xMW2out
      xMW=sqrt(xMW2in)

      call SMDeltaR1L_OS(Qin2,xMW,xMZfw,xGF,xMT,xMH,xalfas,xalfa,
     &             DelAlfa,drSM1L)
      MW=xMW; MZ=xMZfw; CW=MW/MZ; CW2=CW**2; SW2=1-CW2; SW=dsqrt(SW2)
      ! convert from our fixed-width MW, which is defined OS,
      ! to the running-width mass which is measured in experiment. This
      ! number is required in SMDeltaRBOL_OS in the fit-function for the
      ! 2L EW correction
      xMWrun=xMW*(1+(3d0/(4d0*pi)*xGF*xMW**2*(1d0+2d0/(3d0*pi)*xalfas))**2)
      call SMDeltaRBOL_OS(xMWrun,xMW,xMZ,xMZfw,xGF,xMT,xMH,xalfas,
     &             DelAlfa,drSM1L,drSMHO,printiter)
      call NMSSMDeltaR1L_OS(Qin2,xMW,xMZ,xGF,xMT,xalfas,xalfa,
     &             DelAlfa,drSUSY,ilevel,3,ierror,imwfix,printiter)
      if (ierror.gt.0) then
      ierr=2
      return
      endif
      
	  res=(drSM1L+drSMHO)+drSUSY
      xMW2out= xMZ2fw*(0.5+Sqrt(0.25-xfac*(1.+res))) 
      if(printiter) then
         write(*,*) 'NEWITER'
         write(*,*) 'drSM1L=', drSM1L
         write(*,*) 'drSMHO=', drSMHO
         write(*,*) 'drTOT=', res
         write(*,*) "diferences (MWin-MWout): ",sqrt(xMW2in), sqrt(xMW2out), abs(sqrt(xMW2out)-sqrt(xMW2in))
      endif
      if(xMW2out.ne.xMW2out)then
      ierr=2
      print*, '* Warning! too large negative correction to W-mass '
      print*, '  at the order: ',order  
      print*, "value at this order is set equal to the value of
     &  the previous order"             
      return
      endif
        do j=1,9
        lastten(j)=lastten(j+1)
        end do
        lastten(10)=xMW2out             
      i=i+1
      enddo
      ! convert from our fixed-width MW, which is defined OS,
      ! to the running-width mass which is measured in experiment
      ! see eq. (38). (39) and following expression in hep-ph/0202131v4
      xMWout=dsqrt(xMW2out)
      xMWout=xMWout*(1d0+(3d0/(4d0*pi)*xGF*xMWout**2*(1d0+2d0/(3d0*pi)*xalfas))**2)
      xMW2out = xMWout**2

      if(i.eq.100 .or. ierr.gt.0) then  
        print*, '* Warning! Convergence issues in the calculation of W mass'
        print*, '  at the order: ',order  
        print*, "value at this order is set equal to the value of
     &  the previous order"  
        ierr=1            
      endif                                                
      end      
c*********************************************************************c
      subroutine  SMDeltaR1L_OS(aQ2,xMW,xMZ,xGF,xMT,xMH,xalfas,xalfa,
     &             DelAlfa,delta1L)
      implicit none
      double precision aQ2,xMW,xMZ
      double precision xMT,xMH,xalfas,xalfa,xGF,addrun
      double precision SMWSelf,SMZSelf,SMyZSelf,SMDyself
      double precision dMWsq,dMZsq,dZe,dZAA,dZZA,dSW,
     .   selfWW0,DelAlfa,Rho1L
      double precision deltar1Lrem,delta1L
      double precision Qs
      common /scale/ Qs
#include "SM.h" 
      Qs=sqrt(aQ2)
      MW=xMW;MZ=xMZ; MH=xMH; MT=xMT;alfas=xalfas;
      GF=xGF
      CW= xMW/xMZ
      CW2=CW**2; SW2=1.-CW2; SW=sqrt(SW2)
      MW2=MW**2;MZ2=MZ**2;MT2=MT**2;MH2=MH**2
      alfa=xalfa  
c One-loop contribution


      selfWW0= SMWSelf(0D0)
      dMWsq  = SMWSelf(MW2)
      dMZsq  = SMZSelf(MZ2)
      dZZA   = 2d0/MZ2* SMyZSelf()
      rho1L=(dMZsq/MZ2-dMWsq/MW2)
      dZe    =-0.5D0*(-SMDyself() - SW/CW*dZZA)
      dZAA=SMDyself() 
c using eq(8.41) in https://arxiv.org/abs/0709.1075v1    
      deltar1Lrem=dZAA+(selfWW0-dMWsq)/MW2+alfa/(4d0*pi)/SW2*((7d0/2d0/SW2 -2d0)*Log(CW2)+6d0)
     &     +CW/SW*dZZA 
      delta1L=DelAlfa-CW2/SW2*rho1L+deltar1Lrem  
#ifdef printdetails  
      print*, "=========SM============"
      print*, "CW2",CW2
      print*, "selfWW0",selfWW0
      print*, "dMWsq",dMWsq
      print*, "dMZsq",dMZsq
      print*, "dZZA",dZZA
      print*, "dZAA",dZAA
      print*, "dZe", dZe 
      print*, "Delta alpha,  dZAA +CW/SW*dZZA", dZAA +CW/SW*dZZA
      print*, "(selfWW0-dMWsq)/MW2",(selfWW0-dMWsq)/MW2 
      print*, "vertex+box",+alfa/(4*pi)/SW2*((7d0/2d0/SW2-2d0)*Log(CW2)+6d0)-2d0/(CW*SW)*dZZA 
      print*, "dMZsq,dMWsq,-CW2/SW2*rho1L",dMZsq,dMWsq,-CW2/SW2*rho1L
      print*, "deltar1Lrem",deltar1Lrem
      print*, "delta1L",delta1L
      print*, "=========end SM============"        
#endif      
c end One-loop contribution    
      end
c*********************************************************************c
      subroutine SMDeltaRBOL_OS(MWrun,MWfw,MZrun,MZfw,xGF,xMT,xMH,xalfas,
     &             DelAlfa,delta1L,deltaRBOL,printiter)
      implicit none
      integer iloop
      logical printiter
      double precision xMW,xMZ,MWrun,MWfw,MZrun,MZfw,xMT,xMH,xalfas,xalfa,xGF
      double precision Xt,rz,lz,xh,dW,dZZ,dH,lH,DT
      double precision DelAlfa,delta1L,MWsave
      double precision delta2LQCD,delta2LQCDud,delta2LQCDtb,
     .   delta2LQCDAlfa,delta2LQCDRho,delta2LQCDrem,delta3LQCD,
     .   delta3LGF3MT6,delta3LasGF2MT4,delta4LQCD,delta2Lrem,
     .   vt,vb,at,ab,r,x,qb,qt,zeta3,deltaRBOL,z
      double precision kniehlV1,kniehlV1p0,kniehlF1,kniehlF10,
     .   kniehlA1,kniehlA10,l,w,zz,RunAlfaS,a_sMS
#include "SM.h"
      MW=MWfw;MZ=MZfw; MH=xMH; MT=xMT;alfas=xalfas;
      GF=xGF
      CW= MW/MZ
      CW2=CW**2; SW2=1.-CW2; SW=sqrt(SW2)
      MW2=MW**2;MZ2=MZ**2;MT2=MT**2;MH2=MH**2
c Two-loop contribution
        
      ! running alphas at Mtop
      ! alfas=RunAlfaS(alfas,MZrun,xMT) ! one-loop running
      alfas=a_sMS(xMT)
      ! write(*,*) alfas,alfas-0.10379453274837383 ! value obtained with rundec at 3-loops

      ! alfa^2 correction eq. 55 hep-ph/0608099
      ! in this fit formula the _running_ masses have to be used (see
      ! e.g. footnote 7 in 1506.07465 and references therein)
      dW = MWrun/80.404D0 - 1D0
      dZZ = MZrun/91.1876D0 - 1D0
      dH = MH/100D0
      lH = log(dH)
      dT = MT/178D0
      dT = (dT - 1D0)*(dT + 1D0)
       delta2Lrem = .003354D0 +
     &    (-2.09D-4 + (2.54D-5 - 7.85D-6*lH**2)*lH)*lH -
     &    2.33D-6*(dH**2 - 1) +
     &    (7.83D-3 - 9.89D-6*lH + 3.38D-3*dT)*dT +
     &    (.0939D0 + 0.204D0*dT)*dW -0.103D0*dZZ

       ! from here on the fixed-width masses have to be used

       !QCD  Halzen, B.A . Kniel -1991

       delta2LQCDud=-(sqrt2/pi*GF*MWfw**2*SW2)/(4.*pi)/SW2*(CW2/SW2-1.)
     &              *Log(CW2)*(alfas/pi) 
       r= MZfw**2/(2.*MT)**2; x=MWfw**2/MT**2
       qt=2d0/3D0; qb=-1d0/3D0
       vb=(-0.5D0- 2.*SW2*qb)/(2.*CW*SW)
       vt=(0.5D0-2.*SW2*qt)/(2.*CW*SW)
       at=0.5D0/(2.*CW*SW); ab=-0.5D0/(2.*CW*SW)
       zeta3=1.20206D0
       kniehlV1p0= (4.*zeta3-5./6D0)
       kniehlF10=0.5D0*(-3*zeta3-pi**2/6D0+23D0/8D0)
       kniehlA10=3D0*(-2*zeta3-pi**2/6D0+7./4D0)
       
       delta2LQCDAlfa=-(sqrt2/pi*GF*MWfw**2*SW2)*alfas/(pi**2)*qt**2*
     &               (kniehlV1(r)/r-kniehlV1p0)
       delta2LQCDRho=-(sqrt2/pi*GF*MWfw**2*SW2)*alfas/(pi**2)/(4d0*SW2*x)
     &               *(pi**2/6d0+0.5D0) 
       delta2LQCDrem=(sqrt2/pi*GF*MWfw**2*SW2)*alfas/(pi**2)*(
     &      (1d0/SW2*(CW2/SW2-1)
     &      *(kniehlF1(x)-kniehlF10)/x)-CW2/SW2*(1d0/r*(vt**2*kniehlV1(r) 
     &       +at**2*(kniehlA1(r)-kniehlA10)) -2.*(vb**2+ab**2)*Log(MZfw/MT))
     &       +qt**2*kniehlV1(r)/r -2.*qb**2*Log(MZfw/MT))
       delta2LQCD =2.*delta2LQCDud+delta2LQCDAlfa-CW2/SW2*delta2LQCDRho
     &       +delta2LQCDrem

      
      ! expression from FH
!      w = MWfw**2/MT2
!      zz = MZfw**2/MT2
!      l = log(zz)
!      delta2LQCD = sqrt2/pi*GF*MWfw**2*SW2*alfas/(pi**2)*(
!     &              -1d0/4d0/(SW2**2*zz)*(
!     &              (1d0 - 8d0/3d0*SW2)**2*KniehlV1(zz/4D0) + KniehlA1(zz/4D0)
!     &              -1d0/4d0*(1d0 + (1d0 - 4d0/3d0*SW2)**2)*zz*l ) +
!     &              1d0/(SW2**2*w)*((CW2 - SW2)*KniehlF1(w) + SW2*KniehlF1(0d0))
!     &              - 1d0/(SW2**2)*(CW2 - SW2)*log(CW)
!     &              + 2d0*qt**2*(2.404114d0 - 5d0/12d0) - qb**2*l )

c end Two-loop contribution  
c three-loop contribution  
      !QCD page6 - hep-ph/9504413, only contribution from top-bottom
      rz=MZfw**2/MT2
      lz=Log(MZfw**2/MT2)
      Xt=GF*MT2/(8*sqrt2*pi**2)
      delta3LQCD=
     &    -3*CW2/SW2*Xt*(alfas/pi)**2*(
     &    -14.594D0 + (-17.224D0 +(.08829D0 + .4722D0*lz)*lz +
     &    (22.6367D0 + (1.2527D0 - .8519D0*lz)*lz)*SW2 +
     &    (-7.7781D0 + (-.07226D0 + .004938D0*lz)*lz +
     &    SW2*(21.497D0 - 21.0799D0*SW2 +(.05794D0 
     &    - .006584D0*lz)*lz))*rz)*rz )

      xh = MH/MT - 1
      if( xh .le. 1.4D0 ) then
        delta3LGF3MT6 =-CW2/SW2*XT**3*(95.92D0 + (-111.98D0 + (8.099D0 +
     &      (9.36D0 + (7.27D0 - 15.6D0*xh)*xh)*xh)*xh)*xh) ! Eq.18  in hep-ph/0302275 
        delta3LasGF2MT4 =-CW2/SW2*XT**2*alfas/pi* (157.295D0 + (112 + (-24.73D0 +
     &      (7.39D0 + (-3.52D0 + 2.06D0*xh)*xh)*xh)*xh)*xh) ! Eq.19  in hep-ph/0302275 
       endif
c end three-loop contribution 
c four-loop contribution
       ! K.G. Chetyrkin, M. Faisst, J.H. Kühn, P. Maierhoefer, C. Sturm hep-ph/0605201 eq.6
       !  R. Boughezal and M. Czakon Nucl.Phys. B755 (2006) 221, [hep-ph/0606232].
       delta4LQCD = -CW2/SW2*3*Xt*(alfas/pi)**3*(-93.1501D0)
c end four-loop contribution
        
       deltaRBOL=delta2Lrem+delta2LQCD+delta3LQCD+delta3LGF3MT6+
     &         delta3LasGF2MT4+delta4LQCD+(DelAlfa)*((DelAlfa) 
     &         + 2*(delta1L-DelAlfa)) 

      if(printiter) then
        print*, "delta2Lrem=",delta2Lrem  
        print*, "delta2LQCDud",delta2LQCDud      
        print*, "delta2LQCDAlfa",delta2LQCDAlfa
        print*, "delta2LQCDRho",-CW2/SW2*delta2LQCDRho
        print*, "delta2LQCDrem",delta2LQCDrem
        print*, "delta2LQCD",delta2LQCD    
        print*, "delta3LQCD",delta3LQCD
        print*, "delta3LQCD,delta3LGF3MT6",delta3LQCD,delta3LGF3MT6
        print*, "delta3LasGF2MT4,delta4LQCD", delta3LasGF2MT4,delta4LQCD 
        print*, "deltaR",deltaRBOL   
      endif       
      end     

c==========================================================c       
      double precision function kniehlV1(r)
      double precision r,y,h,pi,kniehlx1
      parameter (pi=2d0*asin(1d0))
       y=sqrt(1d0-r)
       h=dLog(2d0*dsqrt(1d0-r))
      ! using interpolating formulae in Nucl.Phys.B 347 (1990) 86-104  
       kniehlV1=-4d0*pi**2/6d0*(3d0-5d0*y**2)*h+1.0829D0+8.*pi*y+8.4465D0*y**2
     &           -66.3923D0*y**3+22.6086D0*y**4
      end
c==========================================================c       
      double precision function kniehlA1(r)
      double precision r,y,h,pi,kniehlx1
      parameter (pi=2d0*asin(1d0))
      y=sqrt(1.-r)
      h=Log(2*sqrt(1.-r))
      ! using interpolating formulae in Nucl.Phys.B 347 (1990) 86-104 
      kniehlA1=8d0*pi**2/6d0*y**2*h-0.6043D0-9.7824D0*y**2-6.5179D0*y**3
     &           +0.8861D0*y**4
      end 
c==========================================================c       
      double precision function kniehlF1(x)
      double precision x,pi
      parameter (pi=2d0*asin(1d0))
      ! using interpolating formulae in Nucl.Phys.B 347 (1990) 86-104 
      ! seems identical to FH
      kniehlF1=(1d0-x)**2*dLog((1d0-x))*(3d0/8d0*dLog((1d0-x))-pi**2/6d0-9d0/8d0)
     &          -1.1881D0-2.0979D0*x+4.1157D0*x**2
     &          -2.2082D0*x**3+3.6968D0*x**4-2.1815D0*x**5
      end    

c=======================running of alphaS ==========================c       
      double precision function RunAlfaS(AlfaSin,Qin,Qout)
      double precision AlfaSin,Qin,Qout
      parameter (pi=2d0*asin(1d0))
      RunAlfaS=AlfaSin/(1d0 + 
     &           (11d0-10d0/3.d0)/(4d0*pi)*AlfaSin*dlog((Qout/Qin)**2))
      end 



c*********************************************************************c
      subroutine  NMSSMDeltaR1L_OS(aQ2,xMW,xMZ,xGF,xMT,xalfas,xalfa,
     &             DelAlfa,res,iloop,ischeme,ierror,imwfix,printiter)
      implicit none
      logical printiter
      integer iloop,i,ihsm,ierror,ischeme,imwfix,ierrhiggs
      double precision aQ2,MW,MZ,xMW,xMZ,xGF,xMT,xalfas,xalfa
      double precision res, DelAlfa,delta1L,DeltaRho2,SelfTWW2L,
     .  SelfTZZ2L,res1L,res2L,rk,MHSM,delrho1LSSM,delR,
     .  SMselfWDP,SMselfWSP,SMselfW,SMselfZDP,SMselfZSP,SMselfZ
      double precision  selfww2LQCD,selfzz2LQCD,selfzzSMQCD,selfwwSMQCD
     .                  ,delrho2LQCD,delrho2LEWSM,delrho2LQCDSM
      double complex tri,box,dZfLe,dZfLne,dZfLmu,dZfLnu, dMWsq, dMZsq,
     .   dZe,dZAA, dZZA, dSW, selfWW0,rho1L,li2_hdec
      double precision SMWSelf,SMZSelf,selfZEW_la,selfWEW_la,
     .   selfZEW,selfWEW,delrho2LEW,delrho1LSUSY,delrho1LSM
      double precision XX, NMSSMWSelf, NMSSMZSelf,NMSSMyZSelf,NMSSMDyself
     .    ,NMSSMdZfnu,NMSSMdZfe, NMSSMbox,NMSSMvertex,nms_full_Zself,
     .    nms_full_Wself
      double precision dMW2,dMZ2,dZe1,dMHpm2,
     .                        dthd,dthu,dths,dtad,dtas,dMTSM,xa,xt,aphi,
     .                        aCTSM,aSM
      double precision dMWoMW,dMZoMZ,vv
      double precision Qs,Qinp
      common /scale/ Qs  
      common /SUSYscale/ Qinp
      common/vectorself/dMWoMW,dMZoMZ   
c Nhung added for EWQCD corrections in decays 1/4/2019
      double precision RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0(3), absAd0(3), absAe0(3),  
     &                 ml20(3), mer20(3), mq20(3), mdr20(3), mur20(3),
     &                 phiAu0(3), phiAd0(3), phiAe0(3)
      common/slhaDRpara/RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0, absAd0, absAe0,  
     &                 ml20, mer20, mq20, mdr20, mur20,phiAu0,phiAd0,phiAe0
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)     
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU   
      double precision dMW2QCD,dMZ2QCD
      common/WZselfQCD/dMW2QCD,dMZ2QCD  
      double precision MW2SM,MW21L,MW22LQCD,MW22LEW
      common /SMWmass/MW2SM
      common /WMASS_NMSSM/MW21L,MW22LQCD,MW22LEW        
#include "HdecayTCLs.inc"  
       if (iloop.eq.0) then
       res=0D0
       go to 113
       endif

       phiAu=phiAu0; mq2=mq20;mur2=mur20;absAu=absAu0  
       MW=xMW
       if (imwfix.eq.1 .and. iloop.eq.1)then
          MW = sqrt(MW2SM)
       endif        
       MW2= MW**2
       MZ=xMZ; MZ2=MZ**2         
       call treelevelmasses_MW(MW,MZ,xalfa,ischeme,ierrhiggs)
       if (ierrhiggs.eq.1)then
         print*, "Negative or NAN tree-level Higgs mass Eigenvalues in W-mass calculation"
         print*, "stop W-mass calculation"
         ierror=2
         return
       endif
       call couplings  
       call couplingsXX 
       CW= MW/MZ; CW2=CW**2;  SW2=1D0-CW2; SW= sqrt(SW2) 
       S2W=2*SW*CW; C2W=CW2-SW2  
       Qs=sqrt(aQ2)
!       Qs=xMT !test SM two-loop
       rk= abs(ZH5(1,4))
       ihsm=1
       do i=2,5
       if (abs(ZH5(i,4)).gt.rk)then
         ihsm=i
         rk =  abs(ZH5(i,4))
       endif
       enddo
       aMH2=MH(ihsm)**2  
       selfWW0= NMSSMWSelf(0D0) ! subtracted the SM contribution
       dMWsq  = NMSSMWSelf(MW2) ! subtracted the SM contribution
       dMZsq  = NMSSMZSelf(MZ2) ! subtracted the SM contribution
       dZZA   = 2/MZ2* NMSSMyZSelf() ! subtracted the SM contribution
       dZAA   = NMSSMDyself()        ! subtracted the SM contribution
       rho1L  = (dMZsq/MZ2-dMWsq/MW2)
       dSW    = CW2/SW/2D0*rho1L
       dZe    = -0.5D0*(-dZAA - SW/CW*dZZA)
      
       dZfLe  = NMSSMdZfe(1)  ! subtracted the SM contribution
       dZfLmu = NMSSMdZfe(2)  ! subtracted the SM contribution
       dZfLne = NMSSMdZfnu(1) ! subtracted the SM contribution
       dZfLnu = NMSSMdZfnu(2) ! subtracted the SM contribution
       box    = NMSSMbox(Qs**2) ! subtracted the SM contribution
       tri    = NMSSMvertex(Qs**2) ! subtracted the SM contribution


       delta1L = 0.5D0*(DCONJG(dZfLe)+dZfLne+DCONJG(dZfLnu)+dZfLmu )
     &       +2*(dZe)+(selfWW0-dMWsq)/MW2 +tri+box-CW2/SW2*rho1L
c       call delr_1L_nmssm(xalfa,delR)  
       delta1L=delta1L*xfacWSM+ delR*(1D0-xfacWSM)     
       res=delta1L  
#ifdef printdetails

       print*,"dZfLe",dZfLe
       print*,"dZfLmu",dZfLmu 
       print*, "dZfLne",dZfLne
       print*, "dZfLnu",dZfLnu
       print*,"selfWW0 ",selfWW0
       print*, "dMWsq",dMWsq
       print*, "dMZsq",dMZsq
       print*,"dZZA",dZZA
       print*,"dZAA", dZAA
       print*, "dSW",dSW
       print*, "2*dZe=",dZe
       print*, "lepton wave function CT=", 0.5D0*(DCONJG(dZfLe)+dZfLne+DCONJG(dZfLnu)+dZfLmu )
       print*, "(selfWW0-dMWsq)/MW2=",(selfWW0-dMWsq)/MW2
       print*, "triangle =",tri
       print*, "box =", box
       print*, "rho =", -CW2/SW2*rho1L     
       stop
#endif 
       if (iloop.eq.1) go to 113  
       res2L=0D0
       if(iloop.gt.1) then  
           vv=Sqrt(4D0*MZ2*SW2*CW2/(4*Pi*xalfa))
           if (imwfix.eq.1 .and. iloop.eq.3 )then  
           call ini_QCD(sqrt(aQ2),3,ierror,0)
           else
           call ini_QCD(sqrt(aQ2),3,ierror,imwfix)
           endif
           if(ierror.eq.2) return  
c for testing with the Kathrin's code           
c           call CalcVEV_QCD(3) 
c           selfww2LQCD=dMW2QCD  
c           selfzz2LQCD=dMZ2QCD      
c end            
           call SelfTWW_QCD(selfww2LQCD)            
           call SelfTZZ_QCD(selfzz2LQCD)
           call SelfTVV_QCDSM(delrho2LQCDSM,ischeme)                   
           delrho2LQCD=(-selfww2LQCD+selfzz2LQCD)-delrho2LQCDSM    
           res2L=- CW2/SW2*(delrho2LQCD)
           res=(delta1L+res2L) 
           if (iloop.eq.2)then 
           go to 113
           else
           call ini_atlambda(sqrt(aQ2),MHSM,xMW,ischeme,ierror,imwfix)
           call SelfTWW2L_MT4(selfWEW,0)
           call SelfTZZ2L_MT4(selfZEW,0)                   
           if (ierror.gt.0)then 
           selfWEW_la=0D0
           selfZEW_la=0D0
           res2L=- CW2/SW2*(delrho2LQCD) 
           res=delta1L+res2L          
           go to 113           
           else                            
           call SelfTWW2L_lambda(selfWEW_la)
           call SelfTZZ2L_lambda(selfZEW_la)
           endif
c           print*, "selfZEW+selfZEW_la",selfZEW,selfZEW_la,selfWEW,selfWEW_la
           selfZEW=selfZEW+selfZEW_la
           selfWEW=selfWEW+selfWEW_la          
           delrho2LEW=(-selfWEW+selfZEW)+(-dMZoMZ*dMZoMZ+
     &        dMWoMW*dMZoMZ)

c           MHSM= sqrt(aMH2)  ! for testing the effect of Higgs mass on the subtracted SM results.

           call ini_SM(MHSM,xMT,xMW,xMZ,xalfa,Qs**2,delrho1LSSM,dMTSM,ischeme)
           call SelfTWW2L_SMEW(SMselfWDP,SMselfWSP,SMselfW)
           call SelfTZZ2L_SMEW(SMselfZDP,SMselfZSP,SMselfZ)
           delrho2LEWSM=SMselfZ-SMselfW +delrho1LSSM
c           print*, "delrho2LEW",delrho2LEW,delrho2LEWSM,MHSM                 
           delrho2LEW=delrho2LEW-delrho2LEWSM
           delrho1LSM=3D0*xalfa/(16D0*pi*MW2*SW2)*xMT**2
           delrho1LSUSY=dMZoMZ-dMWoMW-delrho1LSM          
           delrho2LEW=delrho2LEW
c     &   +(delrho1LSUSY*(DelAlfa -CW2/SW2*(delrho1LSUSY + 2*delrho1LSM)))
           
#ifdef checkSM 
      !check formular provided by Fleischer, Tarasov, Jegerlehner see
      !    Phys.Rev.D 51 (1995) 3820-3837 (a clearer article compared to the one in 1993)
           print*, "DP", SMselfZDP-SMselfWDP
           print*, "SP", SMselfZSP-SMselfWSP
           print*, "finite",SMselfZ-SMselfW, delrho1LSSM,
     &             delrho2LEWSM, +(3/16D0*2*xMT*dMTSM)
     &       /(4D0*MZ2*SW2*CW2/(4*Pi*xalfa))/pi**2
           print*, "vv", Sqrt(4D0*MZ2*SW2*CW2/(4*Pi*xalfa))
            xa= MHSM**2/xMT**2 
            xt=(1/16D0*xMT**2)
     &       /(4D0*MZ2*SW2*CW2/(4*Pi*xalfa))/pi**2
            aphi= 2*asin(sqrt(0.25d0*xa))
            aCTSM=3*xt**2*(13D0/2.-xa+0.5D0*xa*(xa-6)*
     &                 Log(xa)+0.5D0*(xa-4d0)*sqrt(xa)*sqrt(4D0-xa)*(pi-aphi) )
            aSM=3*xt**2*(37/2D0-3*xa-3*(xa+2)*log(xa)+(xa-2)/(2*xa)*pi**2
     &        -3/xa*(xa-1)**2*(xa-2)*li2_hdec(1.-xa)+3*(xa**2-6.*xa+10.)*
     &         DIMAG(li2_hdec(Cos(aphi)+IC*Sin(aphi)))*(- 2/Sqrt(4D0/xa -1) )   )
            print*, "CT SM",aCTSM
            print*, "genuine TL SM",aSM+aCTSM
           stop  
#endif   
           res2L=- CW2/SW2*(delrho2LQCD+delrho2LEW) 
           res=(delta1L+res2L  )       
           endif
       endif
  
#ifdef printdetails
       print*, "QCD, drho, dr", delrho2LQCD,- CW2/SW2*delrho2LQCD
       print*, "EW, drho, dr", delrho2LEW,- CW2/SW2*delrho2LEW       
#endif   
113   if(printiter) then
       write(*,*) "NMSSMdeltaR_QCD =", - CW2/SW2*delrho2LQCD 
       write(*,*) "NMSSMdeltaR_EW =", - CW2/SW2*delrho2LEW
       write(*,*) "NMSSMdeltaR_1L =", delta1L
      endif
      continue
      return  
      end
      


c==========================================================c 
       double precision function SMWself(p2)
       implicit none
       double precision p2
        integer I3Gen1,I3Gen2
       double precision aant1,aant2,aant3,aant4,aant5,aant6,aant7,
     &  aant8,aant9(3),aant10(3),aant11(3,3),aant12(3,3),aant13(3,3),
     &  aant14,aant15,aant16,aant17(3),aant18(3)
#include "SM.h" 
       aant1=ReB0i(bb0,p2,0D0,MW2)
       aant2=ReB0i(bb00,p2,0D0,MW2)
       aant3=ReB0i(bb00,p2,MH2,MW2)
       aant4=ReB0i(bb00,p2,MW2,MZ2)
       aant5=ReB0i(bb1,p2,0D0,MW2)
       aant6=ReB0i(bb0,p2,MH2,MW2)
       aant7=ReB0i(bb0,p2,MW2,MZ2)
       aant8=ReB0i(bb1,p2,MW2,MZ2)
       aant14=myA0(MW2)
       aant15=myA0(MH2)
       aant16=myA0(MZ2)
        Do I3Gen1=1,3
       aant9(I3Gen1)=ReB0i(bb00,p2,0D0,MFe2(I3Gen1))
       aant10(I3Gen1)=ReB0i(bb1,p2,0D0,MFe2(I3Gen1))
       aant17(I3Gen1)=myA0(MFe2(I3Gen1))
        enddo
        Do I3Gen1=1,3
        Do I3Gen2=1,3
       aant11(I3Gen1,I3Gen2)=ReB0i(bb0,p2,MFu2(I3Gen1),MFd2(I3Gen2))
       aant12(I3Gen1,I3Gen2)=ReB0i(bb00,p2,MFu2(I3Gen1),MFd2(I3Gen2))
       aant13(I3Gen1,I3Gen2)=ReB0i(bb1,p2,MFu2(I3Gen1),MFd2(I3Gen2))
        enddo
        enddo
        Do I3Gen2=1,3
       aant18(I3Gen2)=myA0(MFd2(I3Gen2))
        enddo
       SMWself=0D0 
       SMWself=SMWself+(Alfa*(-96*aant2+12*aant1*(MW2-5*p2)-24*aant5*
     &  p2-(12*(aant3+aant4+8*aant4*CW2))/SW2-(-18*aant14-3*(aant15+
     &  aant16+12*aant16*CW2)-12*aant6*MW2-24*aant8*CW2*p2+8*Finite*p2-
     &  3*aant7*(-4*CW2*(2*MZ2+3*p2)+(4*MW2*SW2**2)/CW2))/SW2))/(48d0*
     &  Pi)
           do I3Gen1 = 1,3
       SMWself=SMWself+-(Alfa*(p2*aant10(I3Gen1)+aant17(I3Gen1)-2*
     &  aant9(I3Gen1)))/(4d0*Pi*SW2)
           enddo
           do I3Gen1 = 1,3
           do I3Gen2 = 1,3
       SMWself=SMWself+(-3*Alfa*CKM(I3Gen1,I3Gen2)*CKMC(I3Gen1,I3Gen2)*
     &  (-2*aant12(I3Gen1,I3Gen2)+p2*aant13(I3Gen1,I3Gen2)+
     &  aant18(I3Gen2)+aant11(I3Gen1,I3Gen2)*MFu2(I3Gen1)))/(4d0*Pi*
     &  SW2)
           enddo
           enddo                 
       end function SMWself
c==========================================================c 
       double precision function SMZself(p2)
       implicit none
       double precision p2
        integer I3Gen
       double precision aant1,aant2,aant3,aant4,aant5,aant6,aant7,
     &  aant8(3),aant9(3),aant10(3),aant11(3),aant12(3),aant13(3),
     &  aant14(3),aant15(3),aant16(3),aant17,aant18,aant19,aant20(3),
     &  aant21(3),aant22(3)
#include "SM.h" 
       aant1=ReB0i(bb0,p2,MH2,MZ2)
       aant2=ReB0i(bb0,p2,MW2,MW2)
       aant3=ReB0i(bb00,p2,0D0,0D0)
       aant4=ReB0i(bb00,p2,MH2,MZ2)
       aant5=ReB0i(bb00,p2,MW2,MW2)
       aant6=ReB0i(bb1,p2,0D0,0D0)
       aant7=ReB0i(bb1,p2,MW2,MW2)
       aant17=myA0(MH2)
       aant18=myA0(MW2)
       aant19=myA0(MZ2)
        Do I3Gen=1,3
       aant8(I3Gen)=ReB0i(bb0,p2,MFd2(I3Gen),MFd2(I3Gen))
       aant9(I3Gen)=ReB0i(bb0,p2,MFe2(I3Gen),MFe2(I3Gen))
       aant10(I3Gen)=ReB0i(bb0,p2,MFu2(I3Gen),MFu2(I3Gen))
       aant11(I3Gen)=ReB0i(bb00,p2,MFe2(I3Gen),MFe2(I3Gen))
       aant12(I3Gen)=ReB0i(bb00,p2,MFd2(I3Gen),MFd2(I3Gen))
       aant13(I3Gen)=ReB0i(bb00,p2,MFu2(I3Gen),MFu2(I3Gen))
       aant14(I3Gen)=ReB0i(bb1,p2,MFd2(I3Gen),MFd2(I3Gen))
       aant15(I3Gen)=ReB0i(bb1,p2,MFe2(I3Gen),MFe2(I3Gen))
       aant16(I3Gen)=ReB0i(bb1,p2,MFu2(I3Gen),MFu2(I3Gen))
       aant20(I3Gen)=myA0(MFd2(I3Gen))
       aant21(I3Gen)=myA0(MFu2(I3Gen))
       aant22(I3Gen)=myA0(MFe2(I3Gen))
        enddo
       SMZself=0D0 
       SMZself=SMZself+(Alfa*(3*aant17*CW2+3*aant19*CW2+36*aant3*CW2-
     &  12*aant4*CW2-108*aant5*CW2**3+12*aant1*MW2-24*aant2*CW2**3*MW2-
     &  18*aant6*CW2*p2-60*aant2*CW2**3*p2-24*aant7*CW2**3*p2-8*CW2**3*
     &  Finite*p2+24*aant5*CW2**2*SW2-12*aant5*CW2*SW2**2+24*aant2*CW2*
     &  MW2*SW2**2+6*aant18*CW2*(-3*CW2+12*CW2**2+SW2)))/(48d0*CW2**2*
     &  Pi*SW2)
           do I3Gen = 1,3
       SMZself=SMZself+-(Alfa*(2*((12-9/SW2-8*SW2)*aant12(I3Gen)+(24-
     &  9/SW2-32*SW2)*aant13(I3Gen))+(p2*((9-12*SW2+8*SW2**2)*
     &  aant14(I3Gen)+3*(1-4*SW2+8*SW2**2)*aant15(I3Gen)+(9-24*SW2+32*
     &  SW2**2)*aant16(I3Gen)))/SW2+((9-12*SW2+8*SW2**2)*aant20(I3Gen)+
     &  (9-24*SW2+32*SW2**2)*aant21(I3Gen))/SW2+(3*(1-4*SW2+8*SW2**2)*
     &  (-2*aant11(I3Gen)+aant22(I3Gen)))/SW2+(9*aant8(I3Gen)*
     &  MFd2(I3Gen)+3*aant9(I3Gen)*MFe2(I3Gen)+9*aant10(I3Gen)*
     &  MFu2(I3Gen))/SW2))/(24d0*CW2*Pi) 
           enddo
       end function SMZself
c==========================================================c        
       double precision function SMDyself()
       implicit none
       double precision aant1,aant2,aant3,aant4,aant5
       double precision abnt1,abnt2,abnt3,abnt4,abnt5,abnt6,abnt7,
     &  abnt8,abnt9,abnt10,abnt11,abnt12,abnt13,abnt14,abnt15,abnt16,
     &  abnt17,abnt18,abnt19,abnt20,abnt21,abnt22,abnt23,abnt24
#include "SM.h" 
       aant1=ReB0i(bb0,0D0,MW2,MW2)
       aant2=ReB0i(bb1,0D0,MT2,MT2)
       aant3=ReB0i(bb1,0D0,MW2,MW2)
       aant4=ReB0i(dbb00,0D0,MT2,MT2)
       aant5=ReB0i(dbb00,0D0,MW2,MW2)
       SMDyself=0D0 
       SMDyself=-(Alfa*(15*aant1+2*(8*aant2+3*aant3-16*aant4+18*aant5+
     &  Finite*0)))/(12d0*Pi)+SMDyself
       abnt1=ReB0i(bb00,MZ2,MB2,MB2)
       abnt2=ReB0i(bb00,MZ2,MC2,MC2)
       abnt3=ReB0i(bb00,MZ2,MD2,MD2)
       abnt4=ReB0i(bb00,MZ2,ME2,ME2)
       abnt5=ReB0i(bb00,MZ2,ML2,ML2)
       abnt6=ReB0i(bb00,MZ2,MM2,MM2)
       abnt7=ReB0i(bb00,MZ2,MS2,MS2)
       abnt8=ReB0i(bb00,MZ2,MU2,MU2)
       abnt9=ReB0i(bb1,MZ2,MB2,MB2)
       abnt10=ReB0i(bb1,MZ2,MC2,MC2)
       abnt11=ReB0i(bb1,MZ2,MD2,MD2)
       abnt12=ReB0i(bb1,MZ2,ME2,ME2)
       abnt13=ReB0i(bb1,MZ2,ML2,ML2)
       abnt14=ReB0i(bb1,MZ2,MM2,MM2)
       abnt15=ReB0i(bb1,MZ2,MS2,MS2)
       abnt16=ReB0i(bb1,MZ2,MU2,MU2)
       abnt17=myA0(MB2)
       abnt18=myA0(MC2)
       abnt19=myA0(MD2)
       abnt20=myA0(ME2)
       abnt21=myA0(ML2)
       abnt22=myA0(MM2)
       abnt23=myA0(MS2)
       abnt24=myA0(MU2)
       SMDyself=-(Alfa*(-2*abnt1+abnt17+4*abnt18+abnt19-8*abnt2+3*
     &  abnt20+3*abnt21+3*abnt22+abnt23+4*abnt24-2*abnt3-6*abnt4-6*
     &  abnt5-6*abnt6-2*abnt7-8*abnt8+4*abnt10*MZ2+abnt11*MZ2+3*abnt12*
     &  MZ2+3*abnt13*MZ2+3*abnt14*MZ2+abnt15*MZ2+4*abnt16*MZ2+abnt9*
     &  MZ2))/(3d0*MZ2*Pi)+SMDyself 
       end function SMDyself
c==========================================================c 
c==========================================================c 
       double precision function SMDyselfO()
       implicit none
        integer I3Gen1
       double precision aant1,aant2,aant3,aant4(3),aant5(3),aant6(3),
     &  aant7(3),aant8(3),aant9(3)
#include "SM.h" 
       aant1=ReB0i(bb0,0D0,MW2,MW2)
       aant2=ReB0i(bb1,0D0,MW2,MW2)
       aant3=ReB0i(dbb00,0D0,MW2,MW2)
        Do I3Gen1=1,3
       aant4(I3Gen1)=ReB0i(bb1,0D0,MFd2(I3Gen1),MFd2(I3Gen1))
       aant5(I3Gen1)=ReB0i(bb1,0D0,MFe2(I3Gen1),MFe2(I3Gen1))
       aant6(I3Gen1)=ReB0i(bb1,0D0,MFu2(I3Gen1),MFu2(I3Gen1))
       aant7(I3Gen1)=ReB0i(dbb00,0D0,MFd2(I3Gen1),MFd2(I3Gen1))
       aant8(I3Gen1)=ReB0i(dbb00,0D0,MFe2(I3Gen1),MFe2(I3Gen1))
       aant9(I3Gen1)=ReB0i(dbb00,0D0,MFu2(I3Gen1),MFu2(I3Gen1))
        enddo
       SMDyselfO=0D0 
       SMDyselfO=-(Alfa*(15*aant1+6*aant2+36*aant3+2*Finite))/(12d0*Pi)
     &  +SMDyselfO
           do I3Gen1 = 1,3
       SMDyselfO=SMDyselfO+-(Alfa*(aant4(I3Gen1)+3*aant5(I3Gen1)+4*
     &  aant6(I3Gen1)-2*aant7(I3Gen1)-6*aant8(I3Gen1)-8*aant9(I3Gen1)))
     &  /(3d0*Pi)
           enddo
  
       end function SMDyselfO
c==========================================================c 
c==========================================================c 
       double precision function SMyZself()
       implicit none
        integer I3Gen
       double precision aant1,aant2,aant3(3),aant4(3),aant5(3),aant6,
     &  aant7(3),aant8(3),aant9(3)
#include "SM.h" 
       aant1=ReB0i(bb0,0D0,MW2,MW2)
       aant2=ReB0i(bb00,0D0,MW2,MW2)
       aant6=myA0(MW2)
        Do I3Gen=1,3
       aant3(I3Gen)=ReB0i(bb00,0D0,MFd2(I3Gen),MFd2(I3Gen))
       aant4(I3Gen)=ReB0i(bb00,0D0,MFe2(I3Gen),MFe2(I3Gen))
       aant5(I3Gen)=ReB0i(bb00,0D0,MFu2(I3Gen),MFu2(I3Gen))
       aant7(I3Gen)=myA0(MFd2(I3Gen))
       aant8(I3Gen)=myA0(MFe2(I3Gen))
       aant9(I3Gen)=myA0(MFu2(I3Gen))
        enddo
       SMyZself=0D0 
       SMyZself=SMyZself+(Alfa*(aant6+10*aant2*CW2-6*aant6*CW2+2*aant1*
     &  MW2-2*aant2*SW2))/(4d0*CW*Pi*SW)
           do I3Gen = 1,3
       SMyZself=SMyZself+-(Alfa*((-3+4*SW2)*(-2*aant3(I3Gen)+
     &  aant7(I3Gen))+3*(-1+4*SW2)*(-2*aant4(I3Gen)+aant8(I3Gen))+2*(-
     &  3+8*SW2)*(-2*aant5(I3Gen)+aant9(I3Gen))))/(12d0*CW*Pi*SW)
           enddo
       end function SMyZself
c==========================================================c 
       
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccc Tree-Level-Masses cccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
     
      subroutine treelevelmasses_MW(xMW,xMZ,xalfa,ischeme,ierrhiggs)

      implicit none
      integer ischeme,ierrhiggs
      double precision xMW,xMZ,xalfa
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      
      double precision RAk,RAl,IAk,IAl,arg
      
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
     
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision mtpole,mbMSmb,MSin,MCin,mtms,mbms,mtDR,mbDR
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
     
      double precision Qs,Qinp
     
      double precision ZH5(5,5),ZH(6,6)
     
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      
      double complex nZU(6,6),nZD(6,6)
      
      double precision nMSu(6),nMSd(6)
      
      double precision a_sMS,a_sDR
     
      double precision vu,vd
      
      double precision absAtDR,phiAtDR,mq2DR,mur2DR,absold,absnew
      
      double complex dmtfin,dmtdiv1,dYtfin,dYtdiv1
      
      double complex dMstfin(2,2),dMstdiv1(2,2),dAtfin,
     &               dAtdiv1,dphiAtfin,dphiAtdiv1
     
      double complex dmQLsq,dmtRsq
     
      double precision pi
c Maggie changed 14/1/2019
      double complex AT
c end Maggie changed 14/1/2019      
      parameter (pi = 2d0*Asin(1d0))
      
      logical MHpmInput,CPcon,mQrun,onelswitch
      
      integer i,j
      

      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
     
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /topoles/ mtpole,mbMsmb,MSin,MCin
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch
      common /slhapara/ RAl,RAk
      common /DRstop/ absAtDR,phiAtDR,mq2DR,mur2dR
      common /nSu/ nMSu,nZU
      common /nSd/ nMSd,nZD
      common /scale/ Qs
      common /SUSYscale/ Qinp
c nhung add for atat 22/3/2019
      integer ilevel,igauge 
      common/ilevelATAT/ilevel,igauge
      double precision g3Q, mtQ, vQ, mhQ, asDR,g1Q,g2Q
      double precision dmsq4fin,dmsur4fin 
      double complex dAt4fin
c end nhung add 22/3/2019
c nhung added for atlambda 6/2021
      integer ierror
      double precision nmh(6),nZH(6,6),nMNeu(5),nMCha
      double complex nZneu(5,5)
      common /nAtlambda/nmh,nZH,nMNeu,nZneu,nMCha   
c end nhung added for atlambda 6/2021  
 
c calculate the other SM parameters form the input
!nhung changed here Jun/2022
      alpha=xalfa
      e=sqrt(4*pi*alpha)
!       Mw=sqrt(2*Mz**2 + (sqrt(2d0)*sqrt(Gf*Mz**2*
!      &     (-(sqrt(2d0)*e**2) + 2*Gf*Mz**2)))/Gf)/2.
      Qs=Qinp
      if (abs(xMW-MW).gt.1D-6)then
         MW=xMW; MZ=xMZ 
      endif      
!end nhung changed here Jun/2022         
      g1=(e*Mz)/Mw
      g2=e/sqrt(1-Mw**2/Mz**2)
      v=2d0*Mw/g2
!       v=1/sqrt(Gf*sqrt(2d0))

      

c calcuate other parameters of the Higgs sector from input
      beta=dAtan(tanb)
      vu=v*Sin(beta)
      vd=v*Cos(beta)
      vs=sqrt(2d0)*mueff/abslambda
   
c Bug fixed Kathrin 21/09/2014
        if(MHpmInput) then
        RAl=(-4*abskappa*abslambda*vs**2*Cos(phik + 3*Phis) + 
     -      (4*MHpm**2 + (2*abslambda**2 - g2**2)*v**2)
     -      *Cos(phil + Phis + Phiu)*Sin(2*beta))/
     -      (4.*Sqrt(2d0)*abslambda*vs)
        else
        MHpm=Sqrt(((-2*abslambda**2 + g2**2)*v**2 + 
     -        4*abslambda*vs*(Sqrt(2d0)*RAl+
     -        abskappa*vs*Cos(phik + 3*Phis))/Sin(2*beta)/
     -        Cos(phil + Phis + Phiu))/4.)

        end if
c End bug-fix Kathrin 21/09/2014
        
        IAk=(3*abslambda*v**2*Cos(beta)/Cos(phik + 3*phis)*Sin(beta)*
     -      Sin(phik - phil + 2*phis - phiu))/(Sqrt(2d0)*vs) - 
     -      RAk*Tan(phik + 3*phis)
        IAl=(abskappa*vs/Cos(phil + phis + phiu)*
     -       Sin(phik - phil + 2*phis - phiu))/
     -       Sqrt(2d0) - RAl*Tan(phil + phis + phiu)
     
        absAlambda=Abs(RAl+(0d0,1d0)*IAl)
        phiAl=arg(RAl,IAl)
        absAkappa=Abs(RAk+(0d0,1d0)*IAk)
        phiAk=arg(RAk,IAk)

    
c calculate the Yukawa couplings
      mt=mtpole
      mb=(1d0+4d0/3d0*a_sMS(mbMSmb)/pi+
     &    8.2364d0*(a_sMS(mbMSmb)/pi)**2)*mbMSmb
      Ye(1) = me*sqrt(2d0)/v/Cos(beta)
      Ye(2) = mmu*sqrt(2d0)/v/Cos(beta)
      Ye(3) = mtau*sqrt(2d0)/v/Cos(beta)
      Yu(1) = mu*sqrt(2d0)/v/Sin(beta)
      Yu(2) = mc*sqrt(2d0)/v/Sin(beta)
      Yu(3) = mt*sqrt(2d0)/v/Sin(beta)
      Yd(1) = md*sqrt(2d0)/v/Cos(beta)
      Yd(2) = ms*sqrt(2d0)/v/Cos(beta)
      Yd(3) = mb*sqrt(2d0)/v/Cos(beta)
      
     
 
      call higgstreelevel(v,beta,g1,g2,vs,abslambda,phil,abskappa,phik,
     &         absAkappa,phiAk,absAlambda,phiAl,phiu,phis,Mh,ZH5,CPcon)
      ierrhiggs=0
      do i=1,6,1
          if(Mh(i).ne.mh(i)) then
            ierrhiggs=1
          endif
      enddo
      
      do i=1,6,1
         do j=1,6,1
           if((i.ne.1).and.(j.ne.1)) then
                 ZH(i,j)=ZH5(i-1,j-1)
              else if ((i.eq.1).and.(j.eq.1)) then
                 ZH(i,j)=1
              else
                 ZH(i,j)=0
           end if
         end do
      end do
      

      call charginomasses(absM2,phiM2,g2,v,vs,abslambda,phil,
     &            phiu,phis,beta,UP,UM,MCha)
    

      call neutralinomasses(absM1,phiM1,absM2,phiM2,g1,g2,v,vs,
     &          abslambda,phil,abskappa,phik,phiu,phis,beta,NN,MChi,
     &          CPcon)
    
       
      call sleptonmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,
     &                   phiAe,absAe,ml2,mer2,Ye,MSe,ZE)
        
        
      call dsquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAd,
     &                   absAd,mq2,mdr2,Yd,MSd,ZD)


      call usquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,MSu,ZU)
     
      call usquarkmasses(0d0,0d0,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,nMSu,nZU)
    
    
      g3=Sqrt(alphaS*4d0*pi)
      
!running of the top and bottom quark masses
      absAtDR=absAu(3)
      phiAtDR=phiAu(3)
      mq2DR=mq2(3)
      mur2DR=mur2(3)
c nhung add for atat correction 22/3/2019
      if(igauge.eq.1)then
      call RGEevolutiong1g2(MZ,Qs,g1Q,g2Q,g3Q,mtQ,vQ,mhQ)
      call conversionMStoDRg1g2(mtQ,g1Q,g2Q,g3Q,mtDR,asDR)
      else
      call RGEevolution(MZ, Qs, g3Q, mtQ, vQ, mhQ)
      call conversionMStoDR(mtQ, g3Q, mtDR, asDR)     
      endif
      g3=Sqrt(asDR*4d0*pi) 
c      print*, "g31",g3 ,mtDR,mbDR
c end nhung add for atat correction 22/3/2019
c       g3=Sqrt(0.1184D0*4d0*pi) !turn on for test trilinear
      if(ischeme.eq.1) then
c nhung change here 22/3/2019
      call MStoDR(mbMS(Qs),mbDR,Qs)
      Yu(3) = mtDR*sqrt(2d0)/v/Sin(beta)
      Yd(3) = mbDR*sqrt(2d0)/v/Cos(beta)    
      call dsquarkmasses(0d0,0d0,v,beta,abslambda,vs,phil,phis,phiu,phiAd,
     &                   absAd,mq2,mdr2,Yd,nMSd,nZD)
          

      call usquarkmasses(0d0,0d0,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,nMSu,nZU)
100   continue

      if(ilevel.lt.4)then
      call mtbeffat(mtDR,mbDR,g3,mhQ,vQ,Qs,mt,mb)
      else
      ierror=0
      call higgstreeha(v,beta,0d0,0d0,vs,abslambda,phil,abskappa,phik,
     &         absAkappa,phiAk,absAlambda,phiAl,phiu,phis,nMh,nZH,CPcon,ierror)
      if (ierror.eq.1)then
         ilevel=3
         go to 100
      endif
      call neutralinomasses(0d0,0d0,0d0,0d0,0d0,0d0,v,vs,
     &          abslambda,phil,abskappa,phik,phiu,phis,beta,nZNeu,nMneu,
     &          CPcon)
       
      nMCha=Abs(mueff)

      call mtbeffatlambda(mtDR,mbDR,g3,mhQ,vQ,Qs,mt,mb)
   
      endif        
      Yu(3) = mt*sqrt(2d0)/v/Sin(beta)
      Yd(3) = mb*sqrt(2d0)/v/Cos(beta)
c end nhung change here 22/3/2019
      else

c if OS renormalization is chosen for the stop/top sector
c At, mq2(3) and mur2(3) have to be converted to OS values
c#ifdef nhungcheck  !turn on for test trilinear
      call qcdcouplings
      call topsector(dmtfin,dmtdiv1,dYtfin,dYtdiv1)
      call stopsector(dmtfin,dmtdiv1,dMstfin,dMstdiv1,
     &                dAtfin,dAtdiv1,dphiAtfin,dphiAtdiv1)

c nhung changed for atlambda correction 6/2021
101   continue
      if(ilevel.lt.4)then
      call MSQ_MSU_AT_OStoDR(dmsq4fin,dmsur4fin,dAt4fin)
      else
      call MSQ_MSU_AT_OStoDR_atlamda(dmsq4fin,dmsur4fin,dAt4fin,ierror,2)
         if (ierror .eq.1) then
          ilevel=3
         goto 101
         endif
      endif

c end nhung changed for atlambda correction 6/2021   
  
      absnew=1d9
      absold=absAtDR
      i=1
      do while(Abs(absold-absnew).ge.1d-3 .AND. i.le.100)
      absold=absnew
      call qcdcouplings
      call topsector(dmtfin,dmtdiv1,dYtfin,dYtdiv1)
      call stopsector(dmtfin,dmtdiv1,dMstfin,dMstdiv1,
     &                dAtfin,dAtdiv1,dphiAtfin,dphiAtdiv1)
c nhung changed for atlambda correction 6/2021
      if(ilevel.lt.4)then
      call MSQ_MSU_AT_OStoDR(dmsq4fin,dmsur4fin,dAt4fin)
      else
      call MSQ_MSU_AT_OStoDR_atlamda(dmsq4fin,dmsur4fin,dAt4fin,ierror,2)      
      endif
     
c end nhung changed for atlambda correction 6/2021   

c Maggie changed 14/1/2019
c Mistake found by Nhung      
c      absAu(3)=absAtDR-Realpart(dAtfin)
c      phiAu(3)=phiAtDR-Realpart(dphiAtfin)

c nhung change here for atat 22/3/2019
      AT= absAtDR*(Cos(phiAtDR) + (0,1D0)*sin(phiAtDR))-
     &    dAtfin*(Cos(phiAtDR) + (0,1D0)*sin(phiAtDR))-
     &    absAtDR*dphiAtfin*((0,1D0)*Cos(phiAtDR)-sin(phiAtDR))-
     &    dAt4fin
c end nhung change here for atat 22/3/2019

      absAu(3)=Abs(AT)
      phiAu(3)=arg(DBLE(AT),DIMAG(AT))      
c end Maggie changed 14/1/2019
      
      dmQLsq=Abs(nZU(5,5))**2*dMstfin(1,1)+Abs(nZU(5,6))**2*dMstfin(2,2)
     &      -nZU(6,6)*CONJG(nZU(5,6))*dMstfin(1,2)
     &      -nZU(5,6)*CONJG(nZU(6,6))*dMstfin(2,1)
     &      -2*mt*dmtfin
     
      dmtRsq=Abs(nZU(6,5))**2*dMstfin(1,1)+Abs(nZU(6,6))**2*dMstfin(2,2)
     &      -nZU(5,5)*CONJG(nZU(6,5))*dMstfin(2,1)
     &      -nZU(6,5)*CONJG(nZU(5,5))*dMstfin(1,2)
     &      -2*mt*dmtfin
c      print*, "QCD,dmQLsq,dmtRsq",dmQLsq,dmtRsq,-
c     &    dAtfin*(Cos(phiAtDR) + (0,1D0)*sin(phiAtDR))-
c     &    absAtDR*dphiAtfin*((0,1D0)*Cos(phiAtDR)-sin(phiAtDR))
c      print*, "EW,dmsq4fin,dmsur4fin,dAt4fin",dmsq4fin,dmsur4fin,dAt4fin, MW 
    
c nhung change for atat correction 22/3/2019    
      mq2(3)=mq2DR-Realpart(dmQLsq)-dmsq4fin
      mur2(3)=mur2DR-Realpart(dmtRsq)-dmsur4fin
c end nhung change for atat correction 22/3/2019
      
      mt=mtpole
      Yu(3) = mt*sqrt(2d0)/v/Sin(beta)
      call usquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,MSu,ZU)
      call usquarkmasses(0d0,0d0,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,nMSu,nZU)
      absnew=absAu(3)
      i=i+1
      end do
      if(i.eq.101) then
      print*, '*Warning: Conversion form AtDR to AtOS
     . does not converge properly'
      print*, '  Using simplified conversion; i.e. no iteration'
      absAu(3)=absAtDR
      mur2(3)=mur2DR
      mq2(3)=mq2DR
      call qcdcouplings
      call topsector(dmtfin,dmtdiv1,dYtfin,dYtdiv1)
      call stopsector(dmtfin,dmtdiv1,dMstfin,dMstdiv1,
     &                dAtfin,dAtdiv1,dphiAtfin,dphiAtdiv1)
c nhung changed for atlambda correction 6/2021
      if(ilevel.lt.4)then
      call MSQ_MSU_AT_OStoDR(dmsq4fin,dmsur4fin,dAt4fin)
      else
      call MSQ_MSU_AT_OStoDR_atlamda(dmsq4fin,dmsur4fin,dAt4fin,ierror,2)
      endif
c end nhung changed for atlambda correction 6/2021  

c Maggie changed 14/1/2019
c Mistake found by Nhung      
c      absAu(3)=absAtDR-Realpart(dAtfin)
c      phiAu(3)=phiAtDR-Realpart(dphiAtfin)

c nhung change here for atat 22/3/2019
      AT= absAtDR*(Cos(phiAtDR) + (0,1D0)*sin(phiAtDR))-
     &    dAtfin*(Cos(phiAtDR) + (0,1D0)*sin(phiAtDR))-
     &    absAtDR*dphiAtfin*((0,1D0)*Cos(phiAtDR)-sin(phiAtDR))-
     &    dAt4fin
c end nhung change here for atat 22/3/2019

      absAu(3)=Abs(AT)
      phiAu(3)=arg(DBLE(AT),DIMAG(AT))      
c end Maggie changed 14/1/2019
      
      dmQLsq=Abs(nZU(5,5))**2*dMstfin(1,1)+Abs(nZU(5,6))**2*dMstfin(2,2)
     &      -nZU(6,6)*CONJG(nZU(5,6))*dMstfin(1,2)
     &      -nZU(5,6)*CONJG(nZU(6,6))*dMstfin(2,1)
     &      -2*mt*dmtfin
     
      dmtRsq=Abs(nZU(6,5))**2*dMstfin(1,1)+Abs(nZU(6,6))**2*dMstfin(2,2)
     &      -nZU(5,5)*CONJG(nZU(6,5))*dMstfin(2,1)
     &      -nZU(6,5)*CONJG(nZU(5,5))*dMstfin(1,2)
     &      -2*mt*dmtfin
     
c nhung change for atat correction 22/3/2019    
      mq2(3)=mq2DR-Realpart(dmQLsq)-dmsq4fin
      mur2(3)=mur2DR-Realpart(dmtRsq)-dmsur4fin
c end nhung change for atat correction 22/3/2019 

      end if
c#endif   !turn on for test trilinear
      end if
      
      call dsquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAd,
     &                   absAd,mq2,mdr2,Yd,MSd,ZD)
          

      call usquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,MSu,ZU)

      call usquarkmasses(0d0,0d0,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,nMSu,nZU)

      nMSd(5)=sqrt(mq2(3))
c set the right-handed bottom to some unlikely high number, because it does not 
c contribute to avoid problems with mass degeneracy
      nMSd(6)=123.45678d0          
      do i=5,6
      do j=5,6
      if (i.eq.j) then
      nZD(i,j)=1d0
      else
      nZD(i,j)=0d0
      end if
      end do
      end do
      
      call sneutrinomasses(g1,g2,v,beta,ml2,MSv)
c to fix strong coupling at MZ ! for MW calculation     
      g3=Sqrt(alphaS*4d0*pi)       
c
      return
      end  
      
c==========================================================c 
 
c==========================================================c         
       double precision function NMSSMbox(Q2)
       implicit none
       integer I2G5,I2G6,I3G5,I5G5,I5G6,I6G6,I6G5
       double precision aant1(2,2,6,3),aant2(2,5,6,3),aant3(2,5,6),
     &  aant4(2,5,6,6),aant5(2,5,3)
       double precision myD0,myD00,Q2
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3  
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv 
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)       
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU        
#include "HdecayTCLs.inc" 
        Do I2G5=1,2
        Do I2G6=1,2
        Do I6G5=1,6
        Do I3G5=1,3
       aant1(I2G5,I2G6,I6G5,I3G5)=myD0(MCha2(I2G5),MCha2(I2G6)
     &  ,MSE2(I6G5),MSv2(I3G5),Q2)
        enddo
        enddo
        enddo
        enddo
        Do I2G5=1,2
        Do I5G5=1,5
        Do I6G5=1,6
        Do I3G5=1,3
       aant2(I2G5,I5G5,I6G5,I3G5)=myD0(MCha2(I2G5),MNeu2(I5G5)
     &  ,MSE2(I6G5),MSv2(I3G5),Q2)
        enddo
        enddo
        enddo
        enddo
        Do I2G5=1,2
        Do I5G5=1,5
        Do I6G5=1,6
       aant3(I2G5,I5G5,I6G5)=myD0(MCha2(I2G5),MNeu2(I5G5),MSE2(I6G5),MSv2(2),Q2)
        enddo
        enddo
        enddo
        Do I2G5=1,2
        Do I5G5=1,5
        Do I6G5=1,6
        Do I6G6=1,6
       aant4(I2G5,I5G5,I6G5,I6G6)=myD00(MCha2(I2G5),MNeu2(I5G5)
     &  ,MSE2(I6G5),MSE2(I6G6),Q2)
        enddo
        enddo
        enddo
        enddo
        Do I2G5=1,2
        Do I5G5=1,5
        Do I3G5=1,3
       aant5(I2G5,I5G5,I3G5)=myD00(MCha2(I2G5),MNeu2(I5G5),MSv2(2),MSv2(I3G5),Q2)
        enddo
        enddo
        enddo
       NMSSMbox=0D0 
           do I2G5 = 1,2
           do I3G5 = 1,1
           do I5G5 = 1,5
       NMSSMbox=NMSSMbox+(MW2*aant5(I2G5,I5G5,I3G5)*cchinusnu(I5G5,2)*
     &  ctauchastauR(1,I2G5,I3G5)*DCONJG(ctauchastauR(2,I2G5,2))*(-(g1*
     &  ZNC(I5G5,1))+g2*ZNC(I5G5,2)))/(8d0*g2**2*Pi2*
     &  Sqrt2)
           enddo
           enddo
           enddo
           do I2G5 = 1,2
           do I2G6 = 1,2
           do I3G5 = 1,3
           do I6G5 = 1,6
       NMSSMbox=NMSSMbox+-(MW2*aant1(I2G5,I2G6,I6G5,I3G5)*
     &  CF12F1S12(I2G6,2,I6G5)*ctauchastauR(1,I2G6,I3G5)*
     &  DCONJG(CF12F1S12(I2G5,1,I6G5))*DCONJG(ctauchastauR(2,I2G5,I3G5)
     &  )*MCha(I2G5)*MCha(I2G6))/(16d0*g2**2*pi2)
           enddo
           enddo
           enddo
           enddo
           do I2G5 = 1,2
           do I5G5 = 1,5
           do I6G5 = 1,6
       NMSSMbox=NMSSMbox+-(MW2*aant3(I2G5,I5G5,I6G5)*cchinusnu(I5G5,2)*
     &  DCONJG(cchitaustauL(I5G5,1,I6G5))*DCONJG(CF12F1S12(I2G5,1,I6G5)
     &  )*DCONJG(ctauchastauR(2,I2G5,2))*MCha(I2G5)*MNeu(I5G5))/(16d0*
     &  g2**2*pi2)
           enddo
           enddo
           enddo
           do I2G5 = 1,2
           do I3G5 = 1,1
           do I5G5 = 1,5
           do I6G5 = 1,6
       NMSSMbox=NMSSMbox+(MW2*aant2(I2G5,I5G5,I6G5,I3G5)*
     &  cchitaustauL(I5G5,2,I6G5)*CF12F1S12(I2G5,2,I6G5)*
     &  ctauchastauR(1,I2G5,I3G5)*MCha(I2G5)*MNeu(I5G5)*(-(g1*
     &  ZNC(I5G5,1))+g2*ZNC(I5G5,2)))/(16d0*g2**2*pi2*
     &  Sqrt2)
           enddo
           enddo
           enddo
           enddo
           do I2G5 = 1,2
           do I5G5 = 1,5
           do I6G5 = 1,6
           do I6G6 = 1,6
       NMSSMbox=NMSSMbox+-(MW2*aant4(I2G5,I5G5,I6G5,I6G6)*
     &  cchitaustauL(I5G5,2,I6G5)*CF12F1S12(I2G5,2,I6G5)*
     &  DCONJG(cchitaustauL(I5G5,1,I6G6))*DCONJG(CF12F1S12(I2G5,1,I6G6)
     &  ))/(8d0*g2**2*pi2)
           enddo
           enddo
           enddo
           enddo
       end function NMSSMbox   
c==========================================================c   
       double precision function NMSSMVertex(Q2)
       implicit none
       integer I2G5,I2G6,I3G5,I5G5,I5G6,I6G5,I6G6
       double precision aant1(2,5),aant2(2,5),aant3(2,5,6),aant4(2,5,
     &  3),aant5(2,5),aant6(5,6),aant7(2,5,6),aant8(2,5,3),aant9(5,6,3)
       double precision B0T1,myC0,myC00,Q2
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3  
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv 
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)       
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU           
#include "HdecayTCLs.inc" 

        Do I2G5=1,2
        Do I5G5=1,5
       aant1(I2G5,I5G5)=B0T1(MCha2(I2G5),MNeu2(I5G5),Q2)
       aant2(I2G5,I5G5)=myC0(MCha2(I2G5),MNeu2(I5G5),MSv2(2),Q2)
       aant5(I2G5,I5G5)=myC00(MCha2(I2G5),MNeu2(I5G5),MSv2(2),Q2)
        enddo
        enddo
        Do I2G5=1,2
        Do I5G5=1,5
        Do I6G5=1,6
       aant3(I2G5,I5G5,I6G5)=myC0(MCha2(I2G5),MNeu2(I5G5),MSE2(I6G5),Q2)
       aant7(I2G5,I5G5,I6G5)=myC00(MCha2(I2G5),MNeu2(I5G5),MSE2(I6G5),Q2)
        enddo
        enddo
        enddo
        Do I2G5=1,2
        Do I5G5=1,5
        Do I3G5=1,3
       aant4(I2G5,I5G5,I3G5)=myC0(MCha2(I2G5),MNeu2(I5G5),MSv2(I3G5),Q2)
       aant8(I2G5,I5G5,I3G5)=myC00(MCha2(I2G5),MNeu2(I5G5),MSv2(I3G5),Q2)
        enddo
        enddo
        enddo
        Do I5G5=1,5
        Do I6G5=1,6
       aant6(I5G5,I6G5)=myC00(MNeu2(I5G5),MSE2(I6G5),MSv2(2),Q2)
        enddo
        enddo
        Do I5G5=1,5
        Do I6G5=1,6
        Do I3G5=1,3
       aant9(I5G5,I6G5,I3G5)=myC00(MNeu2(I5G5),MSE2(I6G5),MSv2(I3G5),Q2)
        enddo
        enddo
        enddo
       NMSSMVertex=0D0 
           do I2G5 = 1,2
           do I5G5 = 1,5
       NMSSMVertex=NMSSMVertex+(cchinusnu(I5G5,2)*
     &  DCONJG(ctauchastauR(2,I2G5,2))*(aant1(I2G5,I5G5)*
     &  DCONJG(CRF12F11W(I2G5,I5G5))-2*aant5(I2G5,I5G5)*
     &  DCONJG(CRF12F11W(I2G5,I5G5))+aant2(I2G5,I5G5)*(-
     &  (DCONJG(CLF12F11W(I2G5,I5G5))*MCha(I2G5)*MNeu(I5G5))+
     &  DCONJG(CRF12F11W(I2G5,I5G5))*MSv2(2))))/(8d0*Sqrt2*g2*pi2)
           enddo
           enddo
           do I2G5 = 1,2
           do I3G5 = 1,1
           do I5G5 = 1,5
       NMSSMVertex=NMSSMVertex+(ctauchastauR(1,I2G5,I3G5)*
     &  (aant1(I2G5,I5G5)*CRF12F11W(I2G5,I5G5)-2*aant8(I2G5,I5G5,I3G5)*
     &  CRF12F11W(I2G5,I5G5)+aant4(I2G5,I5G5,I3G5)*(-
     &  (CLF12F11W(I2G5,I5G5)*MCha(I2G5)*MNeu(I5G5))+
     &  CRF12F11W(I2G5,I5G5)*MSv2(I3G5)))*(g1*ZNC(I5G5,1)-g2*
     &  ZNC(I5G5,2)))/(16d0*g2*pi2)
           enddo
           enddo
           enddo
           do I5G5 = 1,5
           do I6G5 = 1,6
       NMSSMVertex=NMSSMVertex+(aant6(I5G5,I6G5)*cchinusnu(I5G5,2)*
     &  cchitaustauL(I5G5,2,I6G5)*CsesvW(I6G5,2))/(4d0*Sqrt2*g2*pi2)
           enddo
           enddo
           do I2G5 = 1,2
           do I5G5 = 1,5
           do I6G5 = 1,6
       NMSSMVertex=NMSSMVertex+-(aant1(I2G5,I5G5)*(CLF12F11W(I2G5,I5G5)
     &  *DCONJG(cchitaustauL(I5G5,1,I6G5))*
     &  DCONJG(CF12F1S12(I2G5,1,I6G5))+cchitaustauL(I5G5,2,I6G5)*
     &  CF12F1S12(I2G5,2,I6G5)*DCONJG(CLF12F11W(I2G5,I5G5)))-2*
     &  aant7(I2G5,I5G5,I6G5)*(CLF12F11W(I2G5,I5G5)*
     &  DCONJG(cchitaustauL(I5G5,1,I6G5))*DCONJG(CF12F1S12(I2G5,1,I6G5)
     &  )+cchitaustauL(I5G5,2,I6G5)*CF12F1S12(I2G5,2,I6G5)*
     &  DCONJG(CLF12F11W(I2G5,I5G5)))+aant3(I2G5,I5G5,I6G5)*
     &  (DCONJG(cchitaustauL(I5G5,1,I6G5))*
     &  DCONJG(CF12F1S12(I2G5,1,I6G5))*(-(CRF12F11W(I2G5,I5G5)*
     &  MCha(I2G5)*MNeu(I5G5))+CLF12F11W(I2G5,I5G5)*MSE2(I6G5))+
     &  cchitaustauL(I5G5,2,I6G5)*CF12F1S12(I2G5,2,I6G5)*(-
     &  (DCONJG(CRF12F11W(I2G5,I5G5))*MCha(I2G5)*MNeu(I5G5))+
     &  DCONJG(CLF12F11W(I2G5,I5G5))*MSE2(I6G5))))/(8d0*Sqrt2*g2*pi2)
           enddo
           enddo
           enddo
           do I3G5 = 1,1
           do I5G5 = 1,5
           do I6G5 = 1,6
       NMSSMVertex=NMSSMVertex+(aant9(I5G5,I6G5,I3G5)*
     &  DCONJG(cchitaustauL(I5G5,1,I6G5))*DCONJG(CsesvW(I6G5,I3G5))*
     &  (g1*ZNC(I5G5,1)-g2*ZNC(I5G5,2)))/(8d0*g2*pi2)
           enddo
           enddo
           enddo
       end function NMSSMVertex                                 
       


c==========================================================c 
       double precision function NMSSMdZfe(i)
       implicit none
       integer i
       double precision aant1(2,3),aant2(5,6)
       double precision myA0, ReB0i
       integer I2G3,I2G4,I2G5,I2G6,I3G3,I3G5,I5G3,I5G5,I5G6,I6G3        
       integer bb0,bb1,bb00,dbb0,dbb1,dbb00
       common /funcID/ bb0,bb1,bb00,dbb0,dbb1,dbb00
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
#include "HdecayTCLs.inc" 
        Do I2G3=1,2
        Do I3G3=1,3
       aant1(I2G3,I3G3)=ReB0i(bb1,0D0,MCha2(I2G3),MSv2(I3G3))
        enddo
        enddo
        Do I5G3=1,5
        Do I6G3=1,6
       aant2(I5G3,I6G3)=ReB0i(bb1,0D0,MNeu2(I5G3),MSe2(I6G3))
        enddo
        enddo
       NMSSMdZfe=0D0 
           do I2G3 = 1,2
           do I3G3 = 1,3
       NMSSMdZfe=NMSSMdZfe+(aant1(I2G3,I3G3)*ctauchastauR(i,I2G3,I3G3)*
     &  DCONJG(ctauchastauR(i,I2G3,I3G3)))/(16d0*pi2)
           enddo
           enddo
           do I5G3 = 1,5
           do I6G3 = 1,6
       NMSSMdZfe=NMSSMdZfe+(aant2(I5G3,I6G3)*cchitaustauL(I5G3,i,I6G3)*
     &  DCONJG(cchitaustauL(I5G3,i,I6G3)))/(16d0*pi2)
           enddo
           enddo
       end function NMSSMdZfe
c==========================================================c 
       double precision function NMSSMdZfnu(i)
       implicit none
       integer i
       double precision aant1(2,6),aant2(5,2)
       integer I2G3,I2G4,I2G5,I2G6,I3G3,I3G5,I5G3,I5G5,I5G6,I6G3
       integer bb0,bb1,bb00,dbb0,dbb1,dbb00
       common /funcID/ bb0,bb1,bb00,dbb0,dbb1,dbb00
       double precision myA0, ReB0i
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
#include "HdecayTCLs.inc" 
        Do I2G3=1,2
        Do I6G3=1,6
       aant1(I2G3,I6G3)=ReB0i(bb1,0D0,MCha2(I2G3),MSe2(I6G3))
        enddo
        enddo
        Do I5G3=1,5
       aant2(I5G3,i)=ReB0i(bb1,0D0,MNeu2(I5G3),MSv2(i))
        enddo
       NMSSMdZfnu=0D0 
           do I5G3 = 1,5
       NMSSMdZfnu=NMSSMdZfnu+(aant2(I5G3,i)*cchinusnu(I5G3,i)*(g1*
     &  ZNC(I5G3,1)-g2*ZNC(I5G3,2)))/(16d0*Sqrt2*pi2)
           enddo
           do I2G3 = 1,2
           do I6G3 = 1,6
       NMSSMdZfnu=NMSSMdZfnu+(aant1(I2G3,I6G3)*CF12F1S12(I2G3,i,I6G3)*
     &  DCONJG(CF12F1S12(I2G3,i,I6G3)))/(16d0*pi2)
           enddo
           enddo
       end function NMSSMdZfnu
c==========================================================c 
       double precision function NMSSMWself(p2)
       implicit none
       double precision p2
       double precision aant1(2,5),aant2(2,5),aant3(2,5),aant4(6,2),
     &  aant5(6,3),aant6(6,6),aant7(2),aant8(3),aant9(2),aant10(6),
     &  aant11(6),aant12(6),aant13(6)
       double precision abnt1,abnt2,abnt3,SMWself     
       integer I2G3,I2G4,I2G5,I2G6,I3G3,I3G4,I3G5,I5G3,I5G4,I5G6,I6G3,I6G4
       integer bb0,bb1,bb00,dbb0,dbb1,dbb00
       common /funcID/ bb0,bb1,bb00,dbb0,dbb1,dbb00
       double precision myA0, ReB0i
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
#include "HdecayTCLs.inc" 
        Do I2G3=1,2
        Do I5G3=1,5
       aant1(I2G3,I5G3)=ReB0i(bb0,p2,MCha2(I2G3),MNeu2(I5G3))
       aant2(I2G3,I5G3)=ReB0i(bb00,p2,MCha2(I2G3),MNeu2(I5G3))
       aant3(I2G3,I5G3)=ReB0i(bb1,p2,MCha2(I2G3),MNeu2(I5G3))
        enddo
        enddo
        Do I6G3=1,6
        Do I2G3=1,2
       aant4(I6G3,I2G3)=ReB0i(bb00,p2,Masshh2(I6G3),MassHpm2(I2G3))
        enddo
        enddo
        Do I6G3=1,6
        Do I3G3=1,3
       aant5(I6G3,I3G3)=ReB0i(bb00,p2,MSe2(I6G3),MSv2(I3G3))
        enddo
        enddo
        Do I6G4=1,6
        Do I6G3=1,6
       aant6(I6G4,I6G3)=ReB0i(bb00,p2,MSd2(I6G4),MSu2(I6G3))
        enddo
        enddo
        Do I2G3=1,2
       aant7(I2G3)=myA0(MassHpm2(I2G3))
       aant9(I2G3)=myA0(MCha2(I2G3))
        enddo
        Do I3G3=1,3
       aant8(I3G3)=myA0(MSv2(I3G3))
        enddo
        Do I6G3=1,6
       aant10(I6G3)=myA0(Masshh2(I6G3))
       aant11(I6G3)=myA0(MSd2(I6G3))
       aant12(I6G3)=myA0(MSe2(I6G3))
       aant13(I6G3)=myA0(MSu2(I6G3))
        enddo
       NMSSMWself=0D0 
           do I2G3 = 2,2
       NMSSMWself=NMSSMWself+(aant7(I2G3)*CHmHpWW(I2G3,I2G3)
     &      + CHmWpA(I2G3)**2*(ReB0i(bb0,p2,0.D0,MassHpm2(I2G3))) + 
     &       CHmWpZ(I2G3)**2*(ReB0i(bb0,p2,MZ2,MassHpm2(I2G3))) )/(16d0*pi2)
           enddo
           do I3G3 = 1,3
       NMSSMWself=NMSSMWself+(g2**2*aant8(I3G3))/(32d0*pi2)
           enddo          
           do I6G3 = 2,6
       NMSSMWself=NMSSMWself+(-(IC*aant10(I6G3)*ChhWmWp(I6G3,I6G3)))/(32d0*
     &  pi2) - 1/16.D0/pi2*(ChWmWp(I6G3)**2*
     &          (ReB0i(bb0,P2,MW2,Masshh2(I6G3))))
           enddo                      
           do I6G3 = 1,6
       NMSSMWself=NMSSMWself+(+6*
     &  aant11(I6G3)*CSdSdWW(I6G3,I6G3)+2*aant12(I6G3)*
     &  CSeSeWW(I6G3,I6G3)+6*aant13(I6G3)*CSuSuWW(I6G3,I6G3))/(32d0*
     &  pi2)
           enddo                          
           do I2G3 = 1,2
           do I5G3 = 1,5
       NMSSMWself=NMSSMWself+((2*aant2(I2G3,I5G3)+p2*aant3(I2G3,I5G3)-
     &  aant9(I2G3))*(CLF12F11W(I2G3,I5G3)*DCONJG(CLF12F11W(I2G3,I5G3))
     &  +CRF12F11W(I2G3,I5G3)*DCONJG(CRF12F11W(I2G3,I5G3)))+
     &  aant1(I2G3,I5G3)*(CLF12F11W(I2G3,I5G3)*
     &  (DCONJG(CRF12F11W(I2G3,I5G3))*MCha(I2G3)*MNeu(I5G3)+
     &  DCONJG(CLF12F11W(I2G3,I5G3))*(p2-MNeu2(I5G3)))+
     &  CRF12F11W(I2G3,I5G3)*(DCONJG(CLF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)+DCONJG(CRF12F11W(I2G3,I5G3))*(p2-MNeu2(I5G3)))))
     &  /(8d0*pi2)
           enddo
           enddo         
           do I2G3 = 1,2
           do I6G3 = 1,6
           if ((I2G3+I6G3).gt.2)then
       NMSSMWself=NMSSMWself+(aant4(I6G3,I2G3)*ChHmWp(I2G3,I6G3)*
     &  ChHpWm(I6G3,I2G3))/(4d0*pi2)
           endif
           enddo
           enddo                   
           do I3G3 = 1,3
           do I6G3 = 1,6
       NMSSMWself=NMSSMWself-(aant5(I6G3,I3G3)*CsesvW(I6G3,I3G3)*
     &  DCONJG(CsesvW(I6G3,I3G3)))/(4d0*pi2)
           enddo
           enddo                   
           do I6G3 = 1,6
           do I6G4 = 1,6
       NMSSMWself=NMSSMWself+(-3*aant6(I6G4,I6G3)*CsdsuW(I6G4,I6G3)*
     &  DCONJG(CsdsuW(I6G4,I6G3)))/(4d0*pi2)
           enddo
           enddo                             
       abnt1=ReB0i(bb0,p2,aMH2,MW2)
       abnt2=ReB0i(bb00,p2,aMH2,MW2)
       abnt3=myA0(aMH2)
       SMWself=0D0 
       SMWself=SMWself+(alpha*(-4*abnt2+abnt3+4*abnt1*MW2))/(16d0*Pi*SW2)   
       NMSSMWself=NMSSMWself-SMWself    
       
       end function NMSSMWself
c==========================================================c 
       double precision function NMSSMZself(p2)
       implicit none
       double precision p2
       double precision aant1(2),aant2(2,2),aant3(2,2),aant4(2,2),
     &  aant5(3),aant6(5,5),aant7(5,5),aant8(5,5),aant9(6,6),aant10(6,
     &  6),aant11(6,6),aant12(6,6),aant13(2),aant14(2),aant15(3),
     &  aant16(5),aant17(6),aant18(6),aant19(6),aant20(6)
       double precision abnt1,abnt2,abnt3,SMZself    
       integer I2G3,I2G4,I2G5,I2G6,I3G3,I3G5,I5G3,I5G4,I5G6,I6G3,I6G4
       integer bb0,bb1,bb00,dbb0,dbb1,dbb00
       common /funcID/ bb0,bb1,bb00,dbb0,dbb1,dbb00
       double precision myA0, ReB0i
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
#include "HdecayTCLs.inc" 
        Do I2G3=1,2
       aant1(I2G3)=ReB0i(bb00,p2,MassHpm2(I2G3),MassHpm2(I2G3))
       aant13(I2G3)=myA0(MassHpm2(I2G3))
        enddo
        Do I2G3=1,2
        Do I2G4=1,2
       aant2(I2G3,I2G4)=ReB0i(bb0,p2,MCha2(I2G3),MCha2(I2G4))
       aant3(I2G3,I2G4)=ReB0i(bb00,p2,MCha2(I2G3),MCha2(I2G4))
       aant4(I2G3,I2G4)=ReB0i(bb1,p2,MCha2(I2G3),MCha2(I2G4))
        enddo
        enddo
        Do I3G3=1,3
       aant5(I3G3)=ReB0i(bb00,p2,MSv2(I3G3),MSv2(I3G3))
       aant15(I3G3)=myA0(MSv2(I3G3))
        enddo
        Do I5G3=1,5
        Do I5G4=1,5
       aant6(I5G3,I5G4)=ReB0i(bb0,p2,MNeu2(I5G3),MNeu2(I5G4))
       aant7(I5G3,I5G4)=ReB0i(bb00,p2,MNeu2(I5G3),MNeu2(I5G4))
       aant8(I5G3,I5G4)=ReB0i(bb1,p2,MNeu2(I5G3),MNeu2(I5G4))
        enddo
        enddo
        Do I6G3=1,6
        Do I6G4=1,6
       aant9(I6G3,I6G4)=ReB0i(bb00,p2,Masshh2(I6G3),Masshh2(I6G4))
       aant10(I6G3,I6G4)=ReB0i(bb00,p2,MSd2(I6G3),MSd2(I6G4))
       aant11(I6G3,I6G4)=ReB0i(bb00,p2,MSe2(I6G3),MSe2(I6G4))
       aant12(I6G3,I6G4)=ReB0i(bb00,p2,MSu2(I6G3),MSu2(I6G4))
        enddo
        enddo
        Do I2G4=1,2
       aant14(I2G4)=myA0(MCha2(I2G4))
        enddo
        Do I5G4=1,5
       aant16(I5G4)=myA0(MNeu2(I5G4))
        enddo
        Do I6G3=1,6
       aant17(I6G3)=myA0(Masshh2(I6G3))
       aant18(I6G3)=myA0(MSd2(I6G3))
       aant19(I6G3)=myA0(MSe2(I6G3))
       aant20(I6G3)=myA0(MSu2(I6G3))
        enddo
       NMSSMZself=0D0 
           do I2G3 = 2,2
       NMSSMZself=NMSSMZself+(-4*CHpHmZ**2*aant1(I2G3)+aant13(I2G3)*
     &  CHpHmZZ(I2G3,I2G3))/(16d0*pi2)+ 
     &       1/8.D0/pi2*(CHmWpZ(I2G3)**2*
     &          (ReB0i(bb0,p2,MW2,MassHpm2(I2G3))))
           enddo
           do I2G3 = 1,2
           do I2G4 = 1,2
       NMSSMZself=NMSSMZself+(-((aant14(I2G4)-2*aant3(I2G3,I2G4)+p2*
     &  aant4(I2G3,I2G4))*(CF12ZL(I2G3,I2G4)*CF12ZL(I2G4,I2G3)+
     &  CF12ZR(I2G3,I2G4)*CF12ZR(I2G4,I2G3)))+aant2(I2G3,I2G4)*
     &  (CF12ZL(I2G4,I2G3)*(CF12ZR(I2G3,I2G4)*MCha(I2G3)*MCha(I2G4)-
     &  CF12ZL(I2G3,I2G4)*MCha2(I2G3))+CF12ZR(I2G4,I2G3)*
     &  (CF12ZL(I2G3,I2G4)*MCha(I2G3)*MCha(I2G4)-CF12ZR(I2G3,I2G4)*
     &  MCha2(I2G3))))/(8d0*pi2)
           enddo
           enddo
           do I3G3 = 1,3
       NMSSMZself=NMSSMZself+(CSvSvZZ*aant15(I3G3)-4*CsvsvZ**2*
     &  aant5(I3G3))/(16d0*pi2)
           enddo
           do I5G3 = 1,5
           do I5G4 = 1,5
       NMSSMZself=NMSSMZself+(-((aant16(I5G4)-2*aant7(I5G3,I5G4)+p2*
     &  aant8(I5G3,I5G4))*(CF11ZL(I5G3,I5G4)*CF11ZL(I5G4,I5G3)+
     &  CF11ZR(I5G3,I5G4)*CF11ZR(I5G4,I5G3)))+aant6(I5G3,I5G4)*
     &  (CF11ZL(I5G4,I5G3)*(CF11ZR(I5G3,I5G4)*MNeu(I5G3)*MNeu(I5G4)-
     &  CF11ZL(I5G3,I5G4)*MNeu2(I5G3))+CF11ZR(I5G4,I5G3)*
     &  (CF11ZL(I5G3,I5G4)*MNeu(I5G3)*MNeu(I5G4)-CF11ZR(I5G3,I5G4)*
     &  MNeu2(I5G3))))/(16d0*pi2)
           enddo
           enddo
           do I6G3 = 2,6
       NMSSMZself=NMSSMZself+(-(IC*aant17(I6G3)*ChhZZ(I6G3,I6G3))
     &  )/(32d0*pi2)- 
     &       1/16.D0/pi2*(ChZZ(I6G3)**2*
     &          (ReB0i(bb0,p2,MZ2,Masshh2(I6G3))))
           enddo           
           do I6G3 = 1,6
       NMSSMZself=NMSSMZself+(6*
     &  aant18(I6G3)*CSdSdZZ(I6G3,I6G3)+2*aant19(I6G3)*
     &  CSeSeZZ(I6G3,I6G3)+6*aant20(I6G3)*CSuSuZZ(I6G3,I6G3))/(32d0*
     &  pi2)
           enddo
           
           do I6G3 = 1,6
           do I6G4 = 1,6
           if((I6G3+I6G4).gt.2)then
       NMSSMZself=NMSSMZself-(aant9(I6G3,I6G4)*ChhZ(I6G3,I6G4)**2)
     &  /(8d0*pi2)
           endif
           enddo
           enddo                  
           do I6G3 = 1,6
           do I6G4 = 1,6
       NMSSMZself=NMSSMZself+-(+6*
     &  aant10(I6G3,I6G4)*CsdmsdpZ(I6G3,I6G4)*CsdmsdpZ(I6G4,I6G3)+2*
     &  aant11(I6G3,I6G4)*CsemsepZ(I6G3,I6G4)*CsemsepZ(I6G4,I6G3)+6*
     &  aant12(I6G3,I6G4)*CsupsumZ(I6G3,I6G4)*CsupsumZ(I6G4,I6G3))
     &  /(8d0*pi2)
           enddo
           enddo
           
       abnt1=ReB0i(bb0,p2,aMH2,MZ2)
       abnt2=ReB0i(bb00,p2,aMH2,MZ2)
       abnt3=myA0(aMH2)
       SMZself=0D0 
       SMZself=SMZself+(Alpha*(-4*abnt2*CW2+abnt3*CW2+4*abnt1*MW2))
     &  /(16d0*CW2**2*Pi*SW2)  
       NMSSMZself=NMSSMZself-SMZself            
       end function NMSSMZself
c==========================================================c 
c==========================================================c 
       double precision function NMSSMDyself()
       implicit none
       double precision aant1,aant2,aant3,aant4,aant5(2),aant6(2),
     &  aant7(2),aant8(2),aant9(3),aant10(3),aant11(3),aant12(3),
     &  aant13(3),aant14(3),aant15(6),aant16(6),aant17(6)
       integer I2G3,I2G4,I2G5,I2G6,I3G3,I3G5,I5G3,I5G4,I5G6,I6G3,I6G4
       integer bb0,bb1,bb00,dbb0,dbb1,dbb00
       common /funcID/ bb0,bb1,bb00,dbb0,dbb1,dbb00
       double precision myA0, ReB0i,addrun
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
#include "HdecayTCLs.inc" 

        Do I2G3=1,2
       aant5(I2G3)=ReB0i(bb1,0D0,MCha2(I2G3),MCha2(I2G3))
       aant6(I2G3)=ReB0i(dbb0,0D0,MW2,MassHpm2(I2G3))
       aant7(I2G3)=ReB0i(dbb00,0D0,MassHpm2(I2G3),MassHpm2(I2G3))
       aant8(I2G3)=ReB0i(dbb00,0D0,MCha2(I2G3),MCha2(I2G3))
        enddo

        Do I6G3=1,6
       aant15(I6G3)=ReB0i(dbb00,0D0,MSd2(I6G3),MSd2(I6G3))
       aant16(I6G3)=ReB0i(dbb00,0D0,MSe2(I6G3),MSe2(I6G3))
       aant17(I6G3)=ReB0i(dbb00,0D0,MSu2(I6G3),MSu2(I6G3))
        enddo
       NMSSMDyself=0D0 

           do I2G3 = 2,2
       NMSSMDyself=NMSSMDyself+(-2*e**2*(aant7(I2G3)
     &  )+aant6(I2G3)*CHmWpA(I2G3)**2)/(8d0*pi2)
           enddo
 
           do I6G3 = 1,6
       NMSSMDyself=NMSSMDyself-(e**2*(aant15(I6G3)+3*aant16(I6G3)+4*
     &  aant17(I6G3)))/(12d0*pi2)
           enddo           
          
           do I2G3 = 1,2
       NMSSMDyself=NMSSMDyself+(-2*e**2*aant5(I2G3)-2*e**2*(
     &  -2*aant8(I2G3)))/(8d0*pi2)
           enddo

      
       end function NMSSMDyself  
c==========================================================c 
       double precision function NMSSMyZself()
       implicit none
       double precision aant1,aant2,aant3(3),aant4(3),aant5(3),
     &  aant6(6),aant7(6),aant8(6),aant9(2),aant10(2),aant11(2),aant12,
     &  aant13(3),aant14(3),aant15(3),aant16(6),aant17(6),aant18(6),
     &  aant19(2),aant20(2)
       integer I2G3,I2G4,I2G5,I2G6,I3G3,I3G4,I3G5,I5G3,I5G4,I5G6,I6G3,I6G4
       integer bb0,bb1,bb00,dbb0,dbb1,dbb00
       common /funcID/ bb0,bb1,bb00,dbb0,dbb1,dbb00
       double precision myA0, ReB0i
       double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       double precision ZH5(5,5),ZH(6,6)
       double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
       common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
       common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
#include "HdecayTCLs.inc" 

        Do I6G3=1,6
       aant6(I6G3)=ReB0i(bb00,0D0,MSd2(I6G3),MSd2(I6G3))
       aant7(I6G3)=ReB0i(bb00,0D0,MSe2(I6G3),MSe2(I6G3))
       aant8(I6G3)=ReB0i(bb00,0D0,MSu2(I6G3),MSu2(I6G3))
       aant16(I6G3)=myA0(MSd2(I6G3))
       aant17(I6G3)=myA0(MSe2(I6G3))
       aant18(I6G3)=myA0(MSu2(I6G3))
        enddo
        Do I2G3=1,2
       aant9(I2G3)=ReB0i(bb0,0D0,MW2,MassHpm2(I2G3))
       aant10(I2G3)=ReB0i(bb00,0D0,MassHpm2(I2G3),MassHpm2(I2G3))
       aant11(I2G3)=ReB0i(bb00,0D0,MCha2(I2G3),MCha2(I2G3))
       aant19(I2G3)=myA0(MCha2(I2G3))
       aant20(I2G3)=myA0(MassHpm2(I2G3))
        enddo
       NMSSMyZself=0D0 
           do I2G3 = 2,2
       NMSSMyZself=NMSSMyZself+(e*(-(CHpHmZ*aant10(I2G3))/4d0)
     &  -(aant9(I2G3)*CHmWpA(I2G3)*CHmWpZ(I2G3))/8d0+((2*C2W*g1*
     &  g2+(-g1**2+g2**2)*S2W)*aant20(I2G3)*(ZP(I2G3,1)**2+ZP(I2G3,2)**
     &  2))/64d0)/pi2
           enddo

           do I2G3 = 1,2
       NMSSMyZself=NMSSMyZself+(e*(-((-2*
     &  aant11(I2G3)+aant19(I2G3))*(CF12ZL(I2G3,I2G3)+CF12ZR(I2G3,I2G3)
     &  ))/8d0))/pi2
           enddo                   
           do I6G3 = 1,6
       NMSSMyZself=NMSSMyZself+(3*aant16(I6G3)*CSdmSdpAZ(I6G3,I6G3)-4*
     &  e*aant6(I6G3)*CsdmsdpZ(I6G3,I6G3)+aant17(I6G3)*
     &  CSemSepAZ(I6G3,I6G3)-4*e*aant7(I6G3)*CsemsepZ(I6G3,I6G3)+3*
     &  aant18(I6G3)*CSumSupAZ(I6G3,I6G3)+8*e*aant8(I6G3)*
     &  CsupsumZ(I6G3,I6G3))/(16d0*pi2)
           enddo
       end function NMSSMyZself
c==========================================================c 
      double precision function B0T1(M12,M22,Q2)
      double precision M12, M22, Q2
      if(M12.eq.0D0 .AND. M22.eq.0D0)then
       B0T1=  0D0
      elseif(M12.eq.0D0 .AND. M22.ne.0D0)then
       B0T1=  1- Log(M22/Q2)
      elseif(M12.gt.0D0 .AND. M22.eq.0D0)then
       B0T1=  1- Log(M12/Q2)
      elseif(abs(M12-M22).eq. 0D0 ) then
       B0T1=  - Log(M22/Q2) 
      else
       B0T1= 1. - Log(M22/Q2) + M12*Log(M12/M22)/(M22-M12)
      endif
      return
      end
      
      
      double precision function myC0(Mass12,Mass22,Mass32,Q2)
      double precision Mass12,Mass22,Mass32,x, y, z, Q2,C
      double precision B0T1
       double precision regMass2,regmass,logX,logx2,xinverse,xinverse2
       common/regularmass/regMass2,regMass,logX,logx2,xinverse,xinverse2

        x=Mass12
        y=Mass22
        z=Mass32
        
       if (z.lt.y) then
          c=z; z=y; y=c
       endif  
 
       if(z.lt.x) then
        c=z;        z=x;        x=c
       endif
 
       if(y.lt.x) then
        c=y; y=x; x=c
       endif
      if (abs(z-x) .gt. 0D0) then
       myC0 =(B0T1(x,y,Q2)-B0T1(y,z,Q2))/(x-z)
      else
        if(abs(y-x) .gt. 0D0)then
       myC0 =(B0T1(x,z,Q2)-B0T1(y,z,Q2))/(x-y)
        else
        if(z.gt.epsi)then
       myC0=-0.5D0/z
        else
       myC0=-0.5D0*xinverse
        endif
        endif
      endif


      return
      end
*
*
*      
	
       double precision function myC00(Mass12,Mass22,Mass32,Q2)
       implicit none
       double precision x2,y2,z2,Q2,c,Mass12,Mass22,Mass32
        x2=Mass12
        y2=Mass22
        z2=Mass32       
       if (z2.lt.y2) then
          c=z2; z2=y2; y2=c
       endif  
 
       if(z2.lt.x2) then
        c=z2;        z2=x2;        x2=c
       endif
 
       if(y2.lt.x2) then
        c=y2; y2=x2; x2=c
       endif       
       If (abs(x2-y2).gt.1D-5)then
          If(abs(z2-y2).lt.1D-5)then
              if (x2.gt.1D-10)then
            myC00=(3*x2 - y2)/(8.*(x2 - y2))+Log(Q2/y2)/4.- 
     -  (x2**2*Log(x2/y2))/(4.*(x2 - y2)**2)
              else
             myC00=0.125D0 + Log(Q2/y2)/4. 
              endif
          else
            if(x2.gt.1D-10)then
            myC00=0.375D0 + Log(Q2/z2)/4. - 
     -  (x2**2*Log(x2/z2))/(4.*(x2 - y2)*(x2 - z2)) - 
     -  (y2**2*Log(y2/z2))/(4.*(-x2 + y2)*(y2 - z2))
            else
            myC00=0.375D0 + Log(Q2/z2)/4. - (y2*Log(y2/z2))/(4.*(y2 - z2))
            endif
          endif
       else
          if(abs(z2-x2).lt.1D-5)then
            myC00=Log(Q2/x2)/4.
          else
            if(x2.gt.1D-10)then
            myC00=(x2 - 3*z2)/(8.*(x2 - z2))+Log(Q2/x2)/4.+ 
     -  (z2**2*Log(x2/z2))/(4.*(-x2+z2)**2)
            else
            myC00=0.375D0 + Log(Q2/z2)/4.
            endif
          endif 
       endif
       
       end function myC00	
c==========================================================c 
       double precision function myD0(Mass12,Mass22,Mass32,Mass42,Q2)
       implicit none
       double precision myC0
       double precision x2,y2,z2,t2,Q2,c,Mass12,Mass22,Mass32,Mass42
        x2=Mass12
        y2=Mass22
        z2=Mass32
        t2=Mass42
                         
       If (abs(x2-y2).gt.1D-5)then
       myD0= (myC0(x2,z2,t2,Q2)-myC0(y2,z2,t2,Q2))/(x2-y2)
       elseif(abs(x2-z2).gt.1D-5)then
       myD0= (myC0(x2,y2,t2,Q2)-myC0(z2,y2,t2,Q2))/(x2-z2)  
       elseif(abs(x2-t2).gt.1D-5)then
       myD0= (myC0(x2,y2,z2,Q2)-myC0(t2,y2,z2,Q2))/(x2-t2)         
       elseif(abs(y2-z2).gt.1D-5)then
       myD0= (myC0(x2,z2,t2,Q2)-myC0(x2,y2,t2,Q2))/(z2-y2)       
       elseif(abs(y2-t2).gt.1D-5)then
       myD0= (myC0(x2,z2,y2,Q2)-myC0(x2,z2,t2,Q2))/(y2-t2)  
       elseif(abs(t2-z2).gt.1D-5)then
       myD0= (myC0(x2,z2,y2,Q2)-myC0(x2,y2,t2,Q2))/(z2-t2)                
       endif
       end function myD0  
       
c==========================================================c 
       double precision function myD00(Mass12,Mass22,Mass32,Mass42,Q2)
       implicit none
       double precision myC00 ,Q2      
       double precision x2,y2,z2,t2,c,Mass12,Mass22,Mass32,Mass42
        x2=Mass12
        y2=Mass22
        z2=Mass32
        t2=Mass42

       If (abs(x2-y2).gt.1D-5)then
       myD00= (myC00(x2,z2,t2,Q2)-myC00(y2,z2,t2,Q2))/(x2-y2)
       elseif(abs(x2-z2).gt.1D-5)then
       myD00= (myC00(x2,y2,t2,Q2)-myC00(z2,y2,t2,Q2))/(x2-z2)  
       elseif(abs(x2-t2).gt.1D-5)then
       myD00= (myC00(x2,y2,z2,Q2)-myC00(t2,y2,z2,Q2))/(x2-t2)         
       elseif(abs(y2-z2).gt.1D-5)then
       myD00= (myC00(x2,z2,t2,Q2)-myC00(x2,y2,t2,Q2))/(z2-y2)       
       elseif(abs(y2-t2).gt.1D-5)then
       myD00= (myC00(x2,z2,y2,Q2)-myC00(x2,z2,t2,Q2))/(y2-t2)  
       elseif(abs(t2-z2).gt.1D-5)then
       myD00= (myC00(x2,z2,y2,Q2)-myC00(x2,y2,t2,Q2))/(z2-t2)                
       endif
       
       end function myD00  
c======================================================================
c######################################################################      
      subroutine ini_QCD(xQs,ischeme,ierr,imwfix)
      implicit none
      integer i,j,k,l,ischeme,izerodv1,ierr,imwfix,ierrhiggs
      double precision MW2,MZ2,pi,ass,MHp2,xQS
      double precision absM3, phiM3      
      double precision Qs
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
     
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision ZH5(5,5),ZH(6,6)
     
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      
      double complex nZD(6,6),nZU(6,6)

      double precision nMSd(6),nMSu(6)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      logical CPcon,MHpmInput,onelswitch,mQrun

      double complex IC,ZUN(2,2),AT,la,Ala,ka,Aka,MUE,expETA,expVS,expM3
      common /gluino/ absM3,phiM3      
      common /scale/ Qs
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /nSu/ nMSu,nZU
      common /nSd/ nMSd,nZD        
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch
      double precision MW2SM,MW21L,MW22LQCD,MW22LEW
      common /SMWmass/MW2SM
      common /WMASS_NMSSM/MW21L,MW22LQCD,MW22LEW 
      double precision RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0(3), absAd0(3), absAe0(3),  
     &                 ml20(3), mer20(3), mq20(3), mdr20(3), mur20(3),
     &                 phiAu0(3), phiAd0(3), phiAe0(3)
      common/slhaDRpara/RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0, absAd0, absAe0,  
     &                 ml20, mer20, mq20, mdr20, mur20,phiAu0,phiAd0,phiAe0
      if (imwfix.eq.1)then
          phiAu=phiAu0; mq2=mq20;mur2=mur20;absAu=absAu0       
          MW = sqrt(MW21L)
          call treelevelmasses_MW(MW,MZ,alpha,3,ierrhiggs) 
          Qs=xQs       
      endif                   
      IC=dcmplx(0,1D0)
      ZUN(1:2,1:2) = nZU(5:6,5:6)
      MW2=Mw**2; MZ2=Mz**2;MHp2=MHpm**2
      Ala= absAlambda*(cos(phiAl) + IC*Sin(phiAl))
      AT= absAu(3)*(cos(phiAu(3)) + IC*Sin(phiAu(3)))
      la= abslambda*(Cos(phil) + IC*Sin(phil))
      ka= abskappa*(Cos(phik) + IC*Sin(phik))
      Aka=absAkappa*(Cos(phiAk) + IC*Sin(phiAk))
      expvs=(Cos(phis) + IC*Sin(phis))
      expETA=(Cos(phiu) + IC*Sin(phiu))
      MUE=vs*la*expvS/dsqrt(2d0)
      expM3=sqrt((Cos(phiM3) + IC*Sin(phiM3)) )
      pi= 4D0*atan(1D0)
      ass=g3**2/4./pi
      if (abs(nMSd(5) - absM3).lt.1D0)then
      print*, "* Warning!! mass of left-handed sbottom very close to gluino mass"
      print*, "stop QCD correction to MW mass"
      ierr=2
      return
      endif
      if (abs(nMSu(5) - absM3).lt.1D0)then
      print*, "* Warning!! mass of stop 1 very close to gluino mass"
      print*, "stop QCD correction to MW mass"
      ierr=2
      return
      endif      

      if (abs(nMSu(6) - absM3).lt.1D0)then
      print*, "* Warning!! mass of stop 2 very close to gluino mass"
      print*, "stop QCD correction to MW mass"
      ierr=2
      return
      endif       

      call ini_setting_QCD(Qs**2,ass,mt,nMSu(5),nMSu(6),ZUN,absM3,
     -   la,ka, Aka,Ala,AT,v,vS,Tanb,expM3,expETA,expvS,MW2,MZ2,MHp2,
     -   MHpmInput,ischeme,izerodv1)
      end  

c######################################################################
      subroutine ini_setting_QCD(Q2N,asN,MTN,MSt1,MST2,ZUN,mg,laN,kaN,
     .   AkaN,AlaN,ATN,vvN,vSN,tbn,expM3N,expETAN,expVSN
     .   ,MW2N,MZ2N,MHpm2N,MHpmInput,RTOPSCHEME,Zerodv1)
      implicit none
      integer i,j,k,i1,i2,i3,l1,Gen3,Gen4,Gen5,Gen6,
     .   RTOPSCHEME, zerodv1  
      double precision Q2N,asN,MTN,MSt1,MST2,mg,vvN,tbn,vSN,
     .                 MW2n,MZ2n,MHpm2N
      double complex expM3N,expVSN,expETAN,ZUN(2,2),ATN
      double complex  AkaN,laN,kaN,AlaN      

      double precision dmsq4fin,dmsur4fin
      double complex dAt4fin 
      logical MHpmInput

c **************
c couplings 
       call couplingsQCDN(Q2N,asN,mg,MTN,MHpm2N,vvN,vSN,TBN,MW2N,MZ2N,
     -   MST1,MST2,ZUN,ATN,laN,kaN,AkaN,AlaN,expM3N,expETAN,expvSN,MHpmInput)
c          print*,"input", Q2N,asN,mg,MTN,MHpm2N,vvN,vSN,TBN,MW2N,MZ2N,
c     -   MST1,MST2,ZUN,ATN,laN,kaN,AkaN,AlaN,expM3N,expETAN,expvSN
c loop integrals
      call LIBLOOP_QCD
c **************
c one-loop counterterms
      call CT1loop_QCD(RTOPSCHEME,dmsq4fin,dmsur4fin,dAt4fin,MHpminput)
c **************
c CT couplings      
      call TLCTcouplings_QCD    
      end               
c======================================================================
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine ini_atlambda(xQs,MHSM,xMW,ischeme,ierror,imwfix)
      implicit none
      integer i,j,k,l,ischeme,ierror,imwfix,ierrhiggs
      double precision MW2,MZ2,MHSM,MHp2,regfac,xMW,xQs
      double precision Qs
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
     
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision ZH5(5,5),ZH(6,6)
     
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      
      double complex nZD(6,6),nZU(6,6)

      double precision nMSd(6),nMSu(6)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      logical CPcon,MHpmInput,onelswitch,mQrun

      double complex ZUN(2,2),AT,la,Ala,ka,Aka,MUE,expETA,expVS
      common /scale/ Qs
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /nSu/ nMSu,nZU
      common /nSd/ nMSd,nZD           
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch
      double precision RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0(3), absAd0(3), absAe0(3),  
     &                 ml20(3), mer20(3), mq20(3), mdr20(3), mur20(3),
     &                 phiAu0(3), phiAd0(3), phiAe0(3)
      common/slhaDRpara/RAl0,RAk0,abslambda0,abskappa0,vs0,mueff0,tanb0,
     &                 absM10, absM20, absAu0, absAd0, absAe0,  
     &                 ml20, mer20, mq20, mdr20, mur20,phiAu0,phiAd0,phiAe0      
      double precision MW2SM,MW21L,MW22LQCD,MW22LEW
      common /SMWmass/MW2SM
      common /WMASS_NMSSM/MW21L,MW22LQCD,MW22LEW   
#include "const.h"     

      if (imwfix.eq.1)then
          phiAu=phiAu0; mq2=mq20;mur2=mur20;absAu=absAu0       
          MW = sqrt(MZ**2/2D0*(1d0+(1d0-4d0*pi*alpha/(sqrt(2D0)*Gf*MZ**2))))  
          MW=sqrt(MW22LQCD)         
          xMW=MW
          call treelevelmasses_MW(MW,MZ,alpha,ischeme,ierrhiggs)
          Qs=xQs
      endif     
      ZUN(1:2,1:2) = nZU(5:6,5:6)
      MW2=Mw**2; MZ2=Mz**2;MHp2=MHpm**2
      Ala= absAlambda*(cos(phiAl) + IC*Sin(phiAl))
      AT= absAu(3)*(cos(phiAu(3)) + IC*Sin(phiAu(3)))
      la= abslambda*(Cos(phil) + IC*Sin(phil))
      ka= abskappa*(Cos(phik) + IC*Sin(phik))
      Aka=absAkappa*(Cos(phiAk) + IC*Sin(phiAk))
      expvs=(Cos(phis) + IC*Sin(phis))
      expETA=(Cos(phiu) + IC*Sin(phiu))
      MUE=vs*la*expvS/dsqrt(2d0)
      regfac=1D0
      call setting_atlambda(Qs**2,mt,MHp2,v,vS,Tanb,MW2,MZ2,
     -   nMSu(5),nMSu(6),ZUN,AT,MUE,Ala,ka,Aka,expETA,expvS,
     -   ischeme,MHpmInput,regfac,MHSM,ierror)
           
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
      subroutine setting_atlambda(Q2N,MTN,MHpm2N,vvN,vSN,TBN,
     -   MW2N,MZ2N,MST1,MST2,ZUN,ATN,MUEN,AlaN,kaN,AKaN,expETAN,expvSN,
     -   ischeme,MHpmInput,regfac,MHSM,ierror)
      implicit none
      integer i,j,l,k,gen2,Gen3,Gen4,Gen5,Gen6,h1,ischeme,ierror,ihsm
      double precision regfac
      double precision Q2N,MTN,MSt1,MSt2,MHpm2N,vvN,vSN,TBN,MW2N,MZ2N,
     .     S2B,C2B,dmsq4fin,dmsur4fin,rk,MHSM

      double complex ATN,ZUN(2,2),MUEN,AlaN,kaN,AkaN,expETAN,expvSN,dAt4fin
      logical MHpmInput
#include "TLMT4.h"
#include "TLMT4lambda.h"
      if(regfac.lt.1D-10)then
      write(*,*) "warning!!! the regulator factor, ", regfac," , is two
     &   small. We use the default value R=1, MG^2=R*10^(-3) MUR^2"      
      regMass2= 1D-3*Q2N
      else
      regmass2=regfac*1D-3*Q2N
      endif
      if(ierror.gt.0) return
      call couplings_atlambda(Q2N,MTN,MHpm2N,vvN,vSN,TBN, MW2N,MZ2N,MST1,
     -  MST2,ZUN,ATN,MUEN,AlaN,kaN,AKaN,expETAN,expvSN,MHpmInput,ierror,2)
      if(ierror.gt.0) return
      
      S2B = 2*TB*CB2;          C2B= (CB - SB)*(CB + SB)      
      call LIBLOOP_atlambda         

      call CT1loop_atlambda(ischeme,dmsq4fin,dmsur4fin,dAt4fin,MHpminput)

      call CTCLs_atlambda()
      rk= abs(ZH(1,2))
      ihsm=1
      do i=2,5
      if (abs(ZH(i,2)).gt.rk)then
         ihsm=i
         rk =  abs(ZH(i,2))
      endif
      enddo
      MHSM=mah(ihsm)    
      end             


