c**********************************************************************
      subroutine LIBLOOP_QCD
      implicit none
      integer i,k,j,IST3,IST4,gen3,gen4,IST5,IST6,IST7
      double precision A0T,AEpT,B0T,BEpT,C0T,CEpT,D0T,DEpT
#include "TLQCDN.h"    
       LogM12= Log(M12/Q2);  
       LogM22= Log(M22/Q2); 
       LogM42=Log(M42/Q2); 
       ZetaN2=pi**2/6D0
       A0T1=A0T(M12,Q2);   AET1=AEpT(M12,Q2)
       A0T2=A0T(M22,Q2);   AET2=AEpT(M22,Q2)
       A0T3=A0T(M32,Q2);   AET3=AEpT(M32,Q2)
       A0T4=A0T(M42,Q2);   AET4=AEpT(M42,Q2)
       MassSu2(1)=M22; MassSu2(2)=M42
       aA0TN(1)=A0T2;  aAETN(1)=AET2
       aA0TN(2)=A0T4;  aAETN(2)=AET4  
      A0T5= A0T(MSQ2,Q2);      AET5= AEpT(MSQ2,Q2)
      aB0T5= B0T(MSQ2,MSQ2,Q2); aBEpT5=BEpT(MSQ2,MSQ2,Q2)
      aB0TN1=B0T(M12, M12, Q2)
      aBEpTN1=BEpT(M12,M12,Q2)                
      do Gen3=1,2
       do Gen4=1,2
        aB0T1(Gen4,Gen3)= B0T(MassSu2(Gen3),MassSu2(Gen4),Q2)
        aBEpT1(Gen4,Gen3)=BEpT(MassSu2(Gen3),MassSu2(Gen4),Q2)
       enddo
      enddo

      do Gen3=1,2
       do Gen4=1,2
        Do k=1,2
        aC0T(Gen3,Gen4,k)=C0T(MassSu2(Gen3),MassSu2(Gen4),MassSu2(k),Q2)
        aCEpT(Gen3,Gen4,k)=CEpT(MassSu2(Gen3),MassSu2(Gen4),MassSu2(k),Q2)
        enddo
       enddo
      enddo 
      
      do j=1,2
        aC0TH2(j)  = C0T(MSQ2,MSQ2,MassSu2(j),Q2)
        aCEpTH2(j) = CEpT(MSQ2,MSQ2,MassSu2(j),Q2)
        aB0TH1(j)  = B0T(MSQ2, MassSu2(j),Q2)
        aBEpTH1(j) = BEpT(MSQ2, MassSu2(j),Q2)
        do i=1,2
        aC0TH1(i,j)  = C0T(MSQ2,MassSu2(i),MassSu2(j),Q2)
        aCEpTH1(i,j) = CEpT(MSQ2,MassSu2(i),MassSu2(j),Q2)
        enddo
      enddo            
       aC0TT3=  C0T(M12,M12,M12,Q2)  
       aCEpTT3=    CEpT(M12,M12,M12,Q2) 
       
         call FD111C(MSQ2,M32,0D0,a0t5,a0t3,0D0,aet5,aet3,0D0,Q2,FD111SBFGG(1:10),0)
       Do ISt3=1,2
         call FD111C(MassSu2(ISt3),M32,0D0,aA0tN(ISt3),a0t3,0D0,aAetN(ISt3),aet3,0D0,Q2,FD111STFGG(1:10,ISt3),0)
       enddo 
         call FD111C(MSQ2,M32,M12,a0t5,a0t3,a0t1,aet5,aet3,aet1,Q2,FD111SBFGT(1:10),0)
       Do ISt3=1,2
         call FD111C(MassSu2(ISt3),M32,M12,aA0tN(ISt3),a0t3,a0t1,aAetN(ISt3),aet3,aet1,Q2,FD111STFGT(1:10,ISt3),0)
       enddo 
         call FD111C(MSQ2,0D0,MSQ2,a0t5,0D0,a0t5,aet5,0D0,aet5,Q2,FD111SBGSB(1:10),0)
       Do ISt3=1,2
         call FD111C(MassSu2(ISt3),0D0,MSQ2,aA0tN(ISt3),0D0,a0t5,aAetN(ISt3),0D0,aet5,Q2,FD111STGSB(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
       Do ISt4=1,2
         call FD111C(MassSu2(ISt3),0D0,MassSu2(ISt4),aA0tN(ISt3),0D0,aA0tN(ISt4),aAetN(ISt3),0D0,aAetN(ISt4),Q2,FD111STGST(1:10,ISt3, ISt4),0)
       enddo 
       enddo 
         call FD111C(0D0,MSQ2,M32,0D0,a0t5,a0t3,0D0,aet5,aet3,Q2,FD111GSBFG(1:10),0)
       Do ISt3=1,2
         call FD111C(0D0,MassSu2(ISt3),M32,0D0,aA0tN(ISt3),a0t3,0D0,aAetN(ISt3),aet3,Q2,FD111GSTFG(1:10,ISt3),0)
       enddo 
         call FD111C(M12,MSQ2,M32,a0t1,a0t5,a0t3,aet1,aet5,aet3,Q2,FD111TSBFG(1:10),0)
       Do ISt3=1,2
         call FD111C(M12,MassSu2(ISt3),M32,a0t1,aA0tN(ISt3),a0t3,aet1,aAetN(ISt3),aet3,Q2,FD111TSTFG(1:10,ISt3),0)
       enddo 
         call FD111C(MSQ2,MSQ2,0D0,a0t5,a0t5,0D0,aet5,aet5,0D0,Q2,FD111SBSBG(1:10),0)
       Do ISt3=1,2
         call FD111C(MSQ2,MassSu2(ISt3),0D0,a0t5,aA0tN(ISt3),0D0,aet5,aAetN(ISt3),0D0,Q2,FD111SBSTG(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
         call FD111C(MassSu2(ISt3),MSQ2,0D0,aA0tN(ISt3),a0t5,0D0,aAetN(ISt3),aet5,0D0,Q2,FD111STSBG(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
       Do ISt4=1,2
         call FD111C(MassSu2(ISt3),MassSu2(ISt4),0D0,aA0tN(ISt3),aA0tN(ISt4),0D0,aAetN(ISt3),aAetN(ISt4),0D0,Q2,FD111STSTG(1:10,ISt3, ISt4),0)
       enddo 
       enddo 
         call FD111C(M12,0D0,0D0,a0t1,0D0,0D0,aet1,0D0,0D0,Q2,FD111TGG(1:10),0)
         call FD111C(M12,0D0,M12,a0t1,0D0,a0t1,aet1,0D0,aet1,Q2,FD111TGT(1:10),0)
         call FD111C(0D0,M12,0D0,0D0,a0t1,0D0,0D0,aet1,0D0,Q2,FD111GTG(1:10),0)
         call FD111C(M12,M12,0D0,a0t1,a0t1,0D0,aet1,aet1,0D0,Q2,FD111TTG(1:10),0)
       Do ISt3=1,2
         call FD111C(M32,MassSu2(ISt3),0D0,a0t3,aA0tN(ISt3),0D0,aet3,aAetN(ISt3),0D0,Q2,FD111FGSTG(1:10,ISt3),0)
       enddo 
         call FD211C(MSQ2,0D0,M32,a0t5,0D0,a0t3,aet5,0D0,aet3,Q2,FD211SBGFG(1:10),0)
       Do ISt3=1,2
         call FD111C(M32,MassSu2(ISt3),M12,a0t3,aA0tN(ISt3),a0t1,aet3,aAetN(ISt3),aet1,Q2,FD111FGSTT(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
         call FD211C(M12,M32,MassSu2(ISt3),a0t1,a0t3,aA0tN(ISt3),aet1,aet3,aAetN(ISt3),Q2,FD211TFGST(1:10,ISt3),0)
       enddo 
         call FD211C(MSQ2,MSQ2,0D0,a0t5,a0t5,0D0,aet5,aet5,0D0,Q2,FD211SBSBG(1:10),0)
       Do ISt3=1,2
       Do ISt4=1,2
         call FD211C(MassSu2(ISt3),MassSu2(ISt4),0D0,aA0tN(ISt3),aA0tN(ISt4),0D0,aAetN(ISt3),aAetN(ISt4),0D0,Q2,FD211STSTG(1:10,ISt3, ISt4),0)
       enddo 
       enddo 
       Do ISt3=1,2
         call FD111C(0D0,M32,MassSu2(ISt3),0D0,a0t3,aA0tN(ISt3),0D0,aet3,aAetN(ISt3),Q2,FD111GFGST(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
         call FD111C(M12,M32,MassSu2(ISt3),a0t1,a0t3,aA0tN(ISt3),aet1,aet3,aAetN(ISt3),Q2,FD111TFGST(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
         call FD211C(MassSu2(ISt3),M12,M32,aA0tN(ISt3),a0t1,a0t3,aAetN(ISt3),aet1,aet3,Q2,FD211STTFG(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
         call FD211C(MassSu2(ISt3),M32,M12,aA0tN(ISt3),a0t3,a0t1,aAetN(ISt3),aet3,aet1,Q2,FD211STFGT(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
         call FD211C(M12,MassSu2(ISt3),M32,a0t1,aA0tN(ISt3),a0t3,aet1,aAetN(ISt3),aet3,Q2,FD211TSTFG(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
         call FD221C(M12,MassSu2(ISt3),M32,a0t1,aA0tN(ISt3),a0t3,aet1,aAetN(ISt3),aet3,Q2,FD221TSTFG(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
       Do ISt4=1,2
         call FD221C(MassSu2(ISt3),MassSu2(ISt4),0D0,aA0tN(ISt3),aA0tN(ISt4),0D0,aAetN(ISt3),aAetN(ISt4),0D0,Q2,FD221STSTG(1:10,ISt3, ISt4),0)
       enddo 
       enddo 
         call FD221C(M12,M12,0D0,a0t1,a0t1,0D0,aet1,aet1,0D0,Q2,FD221TTG(1:10),0)
         call FD221C(MSQ2,MSQ2,0D0,a0t5,a0t5,0D0,aet5,aet5,0D0,Q2,FD221SBSBG(1:10),0)
         call FD221C(0D0,MSQ2,M32,0D0,a0t5,a0t3,0D0,aet5,aet3,Q2,FD221GSBFG(1:10),0)
       Do ISt3=1,2
         call FD311C(M12,M32,MassSu2(ISt3),a0t1,a0t3,aA0tN(ISt3),aet1,aet3,aAetN(ISt3),Q2,FD311TFGST(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
       Do ISt4=1,2
         call FD311C(MassSu2(ISt3),MassSu2(ISt4),0D0,aA0tN(ISt3),aA0tN(ISt4),0D0,aAetN(ISt3),aAetN(ISt4),0D0,Q2,FD311STSTG(1:10,ISt3, ISt4),0)
       enddo 
       enddo 
       Do ISt3=1,2
       Do ISt4=1,2
         call FD211C(MassSu2(ISt3),0D0,MassSu2(ISt4),aA0tN(ISt3),0D0,aA0tN(ISt4),aAetN(ISt3),0D0,aAetN(ISt4),Q2,FD211STGST(1:10,ISt3, ISt4),0)
       enddo 
       enddo 
         call FD211C(MSQ2,M12,M32,a0t5,a0t1,a0t3,aet5,aet1,aet3,Q2,FD211SBTFG(1:10),0)  
         
         call FD211C(M12,M12,0D0,a0t1,a0t1,0D0,aet1,aet1,0D0,Q2,FD211TTG(1:10),0)
         call FD111C(0D0,M32,MSQ2,0D0,a0t3,a0t5,0D0,aet3,aet5,Q2,FD111GFGSB(1:10),0)
         call FD111C(M12,M32,MSQ2,a0t1,a0t3,a0t5,aet1,aet3,aet5,Q2,FD111TFGSB(1:10),0)
         call FD211C(0D0,M32,MSQ2,0D0,a0t3,a0t5,0D0,aet3,aet5,Q2,FD211GFGSB(1:10),0)      
         call FD211C(MSQ2,M32,0D0,a0t5,a0t3,0D0,aet5,aet3,0D0,Q2,FD211SBFGG(1:10),0)
         call FD211C(MSQ2,0D0,MSQ2,a0t5,0D0,a0t5,aet5,0D0,aet5,Q2,FD211SBGSB(1:10),0)          
          

        call FD311C(M1**2,M1**2,0D0,a0t1,a0t1,0D0,aet1,aet1,0D0,Q2,FD311TTG(1:10),0)
       Do ISt3=1,2
         call FD221C(MassSu(ISt3)**2,M1**2,M3**2,aA0tN(ISt3),a0t1,a0t3,aAetN(ISt3),aet1,aet3,Q2,FD221STTFG(1:10,ISt3),0)
       enddo 
       Do ISt3=1,2
         call FD311C(MassSu(ISt3)**2,M1**2,M3**2,aA0tN(ISt3),a0t1,a0t3,aAetN(ISt3),aet1,aet3,Q2,FD311STTFG(1:10,ISt3),0)
       enddo 
         call FD111C(MSQ2,0D0,M3**2,a0t5,0D0,a0t3,aet5,0D0,aet3,Q2,FD111SBGFG(1:10),0)
       Do ISt3=1,2
         call FD111C(MassSu(ISt3)**2,0D0,M3**2,aA0tN(ISt3),0D0,a0t3,aAetN(ISt3),0D0,aet3,Q2,FD111STGFG(1:10,ISt3),0)
       enddo 
         call FD111C(MSQ2,M1**2,M3**2,a0t5,a0t1,a0t3,aet5,aet1,aet3,Q2,FD111SBTFG(1:10),0)
       Do ISt3=1,2
         call FD111C(MassSu(ISt3)**2,M1**2,M3**2,aA0tN(ISt3),a0t1,a0t3,aAetN(ISt3),aet1,aet3,Q2,FD111STTFG(1:10,ISt3),0)
       enddo    
       
         call FD311C(MSQ2,MSQ2,0D0,a0t5,a0t5,0D0,aet5,aet5,0D0,Q2,FD311SBSBG(1:10),0) 
         
         call FD311C(0D0,M3**2,MSQ2,0D0,a0t3,a0t5,0D0,aet3,aet5,Q2,FD311GFGSB(1:10),0)
         call FD311C(MSQ2,0D0,M3**2,a0t5,0D0,a0t3,aet5,0D0,aet3,Q2,FD311SBGFG(1:10),0) 
         
         
c for trilinear couplings
       aD0TT4= D0T(M12,M12,M12,M12,Q2)
       aDEpTT4= DEpT(M12,M12,M12,M12,Q2)       

       do ISt4=1,2
       do ISt5=1,2
       do ISt6=1,2
       do ISt7=1,2
        aD0T(ISt4,ISt5,ISt6,ISt7)= D0T(MassSU2(IST4),MassSU2(IST5),
     .         MassSU2(IST6),MassSU2(IST7),Q2)
        aDEpT(ISt4,ISt5,ISt6,ISt7)= DEpT(MassSU2(IST4),MassSU2(IST5),
     .         MassSU2(IST6),MassSU2(IST7),Q2)
       enddo 
       enddo 
       enddo 
       enddo   
       
         call FD321C(M1**2,M1**2,0D0,a0t1,a0t1,0D0,aet1,aet1,0D0,Q2,FD321TTG(1:10),0)
         call FD411C(M1**2,M1**2,0D0,a0t1,a0t1,0D0,aet1,aet1,0D0,Q2,FD411TTG(1:10),0)     
       Do ISt3=1,2
       Do ISt4=1,2
         call FD111C(0D0,MassSu(ISt3)**2,MassSu(ISt4)**2,0D0,aA0tN(ISt3),aA0tN(ISt4),0D0,aAetN(ISt3),aAetN(ISt4),Q2,FD111GSTST(1:10,ISt3, ISt4),0)
       enddo 
       enddo 
       Do ISt3=1,2
       Do ISt4=1,2
         call FD321C(MassSu(ISt3)**2,MassSu(ISt4)**2,0D0,aA0tN(ISt3),aA0tN(ISt4),0D0,aAetN(ISt3),aAetN(ISt4),0D0,Q2,FD321STSTG(1:10,ISt3, ISt4),0)
       enddo 
       enddo  

       Do ISt4=1,2
         call FD311C(M1**2,MassSu(ISt4)**2,M3**2,a0t1,aA0tN(ISt4),a0t3,aet1,aAetN(ISt4),aet3,Q2,FD311TSTFG(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
         call FD321C(M1**2,MassSu(ISt4)**2,M3**2,a0t1,aA0tN(ISt4),a0t3,aet1,aAetN(ISt4),aet3,Q2,FD321TSTFG(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
         call FD321C(MassSu(ISt4)**2,M1**2,M3**2,aA0tN(ISt4),a0t1,a0t3,aAetN(ISt4),aet1,aet3,Q2,FD321STTFG(1:10,ISt4),0)
       enddo  
       
       Do ISt4=1,2
         call FD111C(M3**2,M1**2,MassSu(ISt4)**2,a0t3,a0t1,aA0tN(ISt4),aet3,aet1,aAetN(ISt4),Q2,FD111FGTST(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
         call FD411C(M1**2,M3**2,MassSu(ISt4)**2,a0t1,a0t3,aA0tN(ISt4),aet1,aet3,aAetN(ISt4),Q2,FD411TFGST(1:10,ISt4),0)
       enddo 
       Do ISt4=1,2
         call FD411C(MassSu(ISt4)**2,M1**2,M3**2,aA0tN(ISt4),a0t1,a0t3,aAetN(ISt4),aet1,aet3,Q2,FD411STTFG(1:10,ISt4),0)
       enddo  
       
       Do ISt3=1,2
       Do ISt4=1,2
         call FD411C(MassSu(ISt3)**2,MassSu(ISt4)**2,0D0,aA0tN(ISt3),aA0tN(ISt4),0D0,aAetN(ISt3),aAetN(ISt4),0D0,Q2,FD411STSTG(1:10,ISt3, ISt4),0)
       enddo 
       enddo                                                       

      end subroutine LIBLOOP_QCD      
