
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c                            MT4 contribution
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
      subroutine CHself_atat(SCH,dtad2MT4,dMHp2MT4,MHpmInput)
      implicit none
      integer i,j,gen2,gen3,gen4,gen5,h1,ICH3,INe3,INH3,IST3,ISt4,ISt5
      double precision SCH(2,2),dtad2MT4(6),dMHp2MT4,massHpm(2)
      double precision fac,fac1,MSQ,signf,M14,I0N,K0T0
      double complex self(2,2),selfSP(2,2),selfDP(2,2)
      double complex selfCT(2,2),selfCTSP(2,2),selfCTDP(2,2)  
 
      double complex aSCH,aSCHSP,aSCHDP
      double complex dReAlambda24(3),dMCH2MT4(2,2,3)
      double precision cosphi,sinphi
      logical MHpmInput
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)  
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe         
#include "TLMT4.h"
      fac=1D0/16D0/Pi**4
      fac1=1D0/16D0/Pi**2      
      self=0D0;  selfSP =0D0;  selfDP=0D0
      selfCT=0D0;  selfCTSP =0D0;  selfCTDP=0D0
       massHpm(1)=0D0; MassHpm(2)=Sqrt(MHp2)
       M14= M12**2; MSQ= sqrt(MSQ2)
       
       
      do i=1,2
       do j=1,2
       selfCTDP(i,j)=-12*M1*CTBS3(i)*CTBS3C(j)*dmt4(1)+selfCTDP(i,j)
       selfCTSP(i,j)=-12*M1*CTBS3(i)*CTBS3C(j)*(aB0TN1*dmt4(1)+dmt4(2))
     &  +selfCTSP(i,j)
        
        !finite      
       selfCT(i,j)=-12*M1*CTBS3(i)*CTBS3C(j)*(aBEpTN1*dmt4(1)+aB0TN1*
     &  dmt4(2)+dmt4(3))+selfCT(i,j)

         enddo
       enddo
     
#ifdef MATHEMATICA
       selfCTDP=selfCTDP*fac1
       selfCTSP=selfCTSP*fac1
       selfCT=selfCT*fac1
        OPEN(16,FILE='output_fortest.dat', STATUS= 'UNKNOWN')       
       do i=1,2
        do j=1,2
       write(16, 100) "TwoLoopChargedSelfCTNoGBC[1]=[", i,",",j,"] = (", DBLE(selfCT(i,j)), ") + I* (",
     .         DIMAG(selfCT(i,j)), ") + (", DBLE(selfCTSP(i,j)), ")/Epsilon + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon +(", DBLE(selfCTDP(i,j)), 
     .         ")/Epsilon^2 + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon^2 "
         enddo
       enddo

       selfCTDP=0
       selfCTSP=0
       selfCT=0
#endif  

       do i=1,2
        do j=1,2
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfCTSP(i,j)=3*aC0TH1(ISt3,ISt4)*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*dMSf4(ISt3,ISt4,1)+selfCTSP(i,j)
              endif
       enddo 
       enddo 
        
        !finite
        
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfCT(i,j)=3*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*
     &  (aCEpTH1(ISt3,ISt4)*dMSf4(ISt3,ISt4,1)+aC0TH1(ISt3,ISt4)*
     &  dMSf4(ISt3,ISt4,2))+selfCT(i,j)
              endif
       enddo 
       enddo 
       do ISt3=1,2
       selfCTSP(i,j)=3*aC0TH2(ISt3)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)*
     &  dMSQ4(1)+selfCTSP(i,j)
       enddo 
        
        !finite
        
       do ISt3=1,2
       selfCT(i,j)=3*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)*(aCEpTH2(ISt3)*
     &  dMSQ4(1)+aC0TH2(ISt3)*dMSQ4(2))+selfCT(i,j)
       enddo 
       enddo
       enddo    
#ifdef MATHEMATICA
       selfCTDP=selfCTDP*fac1
       selfCTSP=selfCTSP*fac1
       selfCT=selfCT*fac1
       do i=1,2
        do j=1,2
       write(16, 100) "TwoLoopChargedSelfCTNoGBC[2][", i,",",j,"] = (", DBLE(selfCT(i,j)), ") + I* (",
     .         DIMAG(selfCT(i,j)), ") + (", DBLE(selfCTSP(i,j)), ")/Epsilon + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon +(", DBLE(selfCTDP(i,j)), 
     .         ")/Epsilon^2 + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon^2 "
         enddo
       enddo

       selfCTDP=0
       selfCTSP=0
       selfCT=0
#endif 

       do i=1,2
        do j=1,2
       do ISt3=1,2
       selfCTDP(i,j)=3*dCS3S3S13S13(i,j,ISt3,ISt3,1)*MassSu2(ISt3)+
     &  selfCTDP(i,j)
       selfCTSP(i,j)=3*(aA0TN(ISt3)*dCS3S3S13S13(i,j,ISt3,ISt3,1)+
     &  dCS3S3S13S13(i,j,ISt3,ISt3,2)*MassSu2(ISt3))+selfCTSP(i,j)
       enddo 
        
        !finite
        
       do ISt3=1,2
       selfCT(i,j)=3*(aAETN(ISt3)*dCS3S3S13S13(i,j,ISt3,ISt3,1)+
     &  aA0TN(ISt3)*dCS3S3S13S13(i,j,ISt3,ISt3,2)+
     &  dCS3S3S13S13(i,j,ISt3,ISt3,3)*MassSu2(ISt3))+selfCT(i,j)
       enddo 
       selfCTDP(i,j)=3*MSQ2*dCS3S3S14S14(i,j,1)+selfCTDP(i,j)
       selfCTSP(i,j)=3*(a0t5*dCS3S3S14S14(i,j,1)+MSQ2*
     &  dCS3S3S14S14(i,j,2))+selfCTSP(i,j)
        
        !finite
        
       selfCT(i,j)=3*(aet5*dCS3S3S14S14(i,j,1)+a0t5*dCS3S3S14S14(i,j,2)
     &  +MSQ2*dCS3S3S14S14(i,j,3))+selfCT(i,j)
       enddo
       enddo    
#ifdef MATHEMATICA
       selfCTDP=selfCTDP*fac1
       selfCTSP=selfCTSP*fac1
       selfCT=selfCT*fac1
       do i=1,2
        do j=1,2
       write(16, 100) "TwoLoopChargedSelfCTNoGBC[3][", i,",",j,"] = (", DBLE(selfCT(i,j)), ") + I* (",
     .         DIMAG(selfCT(i,j)), ") + (", DBLE(selfCTSP(i,j)), ")/Epsilon + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon +(", DBLE(selfCTDP(i,j)), 
     .         ")/Epsilon^2 + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon^2 "
         enddo
       enddo

       selfCTDP=0
       selfCTSP=0
       selfCT=0
#endif  



       do i=1,2
        do j=1,2    
       selfCTDP(i,j)=-6*M12*(CTBS3(i)*DCONJG(dCTBS3(j,1))+CTBS3C(j)*
     &  dCTBS3(i,1))+selfCTDP(i,j)
       selfCTSP(i,j)=-6*(a0t1*(CTBS3(i)*DCONJG(dCTBS3(j,1))+CTBS3C(j)*
     &  dCTBS3(i,1))+M12*(CTBS3(i)*DCONJG(dCTBS3(j,2))+CTBS3C(j)*
     &  dCTBS3(i,2)))+selfCTSP(i,j)

        !finite

       selfCT(i,j)=-6*(aet1*(CTBS3(i)*DCONJG(dCTBS3(j,1))+CTBS3C(j)*
     &  dCTBS3(i,1))+a0t1*(CTBS3(i)*DCONJG(dCTBS3(j,2))+CTBS3C(j)*
     &  dCTBS3(i,2))+M12*(CTBS3(i)*DCONJG(dCTBS3(j,3))+CTBS3C(j)*
     &  dCTBS3(i,3)))+selfCT(i,j)
       enddo
       enddo  
       
#ifdef MATHEMATICA
       selfCTDP=selfCTDP*fac1
       selfCTSP=selfCTSP*fac1
       selfCT=selfCT*fac1
       do i=1,2
        do j=1,2
       write(16, 100) "TwoLoopChargedSelfCTNoGBC[4][", i,",",j,"] = (", DBLE(selfCT(i,j)), ") + I* (",
     .         DIMAG(selfCT(i,j)), ") + (", DBLE(selfCTSP(i,j)), ")/Epsilon + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon +(", DBLE(selfCTDP(i,j)), 
     .         ")/Epsilon^2 + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon^2 "
         enddo
       enddo

       selfCTDP=0
       selfCTSP=0
       selfCT=0
#endif 

       do i=1,2
        do j=1,2   
       do ISt3=1,2
       selfCTDP(i,j)=3*(CS3S13SC(j,ISt3)*dCS3S13S14N(i,ISt3,1)+
     &  CS3S13S(i,ISt3)*dCS3S14S13N(j,ISt3,1))+selfCTDP(i,j)
       selfCTSP(i,j)=3*(CS3S13SC(j,ISt3)*dCS3S13S14N(i,ISt3,2)+
     &  aB0TH1(ISt3)*(CS3S13SC(j,ISt3)*dCS3S13S14N(i,ISt3,1)+
     &  CS3S13S(i,ISt3)*dCS3S14S13N(j,ISt3,1))+CS3S13S(i,ISt3)*
     &  dCS3S14S13N(j,ISt3,2))+selfCTSP(i,j)
       enddo 
        
        !finite
       
      
       do ISt3=1,2
       selfCT(i,j)=3*(CS3S13SC(j,ISt3)*dCS3S13S14N(i,ISt3,3)+
     &  aBEpTH1(ISt3)*(CS3S13SC(j,ISt3)*dCS3S13S14N(i,ISt3,1)+
     &  CS3S13S(i,ISt3)*dCS3S14S13N(j,ISt3,1))+aB0TH1(ISt3)*
     &  (CS3S13SC(j,ISt3)*dCS3S13S14N(i,ISt3,2)+CS3S13S(i,ISt3)*
     &  dCS3S14S13N(j,ISt3,2))+CS3S13S(i,ISt3)*dCS3S14S13N(j,ISt3,3))+
     &  selfCT(i,j)

       enddo       
       enddo
       enddo  

#ifdef MATHEMATICA
       selfCTDP=selfCTDP*fac1
       selfCTSP=selfCTSP*fac1
       selfCT=selfCT*fac1
       do i=1,2
        do j=1,2
       write(16, 100) "TwoLoopChargedSelfCTNoGBC[5][", i,",",j,"] = (", DBLE(selfCT(i,j)), ") + I* (",
     .         DIMAG(selfCT(i,j)), ") + (", DBLE(selfCTSP(i,j)), ")/Epsilon + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon +(", DBLE(selfCTDP(i,j)), 
     .         ")/Epsilon^2 + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon^2 "
         enddo
       enddo

       selfCTDP=0
       selfCTSP=0
       selfCT=0
#endif 

       do i=1,2
        do j=1,2
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfCTDP(i,j)=3*CS3S3S13S13(i,j,ISt4,ISt3)*dMSf4(ISt4,ISt3,1)+
     &  selfCTDP(i,j)
       selfCTSP(i,j)=3*CS3S3S13S13(i,j,ISt4,ISt3)*(aB0T1(ISt3,ISt4)*
     &  dMSf4(ISt4,ISt3,1)+dMSf4(ISt4,ISt3,2))+selfCTSP(i,j)
              endif
       enddo 
       enddo 
        
        !finite
        
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfCT(i,j)=3*CS3S3S13S13(i,j,ISt4,ISt3)*(aBEpT1(ISt3,ISt4)*
     &  dMSf4(ISt4,ISt3,1)+aB0T1(ISt3,ISt4)*dMSf4(ISt4,ISt3,2)+
     &  dMSf4(ISt4,ISt3,3))+selfCT(i,j)
              endif
       enddo 
       enddo 
       selfCTDP(i,j)=3*CS3S3S14S14(i,j)*dMSQ4(1)+selfCTDP(i,j)
       selfCTSP(i,j)=3*CS3S3S14S14(i,j)*(aB0T5*dMSQ4(1)+dMSQ4(2))+selfCTSP(i,j)
        
        !finite
        
       selfCT(i,j)=3*CS3S3S14S14(i,j)*(aBEpT5*dMSQ4(1)+aB0T5*dMSQ4(2)+
     &  dMSQ4(3))+selfCT(i,j)     
       enddo
       enddo  
         
#ifdef MATHEMATICA
       selfCTDP=selfCTDP*fac1
       selfCTSP=selfCTSP*fac1
       selfCT=selfCT*fac1
       do i=1,2
        do j=1,2
       write(16, 100) "TwoLoopChargedSelfCTNoGBC[6][", i,",",j,"] = (", DBLE(selfCT(i,j)), ") + I* (",
     .         DIMAG(selfCT(i,j)), ") + (", DBLE(selfCTSP(i,j)), ")/Epsilon + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon +(", DBLE(selfCTDP(i,j)), 
     .         ")/Epsilon^2 + I* (",
     .         DIMAG(selfCT(i,j)), ")/Epsilon^2 "
         enddo
       enddo

       selfCTDP=0
       selfCTSP=0
       selfCT=0
#endif 

c       print*, "ChargedHiggsCTDP[2,2]=",selfCTDP(2,2)*fac1
c       print*, "ChargedHiggsCTSP[2,2]=",selfCTSP(2,2)*fac1        
c       print*, "ChargedHiggsCT[2,2]=",selfCT(2,2)*fac1            
c#ifdef MT4NNN
       do i=1,2
        do j=1,2
c Diagram 1
       do INH3=1,6
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=(-3*CS3S3S13S13(i,j,ISt3,ISt4)*
     &  CSSSS(INH3,INH3,ISt4,ISt3)*Mah2(INH3))/32.+selfDP(i,j)
       selfSP(i,j)=(-3*CSSSS(INH3,INH3,ISt4,ISt3)*(aC0TH1(ISt3,ISt4)*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*Mah2(INH3)+
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(A0TNH(INH3)+aB0T1(ISt3,ISt4)*
     &  Mah2(INH3))))/32.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*CSSSS(INH3,INH3,ISt4,ISt3)*(A0TNH(INH3)*
     &  (aC0TH1(ISt3,ISt4)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)+
     &  aB0T1(ISt3,ISt4)*CS3S3S13S13(i,j,ISt3,ISt4))+aCEpTH1(ISt3,ISt4)
     &  *CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*Mah2(INH3)+
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(AETNH(INH3)+aBEpT1(ISt3,ISt4)*
     &  Mah2(INH3))))/32.+self(i,j)
       enddo 
       enddo 
       enddo  
c#define details             
#ifdef details
          print*, "self(i,j)1",self(i,j)*fac
        self(i,j)=0D0 
#endif         
c Diagram 2
       do ICH3=1,2
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=(-3*CS3S3S13S13(i,j,ISt3,ISt4)*
     &  CS3S3S13S13(ICH3,ICH3,ISt4,ISt3)*MassHpm(ICH3)**2)/16.+
     &  selfDP(i,j)
       selfSP(i,j)=(-3*CS3S3S13S13(ICH3,ICH3,ISt4,ISt3)*
     &  (aC0TH1(ISt3,ISt4)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*
     &  MassHpm(ICH3)**2+CS3S3S13S13(i,j,ISt3,ISt4)*(A0THpN(ICH3)+
     &  aB0T1(ISt3,ISt4)*MassHpm(ICH3)**2)))/16.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*CS3S3S13S13(ICH3,ICH3,ISt4,ISt3)*(A0THpN(ICH3)*
     &  (aC0TH1(ISt3,ISt4)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)+
     &  aB0T1(ISt3,ISt4)*CS3S3S13S13(i,j,ISt3,ISt4))+aCEpTH1(ISt3,ISt4)
     &  *CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*MassHpm(ICH3)**2+
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(AETHpN(ICH3)+aBEpT1(ISt3,ISt4)*
     &  MassHpm(ICH3)**2)))/16.+self(i,j)
       enddo 
       enddo 
       enddo 
#ifdef details
          print*, "self(i,j)1",self(i,j)*fac
        self(i,j)=0D0 
#endif     
c Diagram 4
       do ICH3=1,2
       do ISt3=1,2
       selfSP(i,j)=(-3*aC0TH2(ISt3)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)*
     &  CS3S3S14S14(ICH3,ICH3)*MassHpm(ICH3)**2)/16.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)*
     &  CS3S3S14S14(ICH3,ICH3)*(A0THpN(ICH3)*aC0TH2(ISt3)+aCEpTH2(ISt3)
     &  *MassHpm(ICH3)**2))/16.+self(i,j)
       enddo 
       enddo
#ifdef details
          print*, "self(i,j)1",self(i,j)*fac
        self(i,j)=0D0 
#endif         
c Diagram 6
       do ICH3=1,2
       selfDP(i,j)=(-3*CS3S3S14S14(i,j)*CS3S3S14S14(ICH3,ICH3)*
     &  MassHpm(ICH3)**2)/16.+selfDP(i,j)
       selfSP(i,j)=(-3*CS3S3S14S14(i,j)*CS3S3S14S14(ICH3,ICH3)*
     &  (A0THpN(ICH3)+aB0T5*MassHpm(ICH3)**2))/16.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*CS3S3S14S14(i,j)*CS3S3S14S14(ICH3,ICH3)*(aB0T5*
     &  A0THpN(ICH3)+AETHpN(ICH3)+aBEpT5*MassHpm(ICH3)**2))/16.+
     &  self(i,j)
       enddo 
#ifdef details
          print*, "self(i,j)1",self(i,j)*fac
        self(i,j)=0D0 
#endif            
c Diagram 3
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
       selfDP(i,j)=(-3*(CS13S13S13S13MT4(ISt4,ISt5,ISt3,ISt5)+3*
     &  CS13S13S13S13MT4(ISt4,ISt5,ISt5,ISt3))*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*MassSu2(ISt5))/16.+selfDP(i,j)
       selfSP(i,j)=(-3*(CS13S13S13S13MT4(ISt4,ISt5,ISt3,ISt5)+3*
     &  CS13S13S13S13MT4(ISt4,ISt5,ISt5,ISt3))*(aC0TH1(ISt3,ISt4)*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*MassSu2(ISt5)+
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(aA0TN(ISt5)+aB0T1(ISt3,ISt4)*
     &  MassSu2(ISt5))))/16.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*(CS13S13S13S13MT4(ISt4,ISt5,ISt3,ISt5)+3*
     &  CS13S13S13S13MT4(ISt4,ISt5,ISt5,ISt3))*(aA0TN(ISt5)*
     &  (aC0TH1(ISt3,ISt4)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)+
     &  aB0T1(ISt3,ISt4)*CS3S3S13S13(i,j,ISt3,ISt4))+aCEpTH1(ISt3,ISt4)
     &  *CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*MassSu2(ISt5)+
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(aAETN(ISt5)+aBEpT1(ISt3,ISt4)*
     &  MassSu2(ISt5))))/16.+self(i,j)
       enddo 
       enddo 
       enddo 
#ifdef details
          print*, "self(i,j)1",self(i,j)*fac
        self(i,j)=0D0 
#endif 
c Diagram 5
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=(-3*CS14S13S14S13MT4(ISt4,ISt3)*(3*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)+MSQ2*CS3S3S13S13(i,j,ISt3,ISt4)))/16.+
     &  selfDP(i,j)
       selfSP(i,j)=(3*CS14S13S14S13MT4(ISt4,ISt3)*(-((3*(aB0TH1(ISt3)+
     &  aB0TH1(ISt4))+MSQ2*aC0TH1(ISt3,ISt4))*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4))-(a0t5+MSQ2*aB0T1(ISt3,ISt4))*
     &  CS3S3S13S13(i,j,ISt3,ISt4))-3*aC0TH2(ISt3)*
     &  CS14S13S14S13MT4(ISt4,ISt4)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)*
     &  MassSu2(ISt4))/16.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*(aA0TN(ISt4)*aC0TH2(ISt3)*
     &  CS14S13S14S13MT4(ISt4,ISt4)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)+
     &  CS14S13S14S13MT4(ISt4,ISt3)*((3*aB0TH1(ISt3)*aB0TH1(ISt4)+3*
     &  aBEpTH1(ISt3)+3*aBEpTH1(ISt4)+a0t5*aC0TH1(ISt3,ISt4)+MSQ2*
     &  aCEpTH1(ISt3,ISt4))*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)+(aet5+
     &  a0t5*aB0T1(ISt3,ISt4)+MSQ2*aBEpT1(ISt3,ISt4))*
     &  CS3S3S13S13(i,j,ISt3,ISt4))+aCEpTH2(ISt3)*
     &  CS14S13S14S13MT4(ISt4,ISt4)*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)*
     &  MassSu2(ISt4)))/16.+self(i,j)
       enddo 
       enddo 
#ifdef details
          print*, "self(i,j)1",self(i,j)*fac
        self(i,j)=0D0 
#endif 
c Diagram 7
       do ISt3=1,2
       selfDP(i,j)=(-3*CS14S13S14S13MT4(ISt3,ISt3)*CS3S3S14S14(i,j)*
     &  MassSu2(ISt3))/16.+selfDP(i,j)
       selfSP(i,j)=(-3*CS14S13S14S13MT4(ISt3,ISt3)*CS3S3S14S14(i,j)*
     &  (aA0TN(ISt3)+aB0T5*MassSu2(ISt3)))/16.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*CS14S13S14S13MT4(ISt3,ISt3)*CS3S3S14S14(i,j)*
     &  (aB0T5*aA0TN(ISt3)+aAETN(ISt3)+aBEpT5*MassSu2(ISt3)))/16.+
     &  self(i,j)
       enddo 
       
#ifdef details
          print*, "self(i,j)1",self(i,j)*fac
        self(i,j)=0D0 
c        stop
#endif 
       enddo
       enddo  
c#define MATHEMATICA       
#ifdef MATHEMATICA
       selfDP=selfDP*fac
       selfSP=selfSP*fac
       self=self*fac
       do i=1,2
        do j=1,2
       write(*, 100) "TwoLoopChargedSelfMT4[1][", i,",",j,"] = (",DBLE(self(i,j)), ") + I* (",
     .         DIMAG(self(i,j)), ") + (", DBLE(selfSP(i,j)), ")/Epsilon + I* (",
     .         DIMAG(self(i,j)), ")/Epsilon +(", DBLE(selfDP(i,j)), 
     .         ")/Epsilon^2 + I* (",
     .         DIMAG(self(i,j)), ")/Epsilon^2 "
         enddo
       enddo
       selfDP=0
       selfSP=0
       self=0
#endif     


       do i=1,2
        do j=1,2
c Diagram 5
       do INH3=1,6
       selfDP(i,j)=(3*CTBS3(i)*CTBS3C(j)*(2*M12*hy(INH3)**2+2*M12*
     &  hyc(INH3)**2+hy(INH3)*hyc(INH3)*(3*M12+2*Mah2(INH3))))/32.+
     &  selfDP(i,j)
       selfSP(i,j)=(-3*CTBS3(i)*CTBS3C(j)*(2*(-2*a0t1+M12)*hy(INH3)**2-
     &  (6*a0t1+M12+4*A0TNH(INH3))*hy(INH3)*hyc(INH3)+2*(-2*a0t1+M12)*
     &  hyc(INH3)**2))/32.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*CTBS3(i)*CTBS3C(j)*(M12*M14*FD211TTH(4,INH3)*
     &  hy(INH3)**2+M12*FD111BTH(5,INH3)*hy(INH3)*hyc(INH3)-M14*
     &  FD111THB(2,INH3)*hy(INH3)*hyc(INH3)+M14*FD111THB(4,INH3)*
     &  hy(INH3)*hyc(INH3)+M14*FD111THT(2,INH3)*hy(INH3)*hyc(INH3)-M14*
     &  FD111THT(4,INH3)*hy(INH3)*hyc(INH3)-M12*FD111TTH(5,INH3)*
     &  hy(INH3)*hyc(INH3)+M12*M14*FD211TTH(2,INH3)*hy(INH3)*hyc(INH3)+
     &  M14*FD211TTH(5,INH3)*hy(INH3)*hyc(INH3)+M12*M14*
     &  FD211TTH(4,INH3)*hyc(INH3)**2+M14*FD111BTH(4,INH3)*(hy(INH3)**
     &  2+hyc(INH3)**2)-M14*FD111TTH(4,INH3)*(hy(INH3)**2+hyc(INH3)**2)
     &  ))/(8.*M12*M14)+self(i,j)
       enddo 
                  
c Diagram 1
       do INH3=1,6
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=(-3*(CS1S3SS(INH3,i,ISt4)*CS3S13SC(j,ISt3)*
     &  CSSS(INH3,ISt3,ISt4)+CS1S3SSC(INH3,j,ISt4)*CS3S13S(i,ISt3)*
     &  CSSS(INH3,ISt4,ISt3)))/32.+selfDP(i,j)
       selfSP(i,j)=(-3*(CS1S3SS(INH3,i,ISt4)*CS3S13SC(j,ISt3)*
     &  CSSS(INH3,ISt3,ISt4)+CS1S3SSC(INH3,j,ISt4)*CS3S13S(i,ISt3)*
     &  CSSS(INH3,ISt4,ISt3))*(2*a0t5+MSQ2-2*aA0TN(ISt3)-MassSu2(ISt3))
     &  )/(32.*(MSQ2-MassSu2(ISt3)))+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*(CS1S3SS(INH3,i,ISt4)*CS3S13SC(j,ISt3)*
     &  CSSS(INH3,ISt3,ISt4)+CS1S3SSC(INH3,j,ISt4)*CS3S13S(i,ISt3)*
     &  CSSS(INH3,ISt4,ISt3))*(FD111HSTSB(1,INH3,ISt4)-
     &  FD111HSTST(1,INH3,ISt3,ISt4)))/(16.*(MSQ**2-MassSu(ISt3)**2))+
     &  self(i,j)
       enddo 
       enddo 
       enddo 
       

                            
c%%%%% diagram set 12 has 6 diagrams    
c Diagram 1
       do INH3=1,6
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
          if( Abs(-MassSu(ISt3) + MassSu(ISt5)) .gt. 1D-15) then 
       selfDP(i,j)=0+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(i,ISt3)*CS3S13SC(j,ISt5)*
     &  CSSS(INH3,ISt4,ISt3)*CSSS(INH3,ISt5,ISt4)*(aA0TN(ISt5)*(-MSQ2+
     &  MassSu2(ISt3))+aA0TN(ISt3)*(MSQ2-MassSu2(ISt5))+a0t5*(-
     &  MassSu2(ISt3)+MassSu2(ISt5))))/(16.*(MSQ-MassSu(ISt3))*(MSQ+
     &  MassSu(ISt3))*(MSQ-MassSu(ISt5))*(MassSu(ISt3)-MassSu(ISt5))*
     &  (MSQ+MassSu(ISt5))*(MassSu(ISt3)+MassSu(ISt5)))+selfSP(i,j)
       self(i,j)=(3*CS3S13S(i,ISt3)*CS3S13SC(j,ISt5)*
     &  CSSS(INH3,ISt4,ISt3)*CSSS(INH3,ISt5,ISt4)*
     &  (FD111HSTST(1,INH3,ISt5,ISt4)*(MSQ**2-MassSu(ISt3)**2)+
     &  FD111HSTSB(1,INH3,ISt4)*(MassSu(ISt3)**2-MassSu(ISt5)**2)+
     &  FD111HSTST(1,INH3,ISt3,ISt4)*(-MSQ**2+MassSu(ISt5)**2)))/(16.*
     &  (MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MSQ-MassSu(ISt5))*
     &  (MassSu(ISt3)-MassSu(ISt5))*(MSQ+MassSu(ISt5))*(MassSu(ISt3)+
     &  MassSu(ISt5)))+self(i,j)
              else
       selfDP(i,j)=0+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(i,ISt3)*CS3S13SC(j,ISt5)*
     &  CSSS(INH3,ISt4,ISt3)*CSSS(INH3,ISt5,ISt4)*(MSQ2*aA0TN(ISt3)+
     &  MassSu(ISt3)**4-(a0t5+MSQ2)*MassSu2(ISt3)))/(16.*(-(MSQ2*
     &  MassSu(ISt3))+MassSu(ISt3)**3)**2)+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS3S13S(i,ISt3)*CS3S13SC(j,ISt5)*
     &  CSSS(INH3,ISt4,ISt3)*CSSS(INH3,ISt5,ISt4)*
     &  (FD111HSTSB(1,INH3,ISt4)-FD111HSTST(1,INH3,ISt3,ISt4)+
     &  FD211StHSt(1,ISt3,INH3,ISt4)*(-MSQ**2+MassSu(ISt3)**2)))/(16.*
     &  (MSQ**2-MassSu(ISt3)**2)**2)+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       enddo 
                
c Diagram 2
       do INH3=1,6
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
          if( Abs(-MassSu(ISt4) + MassSu(ISt5)) .gt. 1D-15) then 
       selfDP(i,j)=(-3*CS3S3S13S13(i,j,ISt4,ISt5)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt5,ISt3))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CS3S3S13S13(i,j,ISt4,ISt5)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt5,ISt3)*(-2*aA0TN(ISt4)+2*aA0TN(ISt5)-
     &  MassSu2(ISt4)+MassSu2(ISt5)))/(32.*(MassSu2(ISt4)-MassSu2(ISt5)
     &  ))+selfSP(i,j)
       self(i,j)=(3*CS3S3S13S13(i,j,ISt4,ISt5)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt5,ISt3)*(FD111HSTST(1,INH3,ISt3,ISt4)-
     &  FD111HSTST(1,INH3,ISt3,ISt5)))/(16.*(MassSu(ISt4)**2-
     &  MassSu(ISt5)**2))+self(i,j)
              else
       selfDP(i,j)=(-3*CS3S3S13S13(i,j,ISt4,ISt5)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt5,ISt3))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CS3S3S13S13(i,j,ISt4,ISt5)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt5,ISt3)*(-2*aA0TN(ISt4)+MassSu2(ISt4)))/(32.*
     &  MassSu(ISt4)**2)+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS3S3S13S13(i,j,ISt4,ISt5)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt5,ISt3)*FD211STSTH(1,ISt4,ISt3,INH3))/16.+
     &  self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
c Diagram 13
       do INH3=1,6
       do ISt3=1,2
       selfDP(i,j)=(-3*CS1S3SS(INH3,i,ISt3)*CS1S3SSC(INH3,j,ISt3)*
     &  (MSQ2+Mah2(INH3)+MassSu2(ISt3)))/32.+selfDP(i,j)
       selfSP(i,j)=(-3*CS1S3SS(INH3,i,ISt3)*CS1S3SSC(INH3,j,ISt3)*(2*
     &  a0t5+MSQ2+2*A0TNH(INH3)+2*aA0TN(ISt3)+Mah2(INH3)+MassSu2(ISt3))
     &  )/32.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS1S3SS(INH3,i,ISt3)*CS1S3SSC(INH3,j,ISt3)*
     &  FD111HSTSB(1,INH3,ISt3))/16.+self(i,j)
       enddo 
       enddo 
c#define details       
#ifdef details               
        print*, "neutral Higgs self(i,j)=",self(i,j)*fac
        self(i,j)=0D0
#endif         
c Diagram 6
       do ICH3=1,2
       selfDP(i,j)=(3*(+CTBS3(i)*CTBS3(ICH3)*CTBS3C(ICH3)*
     &  CTBS3C(j)*(3*M12+4*MassHpm(ICH3)**2)))/32.+selfDP(i,j)
       selfSP(i,j)=(-3*(-((6*a0t1+3*M12+8*A0THpN(ICH3))*CTBS3(i)*
     &  CTBS3(ICH3)*CTBS3C(ICH3)*CTBS3C(j))))/32.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-6*CTBS3(i)*CTBS3(ICH3)*CTBS3C(ICH3)*
     &  CTBS3C(j)*(M12*FD111BBHp(5,ICH3)-M12*FD111BTHp(5,ICH3)-M12*
     &  FD111TBHp(5,ICH3)+M12*FD111TTHp(5,ICH3)-M14*FD211BTHp(5,ICH3)+
     &  M14*FD211TBHp(5,ICH3)))/(16.*M12*M14)+self(i,j)
       enddo 

        
       do ICH3=1,2
       selfDP(i,j)=(3*(-(CS3S3S14S14(i,ICH3)*CS3S3S14S14(ICH3,j)*(2*
     &  MSQ2+MassHpm(ICH3)**2))))/32.+selfDP(i,j)
       selfSP(i,j)=(-3*(+CS3S3S14S14(i,ICH3)*
     &  CS3S3S14S14(ICH3,j)*(4*a0t5+2*MSQ2+2*A0THpN(ICH3)+MassHpm(ICH3)
     &  **2)))/32.+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*M12*M14*CS3S3S14S14(i,ICH3)*CS3S3S14S14(ICH3,j)*
     &  FD111SBHpSB(1,ICH3))/(16.*M12*M14)+self(i,j)
       enddo 
                                      
c Diagram 3
       do ICH3=1,2
       do ISt3=1,2
       selfDP(i,j)=(-3*(CS3S13S(ICH3,ISt3)*(CS3S13SC(j,ISt3)*
     &  CS3S3S14S14(i,ICH3)+CS3S13SC(ICH3,ISt3)*CS3S3S14S14(i,j))+
     &  CS3S13S(i,ISt3)*CS3S13SC(ICH3,ISt3)*CS3S3S14S14(ICH3,j)))/32.+
     &  selfDP(i,j)
       selfSP(i,j)=(-3*(CS3S13S(ICH3,ISt3)*((2*a0t5-MSQ2)*
     &  CS3S13SC(ICH3,ISt3)*CS3S3S14S14(i,j)*(MSQ2-MassSu2(ISt3))+MSQ2*
     &  CS3S13SC(j,ISt3)*CS3S3S14S14(i,ICH3)*(2*a0t5+MSQ2-2*aA0TN(ISt3)
     &  -MassSu2(ISt3)))+MSQ2*CS3S13S(i,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  CS3S3S14S14(ICH3,j)*(2*a0t5+MSQ2-2*aA0TN(ISt3)-MassSu2(ISt3))))
     &  /(32.*MSQ2*(MSQ2-MassSu2(ISt3)))+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*(CS3S13S(i,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  CS3S3S14S14(ICH3,j)*(-FD111HpSTSB(1,ICH3,ISt3)+
     &  FD111SBHpSB(1,ICH3))+CS3S13S(ICH3,ISt3)*(CS3S13SC(j,ISt3)*
     &  CS3S3S14S14(i,ICH3)*(-FD111HpSTSB(1,ICH3,ISt3)+
     &  FD111SBHpSB(1,ICH3))+CS3S13SC(ICH3,ISt3)*CS3S3S14S14(i,j)*
     &  FD211SBSTHp(1,ISt3,ICH3)*(MSQ**2-MassSu(ISt3)**2))))/(16.*(MSQ*
     &  *2-MassSu(ISt3)**2))+self(i,j)
       enddo 
       enddo  
               
c%%%%% diagram set2 2 has 6 diagrams              
c Diagram 1
       do ICH3=1,2
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=(-3*CS3S13S(i,ISt4)*CS3S13SC(ICH3,ISt3)*
     &  CS3S3S13S13(ICH3,j,ISt3,ISt4))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(i,ISt4)*CS3S13SC(ICH3,ISt3)*
     &  CS3S3S13S13(ICH3,j,ISt3,ISt4)*(-2*a0t5-MSQ2+2*aA0TN(ISt4)+
     &  MassSu2(ISt4)))/(32.*(MSQ2-MassSu2(ISt4)))+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS3S13S(i,ISt4)*CS3S13SC(ICH3,ISt3)*
     &  CS3S3S13S13(ICH3,j,ISt3,ISt4)*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTST(1,ICH3,ISt4,ISt3)))/(16.*(MSQ**2-MassSu(ISt4)**2))+
     &  self(i,j)
       enddo 
       enddo 
       enddo                 
c Diagram 2
       do ICH3=1,2
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=(-3*CS3S13S(ICH3,ISt3)*CS3S13SC(j,ISt4)*
     &  CS3S3S13S13(i,ICH3,ISt4,ISt3))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(j,ISt4)*
     &  CS3S3S13S13(i,ICH3,ISt4,ISt3)*(-2*a0t5-MSQ2+2*aA0TN(ISt4)+
     &  MassSu2(ISt4)))/(32.*(MSQ2-MassSu2(ISt4)))+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(j,ISt4)*
     &  CS3S3S13S13(i,ICH3,ISt4,ISt3)*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTST(1,ICH3,ISt4,ISt3)))/(16.*(MSQ**2-MassSu(ISt4)**2))+
     &  self(i,j)
       enddo 
       enddo 
       enddo 
              
c Diagram 3
       do ICH3=1,2
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=0+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(i,ISt3)*CS3S13S(ICH3,ISt4)*
     &  CS3S13SC(ICH3,ISt4)*CS3S13SC(j,ISt3)*(MSQ2**2-MSQ2*aA0TN(ISt3)+
     &  (a0t5-MSQ2)*MassSu2(ISt3)))/(16.*(MSQ**3-MSQ*MassSu2(ISt3))**2)
     &  +selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS3S13S(i,ISt3)*CS3S13S(ICH3,ISt4)*
     &  CS3S13SC(ICH3,ISt4)*CS3S13SC(j,ISt3)*(-FD111HpSTSB(1,ICH3,ISt4)
     &  +FD111HpSTST(1,ICH3,ISt3,ISt4)+FD211SBHpST(1,ICH3,ISt4)*(MSQ**
     &  2-MassSu(ISt3)**2)))/(16.*(MSQ**2-MassSu(ISt3)**2)**2)+
     &  self(i,j)
       enddo 
       enddo 
       enddo 
               
c Diagram 4
       do ICH3=1,2
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfDP(i,j)=0+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(i,ISt3)*CS3S13S(ICH3,ISt4)*
     &  CS3S13SC(ICH3,ISt3)*CS3S13SC(j,ISt4)*(aA0TN(ISt4)*(-MSQ2+
     &  MassSu2(ISt3))+aA0TN(ISt3)*(MSQ2-MassSu2(ISt4))+a0t5*(-
     &  MassSu2(ISt3)+MassSu2(ISt4))))/(16.*(MSQ-MassSu(ISt3))*(MSQ+
     &  MassSu(ISt3))*(MSQ-MassSu(ISt4))*(MassSu(ISt3)-MassSu(ISt4))*
     &  (MSQ+MassSu(ISt4))*(MassSu(ISt3)+MassSu(ISt4)))+selfSP(i,j)
       self(i,j)=(3*CS3S13S(i,ISt3)*CS3S13S(ICH3,ISt4)*
     &  CS3S13SC(ICH3,ISt3)*CS3S13SC(j,ISt4)*(FD111HpSTSB(1,ICH3,ISt4)*
     &  (MSQ**2-MassSu(ISt3)**2)+FD111SBHpSB(1,ICH3)*(MassSu(ISt3)**2-
     &  MassSu(ISt4)**2)+FD111HpSTSB(1,ICH3,ISt3)*(-MSQ**2+MassSu(ISt4)
     &  **2)))/(16.*(MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MSQ-
     &  MassSu(ISt4))*(MassSu(ISt3)-MassSu(ISt4))*(MSQ+MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4)))+self(i,j)
              else
       selfDP(i,j)=0+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(i,ISt3)*CS3S13S(ICH3,ISt4)*
     &  CS3S13SC(ICH3,ISt3)*CS3S13SC(j,ISt4)*(MSQ2*aA0TN(ISt3)+
     &  MassSu(ISt3)**4-(a0t5+MSQ2)*MassSu2(ISt3)))/(16.*(-(MSQ2*
     &  MassSu(ISt3))+MassSu(ISt3)**3)**2)+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS3S13S(i,ISt3)*CS3S13S(ICH3,ISt4)*
     &  CS3S13SC(ICH3,ISt3)*CS3S13SC(j,ISt4)*(-FD111HpSTSB(1,ICH3,ISt3)
     &  +FD111SBHpSB(1,ICH3)+FD211StHpSb(1,ISt3,ICH3)*(-MSQ**2+
     &  MassSu(ISt3)**2)))/(16.*(MSQ**2-MassSu(ISt3)**2)**2)+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
        
c Diagram 5
       do ICH3=1,2
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfDP(i,j)=(-3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  CS3S3S13S13(i,j,ISt4,ISt3))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  CS3S3S13S13(i,j,ISt4,ISt3)*(-2*aA0TN(ISt3)+2*aA0TN(ISt4)-
     &  MassSu2(ISt3)+MassSu2(ISt4)))/(32.*(MassSu2(ISt3)-MassSu2(ISt4)
     &  ))+selfSP(i,j)
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  CS3S3S13S13(i,j,ISt4,ISt3)*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTSB(1,ICH3,ISt4)))/(16.*(MassSu(ISt3)**2-MassSu(ISt4)**
     &  2))+self(i,j)
              else
       selfDP(i,j)=(-3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  CS3S3S13S13(i,j,ISt4,ISt3))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  CS3S3S13S13(i,j,ISt4,ISt3)*(-2*aA0TN(ISt3)+MassSu2(ISt3)))
     &  /(32.*MassSu(ISt3)**2)+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  CS3S3S13S13(i,j,ISt4,ISt3)*FD211StHpSb(1,ISt3,ICH3))/16.+
     &  self(i,j)
              endif
       enddo 
       enddo 
       enddo
         
c Diagram 6
       do ICH3=1,2
       do ISt3=1,2
       do ISt4=1,2
       selfDP(i,j)=(-3*CS3S3S13S13(i,ICH3,ISt4,ISt3)*
     &  CS3S3S13S13(ICH3,j,ISt3,ISt4)*(MassHpm(ICH3)**2+MassSu2(ISt3)+
     &  MassSu2(ISt4)))/32.+selfDP(i,j)
       selfSP(i,j)=(-3*CS3S3S13S13(i,ICH3,ISt4,ISt3)*
     &  CS3S3S13S13(ICH3,j,ISt3,ISt4)*(2*A0THpN(ICH3)+2*aA0TN(ISt3)+2*
     &  aA0TN(ISt4)+MassHpm(ICH3)**2+MassSu2(ISt3)+MassSu2(ISt4)))/32.+
     &  selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CS3S3S13S13(i,ICH3,ISt4,ISt3)*
     &  CS3S3S13S13(ICH3,j,ISt3,ISt4)*FD111HpSTST(1,ICH3,ISt3,ISt4))
     &  /16.+self(i,j)
       enddo 
       enddo 
       enddo  
#ifdef details                           
        print*, "charged Higgs self(i,j)",self(i,j)*fac
        self(i,j)=0D0 
#endif                                  
c Diagram 4
       do INe3=1,3
       do ISt3=1,2
       selfDP(i,j)=(3*CTBS3(i)*CTBS3C(j)*(2*CF11FSR(INe3,ISt3)*
     &  (CF11FSRC(INe3,ISt3)*(M12+MassSu2(ISt3))+M1*CF11FSLC(INe3,ISt3)
     &  *MNeu(INe3))+M1*CF11FSL(INe3,ISt3)*(M1*CF11FSLC(INe3,ISt3)+2*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3))))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CTBS3(i)*CTBS3C(j)*(-((-2*a0t1+M12)*
     &  CF11FSL(INe3,ISt3)*(M1*CF11FSLC(INe3,ISt3)+2*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)))+2*CF11FSR(INe3,ISt3)*(2*a0t1*
     &  (M1*CF11FSRC(INe3,ISt3)+CF11FSLC(INe3,ISt3)*MNeu(INe3))+M1*(2*
     &  aA0TN(ISt3)*CF11FSRC(INe3,ISt3)-M1*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)+CF11FSRC(INe3,ISt3)*MNeu2(INe3)))))/(32.*M1)+
     &  selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*CTBS3(i)*CTBS3C(j)*(CF11FSR(INe3,ISt3)*(M1**3*
     &  CF11FSRC(INe3,ISt3)*(M12*FD111BChiST(5,INe3,ISt3)-M12*
     &  FD111TChiST(5,INe3,ISt3)+M14*FD211TChiSt(5,INe3,ISt3))+M12*M14*
     &  CF11FSLC(INe3,ISt3)*(FD111BChiST(4,INe3,ISt3)-
     &  FD111TChiST(4,INe3,ISt3)+M1**2*FD211TChiSt(4,INe3,ISt3))*
     &  MNeu(INe3))+M14*CF11FSL(INe3,ISt3)*(M1**3*CF11FSLC(INe3,ISt3)*
     &  (-FD111ChiSTB(2,INe3,ISt3)+FD111ChiSTB(4,INe3,ISt3)+
     &  FD111ChiStT(2,INe3,ISt3)-FD111ChiStT(4,INe3,ISt3)+M12*
     &  FD211TChiSt(2,INe3,ISt3))+M12*CF11FSRC(INe3,ISt3)*
     &  (FD111BChiST(4,INe3,ISt3)-FD111TChiST(4,INe3,ISt3)+M1**2*
     &  FD211TChiSt(4,INe3,ISt3))*MNeu(INe3))))/(8.*M1**3*M12*M14)+self(i,j)
       enddo 
       enddo                  
c Diagram 10
       do INe3=1,3
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfDP(i,j)=(-3*(CF11FSL(INe3,ISt3)*(-2*M1*CF11FSRC(INe3,ISt4)*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*MNeu(INe3)+CF11FSLC(INe3,ISt4)*
     &  (CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)+CS3S3S13S13(i,j,ISt3,ISt4)*(-
     &  2*M12+MassSu2(ISt3)+MassSu2(ISt4)-2*MNeu2(INe3))))+
     &  CF11FSR(INe3,ISt3)*(-2*M1*CF11FSLC(INe3,ISt4)*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*MNeu(INe3)+CF11FSRC(INe3,ISt4)*
     &  (CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)+CS3S3S13S13(i,j,ISt3,ISt4)*(-
     &  2*M12+MassSu2(ISt3)+MassSu2(ISt4)-2*MNeu2(INe3))))))/32.+
     &  selfDP(i,j)
       selfSP(i,j)=(3*(-(((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*(2*a0t1*M12+M12**2+2*a0t5*MSQ2+2*M12*MSQ2+
     &  MSQ2**2-MNeu(INe3)**4+A0TNeu(INe3)*(4*(M12+MSQ2)-2*MNeu2(INe3))
     &  ))/((MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MSQ-MassSu(ISt4))*
     &  (MSQ+MassSu(ISt4))))+((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*(2*a0t1*M12+M12**2+MassSu(ISt3)**4+2*M12*
     &  MassSu2(ISt3)+2*aA0TN(ISt3)*MassSu2(ISt3)-MNeu(INe3)**4+
     &  A0TNeu(INe3)*(4*(M12+MassSu2(ISt3))-2*MNeu2(INe3))))/((MSQ-
     &  MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MassSu(ISt3)-MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4)))+((CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe3,ISt4)+CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(2*a0t1*M12+M12**2+
     &  MassSu(ISt4)**4+2*M12*MassSu2(ISt4)+2*aA0TN(ISt4)*MassSu2(ISt4)
     &  -MNeu(INe3)**4+A0TNeu(INe3)*(4*(M12+MassSu2(ISt4))-2*
     &  MNeu2(INe3))))/((MSQ-MassSu(ISt4))*(MSQ+MassSu(ISt4))*(-
     &  MassSu(ISt3)+MassSu(ISt4))*(MassSu(ISt3)+MassSu(ISt4)))+(2*M1*
     &  (CF11FSLC(INe3,ISt4)*CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*
     &  MNeu(INe3)*(2*a0t1+2*a0t5+M12+MSQ2+2*A0TNeu(INe3)+MNeu2(INe3)))
     &  /((MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MSQ-MassSu(ISt4))*
     &  (MSQ+MassSu(ISt4)))-(2*M1*(CF11FSLC(INe3,ISt4)*
     &  CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*MNeu(INe3)*(2*a0t1+M12+2*
     &  A0TNeu(INe3)+2*aA0TN(ISt3)+MassSu2(ISt3)+MNeu2(INe3)))/((MSQ-
     &  MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MassSu(ISt3)-MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4)))+(2*M1*(CF11FSLC(INe3,ISt4)*
     &  CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*MNeu(INe3)*(2*a0t1+M12+2*
     &  A0TNeu(INe3)+2*aA0TN(ISt3)+MassSu2(ISt3)+MNeu2(INe3)))
     &  /(MassSu2(ISt3)-MassSu2(ISt4))-(2*M1*(CF11FSLC(INe3,ISt4)*
     &  CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*MNeu(INe3)*(2*a0t1+M12+2*
     &  A0TNeu(INe3)+2*aA0TN(ISt4)+MassSu2(ISt4)+MNeu2(INe3)))/((MSQ-
     &  MassSu(ISt4))*(MSQ+MassSu(ISt4))*(-MassSu(ISt3)+MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4)))-(2*M1*(CF11FSLC(INe3,ISt4)*
     &  CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*MNeu(INe3)*(2*a0t1+M12+2*
     &  A0TNeu(INe3)+2*aA0TN(ISt4)+MassSu2(ISt4)+MNeu2(INe3)))
     &  /(MassSu2(ISt3)-MassSu2(ISt4))+(2*(CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe3,ISt4)+CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(2*a0t1*M12+2*a0t5*M12+M12**2+
     &  M12*MSQ2+2*(M12+MSQ2)*A0TNeu(INe3)+2*a0t5*MNeu2(INe3)+M12*
     &  MNeu2(INe3)))/((MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MSQ-
     &  MassSu(ISt4))*(MSQ+MassSu(ISt4)))+(4*(CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe3,ISt4)+CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(-(A0TNeu(INe3)*MassSu2(ISt3))
     &  -aA0TN(ISt3)*MNeu2(INe3)-(M12*(2*a0t1+M12+2*A0TNeu(INe3)+2*
     &  aA0TN(ISt3)+MassSu2(ISt3)+MNeu2(INe3)))/2.))/((MSQ-MassSu(ISt3)
     &  )*(MSQ+MassSu(ISt3))*(MassSu(ISt3)-MassSu(ISt4))*(MassSu(ISt3)+
     &  MassSu(ISt4)))+(4*(CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*(-(A0TNeu(INe3)*MassSu2(ISt4))-aA0TN(ISt4)*
     &  MNeu2(INe3)-(M12*(2*a0t1+M12+2*A0TNeu(INe3)+2*aA0TN(ISt4)+
     &  MassSu2(ISt4)+MNeu2(INe3)))/2.))/((MSQ-MassSu(ISt4))*(MSQ+
     &  MassSu(ISt4))*(-MassSu(ISt3)+MassSu(ISt4))*(MassSu(ISt3)+
     &  MassSu(ISt4)))+((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(2*a0t1*M12+M12**2-MassSu(ISt3)**4+
     &  MNeu(INe3)**4+2*M12*MNeu2(INe3)+2*A0TNeu(INe3)*MNeu2(INe3)+
     &  aA0TN(ISt3)*(4*M12-2*MassSu2(ISt3)+4*MNeu2(INe3))))
     &  /(MassSu2(ISt3)-MassSu2(ISt4))-((CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe3,ISt4)+CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(2*a0t1*M12+M12**2-MassSu(ISt4)**4+
     &  MNeu(INe3)**4+2*M12*MNeu2(INe3)+2*A0TNeu(INe3)*MNeu2(INe3)+
     &  aA0TN(ISt4)*(4*M12-2*MassSu2(ISt4)+4*MNeu2(INe3))))
     &  /(MassSu2(ISt3)-MassSu2(ISt4))))/32.+selfSP(i,j)
       self(i,j)=(3*(((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*(-FD111SBChiT(2,INe3)+FD111SBChiT(4,INe3)))
     &  /((MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MSQ-MassSu(ISt4))*
     &  (MSQ+MassSu(ISt4)))-((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*FD111TSBChi(4,INe3))/((MSQ-MassSu(ISt3))*(MSQ+
     &  MassSu(ISt3))*(MSQ-MassSu(ISt4))*(MSQ+MassSu(ISt4)))-
     &  ((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*
     &  (FD111ChiStT(3,INe3,ISt3)-FD111STChiT(2,ISt3,INe3)))/((MSQ-
     &  MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MassSu(ISt3)-MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4)))+((CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe3,ISt4)+CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*FD111TSTChi(4,ISt3,INe3))
     &  /((MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MassSu(ISt3)-
     &  MassSu(ISt4))*(MassSu(ISt3)+MassSu(ISt4)))-((CF11FSL(INe3,ISt3)
     &  *CF11FSLC(INe3,ISt4)+CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(FD111ChiStT(3,INe3,ISt4)-
     &  FD111STChiT(2,ISt4,INe3)))/((MSQ-MassSu(ISt4))*(MSQ+
     &  MassSu(ISt4))*(-MassSu(ISt3)+MassSu(ISt4))*(MassSu(ISt3)+
     &  MassSu(ISt4)))+((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*FD111TSTChi(4,ISt4,INe3))/((MSQ-MassSu(ISt4))*
     &  (MSQ+MassSu(ISt4))*(-MassSu(ISt3)+MassSu(ISt4))*(MassSu(ISt3)+
     &  MassSu(ISt4)))+((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(FD111ChiStT(2,INe3,ISt3)-
     &  FD111ChiStT(4,INe3,ISt3)))/(MassSu(ISt3)**2-MassSu(ISt4)**2)-
     &  ((CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt4)+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe3,ISt4))*CS3S3S13S13(i,j,ISt3,ISt4)*
     &  (FD111ChiStT(2,INe3,ISt4)-FD111ChiStT(4,INe3,ISt4)))
     &  /(MassSu(ISt3)**2-MassSu(ISt4)**2)-(M1*(CF11FSLC(INe3,ISt4)*
     &  CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*FD111TSBChi(1,INe3)*MNeu(INe3)
     &  )/((MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MSQ-MassSu(ISt4))*
     &  (MSQ+MassSu(ISt4)))+(M1*(CF11FSLC(INe3,ISt4)*CF11FSR(INe3,ISt3)
     &  +CF11FSL(INe3,ISt3)*CF11FSRC(INe3,ISt4))*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*FD111TSTChi(1,ISt3,INe3)*MNeu(INe3))/((MSQ-
     &  MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MassSu(ISt3)-MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4)))+(M1*(CF11FSLC(INe3,ISt4)*
     &  CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*FD111TSTChi(1,ISt4,INe3)*
     &  MNeu(INe3))/((MSQ-MassSu(ISt4))*(MSQ+MassSu(ISt4))*(-
     &  MassSu(ISt3)+MassSu(ISt4))*(MassSu(ISt3)+MassSu(ISt4)))-(M1*
     &  (CF11FSLC(INe3,ISt4)*CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe3,ISt4))*CS3S3S13S13(i,j,ISt3,ISt4)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe3))/(MassSu(ISt3)**2-
     &  MassSu(ISt4)**2)+(M1*(CF11FSLC(INe3,ISt4)*CF11FSR(INe3,ISt3)+
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe3,ISt4))*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*FD111TChiST(1,INe3,ISt4)*MNeu(INe3))
     &  /(MassSu(ISt3)**2-MassSu(ISt4)**2)))/8.+self(i,j)
              else
       selfDP(i,j)=(3*(CF11FSL(INe3,ISt3)*(2*M1*CF11FSRC(INe3,ISt4)*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*MNeu(INe3)+CF11FSLC(INe3,ISt4)*(-
     &  (CS3S13S(i,ISt3)*CS3S13SC(j,ISt4))+2*CS3S3S13S13(i,j,ISt3,ISt4)
     &  *(M12-MassSu2(ISt3)+MNeu2(INe3))))+CF11FSR(INe3,ISt3)*(2*M1*
     &  CF11FSLC(INe3,ISt4)*CS3S3S13S13(i,j,ISt3,ISt4)*MNeu(INe3)+
     &  CF11FSRC(INe3,ISt4)*(-(CS3S13S(i,ISt3)*CS3S13SC(j,ISt4))+2*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(M12-MassSu2(ISt3)+MNeu2(INe3))))))
     &  /32.+selfDP(i,j)
       selfSP(i,j)=(-3*(MassSu2(ISt3)*(CF11FSL(INe3,ISt3)*(2*M1*
     &  CF11FSRC(INe3,ISt4)*(CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-
     &  MassSu2(ISt3))**2-2*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(a0t5+
     &  MSQ2-MassSu2(ISt3)))*MNeu(INe3)+CF11FSLC(INe3,ISt4)*(4*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-MassSu2(ISt3))**2*(M12+
     &  MNeu2(INe3))+CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(-4*a0t5*M12+2*
     &  (a0t5-2*M12)*MSQ2+MSQ2**2-MassSu(ISt3)**4+4*M12*MassSu2(ISt3)-
     &  4*(a0t5+MSQ2-MassSu2(ISt3))*MNeu2(INe3))))+CF11FSR(INe3,ISt3)*
     &  (2*M1*CF11FSLC(INe3,ISt4)*(CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-
     &  MassSu2(ISt3))**2-2*CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(a0t5+
     &  MSQ2-MassSu2(ISt3)))*MNeu(INe3)+CF11FSRC(INe3,ISt4)*(4*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-MassSu2(ISt3))**2*(M12+
     &  MNeu2(INe3))+CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(-4*a0t5*M12+2*
     &  (a0t5-2*M12)*MSQ2+MSQ2**2-MassSu(ISt3)**4+4*M12*MassSu2(ISt3)-
     &  4*(a0t5+MSQ2-MassSu2(ISt3))*MNeu2(INe3)))))+aA0TN(ISt3)*
     &  (CF11FSL(INe3,ISt3)*(-4*M1*CF11FSRC(INe3,ISt4)*(-(MSQ2*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4))+CS3S3S13S13(i,j,ISt3,ISt4)*
     &  (MSQ2-MassSu2(ISt3))**2)*MNeu(INe3)+2*CF11FSLC(INe3,ISt4)*(-2*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-MassSu2(ISt3))**2*(M12-
     &  MassSu2(ISt3)+MNeu2(INe3))+CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*
     &  (MassSu(ISt3)**4-2*MSQ2*MassSu2(ISt3)+2*MSQ2*(M12+MNeu2(INe3)))
     &  ))+2*CF11FSR(INe3,ISt3)*(-2*M1*CF11FSLC(INe3,ISt4)*(-(MSQ2*
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4))+CS3S3S13S13(i,j,ISt3,ISt4)*
     &  (MSQ2-MassSu2(ISt3))**2)*MNeu(INe3)+CF11FSRC(INe3,ISt4)*(-2*
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-MassSu2(ISt3))**2*(M12-
     &  MassSu2(ISt3)+MNeu2(INe3))+CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*
     &  (MassSu(ISt3)**4-2*MSQ2*MassSu2(ISt3)+2*MSQ2*(M12+MNeu2(INe3)))
     &  )))))/(32.*(MSQ-MassSu(ISt3))**2*MassSu(ISt3)**2*(MSQ+
     &  MassSu(ISt3))**2)+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*(CF11FSR(INe3,ISt3)*(CF11FSRC(INe3,ISt4)*(-
     &  (CS3S3S13S13(i,j,ISt3,ISt4)*(FD211StChiT(2,ISt3,INe3)-
     &  FD211StChiT(3,ISt3,INe3))*(MSQ**2-MassSu(ISt3)**2)**2)+
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(FD111ChiStT(3,INe3,ISt3)+
     &  FD111SBChiT(2,INe3)-FD111SBChiT(4,INe3)-
     &  FD111STChiT(2,ISt3,INe3)+FD111TSBChi(4,INe3)-
     &  FD111TSTChi(4,ISt3,INe3)+(FD211STTChi(2,ISt3,INe3)-
     &  FD211STTChi(3,ISt3,INe3))*(MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))
     &  ))+M1*CF11FSLC(INe3,ISt4)*(CS3S3S13S13(i,j,ISt3,ISt4)*
     &  FD211StChiT(1,ISt3,INe3)*(MSQ**2-MassSu(ISt3)**2)**2+
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(FD111TSBChi(1,INe3)-
     &  FD111TSTChi(1,ISt3,INe3)+FD211STTChi(1,ISt3,INe3)*(-MSQ**2+
     &  MassSu(ISt3)**2)))*MNeu(INe3))+CF11FSL(INe3,ISt3)*
     &  (CF11FSLC(INe3,ISt4)*(-(CS3S3S13S13(i,j,ISt3,ISt4)*
     &  (FD211StChiT(2,ISt3,INe3)-FD211StChiT(3,ISt3,INe3))*(MSQ**2-
     &  MassSu(ISt3)**2)**2)+CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*
     &  (FD111ChiStT(3,INe3,ISt3)+FD111SBChiT(2,INe3)-
     &  FD111SBChiT(4,INe3)-FD111STChiT(2,ISt3,INe3)+
     &  FD111TSBChi(4,INe3)-FD111TSTChi(4,ISt3,INe3)+
     &  (FD211STTChi(2,ISt3,INe3)-FD211STTChi(3,ISt3,INe3))*(MSQ-
     &  MassSu(ISt3))*(MSQ+MassSu(ISt3))))+M1*CF11FSRC(INe3,ISt4)*
     &  (CS3S3S13S13(i,j,ISt3,ISt4)*FD211StChiT(1,ISt3,INe3)*(MSQ**2-
     &  MassSu(ISt3)**2)**2+CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*
     &  (FD111TSBChi(1,INe3)-FD111TSTChi(1,ISt3,INe3)+
     &  FD211STTChi(1,ISt3,INe3)*(-MSQ**2+MassSu(ISt3)**2)))*MNeu(INe3)
     &  )))/(8.*(MSQ**2-MassSu(ISt3)**2)**2)+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
#ifdef details       
        print*, "neutralino self(i,j)",self(i,j)*fac
        self(i,j)=0D0
#endif 
c Diagram 7
       do ISt3=1,2
       selfDP(i,j)=(-3*CF12F3S*CF12F3SC*CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt3)+3*CF12F4S(ISt3)*CF12F4SC(ISt3)*CTBS3(i)*
     &  CTBS3C(j)*(M12+2*MassSu2(ISt3)))/32.+selfDP(i,j)
       selfSP(i,j)=(3*((2*a0t1+M12+2*MCha2+4*aA0TN(ISt3))*CF12F4S(ISt3)
     &  *CF12F4SC(ISt3)*CTBS3(i)*CTBS3C(j)*(MSQ**3-MSQ*MassSu2(ISt3))**
     &  2+CF12F3S*CF12F3SC*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)*(MSQ2**2*(-
     &  2*a0t5-4*M12-4*MCha2+MSQ2)-MSQ2*MassSu(ISt3)**4+2*MSQ2*
     &  aA0TN(ISt3)*(2*(M12+MCha2)-MassSu2(ISt3))+4*(-(a0t5*(M12+MCha2-
     &  MSQ2))+(M12+MCha2)*MSQ2)*MassSu2(ISt3))))/(32.*(MSQ**3-MSQ*
     &  MassSu2(ISt3))**2)+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*(CF12F4S(ISt3)*CF12F4SC(ISt3)*CTBS3(i)*CTBS3C(j)*
     &  (M12*FD111BChaST(5,ISt3)-M12*FD111TChaST(5,ISt3)+M14*
     &  FD211BChaST(5,ISt3))*(MSQ**2-MassSu(ISt3)**2)**2+CF12F3S*
     &  CF12F3SC*M12*M14*CS3S13S(i,ISt3)*CS3S13SC(j,ISt3)*
     &  (FD111ChaSTT(3,ISt3)+FD111SBChaT(2)-FD111SBChaT(4)-
     &  FD111STChaT(2,ISt3)+FD111TSBCha(4)-FD111TSTCha(4,ISt3)+MSQ**2*
     &  FD211SBTCha(2)-MSQ**2*FD211SBTCha(3)-FD211SBTCha(2)*
     &  MassSu(ISt3)**2+FD211SBTCha(3)*MassSu(ISt3)**2)))/(8.*M12*M14*
     &  (MSQ**2-MassSu(ISt3)**2)**2)+self(i,j)
       enddo         
c Diagram 9
       selfDP(i,j)=(3*CF12F3S*CF12F3SC*((M12+MCha2-MSQ2)*
     &  CS3S3S14S14(i,j)+(M12+MSQ2)*CTBS3(i)*CTBS3C(j)))/16.+
     &  selfDP(i,j)
       selfSP(i,j)=(3*CF12F3S*CF12F3SC*(2*(a0t5*(M12+MCha2-MSQ2)-(M12+
     &  MCha2)*MSQ2)*CS3S3S14S14(i,j)+(2*a0t1+2*a0t5+MCha2)*MSQ2*
     &  CTBS3(i)*CTBS3C(j)))/(16.*MSQ2)+selfSP(i,j)
        
        !finite
        
       self(i,j)=(-3*CF12F3S*CF12F3SC*(M12*M14*CS3S3S14S14(i,j)*(-
     &  FD211SBChaT(2)+FD211SBChaT(3))+CTBS3(i)*CTBS3C(j)*(M12*
     &  (FD111BChaSB(5)-FD111TChaSB(5))+M14*FD211TChaSB(5))))/(8.*M12*
     &  M14)+self(i,j)
        
c Diagram 11
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfDP(i,j)=(-3*CF12F4S(ISt3)*CF12F4SC(ISt4)*(CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)+CS3S3S13S13(i,j,ISt3,ISt4)*(-2*MCha2+
     &  MassSu2(ISt3)+MassSu2(ISt4))))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CF12F4S(ISt3)*CF12F4SC(ISt4)*(-2*aA0TN(ISt4)*
     &  (MSQ2-MassSu2(ISt3))*(-(CS3S13S(i,ISt3)*CS3S13SC(j,ISt4))+
     &  CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-MassSu2(ISt4)))*(2*MCha2-
     &  MassSu2(ISt4))-2*aA0TN(ISt3)*(2*MCha2-MassSu2(ISt3))*
     &  (CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)+CS3S3S13S13(i,j,ISt3,ISt4)*(-
     &  MSQ2+MassSu2(ISt3)))*(MSQ2-MassSu2(ISt4))-(MassSu2(ISt3)-
     &  MassSu2(ISt4))*(CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-MassSu2(ISt3))
     &  *(MSQ2-MassSu2(ISt4))*(MassSu2(ISt3)+MassSu2(ISt4))+
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(-4*a0t5*MCha2+2*a0t5*MSQ2+
     &  MSQ2**2-MSQ2*MassSu2(ISt4)+MassSu2(ISt3)*(-MSQ2+MassSu2(ISt4)))
     &  )))/(32.*(MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3))*(MSQ-
     &  MassSu(ISt4))*(MassSu(ISt3)-MassSu(ISt4))*(MSQ+MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4)))+selfSP(i,j)
       self(i,j)=(3*CF12F4S(ISt3)*CF12F4SC(ISt4)*
     &  (CS3S3S13S13(i,j,ISt3,ISt4)*(FD111ChaSTB(2,ISt3)-
     &  FD111ChaSTB(2,ISt4)-FD111ChaSTB(4,ISt3)+FD111ChaSTB(4,ISt4))*
     &  (MSQ**2-MassSu(ISt3)**2)*(MSQ**2-MassSu(ISt4)**2)+
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(-(MSQ**2*FD111ChaSTB(3,ISt3))
     &  +MSQ**2*FD111ChaSTB(3,ISt4)+MSQ**2*FD111STChaB(2,ISt3)-MSQ**2*
     &  FD111STChaB(2,ISt4)-FD111BSBCha(4)*MassSu(ISt3)**2-
     &  FD111ChaSTB(3,ISt4)*MassSu(ISt3)**2-FD111SBChaB(2)*MassSu(ISt3)
     &  **2+FD111SBChaB(4)*MassSu(ISt3)**2+FD111STChaB(2,ISt4)*
     &  MassSu(ISt3)**2+FD111BSTCha(4,ISt4)*(-MSQ**2+MassSu(ISt3)**2)+
     &  FD111BSBCha(4)*MassSu(ISt4)**2+FD111ChaSTB(3,ISt3)*MassSu(ISt4)
     &  **2+FD111SBChaB(2)*MassSu(ISt4)**2-FD111SBChaB(4)*MassSu(ISt4)*
     &  *2-FD111STChaB(2,ISt3)*MassSu(ISt4)**2+FD111BSTCha(4,ISt3)*
     &  (MSQ**2-MassSu(ISt4)**2))))/(8.*(MSQ-MassSu(ISt3))*(MSQ+
     &  MassSu(ISt3))*(MSQ-MassSu(ISt4))*(MassSu(ISt3)-MassSu(ISt4))*
     &  (MSQ+MassSu(ISt4))*(MassSu(ISt3)+MassSu(ISt4)))+self(i,j)
              else
       selfDP(i,j)=(-3*CF12F4S(ISt3)*CF12F4SC(ISt4)*(CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)+2*CS3S3S13S13(i,j,ISt3,ISt4)*(-MCha2+
     &  MassSu2(ISt3))))/32.+selfDP(i,j)
       selfSP(i,j)=(3*CF12F4S(ISt3)*CF12F4SC(ISt4)*(MassSu2(ISt3)*(-4*
     &  MCha2*CS3S3S13S13(i,j,ISt3,ISt4)*(MSQ2-MassSu2(ISt3))**2+
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(4*MCha2*(a0t5+MSQ2)-MSQ2*(2*
     &  a0t5+MSQ2)+MassSu(ISt3)**4-4*MCha2*MassSu2(ISt3)))+2*
     &  aA0TN(ISt3)*(2*CS3S3S13S13(i,j,ISt3,ISt4)*(MCha-MassSu(ISt3))*
     &  (MCha+MassSu(ISt3))*(MSQ2-MassSu2(ISt3))**2-CS3S13S(i,ISt3)*
     &  CS3S13SC(j,ISt4)*(2*MCha2*MSQ2+MassSu(ISt3)**4-2*MSQ2*
     &  MassSu2(ISt3)))))/(32.*(-(MSQ2*MassSu(ISt3))+MassSu(ISt3)**3)**
     &  2)+selfSP(i,j)
        
        !finite
        
       self(i,j)=(3*CF12F4S(ISt3)*CF12F4SC(ISt4)*
     &  (CS3S3S13S13(i,j,ISt3,ISt4)*(FD211STChaB(2,ISt3)-
     &  FD211STChaB(3,ISt3))*(MSQ**2-MassSu(ISt3)**2)**2+
     &  CS3S13S(i,ISt3)*CS3S13SC(j,ISt4)*(-FD111BSBCha(4)+
     &  FD111BSTCha(4,ISt3)-FD111ChaSTB(3,ISt3)-FD111SBChaB(2)+
     &  FD111SBChaB(4)+FD111STChaB(2,ISt3)-(FD211STBCha(2,ISt3)-
     &  FD211STBCha(3,ISt3))*(MSQ-MassSu(ISt3))*(MSQ+MassSu(ISt3)))))
     &  /(8.*(MSQ**2-MassSu(ISt3)**2)**2)+self(i,j)
              endif
       enddo 
       enddo  
#ifdef details       
                 print*, " chargino self(i,j)1",self(i,j)*fac
        self(i,j)=0D0 
        stop 
#endif         
                
       enddo
       enddo  
         
#ifdef MATHEMATICA
       selfDP=selfDP*fac
       selfSP=selfSP*fac
       self=self*fac
       do i=1,2
        do j=1,2
       write(*, 100) "TwoLoopChargedSelfMT4[2][", i,",",j,"] = (",DBLE(self(i,j)), ") + I* (",
     .         DIMAG(self(i,j)), ") + (", DBLE(selfSP(i,j)), ")/Epsilon + I* (",
     .         DIMAG(self(i,j)), ")/Epsilon +(", DBLE(selfDP(i,j)), 
     .         ")/Epsilon^2 + I* (",
     .         DIMAG(self(i,j)), ")/Epsilon^2 "
         enddo
       enddo
       selfDP=0
       selfSP=0
       self=0
#endif 

       selfDP=selfDP*fac
       selfSP=selfSP*fac
       self=self*fac
       selfCTDP=selfCTDP*fac1
       selfCTSP=selfCTSP*fac1
       selfCT=selfCT*fac1       

c      cosk3s=-2*DBLE(expvS)*DIMAG(expvS)**2+DBLE(expvS)*(DBLE(expvS)**2- DIMAG(expvS)**2)
c      sink3s=2*DBLE(expvS)**2*DIMAG(expvS)+DIMAG(expvS)*(DBLE(expvS)**2- DIMAG(expvS)**2)   
c      Sinphiy = -2*DBLE(expvS)*DIMAG(expvS)
c      Cosphiy =DBLE(expvS)**2 - DIMAG(expvS)**2   
c       cosphi=Cosk3s*Cosphiy-Sink3s*Sinphiy
c       sinphi=Cosk3s*Sinphiy +Sink3s*Cosphiy
       cosphi=cos(phiu+phis+phil)
       sinphi=sin(phiu+phis+phil)
       if (MHpmInput) then
       dReAlambda24(3)=(CB*cosphi*SB*dMHp2MT4)/abs(MUE)-(cosphi*SB**
     &  3*dtad2MT4(1))/(vv*abs(MUE))-(CB**3*cosphi*dtad2MT4(2))
     &  /(vv*abs(MUE))+(sinphi*dtad2MT4(4))/(SB*vv*abs(MUE))+(cosphi*
     &  SB**3*dtad1MT4(1,2)*dv4(2))/(vv**2*abs(MUE))+(CB**3*cosphi*
     &  dtad1MT4(2,2)*dv4(2))/(vv**2*abs(MUE))-(sinphi*dtad1MT4(4,2)*
     &  dv4(2))/(SB*vv**2*abs(MUE)) 
       else
       dReAlambda24(3)=0D0
       endif


       dMCH2MT4(1,1,3)=(CB*dtad2MT4(1))/vv+(SB*dtad2MT4(2))/vv
       dMCH2MT4(1,2,3)=-((SB*dtad2MT4(1))/vv)+(CB*dtad2MT4(2))/vv+
     &  (IC*dtad2MT4(4))/(SB*vv)
       dMCH2MT4(2,1,3)=-((SB*dtad2MT4(1))/vv)+(CB*dtad2MT4(2))/vv-
     &  (IC*dtad2MT4(4))/(SB*vv)
       dMCH2MT4(2,2,3)=(sqrt2*abs(MUE)*(CB2*sqrt2*dReAlambda24(3)+SB2*
     &  sqrt2*dReAlambda24(3)))/(2.*CB*cosphi*SB)+(SB2*dtad2MT4(1))
     &  /(CB*vv)+(CB2*dtad2MT4(2))/(SB*vv)-(sinphi*dtad2MT4(4))
     &  /(CB*cosphi*SB**2*vv)
        
       dMCH2MT4(1,1,3)=dMCH2MT4(1,1,3)+(-((CB*dtad1MT4(1,2)*dv4(2))/vv*
     &  *2)-(SB*dtad1MT4(2,2)*dv4(2))/vv**2)
       dMCH2MT4(1,2,3)=dMCH2MT4(1,2,3)+((SB*dtad1MT4(1,2)*dv4(2))/vv**
     &  2-(CB*dtad1MT4(2,2)*dv4(2))/vv**2-(IC*dtad1MT4(4,2)*dv4(2))
     &  /(SB*vv**2))
       dMCH2MT4(2,1,3)=dMCH2MT4(2,1,3)+((SB*dtad1MT4(1,2)*dv4(2))/vv**
     &  2-(CB*dtad1MT4(2,2)*dv4(2))/vv**2+(IC*dtad1MT4(4,2)*dv4(2))
     &  /(SB*vv**2))
       dMCH2MT4(2,2,3)=dMCH2MT4(2,2,3)+(-((SB**2*dtad1MT4(1,2)*dv4(2))
     &  /(CB*vv**2))-(CB**2*dtad1MT4(2,2)*dv4(2))/(SB*vv**2)+(sinphi*
     &  dtad1MT4(4,2)*dv4(2))/(CB*cosphi*SB**2*vv**2))

#ifdef details     
       print*, "CHiggs_atat=",self
       print*, "CHiggs_atat Counterterm=",selfCT  
       print*, "CHiggs_atat Sum=",self+selfCT      
       print*, "dReAlambda24(3),dMHp2MT4",dReAlambda24(3),dMHp2MT4
       print*, "dMCH2MT4(:,:,3)",dMCH2MT4(:,:,3)
       print*, "renormalized charged Higgs self" ,self+selfCT-dMCH2MT4(:,:,3)            
#endif    
        SCH= self+selfCT-dMCH2MT4(:,:,3)                
100    format(A, I2,A,I2,A,F24.14,A,F24.14,A,F24.14,A,F24.14,A,F24.14,A,F24.14,A)        
       end
